import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AlbBackendGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#description AlbBackendGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#folder_id AlbBackendGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#id AlbBackendGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#labels AlbBackendGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}
    */
    readonly name?: string;
    /**
    * grpc_backend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_backend AlbBackendGroup#grpc_backend}
    */
    readonly grpcBackend?: AlbBackendGroupGrpcBackend[] | cdktf.IResolvable;
    /**
    * http_backend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_backend AlbBackendGroup#http_backend}
    */
    readonly httpBackend?: AlbBackendGroupHttpBackend[] | cdktf.IResolvable;
    /**
    * stream_backend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_backend AlbBackendGroup#stream_backend}
    */
    readonly streamBackend?: AlbBackendGroupStreamBackend[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeouts AlbBackendGroup#timeouts}
    */
    readonly timeouts?: AlbBackendGroupTimeouts;
}
export interface AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}
    */
    readonly serviceName?: string;
}
export declare function albBackendGroupGrpcBackendHealthcheckGrpcHealthcheckToTerraform(struct?: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference | AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck): any;
export declare class AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck | undefined);
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    resetServiceName(): void;
    get serviceNameInput(): string | undefined;
}
export interface AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}
    */
    readonly path: string;
}
export declare function albBackendGroupGrpcBackendHealthcheckHttpHealthcheckToTerraform(struct?: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference | AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck): any;
export declare class AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    get pathInput(): string | undefined;
}
export interface AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}
    */
    readonly receive?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}
    */
    readonly send?: string;
}
export declare function albBackendGroupGrpcBackendHealthcheckStreamHealthcheckToTerraform(struct?: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference | AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck): any;
export declare class AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck | undefined);
    private _receive?;
    get receive(): string;
    set receive(value: string);
    resetReceive(): void;
    get receiveInput(): string | undefined;
    private _send?;
    get send(): string;
    set send(value: string);
    resetSend(): void;
    get sendInput(): string | undefined;
}
export interface AlbBackendGroupGrpcBackendHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}
    */
    readonly healthcheckPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}
    */
    readonly interval: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}
    */
    readonly intervalJitterPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}
    */
    readonly timeout: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * grpc_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_healthcheck AlbBackendGroup#grpc_healthcheck}
    */
    readonly grpcHealthcheck?: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
    /**
    * http_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_healthcheck AlbBackendGroup#http_healthcheck}
    */
    readonly httpHealthcheck?: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
    /**
    * stream_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_healthcheck AlbBackendGroup#stream_healthcheck}
    */
    readonly streamHealthcheck?: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
}
export declare function albBackendGroupGrpcBackendHealthcheckToTerraform(struct?: AlbBackendGroupGrpcBackendHealthcheckOutputReference | AlbBackendGroupGrpcBackendHealthcheck): any;
export declare class AlbBackendGroupGrpcBackendHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendHealthcheck | undefined);
    private _healthcheckPort?;
    get healthcheckPort(): number;
    set healthcheckPort(value: number);
    resetHealthcheckPort(): void;
    get healthcheckPortInput(): number | undefined;
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    private _interval?;
    get interval(): string;
    set interval(value: string);
    get intervalInput(): string | undefined;
    private _intervalJitterPercent?;
    get intervalJitterPercent(): number;
    set intervalJitterPercent(value: number);
    resetIntervalJitterPercent(): void;
    get intervalJitterPercentInput(): number | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    get timeoutInput(): string | undefined;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _grpcHealthcheck;
    get grpcHealthcheck(): AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference;
    putGrpcHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck): void;
    resetGrpcHealthcheck(): void;
    get grpcHealthcheckInput(): AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck | undefined;
    private _httpHealthcheck;
    get httpHealthcheck(): AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference;
    putHttpHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck): void;
    resetHttpHealthcheck(): void;
    get httpHealthcheckInput(): AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck | undefined;
    private _streamHealthcheck;
    get streamHealthcheck(): AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference;
    putStreamHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck): void;
    resetStreamHealthcheck(): void;
    get streamHealthcheckInput(): AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck | undefined;
}
export interface AlbBackendGroupGrpcBackendLoadBalancingConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}
    */
    readonly localityAwareRoutingPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}
    */
    readonly panicThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}
    */
    readonly strictLocality?: boolean | cdktf.IResolvable;
}
export declare function albBackendGroupGrpcBackendLoadBalancingConfigToTerraform(struct?: AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference | AlbBackendGroupGrpcBackendLoadBalancingConfig): any;
export declare class AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendLoadBalancingConfig | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendLoadBalancingConfig | undefined);
    private _localityAwareRoutingPercent?;
    get localityAwareRoutingPercent(): number;
    set localityAwareRoutingPercent(value: number);
    resetLocalityAwareRoutingPercent(): void;
    get localityAwareRoutingPercentInput(): number | undefined;
    private _panicThreshold?;
    get panicThreshold(): number;
    set panicThreshold(value: number);
    resetPanicThreshold(): void;
    get panicThresholdInput(): number | undefined;
    private _strictLocality?;
    get strictLocality(): boolean | cdktf.IResolvable;
    set strictLocality(value: boolean | cdktf.IResolvable);
    resetStrictLocality(): void;
    get strictLocalityInput(): boolean | cdktf.IResolvable | undefined;
}
export interface AlbBackendGroupGrpcBackendTlsValidationContext {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}
    */
    readonly trustedCaBytes?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}
    */
    readonly trustedCaId?: string;
}
export declare function albBackendGroupGrpcBackendTlsValidationContextToTerraform(struct?: AlbBackendGroupGrpcBackendTlsValidationContextOutputReference | AlbBackendGroupGrpcBackendTlsValidationContext): any;
export declare class AlbBackendGroupGrpcBackendTlsValidationContextOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendTlsValidationContext | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendTlsValidationContext | undefined);
    private _trustedCaBytes?;
    get trustedCaBytes(): string;
    set trustedCaBytes(value: string);
    resetTrustedCaBytes(): void;
    get trustedCaBytesInput(): string | undefined;
    private _trustedCaId?;
    get trustedCaId(): string;
    set trustedCaId(value: string);
    resetTrustedCaId(): void;
    get trustedCaIdInput(): string | undefined;
}
export interface AlbBackendGroupGrpcBackendTls {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}
    */
    readonly sni?: string;
    /**
    * validation_context block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#validation_context AlbBackendGroup#validation_context}
    */
    readonly validationContext?: AlbBackendGroupGrpcBackendTlsValidationContext;
}
export declare function albBackendGroupGrpcBackendTlsToTerraform(struct?: AlbBackendGroupGrpcBackendTlsOutputReference | AlbBackendGroupGrpcBackendTls): any;
export declare class AlbBackendGroupGrpcBackendTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupGrpcBackendTls | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackendTls | undefined);
    private _sni?;
    get sni(): string;
    set sni(value: string);
    resetSni(): void;
    get sniInput(): string | undefined;
    private _validationContext;
    get validationContext(): AlbBackendGroupGrpcBackendTlsValidationContextOutputReference;
    putValidationContext(value: AlbBackendGroupGrpcBackendTlsValidationContext): void;
    resetValidationContext(): void;
    get validationContextInput(): AlbBackendGroupGrpcBackendTlsValidationContext | undefined;
}
export interface AlbBackendGroupGrpcBackend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}
    */
    readonly targetGroupIds: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}
    */
    readonly weight?: number;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck AlbBackendGroup#healthcheck}
    */
    readonly healthcheck?: AlbBackendGroupGrpcBackendHealthcheck;
    /**
    * load_balancing_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#load_balancing_config AlbBackendGroup#load_balancing_config}
    */
    readonly loadBalancingConfig?: AlbBackendGroupGrpcBackendLoadBalancingConfig;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#tls AlbBackendGroup#tls}
    */
    readonly tls?: AlbBackendGroupGrpcBackendTls;
}
export declare function albBackendGroupGrpcBackendToTerraform(struct?: AlbBackendGroupGrpcBackend | cdktf.IResolvable): any;
export declare class AlbBackendGroupGrpcBackendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbBackendGroupGrpcBackend | cdktf.IResolvable | undefined;
    set internalValue(value: AlbBackendGroupGrpcBackend | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _targetGroupIds?;
    get targetGroupIds(): string[];
    set targetGroupIds(value: string[]);
    get targetGroupIdsInput(): string[] | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _healthcheck;
    get healthcheck(): AlbBackendGroupGrpcBackendHealthcheckOutputReference;
    putHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheck): void;
    resetHealthcheck(): void;
    get healthcheckInput(): AlbBackendGroupGrpcBackendHealthcheck | undefined;
    private _loadBalancingConfig;
    get loadBalancingConfig(): AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference;
    putLoadBalancingConfig(value: AlbBackendGroupGrpcBackendLoadBalancingConfig): void;
    resetLoadBalancingConfig(): void;
    get loadBalancingConfigInput(): AlbBackendGroupGrpcBackendLoadBalancingConfig | undefined;
    private _tls;
    get tls(): AlbBackendGroupGrpcBackendTlsOutputReference;
    putTls(value: AlbBackendGroupGrpcBackendTls): void;
    resetTls(): void;
    get tlsInput(): AlbBackendGroupGrpcBackendTls | undefined;
}
export declare class AlbBackendGroupGrpcBackendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbBackendGroupGrpcBackend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbBackendGroupGrpcBackendOutputReference;
}
export interface AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}
    */
    readonly serviceName?: string;
}
export declare function albBackendGroupHttpBackendHealthcheckGrpcHealthcheckToTerraform(struct?: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference | AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck): any;
export declare class AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck | undefined);
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    resetServiceName(): void;
    get serviceNameInput(): string | undefined;
}
export interface AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}
    */
    readonly path: string;
}
export declare function albBackendGroupHttpBackendHealthcheckHttpHealthcheckToTerraform(struct?: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference | AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck): any;
export declare class AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    get pathInput(): string | undefined;
}
export interface AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}
    */
    readonly receive?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}
    */
    readonly send?: string;
}
export declare function albBackendGroupHttpBackendHealthcheckStreamHealthcheckToTerraform(struct?: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference | AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck): any;
export declare class AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck | undefined);
    private _receive?;
    get receive(): string;
    set receive(value: string);
    resetReceive(): void;
    get receiveInput(): string | undefined;
    private _send?;
    get send(): string;
    set send(value: string);
    resetSend(): void;
    get sendInput(): string | undefined;
}
export interface AlbBackendGroupHttpBackendHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}
    */
    readonly healthcheckPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}
    */
    readonly interval: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}
    */
    readonly intervalJitterPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}
    */
    readonly timeout: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * grpc_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_healthcheck AlbBackendGroup#grpc_healthcheck}
    */
    readonly grpcHealthcheck?: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
    /**
    * http_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_healthcheck AlbBackendGroup#http_healthcheck}
    */
    readonly httpHealthcheck?: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
    /**
    * stream_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_healthcheck AlbBackendGroup#stream_healthcheck}
    */
    readonly streamHealthcheck?: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
}
export declare function albBackendGroupHttpBackendHealthcheckToTerraform(struct?: AlbBackendGroupHttpBackendHealthcheckOutputReference | AlbBackendGroupHttpBackendHealthcheck): any;
export declare class AlbBackendGroupHttpBackendHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendHealthcheck | undefined);
    private _healthcheckPort?;
    get healthcheckPort(): number;
    set healthcheckPort(value: number);
    resetHealthcheckPort(): void;
    get healthcheckPortInput(): number | undefined;
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    private _interval?;
    get interval(): string;
    set interval(value: string);
    get intervalInput(): string | undefined;
    private _intervalJitterPercent?;
    get intervalJitterPercent(): number;
    set intervalJitterPercent(value: number);
    resetIntervalJitterPercent(): void;
    get intervalJitterPercentInput(): number | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    get timeoutInput(): string | undefined;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _grpcHealthcheck;
    get grpcHealthcheck(): AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference;
    putGrpcHealthcheck(value: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck): void;
    resetGrpcHealthcheck(): void;
    get grpcHealthcheckInput(): AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck | undefined;
    private _httpHealthcheck;
    get httpHealthcheck(): AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference;
    putHttpHealthcheck(value: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck): void;
    resetHttpHealthcheck(): void;
    get httpHealthcheckInput(): AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck | undefined;
    private _streamHealthcheck;
    get streamHealthcheck(): AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference;
    putStreamHealthcheck(value: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck): void;
    resetStreamHealthcheck(): void;
    get streamHealthcheckInput(): AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck | undefined;
}
export interface AlbBackendGroupHttpBackendLoadBalancingConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}
    */
    readonly localityAwareRoutingPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}
    */
    readonly panicThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}
    */
    readonly strictLocality?: boolean | cdktf.IResolvable;
}
export declare function albBackendGroupHttpBackendLoadBalancingConfigToTerraform(struct?: AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference | AlbBackendGroupHttpBackendLoadBalancingConfig): any;
export declare class AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendLoadBalancingConfig | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendLoadBalancingConfig | undefined);
    private _localityAwareRoutingPercent?;
    get localityAwareRoutingPercent(): number;
    set localityAwareRoutingPercent(value: number);
    resetLocalityAwareRoutingPercent(): void;
    get localityAwareRoutingPercentInput(): number | undefined;
    private _panicThreshold?;
    get panicThreshold(): number;
    set panicThreshold(value: number);
    resetPanicThreshold(): void;
    get panicThresholdInput(): number | undefined;
    private _strictLocality?;
    get strictLocality(): boolean | cdktf.IResolvable;
    set strictLocality(value: boolean | cdktf.IResolvable);
    resetStrictLocality(): void;
    get strictLocalityInput(): boolean | cdktf.IResolvable | undefined;
}
export interface AlbBackendGroupHttpBackendTlsValidationContext {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}
    */
    readonly trustedCaBytes?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}
    */
    readonly trustedCaId?: string;
}
export declare function albBackendGroupHttpBackendTlsValidationContextToTerraform(struct?: AlbBackendGroupHttpBackendTlsValidationContextOutputReference | AlbBackendGroupHttpBackendTlsValidationContext): any;
export declare class AlbBackendGroupHttpBackendTlsValidationContextOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendTlsValidationContext | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendTlsValidationContext | undefined);
    private _trustedCaBytes?;
    get trustedCaBytes(): string;
    set trustedCaBytes(value: string);
    resetTrustedCaBytes(): void;
    get trustedCaBytesInput(): string | undefined;
    private _trustedCaId?;
    get trustedCaId(): string;
    set trustedCaId(value: string);
    resetTrustedCaId(): void;
    get trustedCaIdInput(): string | undefined;
}
export interface AlbBackendGroupHttpBackendTls {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}
    */
    readonly sni?: string;
    /**
    * validation_context block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#validation_context AlbBackendGroup#validation_context}
    */
    readonly validationContext?: AlbBackendGroupHttpBackendTlsValidationContext;
}
export declare function albBackendGroupHttpBackendTlsToTerraform(struct?: AlbBackendGroupHttpBackendTlsOutputReference | AlbBackendGroupHttpBackendTls): any;
export declare class AlbBackendGroupHttpBackendTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupHttpBackendTls | undefined;
    set internalValue(value: AlbBackendGroupHttpBackendTls | undefined);
    private _sni?;
    get sni(): string;
    set sni(value: string);
    resetSni(): void;
    get sniInput(): string | undefined;
    private _validationContext;
    get validationContext(): AlbBackendGroupHttpBackendTlsValidationContextOutputReference;
    putValidationContext(value: AlbBackendGroupHttpBackendTlsValidationContext): void;
    resetValidationContext(): void;
    get validationContextInput(): AlbBackendGroupHttpBackendTlsValidationContext | undefined;
}
export interface AlbBackendGroupHttpBackend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#storage_bucket AlbBackendGroup#storage_bucket}
    */
    readonly storageBucket?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}
    */
    readonly targetGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}
    */
    readonly weight?: number;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck AlbBackendGroup#healthcheck}
    */
    readonly healthcheck?: AlbBackendGroupHttpBackendHealthcheck;
    /**
    * load_balancing_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#load_balancing_config AlbBackendGroup#load_balancing_config}
    */
    readonly loadBalancingConfig?: AlbBackendGroupHttpBackendLoadBalancingConfig;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#tls AlbBackendGroup#tls}
    */
    readonly tls?: AlbBackendGroupHttpBackendTls;
}
export declare function albBackendGroupHttpBackendToTerraform(struct?: AlbBackendGroupHttpBackend | cdktf.IResolvable): any;
export declare class AlbBackendGroupHttpBackendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbBackendGroupHttpBackend | cdktf.IResolvable | undefined;
    set internalValue(value: AlbBackendGroupHttpBackend | cdktf.IResolvable | undefined);
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _storageBucket?;
    get storageBucket(): string;
    set storageBucket(value: string);
    resetStorageBucket(): void;
    get storageBucketInput(): string | undefined;
    private _targetGroupIds?;
    get targetGroupIds(): string[];
    set targetGroupIds(value: string[]);
    resetTargetGroupIds(): void;
    get targetGroupIdsInput(): string[] | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _healthcheck;
    get healthcheck(): AlbBackendGroupHttpBackendHealthcheckOutputReference;
    putHealthcheck(value: AlbBackendGroupHttpBackendHealthcheck): void;
    resetHealthcheck(): void;
    get healthcheckInput(): AlbBackendGroupHttpBackendHealthcheck | undefined;
    private _loadBalancingConfig;
    get loadBalancingConfig(): AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference;
    putLoadBalancingConfig(value: AlbBackendGroupHttpBackendLoadBalancingConfig): void;
    resetLoadBalancingConfig(): void;
    get loadBalancingConfigInput(): AlbBackendGroupHttpBackendLoadBalancingConfig | undefined;
    private _tls;
    get tls(): AlbBackendGroupHttpBackendTlsOutputReference;
    putTls(value: AlbBackendGroupHttpBackendTls): void;
    resetTls(): void;
    get tlsInput(): AlbBackendGroupHttpBackendTls | undefined;
}
export declare class AlbBackendGroupHttpBackendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbBackendGroupHttpBackend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbBackendGroupHttpBackendOutputReference;
}
export interface AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}
    */
    readonly serviceName?: string;
}
export declare function albBackendGroupStreamBackendHealthcheckGrpcHealthcheckToTerraform(struct?: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference | AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck): any;
export declare class AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck | undefined);
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    resetServiceName(): void;
    get serviceNameInput(): string | undefined;
}
export interface AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}
    */
    readonly path: string;
}
export declare function albBackendGroupStreamBackendHealthcheckHttpHealthcheckToTerraform(struct?: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference | AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck): any;
export declare class AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    private _path?;
    get path(): string;
    set path(value: string);
    get pathInput(): string | undefined;
}
export interface AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}
    */
    readonly receive?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}
    */
    readonly send?: string;
}
export declare function albBackendGroupStreamBackendHealthcheckStreamHealthcheckToTerraform(struct?: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference | AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck): any;
export declare class AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck | undefined);
    private _receive?;
    get receive(): string;
    set receive(value: string);
    resetReceive(): void;
    get receiveInput(): string | undefined;
    private _send?;
    get send(): string;
    set send(value: string);
    resetSend(): void;
    get sendInput(): string | undefined;
}
export interface AlbBackendGroupStreamBackendHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}
    */
    readonly healthcheckPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}
    */
    readonly interval: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}
    */
    readonly intervalJitterPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}
    */
    readonly timeout: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * grpc_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_healthcheck AlbBackendGroup#grpc_healthcheck}
    */
    readonly grpcHealthcheck?: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
    /**
    * http_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_healthcheck AlbBackendGroup#http_healthcheck}
    */
    readonly httpHealthcheck?: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
    /**
    * stream_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_healthcheck AlbBackendGroup#stream_healthcheck}
    */
    readonly streamHealthcheck?: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
}
export declare function albBackendGroupStreamBackendHealthcheckToTerraform(struct?: AlbBackendGroupStreamBackendHealthcheckOutputReference | AlbBackendGroupStreamBackendHealthcheck): any;
export declare class AlbBackendGroupStreamBackendHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendHealthcheck | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendHealthcheck | undefined);
    private _healthcheckPort?;
    get healthcheckPort(): number;
    set healthcheckPort(value: number);
    resetHealthcheckPort(): void;
    get healthcheckPortInput(): number | undefined;
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    private _interval?;
    get interval(): string;
    set interval(value: string);
    get intervalInput(): string | undefined;
    private _intervalJitterPercent?;
    get intervalJitterPercent(): number;
    set intervalJitterPercent(value: number);
    resetIntervalJitterPercent(): void;
    get intervalJitterPercentInput(): number | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    get timeoutInput(): string | undefined;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _grpcHealthcheck;
    get grpcHealthcheck(): AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference;
    putGrpcHealthcheck(value: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck): void;
    resetGrpcHealthcheck(): void;
    get grpcHealthcheckInput(): AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck | undefined;
    private _httpHealthcheck;
    get httpHealthcheck(): AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference;
    putHttpHealthcheck(value: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck): void;
    resetHttpHealthcheck(): void;
    get httpHealthcheckInput(): AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck | undefined;
    private _streamHealthcheck;
    get streamHealthcheck(): AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference;
    putStreamHealthcheck(value: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck): void;
    resetStreamHealthcheck(): void;
    get streamHealthcheckInput(): AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck | undefined;
}
export interface AlbBackendGroupStreamBackendLoadBalancingConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}
    */
    readonly localityAwareRoutingPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}
    */
    readonly panicThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}
    */
    readonly strictLocality?: boolean | cdktf.IResolvable;
}
export declare function albBackendGroupStreamBackendLoadBalancingConfigToTerraform(struct?: AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference | AlbBackendGroupStreamBackendLoadBalancingConfig): any;
export declare class AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendLoadBalancingConfig | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendLoadBalancingConfig | undefined);
    private _localityAwareRoutingPercent?;
    get localityAwareRoutingPercent(): number;
    set localityAwareRoutingPercent(value: number);
    resetLocalityAwareRoutingPercent(): void;
    get localityAwareRoutingPercentInput(): number | undefined;
    private _panicThreshold?;
    get panicThreshold(): number;
    set panicThreshold(value: number);
    resetPanicThreshold(): void;
    get panicThresholdInput(): number | undefined;
    private _strictLocality?;
    get strictLocality(): boolean | cdktf.IResolvable;
    set strictLocality(value: boolean | cdktf.IResolvable);
    resetStrictLocality(): void;
    get strictLocalityInput(): boolean | cdktf.IResolvable | undefined;
}
export interface AlbBackendGroupStreamBackendTlsValidationContext {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}
    */
    readonly trustedCaBytes?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}
    */
    readonly trustedCaId?: string;
}
export declare function albBackendGroupStreamBackendTlsValidationContextToTerraform(struct?: AlbBackendGroupStreamBackendTlsValidationContextOutputReference | AlbBackendGroupStreamBackendTlsValidationContext): any;
export declare class AlbBackendGroupStreamBackendTlsValidationContextOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendTlsValidationContext | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendTlsValidationContext | undefined);
    private _trustedCaBytes?;
    get trustedCaBytes(): string;
    set trustedCaBytes(value: string);
    resetTrustedCaBytes(): void;
    get trustedCaBytesInput(): string | undefined;
    private _trustedCaId?;
    get trustedCaId(): string;
    set trustedCaId(value: string);
    resetTrustedCaId(): void;
    get trustedCaIdInput(): string | undefined;
}
export interface AlbBackendGroupStreamBackendTls {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}
    */
    readonly sni?: string;
    /**
    * validation_context block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#validation_context AlbBackendGroup#validation_context}
    */
    readonly validationContext?: AlbBackendGroupStreamBackendTlsValidationContext;
}
export declare function albBackendGroupStreamBackendTlsToTerraform(struct?: AlbBackendGroupStreamBackendTlsOutputReference | AlbBackendGroupStreamBackendTls): any;
export declare class AlbBackendGroupStreamBackendTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupStreamBackendTls | undefined;
    set internalValue(value: AlbBackendGroupStreamBackendTls | undefined);
    private _sni?;
    get sni(): string;
    set sni(value: string);
    resetSni(): void;
    get sniInput(): string | undefined;
    private _validationContext;
    get validationContext(): AlbBackendGroupStreamBackendTlsValidationContextOutputReference;
    putValidationContext(value: AlbBackendGroupStreamBackendTlsValidationContext): void;
    resetValidationContext(): void;
    get validationContextInput(): AlbBackendGroupStreamBackendTlsValidationContext | undefined;
}
export interface AlbBackendGroupStreamBackend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}
    */
    readonly targetGroupIds: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}
    */
    readonly weight?: number;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck AlbBackendGroup#healthcheck}
    */
    readonly healthcheck?: AlbBackendGroupStreamBackendHealthcheck;
    /**
    * load_balancing_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#load_balancing_config AlbBackendGroup#load_balancing_config}
    */
    readonly loadBalancingConfig?: AlbBackendGroupStreamBackendLoadBalancingConfig;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#tls AlbBackendGroup#tls}
    */
    readonly tls?: AlbBackendGroupStreamBackendTls;
}
export declare function albBackendGroupStreamBackendToTerraform(struct?: AlbBackendGroupStreamBackend | cdktf.IResolvable): any;
export declare class AlbBackendGroupStreamBackendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbBackendGroupStreamBackend | cdktf.IResolvable | undefined;
    set internalValue(value: AlbBackendGroupStreamBackend | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _targetGroupIds?;
    get targetGroupIds(): string[];
    set targetGroupIds(value: string[]);
    get targetGroupIdsInput(): string[] | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _healthcheck;
    get healthcheck(): AlbBackendGroupStreamBackendHealthcheckOutputReference;
    putHealthcheck(value: AlbBackendGroupStreamBackendHealthcheck): void;
    resetHealthcheck(): void;
    get healthcheckInput(): AlbBackendGroupStreamBackendHealthcheck | undefined;
    private _loadBalancingConfig;
    get loadBalancingConfig(): AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference;
    putLoadBalancingConfig(value: AlbBackendGroupStreamBackendLoadBalancingConfig): void;
    resetLoadBalancingConfig(): void;
    get loadBalancingConfigInput(): AlbBackendGroupStreamBackendLoadBalancingConfig | undefined;
    private _tls;
    get tls(): AlbBackendGroupStreamBackendTlsOutputReference;
    putTls(value: AlbBackendGroupStreamBackendTls): void;
    resetTls(): void;
    get tlsInput(): AlbBackendGroupStreamBackendTls | undefined;
}
export declare class AlbBackendGroupStreamBackendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbBackendGroupStreamBackend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbBackendGroupStreamBackendOutputReference;
}
export interface AlbBackendGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#create AlbBackendGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#delete AlbBackendGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#update AlbBackendGroup#update}
    */
    readonly update?: string;
}
export declare function albBackendGroupTimeoutsToTerraform(struct?: AlbBackendGroupTimeoutsOutputReference | AlbBackendGroupTimeouts | cdktf.IResolvable): any;
export declare class AlbBackendGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbBackendGroupTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: AlbBackendGroupTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group yandex_alb_backend_group}
*/
export declare class AlbBackendGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_alb_backend_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group yandex_alb_backend_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AlbBackendGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: AlbBackendGroupConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _grpcBackend;
    get grpcBackend(): AlbBackendGroupGrpcBackendList;
    putGrpcBackend(value: AlbBackendGroupGrpcBackend[] | cdktf.IResolvable): void;
    resetGrpcBackend(): void;
    get grpcBackendInput(): cdktf.IResolvable | AlbBackendGroupGrpcBackend[] | undefined;
    private _httpBackend;
    get httpBackend(): AlbBackendGroupHttpBackendList;
    putHttpBackend(value: AlbBackendGroupHttpBackend[] | cdktf.IResolvable): void;
    resetHttpBackend(): void;
    get httpBackendInput(): cdktf.IResolvable | AlbBackendGroupHttpBackend[] | undefined;
    private _streamBackend;
    get streamBackend(): AlbBackendGroupStreamBackendList;
    putStreamBackend(value: AlbBackendGroupStreamBackend[] | cdktf.IResolvable): void;
    resetStreamBackend(): void;
    get streamBackendInput(): cdktf.IResolvable | AlbBackendGroupStreamBackend[] | undefined;
    private _timeouts;
    get timeouts(): AlbBackendGroupTimeoutsOutputReference;
    putTimeouts(value: AlbBackendGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | AlbBackendGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=alb-backend-group.d.ts.map