import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AlbVirtualHostConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#authority AlbVirtualHost#authority}
    */
    readonly authority?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_router_id AlbVirtualHost#http_router_id}
    */
    readonly httpRouterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#id AlbVirtualHost#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}
    */
    readonly name: string;
    /**
    * modify_request_headers block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#modify_request_headers AlbVirtualHost#modify_request_headers}
    */
    readonly modifyRequestHeaders?: AlbVirtualHostModifyRequestHeaders[] | cdktf.IResolvable;
    /**
    * modify_response_headers block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#modify_response_headers AlbVirtualHost#modify_response_headers}
    */
    readonly modifyResponseHeaders?: AlbVirtualHostModifyResponseHeaders[] | cdktf.IResolvable;
    /**
    * route block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#route AlbVirtualHost#route}
    */
    readonly route?: AlbVirtualHostRoute[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#timeouts AlbVirtualHost#timeouts}
    */
    readonly timeouts?: AlbVirtualHostTimeouts;
}
export interface AlbVirtualHostModifyRequestHeaders {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#append AlbVirtualHost#append}
    */
    readonly append?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove AlbVirtualHost#remove}
    */
    readonly remove?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace AlbVirtualHost#replace}
    */
    readonly replace?: string;
}
export declare function albVirtualHostModifyRequestHeadersToTerraform(struct?: AlbVirtualHostModifyRequestHeaders | cdktf.IResolvable): any;
export declare class AlbVirtualHostModifyRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbVirtualHostModifyRequestHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: AlbVirtualHostModifyRequestHeaders | cdktf.IResolvable | undefined);
    private _append?;
    get append(): string;
    set append(value: string);
    resetAppend(): void;
    get appendInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _remove?;
    get remove(): boolean | cdktf.IResolvable;
    set remove(value: boolean | cdktf.IResolvable);
    resetRemove(): void;
    get removeInput(): boolean | cdktf.IResolvable | undefined;
    private _replace?;
    get replace(): string;
    set replace(value: string);
    resetReplace(): void;
    get replaceInput(): string | undefined;
}
export declare class AlbVirtualHostModifyRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbVirtualHostModifyRequestHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbVirtualHostModifyRequestHeadersOutputReference;
}
export interface AlbVirtualHostModifyResponseHeaders {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#append AlbVirtualHost#append}
    */
    readonly append?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove AlbVirtualHost#remove}
    */
    readonly remove?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace AlbVirtualHost#replace}
    */
    readonly replace?: string;
}
export declare function albVirtualHostModifyResponseHeadersToTerraform(struct?: AlbVirtualHostModifyResponseHeaders | cdktf.IResolvable): any;
export declare class AlbVirtualHostModifyResponseHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbVirtualHostModifyResponseHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: AlbVirtualHostModifyResponseHeaders | cdktf.IResolvable | undefined);
    private _append?;
    get append(): string;
    set append(value: string);
    resetAppend(): void;
    get appendInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _remove?;
    get remove(): boolean | cdktf.IResolvable;
    set remove(value: boolean | cdktf.IResolvable);
    resetRemove(): void;
    get removeInput(): boolean | cdktf.IResolvable | undefined;
    private _replace?;
    get replace(): string;
    set replace(value: string);
    resetReplace(): void;
    get replaceInput(): string | undefined;
}
export declare class AlbVirtualHostModifyResponseHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbVirtualHostModifyResponseHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbVirtualHostModifyResponseHeadersOutputReference;
}
export interface AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#exact AlbVirtualHost#exact}
    */
    readonly exact?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix AlbVirtualHost#prefix}
    */
    readonly prefix?: string;
}
export declare function albVirtualHostRouteGrpcRouteGrpcMatchFqmnToTerraform(struct?: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference | AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn): any;
export declare class AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn | undefined;
    set internalValue(value: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn | undefined);
    private _exact?;
    get exact(): string;
    set exact(value: string);
    resetExact(): void;
    get exactInput(): string | undefined;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
}
export interface AlbVirtualHostRouteGrpcRouteGrpcMatch {
    /**
    * fqmn block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#fqmn AlbVirtualHost#fqmn}
    */
    readonly fqmn?: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn;
}
export declare function albVirtualHostRouteGrpcRouteGrpcMatchToTerraform(struct?: AlbVirtualHostRouteGrpcRouteGrpcMatch | cdktf.IResolvable): any;
export declare class AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbVirtualHostRouteGrpcRouteGrpcMatch | cdktf.IResolvable | undefined;
    set internalValue(value: AlbVirtualHostRouteGrpcRouteGrpcMatch | cdktf.IResolvable | undefined);
    private _fqmn;
    get fqmn(): AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference;
    putFqmn(value: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn): void;
    resetFqmn(): void;
    get fqmnInput(): AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn | undefined;
}
export declare class AlbVirtualHostRouteGrpcRouteGrpcMatchList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbVirtualHostRouteGrpcRouteGrpcMatch[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference;
}
export interface AlbVirtualHostRouteGrpcRouteGrpcRouteAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#auto_host_rewrite AlbVirtualHost#auto_host_rewrite}
    */
    readonly autoHostRewrite?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#backend_group_id AlbVirtualHost#backend_group_id}
    */
    readonly backendGroupId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#host_rewrite AlbVirtualHost#host_rewrite}
    */
    readonly hostRewrite?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#idle_timeout AlbVirtualHost#idle_timeout}
    */
    readonly idleTimeout?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#max_timeout AlbVirtualHost#max_timeout}
    */
    readonly maxTimeout?: string;
}
export declare function albVirtualHostRouteGrpcRouteGrpcRouteActionToTerraform(struct?: AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference | AlbVirtualHostRouteGrpcRouteGrpcRouteAction): any;
export declare class AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteGrpcRouteGrpcRouteAction | undefined;
    set internalValue(value: AlbVirtualHostRouteGrpcRouteGrpcRouteAction | undefined);
    private _autoHostRewrite?;
    get autoHostRewrite(): boolean | cdktf.IResolvable;
    set autoHostRewrite(value: boolean | cdktf.IResolvable);
    resetAutoHostRewrite(): void;
    get autoHostRewriteInput(): boolean | cdktf.IResolvable | undefined;
    private _backendGroupId?;
    get backendGroupId(): string;
    set backendGroupId(value: string);
    get backendGroupIdInput(): string | undefined;
    private _hostRewrite?;
    get hostRewrite(): string;
    set hostRewrite(value: string);
    resetHostRewrite(): void;
    get hostRewriteInput(): string | undefined;
    private _idleTimeout?;
    get idleTimeout(): string;
    set idleTimeout(value: string);
    resetIdleTimeout(): void;
    get idleTimeoutInput(): string | undefined;
    private _maxTimeout?;
    get maxTimeout(): string;
    set maxTimeout(value: string);
    resetMaxTimeout(): void;
    get maxTimeoutInput(): string | undefined;
}
export interface AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#status AlbVirtualHost#status}
    */
    readonly status?: string;
}
export declare function albVirtualHostRouteGrpcRouteGrpcStatusResponseActionToTerraform(struct?: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference | AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction): any;
export declare class AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction | undefined;
    set internalValue(value: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction | undefined);
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
}
export interface AlbVirtualHostRouteGrpcRoute {
    /**
    * grpc_match block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_match AlbVirtualHost#grpc_match}
    */
    readonly grpcMatch?: AlbVirtualHostRouteGrpcRouteGrpcMatch[] | cdktf.IResolvable;
    /**
    * grpc_route_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_route_action AlbVirtualHost#grpc_route_action}
    */
    readonly grpcRouteAction?: AlbVirtualHostRouteGrpcRouteGrpcRouteAction;
    /**
    * grpc_status_response_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_status_response_action AlbVirtualHost#grpc_status_response_action}
    */
    readonly grpcStatusResponseAction?: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction;
}
export declare function albVirtualHostRouteGrpcRouteToTerraform(struct?: AlbVirtualHostRouteGrpcRouteOutputReference | AlbVirtualHostRouteGrpcRoute): any;
export declare class AlbVirtualHostRouteGrpcRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteGrpcRoute | undefined;
    set internalValue(value: AlbVirtualHostRouteGrpcRoute | undefined);
    private _grpcMatch;
    get grpcMatch(): AlbVirtualHostRouteGrpcRouteGrpcMatchList;
    putGrpcMatch(value: AlbVirtualHostRouteGrpcRouteGrpcMatch[] | cdktf.IResolvable): void;
    resetGrpcMatch(): void;
    get grpcMatchInput(): cdktf.IResolvable | AlbVirtualHostRouteGrpcRouteGrpcMatch[] | undefined;
    private _grpcRouteAction;
    get grpcRouteAction(): AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference;
    putGrpcRouteAction(value: AlbVirtualHostRouteGrpcRouteGrpcRouteAction): void;
    resetGrpcRouteAction(): void;
    get grpcRouteActionInput(): AlbVirtualHostRouteGrpcRouteGrpcRouteAction | undefined;
    private _grpcStatusResponseAction;
    get grpcStatusResponseAction(): AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference;
    putGrpcStatusResponseAction(value: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction): void;
    resetGrpcStatusResponseAction(): void;
    get grpcStatusResponseActionInput(): AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction | undefined;
}
export interface AlbVirtualHostRouteHttpRouteDirectResponseAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#body AlbVirtualHost#body}
    */
    readonly body?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#status AlbVirtualHost#status}
    */
    readonly status?: number;
}
export declare function albVirtualHostRouteHttpRouteDirectResponseActionToTerraform(struct?: AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference | AlbVirtualHostRouteHttpRouteDirectResponseAction): any;
export declare class AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteHttpRouteDirectResponseAction | undefined;
    set internalValue(value: AlbVirtualHostRouteHttpRouteDirectResponseAction | undefined);
    private _body?;
    get body(): string;
    set body(value: string);
    resetBody(): void;
    get bodyInput(): string | undefined;
    private _status?;
    get status(): number;
    set status(value: number);
    resetStatus(): void;
    get statusInput(): number | undefined;
}
export interface AlbVirtualHostRouteHttpRouteHttpMatchPath {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#exact AlbVirtualHost#exact}
    */
    readonly exact?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix AlbVirtualHost#prefix}
    */
    readonly prefix?: string;
}
export declare function albVirtualHostRouteHttpRouteHttpMatchPathToTerraform(struct?: AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference | AlbVirtualHostRouteHttpRouteHttpMatchPath): any;
export declare class AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteHttpRouteHttpMatchPath | undefined;
    set internalValue(value: AlbVirtualHostRouteHttpRouteHttpMatchPath | undefined);
    private _exact?;
    get exact(): string;
    set exact(value: string);
    resetExact(): void;
    get exactInput(): string | undefined;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
}
export interface AlbVirtualHostRouteHttpRouteHttpMatch {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_method AlbVirtualHost#http_method}
    */
    readonly httpMethod?: string[];
    /**
    * path block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#path AlbVirtualHost#path}
    */
    readonly path?: AlbVirtualHostRouteHttpRouteHttpMatchPath;
}
export declare function albVirtualHostRouteHttpRouteHttpMatchToTerraform(struct?: AlbVirtualHostRouteHttpRouteHttpMatch | cdktf.IResolvable): any;
export declare class AlbVirtualHostRouteHttpRouteHttpMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbVirtualHostRouteHttpRouteHttpMatch | cdktf.IResolvable | undefined;
    set internalValue(value: AlbVirtualHostRouteHttpRouteHttpMatch | cdktf.IResolvable | undefined);
    private _httpMethod?;
    get httpMethod(): string[];
    set httpMethod(value: string[]);
    resetHttpMethod(): void;
    get httpMethodInput(): string[] | undefined;
    private _path;
    get path(): AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference;
    putPath(value: AlbVirtualHostRouteHttpRouteHttpMatchPath): void;
    resetPath(): void;
    get pathInput(): AlbVirtualHostRouteHttpRouteHttpMatchPath | undefined;
}
export declare class AlbVirtualHostRouteHttpRouteHttpMatchList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbVirtualHostRouteHttpRouteHttpMatch[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbVirtualHostRouteHttpRouteHttpMatchOutputReference;
}
export interface AlbVirtualHostRouteHttpRouteHttpRouteAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#auto_host_rewrite AlbVirtualHost#auto_host_rewrite}
    */
    readonly autoHostRewrite?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#backend_group_id AlbVirtualHost#backend_group_id}
    */
    readonly backendGroupId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#host_rewrite AlbVirtualHost#host_rewrite}
    */
    readonly hostRewrite?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#idle_timeout AlbVirtualHost#idle_timeout}
    */
    readonly idleTimeout?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix_rewrite AlbVirtualHost#prefix_rewrite}
    */
    readonly prefixRewrite?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#timeout AlbVirtualHost#timeout}
    */
    readonly timeout?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#upgrade_types AlbVirtualHost#upgrade_types}
    */
    readonly upgradeTypes?: string[];
}
export declare function albVirtualHostRouteHttpRouteHttpRouteActionToTerraform(struct?: AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference | AlbVirtualHostRouteHttpRouteHttpRouteAction): any;
export declare class AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteHttpRouteHttpRouteAction | undefined;
    set internalValue(value: AlbVirtualHostRouteHttpRouteHttpRouteAction | undefined);
    private _autoHostRewrite?;
    get autoHostRewrite(): boolean | cdktf.IResolvable;
    set autoHostRewrite(value: boolean | cdktf.IResolvable);
    resetAutoHostRewrite(): void;
    get autoHostRewriteInput(): boolean | cdktf.IResolvable | undefined;
    private _backendGroupId?;
    get backendGroupId(): string;
    set backendGroupId(value: string);
    get backendGroupIdInput(): string | undefined;
    private _hostRewrite?;
    get hostRewrite(): string;
    set hostRewrite(value: string);
    resetHostRewrite(): void;
    get hostRewriteInput(): string | undefined;
    private _idleTimeout?;
    get idleTimeout(): string;
    set idleTimeout(value: string);
    resetIdleTimeout(): void;
    get idleTimeoutInput(): string | undefined;
    private _prefixRewrite?;
    get prefixRewrite(): string;
    set prefixRewrite(value: string);
    resetPrefixRewrite(): void;
    get prefixRewriteInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    resetTimeout(): void;
    get timeoutInput(): string | undefined;
    private _upgradeTypes?;
    get upgradeTypes(): string[];
    set upgradeTypes(value: string[]);
    resetUpgradeTypes(): void;
    get upgradeTypesInput(): string[] | undefined;
}
export interface AlbVirtualHostRouteHttpRouteRedirectAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove_query AlbVirtualHost#remove_query}
    */
    readonly removeQuery?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_host AlbVirtualHost#replace_host}
    */
    readonly replaceHost?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_path AlbVirtualHost#replace_path}
    */
    readonly replacePath?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_port AlbVirtualHost#replace_port}
    */
    readonly replacePort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_prefix AlbVirtualHost#replace_prefix}
    */
    readonly replacePrefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_scheme AlbVirtualHost#replace_scheme}
    */
    readonly replaceScheme?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#response_code AlbVirtualHost#response_code}
    */
    readonly responseCode?: string;
}
export declare function albVirtualHostRouteHttpRouteRedirectActionToTerraform(struct?: AlbVirtualHostRouteHttpRouteRedirectActionOutputReference | AlbVirtualHostRouteHttpRouteRedirectAction): any;
export declare class AlbVirtualHostRouteHttpRouteRedirectActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteHttpRouteRedirectAction | undefined;
    set internalValue(value: AlbVirtualHostRouteHttpRouteRedirectAction | undefined);
    private _removeQuery?;
    get removeQuery(): boolean | cdktf.IResolvable;
    set removeQuery(value: boolean | cdktf.IResolvable);
    resetRemoveQuery(): void;
    get removeQueryInput(): boolean | cdktf.IResolvable | undefined;
    private _replaceHost?;
    get replaceHost(): string;
    set replaceHost(value: string);
    resetReplaceHost(): void;
    get replaceHostInput(): string | undefined;
    private _replacePath?;
    get replacePath(): string;
    set replacePath(value: string);
    resetReplacePath(): void;
    get replacePathInput(): string | undefined;
    private _replacePort?;
    get replacePort(): number;
    set replacePort(value: number);
    resetReplacePort(): void;
    get replacePortInput(): number | undefined;
    private _replacePrefix?;
    get replacePrefix(): string;
    set replacePrefix(value: string);
    resetReplacePrefix(): void;
    get replacePrefixInput(): string | undefined;
    private _replaceScheme?;
    get replaceScheme(): string;
    set replaceScheme(value: string);
    resetReplaceScheme(): void;
    get replaceSchemeInput(): string | undefined;
    private _responseCode?;
    get responseCode(): string;
    set responseCode(value: string);
    resetResponseCode(): void;
    get responseCodeInput(): string | undefined;
}
export interface AlbVirtualHostRouteHttpRoute {
    /**
    * direct_response_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#direct_response_action AlbVirtualHost#direct_response_action}
    */
    readonly directResponseAction?: AlbVirtualHostRouteHttpRouteDirectResponseAction;
    /**
    * http_match block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_match AlbVirtualHost#http_match}
    */
    readonly httpMatch?: AlbVirtualHostRouteHttpRouteHttpMatch[] | cdktf.IResolvable;
    /**
    * http_route_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_route_action AlbVirtualHost#http_route_action}
    */
    readonly httpRouteAction?: AlbVirtualHostRouteHttpRouteHttpRouteAction;
    /**
    * redirect_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#redirect_action AlbVirtualHost#redirect_action}
    */
    readonly redirectAction?: AlbVirtualHostRouteHttpRouteRedirectAction;
}
export declare function albVirtualHostRouteHttpRouteToTerraform(struct?: AlbVirtualHostRouteHttpRouteOutputReference | AlbVirtualHostRouteHttpRoute): any;
export declare class AlbVirtualHostRouteHttpRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostRouteHttpRoute | undefined;
    set internalValue(value: AlbVirtualHostRouteHttpRoute | undefined);
    private _directResponseAction;
    get directResponseAction(): AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference;
    putDirectResponseAction(value: AlbVirtualHostRouteHttpRouteDirectResponseAction): void;
    resetDirectResponseAction(): void;
    get directResponseActionInput(): AlbVirtualHostRouteHttpRouteDirectResponseAction | undefined;
    private _httpMatch;
    get httpMatch(): AlbVirtualHostRouteHttpRouteHttpMatchList;
    putHttpMatch(value: AlbVirtualHostRouteHttpRouteHttpMatch[] | cdktf.IResolvable): void;
    resetHttpMatch(): void;
    get httpMatchInput(): cdktf.IResolvable | AlbVirtualHostRouteHttpRouteHttpMatch[] | undefined;
    private _httpRouteAction;
    get httpRouteAction(): AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference;
    putHttpRouteAction(value: AlbVirtualHostRouteHttpRouteHttpRouteAction): void;
    resetHttpRouteAction(): void;
    get httpRouteActionInput(): AlbVirtualHostRouteHttpRouteHttpRouteAction | undefined;
    private _redirectAction;
    get redirectAction(): AlbVirtualHostRouteHttpRouteRedirectActionOutputReference;
    putRedirectAction(value: AlbVirtualHostRouteHttpRouteRedirectAction): void;
    resetRedirectAction(): void;
    get redirectActionInput(): AlbVirtualHostRouteHttpRouteRedirectAction | undefined;
}
export interface AlbVirtualHostRoute {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}
    */
    readonly name?: string;
    /**
    * grpc_route block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_route AlbVirtualHost#grpc_route}
    */
    readonly grpcRoute?: AlbVirtualHostRouteGrpcRoute;
    /**
    * http_route block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_route AlbVirtualHost#http_route}
    */
    readonly httpRoute?: AlbVirtualHostRouteHttpRoute;
}
export declare function albVirtualHostRouteToTerraform(struct?: AlbVirtualHostRoute | cdktf.IResolvable): any;
export declare class AlbVirtualHostRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlbVirtualHostRoute | cdktf.IResolvable | undefined;
    set internalValue(value: AlbVirtualHostRoute | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _grpcRoute;
    get grpcRoute(): AlbVirtualHostRouteGrpcRouteOutputReference;
    putGrpcRoute(value: AlbVirtualHostRouteGrpcRoute): void;
    resetGrpcRoute(): void;
    get grpcRouteInput(): AlbVirtualHostRouteGrpcRoute | undefined;
    private _httpRoute;
    get httpRoute(): AlbVirtualHostRouteHttpRouteOutputReference;
    putHttpRoute(value: AlbVirtualHostRouteHttpRoute): void;
    resetHttpRoute(): void;
    get httpRouteInput(): AlbVirtualHostRouteHttpRoute | undefined;
}
export declare class AlbVirtualHostRouteList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlbVirtualHostRoute[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlbVirtualHostRouteOutputReference;
}
export interface AlbVirtualHostTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#create AlbVirtualHost#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#delete AlbVirtualHost#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#update AlbVirtualHost#update}
    */
    readonly update?: string;
}
export declare function albVirtualHostTimeoutsToTerraform(struct?: AlbVirtualHostTimeoutsOutputReference | AlbVirtualHostTimeouts | cdktf.IResolvable): any;
export declare class AlbVirtualHostTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): AlbVirtualHostTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: AlbVirtualHostTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host yandex_alb_virtual_host}
*/
export declare class AlbVirtualHost extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_alb_virtual_host";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host yandex_alb_virtual_host} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AlbVirtualHostConfig
    */
    constructor(scope: Construct, id: string, config: AlbVirtualHostConfig);
    private _authority?;
    get authority(): string[];
    set authority(value: string[]);
    resetAuthority(): void;
    get authorityInput(): string[] | undefined;
    private _httpRouterId?;
    get httpRouterId(): string;
    set httpRouterId(value: string);
    get httpRouterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _modifyRequestHeaders;
    get modifyRequestHeaders(): AlbVirtualHostModifyRequestHeadersList;
    putModifyRequestHeaders(value: AlbVirtualHostModifyRequestHeaders[] | cdktf.IResolvable): void;
    resetModifyRequestHeaders(): void;
    get modifyRequestHeadersInput(): cdktf.IResolvable | AlbVirtualHostModifyRequestHeaders[] | undefined;
    private _modifyResponseHeaders;
    get modifyResponseHeaders(): AlbVirtualHostModifyResponseHeadersList;
    putModifyResponseHeaders(value: AlbVirtualHostModifyResponseHeaders[] | cdktf.IResolvable): void;
    resetModifyResponseHeaders(): void;
    get modifyResponseHeadersInput(): cdktf.IResolvable | AlbVirtualHostModifyResponseHeaders[] | undefined;
    private _route;
    get route(): AlbVirtualHostRouteList;
    putRoute(value: AlbVirtualHostRoute[] | cdktf.IResolvable): void;
    resetRoute(): void;
    get routeInput(): cdktf.IResolvable | AlbVirtualHostRoute[] | undefined;
    private _timeouts;
    get timeouts(): AlbVirtualHostTimeoutsOutputReference;
    putTimeouts(value: AlbVirtualHostTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | AlbVirtualHostTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=alb-virtual-host.d.ts.map