import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface CdnOriginGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#id CdnOriginGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#name CdnOriginGroup#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#use_next CdnOriginGroup#use_next}
    */
    readonly useNext?: boolean | cdktf.IResolvable;
    /**
    * origin block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#origin CdnOriginGroup#origin}
    */
    readonly origin: CdnOriginGroupOrigin[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#timeouts CdnOriginGroup#timeouts}
    */
    readonly timeouts?: CdnOriginGroupTimeouts;
}
export interface CdnOriginGroupOrigin {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#backup CdnOriginGroup#backup}
    */
    readonly backup?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#enabled CdnOriginGroup#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#source CdnOriginGroup#source}
    */
    readonly source: string;
}
export declare function cdnOriginGroupOriginToTerraform(struct?: CdnOriginGroupOrigin | cdktf.IResolvable): any;
export declare class CdnOriginGroupOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): CdnOriginGroupOrigin | cdktf.IResolvable | undefined;
    set internalValue(value: CdnOriginGroupOrigin | cdktf.IResolvable | undefined);
    private _backup?;
    get backup(): boolean | cdktf.IResolvable;
    set backup(value: boolean | cdktf.IResolvable);
    resetBackup(): void;
    get backupInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    get originGroupId(): number;
    private _source?;
    get source(): string;
    set source(value: string);
    get sourceInput(): string | undefined;
}
export declare class CdnOriginGroupOriginList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: CdnOriginGroupOrigin[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): CdnOriginGroupOriginOutputReference;
}
export interface CdnOriginGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#create CdnOriginGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#delete CdnOriginGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#update CdnOriginGroup#update}
    */
    readonly update?: string;
}
export declare function cdnOriginGroupTimeoutsToTerraform(struct?: CdnOriginGroupTimeoutsOutputReference | CdnOriginGroupTimeouts | cdktf.IResolvable): any;
export declare class CdnOriginGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): CdnOriginGroupTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: CdnOriginGroupTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group yandex_cdn_origin_group}
*/
export declare class CdnOriginGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_cdn_origin_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group yandex_cdn_origin_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options CdnOriginGroupConfig
    */
    constructor(scope: Construct, id: string, config: CdnOriginGroupConfig);
    get folderId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _useNext?;
    get useNext(): boolean | cdktf.IResolvable;
    set useNext(value: boolean | cdktf.IResolvable);
    resetUseNext(): void;
    get useNextInput(): boolean | cdktf.IResolvable | undefined;
    private _origin;
    get origin(): CdnOriginGroupOriginList;
    putOrigin(value: CdnOriginGroupOrigin[] | cdktf.IResolvable): void;
    get originInput(): cdktf.IResolvable | CdnOriginGroupOrigin[] | undefined;
    private _timeouts;
    get timeouts(): CdnOriginGroupTimeoutsOutputReference;
    putTimeouts(value: CdnOriginGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | CdnOriginGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=cdn-origin-group.d.ts.map