import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ComputeDiskPlacementGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#description ComputeDiskPlacementGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#folder_id ComputeDiskPlacementGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#id ComputeDiskPlacementGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#labels ComputeDiskPlacementGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#name ComputeDiskPlacementGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#zone ComputeDiskPlacementGroup#zone}
    */
    readonly zone?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#timeouts ComputeDiskPlacementGroup#timeouts}
    */
    readonly timeouts?: ComputeDiskPlacementGroupTimeouts;
}
export interface ComputeDiskPlacementGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#create ComputeDiskPlacementGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#delete ComputeDiskPlacementGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#update ComputeDiskPlacementGroup#update}
    */
    readonly update?: string;
}
export declare function computeDiskPlacementGroupTimeoutsToTerraform(struct?: ComputeDiskPlacementGroupTimeoutsOutputReference | ComputeDiskPlacementGroupTimeouts | cdktf.IResolvable): any;
export declare class ComputeDiskPlacementGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeDiskPlacementGroupTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeDiskPlacementGroupTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group yandex_compute_disk_placement_group}
*/
export declare class ComputeDiskPlacementGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_compute_disk_placement_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group yandex_compute_disk_placement_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ComputeDiskPlacementGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: ComputeDiskPlacementGroupConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get status(): string;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    resetZone(): void;
    get zoneInput(): string | undefined;
    private _timeouts;
    get timeouts(): ComputeDiskPlacementGroupTimeoutsOutputReference;
    putTimeouts(value: ComputeDiskPlacementGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ComputeDiskPlacementGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=compute-disk-placement-group.d.ts.map