import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ComputeInstanceGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#deletion_protection ComputeInstanceGroup#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#id ComputeInstanceGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_checking_health_duration ComputeInstanceGroup#max_checking_health_duration}
    */
    readonly maxCheckingHealthDuration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#name ComputeInstanceGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service_account_id ComputeInstanceGroup#service_account_id}
    */
    readonly serviceAccountId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#variables ComputeInstanceGroup#variables}
    */
    readonly variables?: {
        [key: string]: string;
    };
    /**
    * allocation_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#allocation_policy ComputeInstanceGroup#allocation_policy}
    */
    readonly allocationPolicy: ComputeInstanceGroupAllocationPolicy;
    /**
    * application_load_balancer block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#application_load_balancer ComputeInstanceGroup#application_load_balancer}
    */
    readonly applicationLoadBalancer?: ComputeInstanceGroupApplicationLoadBalancer;
    /**
    * deploy_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#deploy_policy ComputeInstanceGroup#deploy_policy}
    */
    readonly deployPolicy: ComputeInstanceGroupDeployPolicy;
    /**
    * health_check block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#health_check ComputeInstanceGroup#health_check}
    */
    readonly healthCheck?: ComputeInstanceGroupHealthCheck[] | cdktf.IResolvable;
    /**
    * instance_template block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#instance_template ComputeInstanceGroup#instance_template}
    */
    readonly instanceTemplate: ComputeInstanceGroupInstanceTemplate;
    /**
    * load_balancer block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#load_balancer ComputeInstanceGroup#load_balancer}
    */
    readonly loadBalancer?: ComputeInstanceGroupLoadBalancer;
    /**
    * scale_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#scale_policy ComputeInstanceGroup#scale_policy}
    */
    readonly scalePolicy: ComputeInstanceGroupScalePolicy;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#timeouts ComputeInstanceGroup#timeouts}
    */
    readonly timeouts?: ComputeInstanceGroupTimeouts;
}
export interface ComputeInstanceGroupInstancesNetworkInterface {
}
export declare function computeInstanceGroupInstancesNetworkInterfaceToTerraform(struct?: ComputeInstanceGroupInstancesNetworkInterface): any;
export declare class ComputeInstanceGroupInstancesNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstancesNetworkInterface | undefined;
    set internalValue(value: ComputeInstanceGroupInstancesNetworkInterface | undefined);
    get index(): number;
    get ipAddress(): string;
    get ipv4(): cdktf.IResolvable;
    get ipv6(): cdktf.IResolvable;
    get ipv6Address(): string;
    get macAddress(): string;
    get nat(): cdktf.IResolvable;
    get natIpAddress(): string;
    get natIpVersion(): string;
    get subnetId(): string;
}
export declare class ComputeInstanceGroupInstancesNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstancesNetworkInterfaceOutputReference;
}
export interface ComputeInstanceGroupInstances {
}
export declare function computeInstanceGroupInstancesToTerraform(struct?: ComputeInstanceGroupInstances): any;
export declare class ComputeInstanceGroupInstancesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstances | undefined;
    set internalValue(value: ComputeInstanceGroupInstances | undefined);
    get fqdn(): string;
    get instanceId(): string;
    get name(): string;
    private _networkInterface;
    get networkInterface(): ComputeInstanceGroupInstancesNetworkInterfaceList;
    get status(): string;
    get statusChangedAt(): string;
    get statusMessage(): string;
    get zoneId(): string;
}
export declare class ComputeInstanceGroupInstancesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstancesOutputReference;
}
export interface ComputeInstanceGroupAllocationPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#zones ComputeInstanceGroup#zones}
    */
    readonly zones: string[];
}
export declare function computeInstanceGroupAllocationPolicyToTerraform(struct?: ComputeInstanceGroupAllocationPolicyOutputReference | ComputeInstanceGroupAllocationPolicy): any;
export declare class ComputeInstanceGroupAllocationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupAllocationPolicy | undefined;
    set internalValue(value: ComputeInstanceGroupAllocationPolicy | undefined);
    private _zones?;
    get zones(): string[];
    set zones(value: string[]);
    get zonesInput(): string[] | undefined;
}
export interface ComputeInstanceGroupApplicationLoadBalancer {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_opening_traffic_duration ComputeInstanceGroup#max_opening_traffic_duration}
    */
    readonly maxOpeningTrafficDuration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_description ComputeInstanceGroup#target_group_description}
    */
    readonly targetGroupDescription?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_labels ComputeInstanceGroup#target_group_labels}
    */
    readonly targetGroupLabels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_name ComputeInstanceGroup#target_group_name}
    */
    readonly targetGroupName?: string;
}
export declare function computeInstanceGroupApplicationLoadBalancerToTerraform(struct?: ComputeInstanceGroupApplicationLoadBalancerOutputReference | ComputeInstanceGroupApplicationLoadBalancer): any;
export declare class ComputeInstanceGroupApplicationLoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupApplicationLoadBalancer | undefined;
    set internalValue(value: ComputeInstanceGroupApplicationLoadBalancer | undefined);
    private _maxOpeningTrafficDuration?;
    get maxOpeningTrafficDuration(): number;
    set maxOpeningTrafficDuration(value: number);
    resetMaxOpeningTrafficDuration(): void;
    get maxOpeningTrafficDurationInput(): number | undefined;
    get statusMessage(): string;
    private _targetGroupDescription?;
    get targetGroupDescription(): string;
    set targetGroupDescription(value: string);
    resetTargetGroupDescription(): void;
    get targetGroupDescriptionInput(): string | undefined;
    get targetGroupId(): string;
    private _targetGroupLabels?;
    get targetGroupLabels(): {
        [key: string]: string;
    };
    set targetGroupLabels(value: {
        [key: string]: string;
    });
    resetTargetGroupLabels(): void;
    get targetGroupLabelsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetGroupName?;
    get targetGroupName(): string;
    set targetGroupName(value: string);
    resetTargetGroupName(): void;
    get targetGroupNameInput(): string | undefined;
}
export interface ComputeInstanceGroupDeployPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_creating ComputeInstanceGroup#max_creating}
    */
    readonly maxCreating?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_deleting ComputeInstanceGroup#max_deleting}
    */
    readonly maxDeleting?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_expansion ComputeInstanceGroup#max_expansion}
    */
    readonly maxExpansion: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_unavailable ComputeInstanceGroup#max_unavailable}
    */
    readonly maxUnavailable: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#startup_duration ComputeInstanceGroup#startup_duration}
    */
    readonly startupDuration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#strategy ComputeInstanceGroup#strategy}
    */
    readonly strategy?: string;
}
export declare function computeInstanceGroupDeployPolicyToTerraform(struct?: ComputeInstanceGroupDeployPolicyOutputReference | ComputeInstanceGroupDeployPolicy): any;
export declare class ComputeInstanceGroupDeployPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupDeployPolicy | undefined;
    set internalValue(value: ComputeInstanceGroupDeployPolicy | undefined);
    private _maxCreating?;
    get maxCreating(): number;
    set maxCreating(value: number);
    resetMaxCreating(): void;
    get maxCreatingInput(): number | undefined;
    private _maxDeleting?;
    get maxDeleting(): number;
    set maxDeleting(value: number);
    resetMaxDeleting(): void;
    get maxDeletingInput(): number | undefined;
    private _maxExpansion?;
    get maxExpansion(): number;
    set maxExpansion(value: number);
    get maxExpansionInput(): number | undefined;
    private _maxUnavailable?;
    get maxUnavailable(): number;
    set maxUnavailable(value: number);
    get maxUnavailableInput(): number | undefined;
    private _startupDuration?;
    get startupDuration(): number;
    set startupDuration(value: number);
    resetStartupDuration(): void;
    get startupDurationInput(): number | undefined;
    private _strategy?;
    get strategy(): string;
    set strategy(value: string);
    resetStrategy(): void;
    get strategyInput(): string | undefined;
}
export interface ComputeInstanceGroupHealthCheckHttpOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#path ComputeInstanceGroup#path}
    */
    readonly path: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#port ComputeInstanceGroup#port}
    */
    readonly port: number;
}
export declare function computeInstanceGroupHealthCheckHttpOptionsToTerraform(struct?: ComputeInstanceGroupHealthCheckHttpOptions | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupHealthCheckHttpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupHealthCheckHttpOptions | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupHealthCheckHttpOptions | cdktf.IResolvable | undefined);
    private _path?;
    get path(): string;
    set path(value: string);
    get pathInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
}
export declare class ComputeInstanceGroupHealthCheckHttpOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupHealthCheckHttpOptions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupHealthCheckHttpOptionsOutputReference;
}
export interface ComputeInstanceGroupHealthCheckTcpOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#port ComputeInstanceGroup#port}
    */
    readonly port: number;
}
export declare function computeInstanceGroupHealthCheckTcpOptionsToTerraform(struct?: ComputeInstanceGroupHealthCheckTcpOptionsOutputReference | ComputeInstanceGroupHealthCheckTcpOptions): any;
export declare class ComputeInstanceGroupHealthCheckTcpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupHealthCheckTcpOptions | undefined;
    set internalValue(value: ComputeInstanceGroupHealthCheckTcpOptions | undefined);
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
}
export interface ComputeInstanceGroupHealthCheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#healthy_threshold ComputeInstanceGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#interval ComputeInstanceGroup#interval}
    */
    readonly interval?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#timeout ComputeInstanceGroup#timeout}
    */
    readonly timeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#unhealthy_threshold ComputeInstanceGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * http_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#http_options ComputeInstanceGroup#http_options}
    */
    readonly httpOptions?: ComputeInstanceGroupHealthCheckHttpOptions[] | cdktf.IResolvable;
    /**
    * tcp_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#tcp_options ComputeInstanceGroup#tcp_options}
    */
    readonly tcpOptions?: ComputeInstanceGroupHealthCheckTcpOptions;
}
export declare function computeInstanceGroupHealthCheckToTerraform(struct?: ComputeInstanceGroupHealthCheck | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupHealthCheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupHealthCheck | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupHealthCheck | cdktf.IResolvable | undefined);
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    private _interval?;
    get interval(): number;
    set interval(value: number);
    resetInterval(): void;
    get intervalInput(): number | undefined;
    private _timeout?;
    get timeout(): number;
    set timeout(value: number);
    resetTimeout(): void;
    get timeoutInput(): number | undefined;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _httpOptions;
    get httpOptions(): ComputeInstanceGroupHealthCheckHttpOptionsList;
    putHttpOptions(value: ComputeInstanceGroupHealthCheckHttpOptions[] | cdktf.IResolvable): void;
    resetHttpOptions(): void;
    get httpOptionsInput(): cdktf.IResolvable | ComputeInstanceGroupHealthCheckHttpOptions[] | undefined;
    private _tcpOptions;
    get tcpOptions(): ComputeInstanceGroupHealthCheckTcpOptionsOutputReference;
    putTcpOptions(value: ComputeInstanceGroupHealthCheckTcpOptions): void;
    resetTcpOptions(): void;
    get tcpOptionsInput(): ComputeInstanceGroupHealthCheckTcpOptions | undefined;
}
export declare class ComputeInstanceGroupHealthCheckList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupHealthCheck[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupHealthCheckOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#image_id ComputeInstanceGroup#image_id}
    */
    readonly imageId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}
    */
    readonly size?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#snapshot_id ComputeInstanceGroup#snapshot_id}
    */
    readonly snapshotId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}
    */
    readonly type?: string;
}
export declare function computeInstanceGroupInstanceTemplateBootDiskInitializeParamsToTerraform(struct?: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference | ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams): any;
export declare class ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _imageId?;
    get imageId(): string;
    set imageId(value: string);
    resetImageId(): void;
    get imageIdInput(): string | undefined;
    private _size?;
    get size(): number;
    set size(value: number);
    resetSize(): void;
    get sizeInput(): number | undefined;
    private _snapshotId?;
    get snapshotId(): string;
    set snapshotId(value: string);
    resetSnapshotId(): void;
    get snapshotIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface ComputeInstanceGroupInstanceTemplateBootDisk {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#device_name ComputeInstanceGroup#device_name}
    */
    readonly deviceName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#disk_id ComputeInstanceGroup#disk_id}
    */
    readonly diskId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#mode ComputeInstanceGroup#mode}
    */
    readonly mode?: string;
    /**
    * initialize_params block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initialize_params ComputeInstanceGroup#initialize_params}
    */
    readonly initializeParams?: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams;
}
export declare function computeInstanceGroupInstanceTemplateBootDiskToTerraform(struct?: ComputeInstanceGroupInstanceTemplateBootDiskOutputReference | ComputeInstanceGroupInstanceTemplateBootDisk): any;
export declare class ComputeInstanceGroupInstanceTemplateBootDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplateBootDisk | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateBootDisk | undefined);
    private _deviceName?;
    get deviceName(): string;
    set deviceName(value: string);
    resetDeviceName(): void;
    get deviceNameInput(): string | undefined;
    private _diskId?;
    get diskId(): string;
    set diskId(value: string);
    resetDiskId(): void;
    get diskIdInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _initializeParams;
    get initializeParams(): ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference;
    putInitializeParams(value: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams): void;
    resetInitializeParams(): void;
    get initializeParamsInput(): ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams | undefined;
}
export interface ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}
    */
    readonly dnsZoneId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}
    */
    readonly fqdn: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}
    */
    readonly ptr?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}
    */
    readonly ttl?: number;
}
export declare function computeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordToTerraform(struct?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord | cdktf.IResolvable | undefined);
    private _dnsZoneId?;
    get dnsZoneId(): string;
    set dnsZoneId(value: string);
    resetDnsZoneId(): void;
    get dnsZoneIdInput(): string | undefined;
    private _fqdn?;
    get fqdn(): string;
    set fqdn(value: string);
    get fqdnInput(): string | undefined;
    private _ptr?;
    get ptr(): boolean | cdktf.IResolvable;
    set ptr(value: boolean | cdktf.IResolvable);
    resetPtr(): void;
    get ptrInput(): boolean | cdktf.IResolvable | undefined;
    private _ttl?;
    get ttl(): number;
    set ttl(value: number);
    resetTtl(): void;
    get ttlInput(): number | undefined;
}
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}
    */
    readonly dnsZoneId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}
    */
    readonly fqdn: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}
    */
    readonly ptr?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}
    */
    readonly ttl?: number;
}
export declare function computeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordToTerraform(struct?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord | cdktf.IResolvable | undefined);
    private _dnsZoneId?;
    get dnsZoneId(): string;
    set dnsZoneId(value: string);
    resetDnsZoneId(): void;
    get dnsZoneIdInput(): string | undefined;
    private _fqdn?;
    get fqdn(): string;
    set fqdn(value: string);
    get fqdnInput(): string | undefined;
    private _ptr?;
    get ptr(): boolean | cdktf.IResolvable;
    set ptr(value: boolean | cdktf.IResolvable);
    resetPtr(): void;
    get ptrInput(): boolean | cdktf.IResolvable | undefined;
    private _ttl?;
    get ttl(): number;
    set ttl(value: number);
    resetTtl(): void;
    get ttlInput(): number | undefined;
}
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}
    */
    readonly dnsZoneId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}
    */
    readonly fqdn: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}
    */
    readonly ptr?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}
    */
    readonly ttl?: number;
}
export declare function computeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordToTerraform(struct?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord | cdktf.IResolvable | undefined);
    private _dnsZoneId?;
    get dnsZoneId(): string;
    set dnsZoneId(value: string);
    resetDnsZoneId(): void;
    get dnsZoneIdInput(): string | undefined;
    private _fqdn?;
    get fqdn(): string;
    set fqdn(value: string);
    get fqdnInput(): string | undefined;
    private _ptr?;
    get ptr(): boolean | cdktf.IResolvable;
    set ptr(value: boolean | cdktf.IResolvable);
    resetPtr(): void;
    get ptrInput(): boolean | cdktf.IResolvable | undefined;
    private _ttl?;
    get ttl(): number;
    set ttl(value: number);
    resetTtl(): void;
    get ttlInput(): number | undefined;
}
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplateNetworkInterface {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ip_address ComputeInstanceGroup#ip_address}
    */
    readonly ipAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv4 ComputeInstanceGroup#ipv4}
    */
    readonly ipv4?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6 ComputeInstanceGroup#ipv6}
    */
    readonly ipv6?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6_address ComputeInstanceGroup#ipv6_address}
    */
    readonly ipv6Address?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat ComputeInstanceGroup#nat}
    */
    readonly nat?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat_ip_address ComputeInstanceGroup#nat_ip_address}
    */
    readonly natIpAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_id ComputeInstanceGroup#network_id}
    */
    readonly networkId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#security_group_ids ComputeInstanceGroup#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#subnet_ids ComputeInstanceGroup#subnet_ids}
    */
    readonly subnetIds?: string[];
    /**
    * dns_record block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_record ComputeInstanceGroup#dns_record}
    */
    readonly dnsRecord?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[] | cdktf.IResolvable;
    /**
    * ipv6_dns_record block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6_dns_record ComputeInstanceGroup#ipv6_dns_record}
    */
    readonly ipv6DnsRecord?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[] | cdktf.IResolvable;
    /**
    * nat_dns_record block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat_dns_record ComputeInstanceGroup#nat_dns_record}
    */
    readonly natDnsRecord?: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[] | cdktf.IResolvable;
}
export declare function computeInstanceGroupInstanceTemplateNetworkInterfaceToTerraform(struct?: ComputeInstanceGroupInstanceTemplateNetworkInterface | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstanceTemplateNetworkInterface | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateNetworkInterface | cdktf.IResolvable | undefined);
    private _ipAddress?;
    get ipAddress(): string;
    set ipAddress(value: string);
    resetIpAddress(): void;
    get ipAddressInput(): string | undefined;
    private _ipv4?;
    get ipv4(): boolean | cdktf.IResolvable;
    set ipv4(value: boolean | cdktf.IResolvable);
    resetIpv4(): void;
    get ipv4Input(): boolean | cdktf.IResolvable | undefined;
    private _ipv6?;
    get ipv6(): boolean | cdktf.IResolvable;
    set ipv6(value: boolean | cdktf.IResolvable);
    resetIpv6(): void;
    get ipv6Input(): boolean | cdktf.IResolvable | undefined;
    private _ipv6Address?;
    get ipv6Address(): string;
    set ipv6Address(value: string);
    resetIpv6Address(): void;
    get ipv6AddressInput(): string | undefined;
    private _nat?;
    get nat(): boolean | cdktf.IResolvable;
    set nat(value: boolean | cdktf.IResolvable);
    resetNat(): void;
    get natInput(): boolean | cdktf.IResolvable | undefined;
    private _natIpAddress?;
    get natIpAddress(): string;
    set natIpAddress(value: string);
    resetNatIpAddress(): void;
    get natIpAddressInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    resetNetworkId(): void;
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    get subnetIds(): string[];
    set subnetIds(value: string[]);
    resetSubnetIds(): void;
    get subnetIdsInput(): string[] | undefined;
    private _dnsRecord;
    get dnsRecord(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList;
    putDnsRecord(value: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[] | cdktf.IResolvable): void;
    resetDnsRecord(): void;
    get dnsRecordInput(): cdktf.IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[] | undefined;
    private _ipv6DnsRecord;
    get ipv6DnsRecord(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList;
    putIpv6DnsRecord(value: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[] | cdktf.IResolvable): void;
    resetIpv6DnsRecord(): void;
    get ipv6DnsRecordInput(): cdktf.IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[] | undefined;
    private _natDnsRecord;
    get natDnsRecord(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList;
    putNatDnsRecord(value: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[] | cdktf.IResolvable): void;
    resetNatDnsRecord(): void;
    get natDnsRecordInput(): cdktf.IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[] | undefined;
}
export declare class ComputeInstanceGroupInstanceTemplateNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupInstanceTemplateNetworkInterface[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplateNetworkSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}
    */
    readonly type?: string;
}
export declare function computeInstanceGroupInstanceTemplateNetworkSettingsToTerraform(struct?: ComputeInstanceGroupInstanceTemplateNetworkSettings | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstanceTemplateNetworkSettings | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateNetworkSettings | cdktf.IResolvable | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export declare class ComputeInstanceGroupInstanceTemplateNetworkSettingsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupInstanceTemplateNetworkSettings[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplatePlacementPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#placement_group_id ComputeInstanceGroup#placement_group_id}
    */
    readonly placementGroupId: string;
}
export declare function computeInstanceGroupInstanceTemplatePlacementPolicyToTerraform(struct?: ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference | ComputeInstanceGroupInstanceTemplatePlacementPolicy): any;
export declare class ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplatePlacementPolicy | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplatePlacementPolicy | undefined);
    private _placementGroupId?;
    get placementGroupId(): string;
    set placementGroupId(value: string);
    get placementGroupIdInput(): string | undefined;
}
export interface ComputeInstanceGroupInstanceTemplateResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#core_fraction ComputeInstanceGroup#core_fraction}
    */
    readonly coreFraction?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cores ComputeInstanceGroup#cores}
    */
    readonly cores: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#gpus ComputeInstanceGroup#gpus}
    */
    readonly gpus?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#memory ComputeInstanceGroup#memory}
    */
    readonly memory: number;
}
export declare function computeInstanceGroupInstanceTemplateResourcesToTerraform(struct?: ComputeInstanceGroupInstanceTemplateResourcesOutputReference | ComputeInstanceGroupInstanceTemplateResources): any;
export declare class ComputeInstanceGroupInstanceTemplateResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplateResources | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateResources | undefined);
    private _coreFraction?;
    get coreFraction(): number;
    set coreFraction(value: number);
    resetCoreFraction(): void;
    get coreFractionInput(): number | undefined;
    private _cores?;
    get cores(): number;
    set cores(value: number);
    get coresInput(): number | undefined;
    private _gpus?;
    get gpus(): number;
    set gpus(value: number);
    resetGpus(): void;
    get gpusInput(): number | undefined;
    private _memory?;
    get memory(): number;
    set memory(value: number);
    get memoryInput(): number | undefined;
}
export interface ComputeInstanceGroupInstanceTemplateSchedulingPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#preemptible ComputeInstanceGroup#preemptible}
    */
    readonly preemptible?: boolean | cdktf.IResolvable;
}
export declare function computeInstanceGroupInstanceTemplateSchedulingPolicyToTerraform(struct?: ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference | ComputeInstanceGroupInstanceTemplateSchedulingPolicy): any;
export declare class ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplateSchedulingPolicy | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateSchedulingPolicy | undefined);
    private _preemptible?;
    get preemptible(): boolean | cdktf.IResolvable;
    set preemptible(value: boolean | cdktf.IResolvable);
    resetPreemptible(): void;
    get preemptibleInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#image_id ComputeInstanceGroup#image_id}
    */
    readonly imageId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}
    */
    readonly size?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#snapshot_id ComputeInstanceGroup#snapshot_id}
    */
    readonly snapshotId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}
    */
    readonly type?: string;
}
export declare function computeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsToTerraform(struct?: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference | ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams): any;
export declare class ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _imageId?;
    get imageId(): string;
    set imageId(value: string);
    resetImageId(): void;
    get imageIdInput(): string | undefined;
    private _size?;
    get size(): number;
    set size(value: number);
    resetSize(): void;
    get sizeInput(): number | undefined;
    private _snapshotId?;
    get snapshotId(): string;
    set snapshotId(value: string);
    resetSnapshotId(): void;
    get snapshotIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface ComputeInstanceGroupInstanceTemplateSecondaryDisk {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#device_name ComputeInstanceGroup#device_name}
    */
    readonly deviceName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#disk_id ComputeInstanceGroup#disk_id}
    */
    readonly diskId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#mode ComputeInstanceGroup#mode}
    */
    readonly mode?: string;
    /**
    * initialize_params block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initialize_params ComputeInstanceGroup#initialize_params}
    */
    readonly initializeParams?: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams;
}
export declare function computeInstanceGroupInstanceTemplateSecondaryDiskToTerraform(struct?: ComputeInstanceGroupInstanceTemplateSecondaryDisk | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupInstanceTemplateSecondaryDisk | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplateSecondaryDisk | cdktf.IResolvable | undefined);
    private _deviceName?;
    get deviceName(): string;
    set deviceName(value: string);
    resetDeviceName(): void;
    get deviceNameInput(): string | undefined;
    private _diskId?;
    get diskId(): string;
    set diskId(value: string);
    resetDiskId(): void;
    get diskIdInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _initializeParams;
    get initializeParams(): ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference;
    putInitializeParams(value: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams): void;
    resetInitializeParams(): void;
    get initializeParamsInput(): ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams | undefined;
}
export declare class ComputeInstanceGroupInstanceTemplateSecondaryDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupInstanceTemplateSecondaryDisk[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference;
}
export interface ComputeInstanceGroupInstanceTemplate {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#hostname ComputeInstanceGroup#hostname}
    */
    readonly hostname?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metadata ComputeInstanceGroup#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#name ComputeInstanceGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#platform_id ComputeInstanceGroup#platform_id}
    */
    readonly platformId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service_account_id ComputeInstanceGroup#service_account_id}
    */
    readonly serviceAccountId?: string;
    /**
    * boot_disk block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#boot_disk ComputeInstanceGroup#boot_disk}
    */
    readonly bootDisk: ComputeInstanceGroupInstanceTemplateBootDisk;
    /**
    * network_interface block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_interface ComputeInstanceGroup#network_interface}
    */
    readonly networkInterface: ComputeInstanceGroupInstanceTemplateNetworkInterface[] | cdktf.IResolvable;
    /**
    * network_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_settings ComputeInstanceGroup#network_settings}
    */
    readonly networkSettings?: ComputeInstanceGroupInstanceTemplateNetworkSettings[] | cdktf.IResolvable;
    /**
    * placement_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#placement_policy ComputeInstanceGroup#placement_policy}
    */
    readonly placementPolicy?: ComputeInstanceGroupInstanceTemplatePlacementPolicy;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#resources ComputeInstanceGroup#resources}
    */
    readonly resources: ComputeInstanceGroupInstanceTemplateResources;
    /**
    * scheduling_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#scheduling_policy ComputeInstanceGroup#scheduling_policy}
    */
    readonly schedulingPolicy?: ComputeInstanceGroupInstanceTemplateSchedulingPolicy;
    /**
    * secondary_disk block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#secondary_disk ComputeInstanceGroup#secondary_disk}
    */
    readonly secondaryDisk?: ComputeInstanceGroupInstanceTemplateSecondaryDisk[] | cdktf.IResolvable;
}
export declare function computeInstanceGroupInstanceTemplateToTerraform(struct?: ComputeInstanceGroupInstanceTemplateOutputReference | ComputeInstanceGroupInstanceTemplate): any;
export declare class ComputeInstanceGroupInstanceTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupInstanceTemplate | undefined;
    set internalValue(value: ComputeInstanceGroupInstanceTemplate | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _platformId?;
    get platformId(): string;
    set platformId(value: string);
    resetPlatformId(): void;
    get platformIdInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    resetServiceAccountId(): void;
    get serviceAccountIdInput(): string | undefined;
    private _bootDisk;
    get bootDisk(): ComputeInstanceGroupInstanceTemplateBootDiskOutputReference;
    putBootDisk(value: ComputeInstanceGroupInstanceTemplateBootDisk): void;
    get bootDiskInput(): ComputeInstanceGroupInstanceTemplateBootDisk | undefined;
    private _networkInterface;
    get networkInterface(): ComputeInstanceGroupInstanceTemplateNetworkInterfaceList;
    putNetworkInterface(value: ComputeInstanceGroupInstanceTemplateNetworkInterface[] | cdktf.IResolvable): void;
    get networkInterfaceInput(): cdktf.IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterface[] | undefined;
    private _networkSettings;
    get networkSettings(): ComputeInstanceGroupInstanceTemplateNetworkSettingsList;
    putNetworkSettings(value: ComputeInstanceGroupInstanceTemplateNetworkSettings[] | cdktf.IResolvable): void;
    resetNetworkSettings(): void;
    get networkSettingsInput(): cdktf.IResolvable | ComputeInstanceGroupInstanceTemplateNetworkSettings[] | undefined;
    private _placementPolicy;
    get placementPolicy(): ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference;
    putPlacementPolicy(value: ComputeInstanceGroupInstanceTemplatePlacementPolicy): void;
    resetPlacementPolicy(): void;
    get placementPolicyInput(): ComputeInstanceGroupInstanceTemplatePlacementPolicy | undefined;
    private _resources;
    get resources(): ComputeInstanceGroupInstanceTemplateResourcesOutputReference;
    putResources(value: ComputeInstanceGroupInstanceTemplateResources): void;
    get resourcesInput(): ComputeInstanceGroupInstanceTemplateResources | undefined;
    private _schedulingPolicy;
    get schedulingPolicy(): ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference;
    putSchedulingPolicy(value: ComputeInstanceGroupInstanceTemplateSchedulingPolicy): void;
    resetSchedulingPolicy(): void;
    get schedulingPolicyInput(): ComputeInstanceGroupInstanceTemplateSchedulingPolicy | undefined;
    private _secondaryDisk;
    get secondaryDisk(): ComputeInstanceGroupInstanceTemplateSecondaryDiskList;
    putSecondaryDisk(value: ComputeInstanceGroupInstanceTemplateSecondaryDisk[] | cdktf.IResolvable): void;
    resetSecondaryDisk(): void;
    get secondaryDiskInput(): cdktf.IResolvable | ComputeInstanceGroupInstanceTemplateSecondaryDisk[] | undefined;
}
export interface ComputeInstanceGroupLoadBalancer {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_opening_traffic_duration ComputeInstanceGroup#max_opening_traffic_duration}
    */
    readonly maxOpeningTrafficDuration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_description ComputeInstanceGroup#target_group_description}
    */
    readonly targetGroupDescription?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_labels ComputeInstanceGroup#target_group_labels}
    */
    readonly targetGroupLabels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_name ComputeInstanceGroup#target_group_name}
    */
    readonly targetGroupName?: string;
}
export declare function computeInstanceGroupLoadBalancerToTerraform(struct?: ComputeInstanceGroupLoadBalancerOutputReference | ComputeInstanceGroupLoadBalancer): any;
export declare class ComputeInstanceGroupLoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupLoadBalancer | undefined;
    set internalValue(value: ComputeInstanceGroupLoadBalancer | undefined);
    private _maxOpeningTrafficDuration?;
    get maxOpeningTrafficDuration(): number;
    set maxOpeningTrafficDuration(value: number);
    resetMaxOpeningTrafficDuration(): void;
    get maxOpeningTrafficDurationInput(): number | undefined;
    get statusMessage(): string;
    private _targetGroupDescription?;
    get targetGroupDescription(): string;
    set targetGroupDescription(value: string);
    resetTargetGroupDescription(): void;
    get targetGroupDescriptionInput(): string | undefined;
    get targetGroupId(): string;
    private _targetGroupLabels?;
    get targetGroupLabels(): {
        [key: string]: string;
    };
    set targetGroupLabels(value: {
        [key: string]: string;
    });
    resetTargetGroupLabels(): void;
    get targetGroupLabelsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetGroupName?;
    get targetGroupName(): string;
    set targetGroupName(value: string);
    resetTargetGroupName(): void;
    get targetGroupNameInput(): string | undefined;
}
export interface ComputeInstanceGroupScalePolicyAutoScaleCustomRule {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_name ComputeInstanceGroup#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_type ComputeInstanceGroup#metric_type}
    */
    readonly metricType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#rule_type ComputeInstanceGroup#rule_type}
    */
    readonly ruleType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service ComputeInstanceGroup#service}
    */
    readonly service?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target ComputeInstanceGroup#target}
    */
    readonly target: number;
}
export declare function computeInstanceGroupScalePolicyAutoScaleCustomRuleToTerraform(struct?: ComputeInstanceGroupScalePolicyAutoScaleCustomRule | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupScalePolicyAutoScaleCustomRule | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupScalePolicyAutoScaleCustomRule | cdktf.IResolvable | undefined);
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _metricType?;
    get metricType(): string;
    set metricType(value: string);
    get metricTypeInput(): string | undefined;
    private _ruleType?;
    get ruleType(): string;
    set ruleType(value: string);
    get ruleTypeInput(): string | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    resetService(): void;
    get serviceInput(): string | undefined;
    private _target?;
    get target(): number;
    set target(value: number);
    get targetInput(): number | undefined;
}
export declare class ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupScalePolicyAutoScaleCustomRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference;
}
export interface ComputeInstanceGroupScalePolicyAutoScale {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cpu_utilization_target ComputeInstanceGroup#cpu_utilization_target}
    */
    readonly cpuUtilizationTarget?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initial_size ComputeInstanceGroup#initial_size}
    */
    readonly initialSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_size ComputeInstanceGroup#max_size}
    */
    readonly maxSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#measurement_duration ComputeInstanceGroup#measurement_duration}
    */
    readonly measurementDuration: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#min_zone_size ComputeInstanceGroup#min_zone_size}
    */
    readonly minZoneSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#stabilization_duration ComputeInstanceGroup#stabilization_duration}
    */
    readonly stabilizationDuration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#warmup_duration ComputeInstanceGroup#warmup_duration}
    */
    readonly warmupDuration?: number;
    /**
    * custom_rule block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#custom_rule ComputeInstanceGroup#custom_rule}
    */
    readonly customRule?: ComputeInstanceGroupScalePolicyAutoScaleCustomRule[] | cdktf.IResolvable;
}
export declare function computeInstanceGroupScalePolicyAutoScaleToTerraform(struct?: ComputeInstanceGroupScalePolicyAutoScaleOutputReference | ComputeInstanceGroupScalePolicyAutoScale): any;
export declare class ComputeInstanceGroupScalePolicyAutoScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupScalePolicyAutoScale | undefined;
    set internalValue(value: ComputeInstanceGroupScalePolicyAutoScale | undefined);
    private _cpuUtilizationTarget?;
    get cpuUtilizationTarget(): number;
    set cpuUtilizationTarget(value: number);
    resetCpuUtilizationTarget(): void;
    get cpuUtilizationTargetInput(): number | undefined;
    private _initialSize?;
    get initialSize(): number;
    set initialSize(value: number);
    get initialSizeInput(): number | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    resetMaxSize(): void;
    get maxSizeInput(): number | undefined;
    private _measurementDuration?;
    get measurementDuration(): number;
    set measurementDuration(value: number);
    get measurementDurationInput(): number | undefined;
    private _minZoneSize?;
    get minZoneSize(): number;
    set minZoneSize(value: number);
    resetMinZoneSize(): void;
    get minZoneSizeInput(): number | undefined;
    private _stabilizationDuration?;
    get stabilizationDuration(): number;
    set stabilizationDuration(value: number);
    resetStabilizationDuration(): void;
    get stabilizationDurationInput(): number | undefined;
    private _warmupDuration?;
    get warmupDuration(): number;
    set warmupDuration(value: number);
    resetWarmupDuration(): void;
    get warmupDurationInput(): number | undefined;
    private _customRule;
    get customRule(): ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList;
    putCustomRule(value: ComputeInstanceGroupScalePolicyAutoScaleCustomRule[] | cdktf.IResolvable): void;
    resetCustomRule(): void;
    get customRuleInput(): cdktf.IResolvable | ComputeInstanceGroupScalePolicyAutoScaleCustomRule[] | undefined;
}
export interface ComputeInstanceGroupScalePolicyFixedScale {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}
    */
    readonly size: number;
}
export declare function computeInstanceGroupScalePolicyFixedScaleToTerraform(struct?: ComputeInstanceGroupScalePolicyFixedScaleOutputReference | ComputeInstanceGroupScalePolicyFixedScale): any;
export declare class ComputeInstanceGroupScalePolicyFixedScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupScalePolicyFixedScale | undefined;
    set internalValue(value: ComputeInstanceGroupScalePolicyFixedScale | undefined);
    private _size?;
    get size(): number;
    set size(value: number);
    get sizeInput(): number | undefined;
}
export interface ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_name ComputeInstanceGroup#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_type ComputeInstanceGroup#metric_type}
    */
    readonly metricType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#rule_type ComputeInstanceGroup#rule_type}
    */
    readonly ruleType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service ComputeInstanceGroup#service}
    */
    readonly service?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target ComputeInstanceGroup#target}
    */
    readonly target: number;
}
export declare function computeInstanceGroupScalePolicyTestAutoScaleCustomRuleToTerraform(struct?: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule | cdktf.IResolvable | undefined);
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _metricType?;
    get metricType(): string;
    set metricType(value: string);
    get metricTypeInput(): string | undefined;
    private _ruleType?;
    get ruleType(): string;
    set ruleType(value: string);
    get ruleTypeInput(): string | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    resetService(): void;
    get serviceInput(): string | undefined;
    private _target?;
    get target(): number;
    set target(value: number);
    get targetInput(): number | undefined;
}
export declare class ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference;
}
export interface ComputeInstanceGroupScalePolicyTestAutoScale {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cpu_utilization_target ComputeInstanceGroup#cpu_utilization_target}
    */
    readonly cpuUtilizationTarget?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initial_size ComputeInstanceGroup#initial_size}
    */
    readonly initialSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_size ComputeInstanceGroup#max_size}
    */
    readonly maxSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#measurement_duration ComputeInstanceGroup#measurement_duration}
    */
    readonly measurementDuration: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#min_zone_size ComputeInstanceGroup#min_zone_size}
    */
    readonly minZoneSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#stabilization_duration ComputeInstanceGroup#stabilization_duration}
    */
    readonly stabilizationDuration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#warmup_duration ComputeInstanceGroup#warmup_duration}
    */
    readonly warmupDuration?: number;
    /**
    * custom_rule block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#custom_rule ComputeInstanceGroup#custom_rule}
    */
    readonly customRule?: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[] | cdktf.IResolvable;
}
export declare function computeInstanceGroupScalePolicyTestAutoScaleToTerraform(struct?: ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference | ComputeInstanceGroupScalePolicyTestAutoScale): any;
export declare class ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupScalePolicyTestAutoScale | undefined;
    set internalValue(value: ComputeInstanceGroupScalePolicyTestAutoScale | undefined);
    private _cpuUtilizationTarget?;
    get cpuUtilizationTarget(): number;
    set cpuUtilizationTarget(value: number);
    resetCpuUtilizationTarget(): void;
    get cpuUtilizationTargetInput(): number | undefined;
    private _initialSize?;
    get initialSize(): number;
    set initialSize(value: number);
    get initialSizeInput(): number | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    resetMaxSize(): void;
    get maxSizeInput(): number | undefined;
    private _measurementDuration?;
    get measurementDuration(): number;
    set measurementDuration(value: number);
    get measurementDurationInput(): number | undefined;
    private _minZoneSize?;
    get minZoneSize(): number;
    set minZoneSize(value: number);
    resetMinZoneSize(): void;
    get minZoneSizeInput(): number | undefined;
    private _stabilizationDuration?;
    get stabilizationDuration(): number;
    set stabilizationDuration(value: number);
    resetStabilizationDuration(): void;
    get stabilizationDurationInput(): number | undefined;
    private _warmupDuration?;
    get warmupDuration(): number;
    set warmupDuration(value: number);
    resetWarmupDuration(): void;
    get warmupDurationInput(): number | undefined;
    private _customRule;
    get customRule(): ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList;
    putCustomRule(value: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[] | cdktf.IResolvable): void;
    resetCustomRule(): void;
    get customRuleInput(): cdktf.IResolvable | ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[] | undefined;
}
export interface ComputeInstanceGroupScalePolicy {
    /**
    * auto_scale block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#auto_scale ComputeInstanceGroup#auto_scale}
    */
    readonly autoScale?: ComputeInstanceGroupScalePolicyAutoScale;
    /**
    * fixed_scale block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fixed_scale ComputeInstanceGroup#fixed_scale}
    */
    readonly fixedScale?: ComputeInstanceGroupScalePolicyFixedScale;
    /**
    * test_auto_scale block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#test_auto_scale ComputeInstanceGroup#test_auto_scale}
    */
    readonly testAutoScale?: ComputeInstanceGroupScalePolicyTestAutoScale;
}
export declare function computeInstanceGroupScalePolicyToTerraform(struct?: ComputeInstanceGroupScalePolicyOutputReference | ComputeInstanceGroupScalePolicy): any;
export declare class ComputeInstanceGroupScalePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupScalePolicy | undefined;
    set internalValue(value: ComputeInstanceGroupScalePolicy | undefined);
    private _autoScale;
    get autoScale(): ComputeInstanceGroupScalePolicyAutoScaleOutputReference;
    putAutoScale(value: ComputeInstanceGroupScalePolicyAutoScale): void;
    resetAutoScale(): void;
    get autoScaleInput(): ComputeInstanceGroupScalePolicyAutoScale | undefined;
    private _fixedScale;
    get fixedScale(): ComputeInstanceGroupScalePolicyFixedScaleOutputReference;
    putFixedScale(value: ComputeInstanceGroupScalePolicyFixedScale): void;
    resetFixedScale(): void;
    get fixedScaleInput(): ComputeInstanceGroupScalePolicyFixedScale | undefined;
    private _testAutoScale;
    get testAutoScale(): ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference;
    putTestAutoScale(value: ComputeInstanceGroupScalePolicyTestAutoScale): void;
    resetTestAutoScale(): void;
    get testAutoScaleInput(): ComputeInstanceGroupScalePolicyTestAutoScale | undefined;
}
export interface ComputeInstanceGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#create ComputeInstanceGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#delete ComputeInstanceGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#update ComputeInstanceGroup#update}
    */
    readonly update?: string;
}
export declare function computeInstanceGroupTimeoutsToTerraform(struct?: ComputeInstanceGroupTimeoutsOutputReference | ComputeInstanceGroupTimeouts | cdktf.IResolvable): any;
export declare class ComputeInstanceGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ComputeInstanceGroupTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ComputeInstanceGroupTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group yandex_compute_instance_group}
*/
export declare class ComputeInstanceGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_compute_instance_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group yandex_compute_instance_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ComputeInstanceGroupConfig
    */
    constructor(scope: Construct, id: string, config: ComputeInstanceGroupConfig);
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _instances;
    get instances(): ComputeInstanceGroupInstancesList;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _maxCheckingHealthDuration?;
    get maxCheckingHealthDuration(): number;
    set maxCheckingHealthDuration(value: number);
    resetMaxCheckingHealthDuration(): void;
    get maxCheckingHealthDurationInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
    get status(): string;
    private _variables?;
    get variables(): {
        [key: string]: string;
    };
    set variables(value: {
        [key: string]: string;
    });
    resetVariables(): void;
    get variablesInput(): {
        [key: string]: string;
    } | undefined;
    private _allocationPolicy;
    get allocationPolicy(): ComputeInstanceGroupAllocationPolicyOutputReference;
    putAllocationPolicy(value: ComputeInstanceGroupAllocationPolicy): void;
    get allocationPolicyInput(): ComputeInstanceGroupAllocationPolicy | undefined;
    private _applicationLoadBalancer;
    get applicationLoadBalancer(): ComputeInstanceGroupApplicationLoadBalancerOutputReference;
    putApplicationLoadBalancer(value: ComputeInstanceGroupApplicationLoadBalancer): void;
    resetApplicationLoadBalancer(): void;
    get applicationLoadBalancerInput(): ComputeInstanceGroupApplicationLoadBalancer | undefined;
    private _deployPolicy;
    get deployPolicy(): ComputeInstanceGroupDeployPolicyOutputReference;
    putDeployPolicy(value: ComputeInstanceGroupDeployPolicy): void;
    get deployPolicyInput(): ComputeInstanceGroupDeployPolicy | undefined;
    private _healthCheck;
    get healthCheck(): ComputeInstanceGroupHealthCheckList;
    putHealthCheck(value: ComputeInstanceGroupHealthCheck[] | cdktf.IResolvable): void;
    resetHealthCheck(): void;
    get healthCheckInput(): cdktf.IResolvable | ComputeInstanceGroupHealthCheck[] | undefined;
    private _instanceTemplate;
    get instanceTemplate(): ComputeInstanceGroupInstanceTemplateOutputReference;
    putInstanceTemplate(value: ComputeInstanceGroupInstanceTemplate): void;
    get instanceTemplateInput(): ComputeInstanceGroupInstanceTemplate | undefined;
    private _loadBalancer;
    get loadBalancer(): ComputeInstanceGroupLoadBalancerOutputReference;
    putLoadBalancer(value: ComputeInstanceGroupLoadBalancer): void;
    resetLoadBalancer(): void;
    get loadBalancerInput(): ComputeInstanceGroupLoadBalancer | undefined;
    private _scalePolicy;
    get scalePolicy(): ComputeInstanceGroupScalePolicyOutputReference;
    putScalePolicy(value: ComputeInstanceGroupScalePolicy): void;
    get scalePolicyInput(): ComputeInstanceGroupScalePolicy | undefined;
    private _timeouts;
    get timeouts(): ComputeInstanceGroupTimeoutsOutputReference;
    putTimeouts(value: ComputeInstanceGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ComputeInstanceGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=compute-instance-group.d.ts.map