import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ContainerRepositoryIamBindingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#id ContainerRepositoryIamBinding#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#members ContainerRepositoryIamBinding#members}
    */
    readonly members: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#repository_id ContainerRepositoryIamBinding#repository_id}
    */
    readonly repositoryId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#role ContainerRepositoryIamBinding#role}
    */
    readonly role: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#sleep_after ContainerRepositoryIamBinding#sleep_after}
    */
    readonly sleepAfter?: number;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding yandex_container_repository_iam_binding}
*/
export declare class ContainerRepositoryIamBinding extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_container_repository_iam_binding";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding yandex_container_repository_iam_binding} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ContainerRepositoryIamBindingConfig
    */
    constructor(scope: Construct, id: string, config: ContainerRepositoryIamBindingConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _members?;
    get members(): string[];
    set members(value: string[]);
    get membersInput(): string[] | undefined;
    private _repositoryId?;
    get repositoryId(): string;
    set repositoryId(value: string);
    get repositoryIdInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _sleepAfter?;
    get sleepAfter(): number;
    set sleepAfter(value: number);
    resetSleepAfter(): void;
    get sleepAfterInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=container-repository-iam-binding.d.ts.map