import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ContainerRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#id ContainerRepository#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#name ContainerRepository#name}
    */
    readonly name?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#timeouts ContainerRepository#timeouts}
    */
    readonly timeouts?: ContainerRepositoryTimeouts;
}
export interface ContainerRepositoryTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#create ContainerRepository#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#delete ContainerRepository#delete}
    */
    readonly delete?: string;
}
export declare function containerRepositoryTimeoutsToTerraform(struct?: ContainerRepositoryTimeoutsOutputReference | ContainerRepositoryTimeouts | cdktf.IResolvable): any;
export declare class ContainerRepositoryTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ContainerRepositoryTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: ContainerRepositoryTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/container_repository yandex_container_repository}
*/
export declare class ContainerRepository extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_container_repository";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/container_repository yandex_container_repository} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ContainerRepositoryConfig = {}
    */
    constructor(scope: Construct, id: string, config?: ContainerRepositoryConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _timeouts;
    get timeouts(): ContainerRepositoryTimeoutsOutputReference;
    putTimeouts(value: ContainerRepositoryTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | ContainerRepositoryTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=container-repository.d.ts.map