import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexAlbBackendGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#backend_group_id DataYandexAlbBackendGroup#backend_group_id}
    */
    readonly backendGroupId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#description DataYandexAlbBackendGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#folder_id DataYandexAlbBackendGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#id DataYandexAlbBackendGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#labels DataYandexAlbBackendGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#name DataYandexAlbBackendGroup#name}
    */
    readonly name?: string;
    /**
    * grpc_backend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_backend DataYandexAlbBackendGroup#grpc_backend}
    */
    readonly grpcBackend?: DataYandexAlbBackendGroupGrpcBackend[] | cdktf.IResolvable;
    /**
    * http_backend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_backend DataYandexAlbBackendGroup#http_backend}
    */
    readonly httpBackend?: DataYandexAlbBackendGroupHttpBackend[] | cdktf.IResolvable;
    /**
    * stream_backend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_backend DataYandexAlbBackendGroup#stream_backend}
    */
    readonly streamBackend?: DataYandexAlbBackendGroupStreamBackend[] | cdktf.IResolvable;
}
export interface DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}
    */
    readonly serviceName?: string;
}
export declare function dataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference | DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck): any;
export declare class DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck | undefined);
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    resetServiceName(): void;
    get serviceNameInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
}
export declare function dataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference | DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck): any;
export declare class DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    get path(): string;
}
export interface DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}
    */
    readonly receive?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}
    */
    readonly send?: string;
}
export declare function dataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference | DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck): any;
export declare class DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck | undefined);
    private _receive?;
    get receive(): string;
    set receive(value: string);
    resetReceive(): void;
    get receiveInput(): string | undefined;
    private _send?;
    get send(): string;
    set send(value: string);
    resetSend(): void;
    get sendInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupGrpcBackendHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}
    */
    readonly healthcheckPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}
    */
    readonly intervalJitterPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * grpc_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_healthcheck DataYandexAlbBackendGroup#grpc_healthcheck}
    */
    readonly grpcHealthcheck?: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
    /**
    * http_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_healthcheck DataYandexAlbBackendGroup#http_healthcheck}
    */
    readonly httpHealthcheck?: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
    /**
    * stream_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_healthcheck DataYandexAlbBackendGroup#stream_healthcheck}
    */
    readonly streamHealthcheck?: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
}
export declare function dataYandexAlbBackendGroupGrpcBackendHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference | DataYandexAlbBackendGroupGrpcBackendHealthcheck): any;
export declare class DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendHealthcheck | undefined);
    private _healthcheckPort?;
    get healthcheckPort(): number;
    set healthcheckPort(value: number);
    resetHealthcheckPort(): void;
    get healthcheckPortInput(): number | undefined;
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    get interval(): string;
    private _intervalJitterPercent?;
    get intervalJitterPercent(): number;
    set intervalJitterPercent(value: number);
    resetIntervalJitterPercent(): void;
    get intervalJitterPercentInput(): number | undefined;
    get timeout(): string;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _grpcHealthcheck;
    get grpcHealthcheck(): DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference;
    putGrpcHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck): void;
    resetGrpcHealthcheck(): void;
    get grpcHealthcheckInput(): DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck | undefined;
    private _httpHealthcheck;
    get httpHealthcheck(): DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference;
    putHttpHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck): void;
    resetHttpHealthcheck(): void;
    get httpHealthcheckInput(): DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck | undefined;
    private _streamHealthcheck;
    get streamHealthcheck(): DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference;
    putStreamHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck): void;
    resetStreamHealthcheck(): void;
    get streamHealthcheckInput(): DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck | undefined;
}
export interface DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}
    */
    readonly localityAwareRoutingPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}
    */
    readonly panicThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}
    */
    readonly strictLocality?: boolean | cdktf.IResolvable;
}
export declare function dataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference | DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig): any;
export declare class DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig | undefined);
    private _localityAwareRoutingPercent?;
    get localityAwareRoutingPercent(): number;
    set localityAwareRoutingPercent(value: number);
    resetLocalityAwareRoutingPercent(): void;
    get localityAwareRoutingPercentInput(): number | undefined;
    private _panicThreshold?;
    get panicThreshold(): number;
    set panicThreshold(value: number);
    resetPanicThreshold(): void;
    get panicThresholdInput(): number | undefined;
    private _strictLocality?;
    get strictLocality(): boolean | cdktf.IResolvable;
    set strictLocality(value: boolean | cdktf.IResolvable);
    resetStrictLocality(): void;
    get strictLocalityInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataYandexAlbBackendGroupGrpcBackendTlsValidationContext {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}
    */
    readonly trustedCaBytes?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}
    */
    readonly trustedCaId?: string;
}
export declare function dataYandexAlbBackendGroupGrpcBackendTlsValidationContextToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference | DataYandexAlbBackendGroupGrpcBackendTlsValidationContext): any;
export declare class DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendTlsValidationContext | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext | undefined);
    private _trustedCaBytes?;
    get trustedCaBytes(): string;
    set trustedCaBytes(value: string);
    resetTrustedCaBytes(): void;
    get trustedCaBytesInput(): string | undefined;
    private _trustedCaId?;
    get trustedCaId(): string;
    set trustedCaId(value: string);
    resetTrustedCaId(): void;
    get trustedCaIdInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupGrpcBackendTls {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}
    */
    readonly sni?: string;
    /**
    * validation_context block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#validation_context DataYandexAlbBackendGroup#validation_context}
    */
    readonly validationContext?: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext;
}
export declare function dataYandexAlbBackendGroupGrpcBackendTlsToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackendTlsOutputReference | DataYandexAlbBackendGroupGrpcBackendTls): any;
export declare class DataYandexAlbBackendGroupGrpcBackendTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackendTls | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackendTls | undefined);
    private _sni?;
    get sni(): string;
    set sni(value: string);
    resetSni(): void;
    get sniInput(): string | undefined;
    private _validationContext;
    get validationContext(): DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference;
    putValidationContext(value: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext): void;
    resetValidationContext(): void;
    get validationContextInput(): DataYandexAlbBackendGroupGrpcBackendTlsValidationContext | undefined;
}
export interface DataYandexAlbBackendGroupGrpcBackend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}
    */
    readonly weight?: number;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck DataYandexAlbBackendGroup#healthcheck}
    */
    readonly healthcheck?: DataYandexAlbBackendGroupGrpcBackendHealthcheck;
    /**
    * load_balancing_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#load_balancing_config DataYandexAlbBackendGroup#load_balancing_config}
    */
    readonly loadBalancingConfig?: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#tls DataYandexAlbBackendGroup#tls}
    */
    readonly tls?: DataYandexAlbBackendGroupGrpcBackendTls;
}
export declare function dataYandexAlbBackendGroupGrpcBackendToTerraform(struct?: DataYandexAlbBackendGroupGrpcBackend | cdktf.IResolvable): any;
export declare class DataYandexAlbBackendGroupGrpcBackendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbBackendGroupGrpcBackend | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexAlbBackendGroupGrpcBackend | cdktf.IResolvable | undefined);
    get name(): string;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    get targetGroupIds(): string[];
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _healthcheck;
    get healthcheck(): DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference;
    putHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheck): void;
    resetHealthcheck(): void;
    get healthcheckInput(): DataYandexAlbBackendGroupGrpcBackendHealthcheck | undefined;
    private _loadBalancingConfig;
    get loadBalancingConfig(): DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference;
    putLoadBalancingConfig(value: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig): void;
    resetLoadBalancingConfig(): void;
    get loadBalancingConfigInput(): DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig | undefined;
    private _tls;
    get tls(): DataYandexAlbBackendGroupGrpcBackendTlsOutputReference;
    putTls(value: DataYandexAlbBackendGroupGrpcBackendTls): void;
    resetTls(): void;
    get tlsInput(): DataYandexAlbBackendGroupGrpcBackendTls | undefined;
}
export declare class DataYandexAlbBackendGroupGrpcBackendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexAlbBackendGroupGrpcBackend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbBackendGroupGrpcBackendOutputReference;
}
export interface DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}
    */
    readonly serviceName?: string;
}
export declare function dataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference | DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck): any;
export declare class DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck | undefined);
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    resetServiceName(): void;
    get serviceNameInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
}
export declare function dataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference | DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck): any;
export declare class DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    get path(): string;
}
export interface DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}
    */
    readonly receive?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}
    */
    readonly send?: string;
}
export declare function dataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference | DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck): any;
export declare class DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck | undefined);
    private _receive?;
    get receive(): string;
    set receive(value: string);
    resetReceive(): void;
    get receiveInput(): string | undefined;
    private _send?;
    get send(): string;
    set send(value: string);
    resetSend(): void;
    get sendInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupHttpBackendHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}
    */
    readonly healthcheckPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}
    */
    readonly intervalJitterPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * grpc_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_healthcheck DataYandexAlbBackendGroup#grpc_healthcheck}
    */
    readonly grpcHealthcheck?: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
    /**
    * http_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_healthcheck DataYandexAlbBackendGroup#http_healthcheck}
    */
    readonly httpHealthcheck?: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
    /**
    * stream_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_healthcheck DataYandexAlbBackendGroup#stream_healthcheck}
    */
    readonly streamHealthcheck?: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
}
export declare function dataYandexAlbBackendGroupHttpBackendHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference | DataYandexAlbBackendGroupHttpBackendHealthcheck): any;
export declare class DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendHealthcheck | undefined);
    private _healthcheckPort?;
    get healthcheckPort(): number;
    set healthcheckPort(value: number);
    resetHealthcheckPort(): void;
    get healthcheckPortInput(): number | undefined;
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    get interval(): string;
    private _intervalJitterPercent?;
    get intervalJitterPercent(): number;
    set intervalJitterPercent(value: number);
    resetIntervalJitterPercent(): void;
    get intervalJitterPercentInput(): number | undefined;
    get timeout(): string;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _grpcHealthcheck;
    get grpcHealthcheck(): DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference;
    putGrpcHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck): void;
    resetGrpcHealthcheck(): void;
    get grpcHealthcheckInput(): DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck | undefined;
    private _httpHealthcheck;
    get httpHealthcheck(): DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference;
    putHttpHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck): void;
    resetHttpHealthcheck(): void;
    get httpHealthcheckInput(): DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck | undefined;
    private _streamHealthcheck;
    get streamHealthcheck(): DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference;
    putStreamHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck): void;
    resetStreamHealthcheck(): void;
    get streamHealthcheckInput(): DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck | undefined;
}
export interface DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}
    */
    readonly localityAwareRoutingPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}
    */
    readonly panicThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}
    */
    readonly strictLocality?: boolean | cdktf.IResolvable;
}
export declare function dataYandexAlbBackendGroupHttpBackendLoadBalancingConfigToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference | DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig): any;
export declare class DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig | undefined);
    private _localityAwareRoutingPercent?;
    get localityAwareRoutingPercent(): number;
    set localityAwareRoutingPercent(value: number);
    resetLocalityAwareRoutingPercent(): void;
    get localityAwareRoutingPercentInput(): number | undefined;
    private _panicThreshold?;
    get panicThreshold(): number;
    set panicThreshold(value: number);
    resetPanicThreshold(): void;
    get panicThresholdInput(): number | undefined;
    private _strictLocality?;
    get strictLocality(): boolean | cdktf.IResolvable;
    set strictLocality(value: boolean | cdktf.IResolvable);
    resetStrictLocality(): void;
    get strictLocalityInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataYandexAlbBackendGroupHttpBackendTlsValidationContext {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}
    */
    readonly trustedCaBytes?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}
    */
    readonly trustedCaId?: string;
}
export declare function dataYandexAlbBackendGroupHttpBackendTlsValidationContextToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference | DataYandexAlbBackendGroupHttpBackendTlsValidationContext): any;
export declare class DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendTlsValidationContext | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendTlsValidationContext | undefined);
    private _trustedCaBytes?;
    get trustedCaBytes(): string;
    set trustedCaBytes(value: string);
    resetTrustedCaBytes(): void;
    get trustedCaBytesInput(): string | undefined;
    private _trustedCaId?;
    get trustedCaId(): string;
    set trustedCaId(value: string);
    resetTrustedCaId(): void;
    get trustedCaIdInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupHttpBackendTls {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}
    */
    readonly sni?: string;
    /**
    * validation_context block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#validation_context DataYandexAlbBackendGroup#validation_context}
    */
    readonly validationContext?: DataYandexAlbBackendGroupHttpBackendTlsValidationContext;
}
export declare function dataYandexAlbBackendGroupHttpBackendTlsToTerraform(struct?: DataYandexAlbBackendGroupHttpBackendTlsOutputReference | DataYandexAlbBackendGroupHttpBackendTls): any;
export declare class DataYandexAlbBackendGroupHttpBackendTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupHttpBackendTls | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackendTls | undefined);
    private _sni?;
    get sni(): string;
    set sni(value: string);
    resetSni(): void;
    get sniInput(): string | undefined;
    private _validationContext;
    get validationContext(): DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference;
    putValidationContext(value: DataYandexAlbBackendGroupHttpBackendTlsValidationContext): void;
    resetValidationContext(): void;
    get validationContextInput(): DataYandexAlbBackendGroupHttpBackendTlsValidationContext | undefined;
}
export interface DataYandexAlbBackendGroupHttpBackend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#storage_bucket DataYandexAlbBackendGroup#storage_bucket}
    */
    readonly storageBucket?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#target_group_ids DataYandexAlbBackendGroup#target_group_ids}
    */
    readonly targetGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}
    */
    readonly weight?: number;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck DataYandexAlbBackendGroup#healthcheck}
    */
    readonly healthcheck?: DataYandexAlbBackendGroupHttpBackendHealthcheck;
    /**
    * load_balancing_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#load_balancing_config DataYandexAlbBackendGroup#load_balancing_config}
    */
    readonly loadBalancingConfig?: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#tls DataYandexAlbBackendGroup#tls}
    */
    readonly tls?: DataYandexAlbBackendGroupHttpBackendTls;
}
export declare function dataYandexAlbBackendGroupHttpBackendToTerraform(struct?: DataYandexAlbBackendGroupHttpBackend | cdktf.IResolvable): any;
export declare class DataYandexAlbBackendGroupHttpBackendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbBackendGroupHttpBackend | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexAlbBackendGroupHttpBackend | cdktf.IResolvable | undefined);
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    get name(): string;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _storageBucket?;
    get storageBucket(): string;
    set storageBucket(value: string);
    resetStorageBucket(): void;
    get storageBucketInput(): string | undefined;
    private _targetGroupIds?;
    get targetGroupIds(): string[];
    set targetGroupIds(value: string[]);
    resetTargetGroupIds(): void;
    get targetGroupIdsInput(): string[] | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _healthcheck;
    get healthcheck(): DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference;
    putHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheck): void;
    resetHealthcheck(): void;
    get healthcheckInput(): DataYandexAlbBackendGroupHttpBackendHealthcheck | undefined;
    private _loadBalancingConfig;
    get loadBalancingConfig(): DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference;
    putLoadBalancingConfig(value: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig): void;
    resetLoadBalancingConfig(): void;
    get loadBalancingConfigInput(): DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig | undefined;
    private _tls;
    get tls(): DataYandexAlbBackendGroupHttpBackendTlsOutputReference;
    putTls(value: DataYandexAlbBackendGroupHttpBackendTls): void;
    resetTls(): void;
    get tlsInput(): DataYandexAlbBackendGroupHttpBackendTls | undefined;
}
export declare class DataYandexAlbBackendGroupHttpBackendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexAlbBackendGroupHttpBackend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbBackendGroupHttpBackendOutputReference;
}
export interface DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}
    */
    readonly serviceName?: string;
}
export declare function dataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference | DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck): any;
export declare class DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck | undefined);
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    resetServiceName(): void;
    get serviceNameInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}
    */
    readonly host?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}
    */
    readonly http2?: boolean | cdktf.IResolvable;
}
export declare function dataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference | DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck): any;
export declare class DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck | undefined);
    private _host?;
    get host(): string;
    set host(value: string);
    resetHost(): void;
    get hostInput(): string | undefined;
    private _http2?;
    get http2(): boolean | cdktf.IResolvable;
    set http2(value: boolean | cdktf.IResolvable);
    resetHttp2(): void;
    get http2Input(): boolean | cdktf.IResolvable | undefined;
    get path(): string;
}
export interface DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}
    */
    readonly receive?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}
    */
    readonly send?: string;
}
export declare function dataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference | DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck): any;
export declare class DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck | undefined);
    private _receive?;
    get receive(): string;
    set receive(value: string);
    resetReceive(): void;
    get receiveInput(): string | undefined;
    private _send?;
    get send(): string;
    set send(value: string);
    resetSend(): void;
    get sendInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupStreamBackendHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}
    */
    readonly healthcheckPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}
    */
    readonly intervalJitterPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * grpc_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_healthcheck DataYandexAlbBackendGroup#grpc_healthcheck}
    */
    readonly grpcHealthcheck?: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
    /**
    * http_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_healthcheck DataYandexAlbBackendGroup#http_healthcheck}
    */
    readonly httpHealthcheck?: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
    /**
    * stream_healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_healthcheck DataYandexAlbBackendGroup#stream_healthcheck}
    */
    readonly streamHealthcheck?: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
}
export declare function dataYandexAlbBackendGroupStreamBackendHealthcheckToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference | DataYandexAlbBackendGroupStreamBackendHealthcheck): any;
export declare class DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendHealthcheck | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendHealthcheck | undefined);
    private _healthcheckPort?;
    get healthcheckPort(): number;
    set healthcheckPort(value: number);
    resetHealthcheckPort(): void;
    get healthcheckPortInput(): number | undefined;
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    get interval(): string;
    private _intervalJitterPercent?;
    get intervalJitterPercent(): number;
    set intervalJitterPercent(value: number);
    resetIntervalJitterPercent(): void;
    get intervalJitterPercentInput(): number | undefined;
    get timeout(): string;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _grpcHealthcheck;
    get grpcHealthcheck(): DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference;
    putGrpcHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck): void;
    resetGrpcHealthcheck(): void;
    get grpcHealthcheckInput(): DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck | undefined;
    private _httpHealthcheck;
    get httpHealthcheck(): DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference;
    putHttpHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck): void;
    resetHttpHealthcheck(): void;
    get httpHealthcheckInput(): DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck | undefined;
    private _streamHealthcheck;
    get streamHealthcheck(): DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference;
    putStreamHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck): void;
    resetStreamHealthcheck(): void;
    get streamHealthcheckInput(): DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck | undefined;
}
export interface DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}
    */
    readonly localityAwareRoutingPercent?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}
    */
    readonly panicThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}
    */
    readonly strictLocality?: boolean | cdktf.IResolvable;
}
export declare function dataYandexAlbBackendGroupStreamBackendLoadBalancingConfigToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference | DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig): any;
export declare class DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig | undefined);
    private _localityAwareRoutingPercent?;
    get localityAwareRoutingPercent(): number;
    set localityAwareRoutingPercent(value: number);
    resetLocalityAwareRoutingPercent(): void;
    get localityAwareRoutingPercentInput(): number | undefined;
    private _panicThreshold?;
    get panicThreshold(): number;
    set panicThreshold(value: number);
    resetPanicThreshold(): void;
    get panicThresholdInput(): number | undefined;
    private _strictLocality?;
    get strictLocality(): boolean | cdktf.IResolvable;
    set strictLocality(value: boolean | cdktf.IResolvable);
    resetStrictLocality(): void;
    get strictLocalityInput(): boolean | cdktf.IResolvable | undefined;
}
export interface DataYandexAlbBackendGroupStreamBackendTlsValidationContext {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}
    */
    readonly trustedCaBytes?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}
    */
    readonly trustedCaId?: string;
}
export declare function dataYandexAlbBackendGroupStreamBackendTlsValidationContextToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference | DataYandexAlbBackendGroupStreamBackendTlsValidationContext): any;
export declare class DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendTlsValidationContext | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendTlsValidationContext | undefined);
    private _trustedCaBytes?;
    get trustedCaBytes(): string;
    set trustedCaBytes(value: string);
    resetTrustedCaBytes(): void;
    get trustedCaBytesInput(): string | undefined;
    private _trustedCaId?;
    get trustedCaId(): string;
    set trustedCaId(value: string);
    resetTrustedCaId(): void;
    get trustedCaIdInput(): string | undefined;
}
export interface DataYandexAlbBackendGroupStreamBackendTls {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}
    */
    readonly sni?: string;
    /**
    * validation_context block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#validation_context DataYandexAlbBackendGroup#validation_context}
    */
    readonly validationContext?: DataYandexAlbBackendGroupStreamBackendTlsValidationContext;
}
export declare function dataYandexAlbBackendGroupStreamBackendTlsToTerraform(struct?: DataYandexAlbBackendGroupStreamBackendTlsOutputReference | DataYandexAlbBackendGroupStreamBackendTls): any;
export declare class DataYandexAlbBackendGroupStreamBackendTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbBackendGroupStreamBackendTls | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackendTls | undefined);
    private _sni?;
    get sni(): string;
    set sni(value: string);
    resetSni(): void;
    get sniInput(): string | undefined;
    private _validationContext;
    get validationContext(): DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference;
    putValidationContext(value: DataYandexAlbBackendGroupStreamBackendTlsValidationContext): void;
    resetValidationContext(): void;
    get validationContextInput(): DataYandexAlbBackendGroupStreamBackendTlsValidationContext | undefined;
}
export interface DataYandexAlbBackendGroupStreamBackend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}
    */
    readonly weight?: number;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck DataYandexAlbBackendGroup#healthcheck}
    */
    readonly healthcheck?: DataYandexAlbBackendGroupStreamBackendHealthcheck;
    /**
    * load_balancing_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#load_balancing_config DataYandexAlbBackendGroup#load_balancing_config}
    */
    readonly loadBalancingConfig?: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig;
    /**
    * tls block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#tls DataYandexAlbBackendGroup#tls}
    */
    readonly tls?: DataYandexAlbBackendGroupStreamBackendTls;
}
export declare function dataYandexAlbBackendGroupStreamBackendToTerraform(struct?: DataYandexAlbBackendGroupStreamBackend | cdktf.IResolvable): any;
export declare class DataYandexAlbBackendGroupStreamBackendOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbBackendGroupStreamBackend | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexAlbBackendGroupStreamBackend | cdktf.IResolvable | undefined);
    get name(): string;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    get targetGroupIds(): string[];
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
    private _healthcheck;
    get healthcheck(): DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference;
    putHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheck): void;
    resetHealthcheck(): void;
    get healthcheckInput(): DataYandexAlbBackendGroupStreamBackendHealthcheck | undefined;
    private _loadBalancingConfig;
    get loadBalancingConfig(): DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference;
    putLoadBalancingConfig(value: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig): void;
    resetLoadBalancingConfig(): void;
    get loadBalancingConfigInput(): DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig | undefined;
    private _tls;
    get tls(): DataYandexAlbBackendGroupStreamBackendTlsOutputReference;
    putTls(value: DataYandexAlbBackendGroupStreamBackendTls): void;
    resetTls(): void;
    get tlsInput(): DataYandexAlbBackendGroupStreamBackendTls | undefined;
}
export declare class DataYandexAlbBackendGroupStreamBackendList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexAlbBackendGroupStreamBackend[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbBackendGroupStreamBackendOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group yandex_alb_backend_group}
*/
export declare class DataYandexAlbBackendGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_alb_backend_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group yandex_alb_backend_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexAlbBackendGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexAlbBackendGroupConfig);
    private _backendGroupId?;
    get backendGroupId(): string;
    set backendGroupId(value: string);
    resetBackendGroupId(): void;
    get backendGroupIdInput(): string | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _grpcBackend;
    get grpcBackend(): DataYandexAlbBackendGroupGrpcBackendList;
    putGrpcBackend(value: DataYandexAlbBackendGroupGrpcBackend[] | cdktf.IResolvable): void;
    resetGrpcBackend(): void;
    get grpcBackendInput(): cdktf.IResolvable | DataYandexAlbBackendGroupGrpcBackend[] | undefined;
    private _httpBackend;
    get httpBackend(): DataYandexAlbBackendGroupHttpBackendList;
    putHttpBackend(value: DataYandexAlbBackendGroupHttpBackend[] | cdktf.IResolvable): void;
    resetHttpBackend(): void;
    get httpBackendInput(): cdktf.IResolvable | DataYandexAlbBackendGroupHttpBackend[] | undefined;
    private _streamBackend;
    get streamBackend(): DataYandexAlbBackendGroupStreamBackendList;
    putStreamBackend(value: DataYandexAlbBackendGroupStreamBackend[] | cdktf.IResolvable): void;
    resetStreamBackend(): void;
    get streamBackendInput(): cdktf.IResolvable | DataYandexAlbBackendGroupStreamBackend[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-alb-backend-group.d.ts.map