import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexAlbHttpRouterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#description DataYandexAlbHttpRouter#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#folder_id DataYandexAlbHttpRouter#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#http_router_id DataYandexAlbHttpRouter#http_router_id}
    */
    readonly httpRouterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#id DataYandexAlbHttpRouter#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#name DataYandexAlbHttpRouter#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router yandex_alb_http_router}
*/
export declare class DataYandexAlbHttpRouter extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_alb_http_router";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router yandex_alb_http_router} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexAlbHttpRouterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexAlbHttpRouterConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _httpRouterId?;
    get httpRouterId(): string;
    set httpRouterId(value: string);
    resetHttpRouterId(): void;
    get httpRouterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-alb-http-router.d.ts.map