import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexAlbLoadBalancerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#id DataYandexAlbLoadBalancer#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#load_balancer_id DataYandexAlbLoadBalancer#load_balancer_id}
    */
    readonly loadBalancerId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#name DataYandexAlbLoadBalancer#name}
    */
    readonly name?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#timeouts DataYandexAlbLoadBalancer#timeouts}
    */
    readonly timeouts?: DataYandexAlbLoadBalancerTimeouts;
}
export interface DataYandexAlbLoadBalancerAllocationPolicyLocation {
}
export declare function dataYandexAlbLoadBalancerAllocationPolicyLocationToTerraform(struct?: DataYandexAlbLoadBalancerAllocationPolicyLocation): any;
export declare class DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerAllocationPolicyLocation | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerAllocationPolicyLocation | undefined);
    get disableTraffic(): cdktf.IResolvable;
    get subnetId(): string;
    get zoneId(): string;
}
export declare class DataYandexAlbLoadBalancerAllocationPolicyLocationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference;
}
export interface DataYandexAlbLoadBalancerAllocationPolicy {
}
export declare function dataYandexAlbLoadBalancerAllocationPolicyToTerraform(struct?: DataYandexAlbLoadBalancerAllocationPolicy): any;
export declare class DataYandexAlbLoadBalancerAllocationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerAllocationPolicy | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerAllocationPolicy | undefined);
    private _location;
    get location(): DataYandexAlbLoadBalancerAllocationPolicyLocationList;
}
export declare class DataYandexAlbLoadBalancerAllocationPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerAllocationPolicyOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address {
}
export declare function dataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressToTerraform(struct?: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address): any;
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address | undefined);
    get address(): string;
}
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address {
}
export declare function dataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressToTerraform(struct?: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address): any;
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address | undefined);
    get address(): string;
}
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address {
}
export declare function dataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressToTerraform(struct?: DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address): any;
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address | undefined);
    get address(): string;
    get subnetId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerEndpointAddress {
}
export declare function dataYandexAlbLoadBalancerListenerEndpointAddressToTerraform(struct?: DataYandexAlbLoadBalancerListenerEndpointAddress): any;
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerEndpointAddress | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerEndpointAddress | undefined);
    private _externalIpv4Address;
    get externalIpv4Address(): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList;
    private _externalIpv6Address;
    get externalIpv6Address(): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList;
    private _internalIpv4Address;
    get internalIpv4Address(): DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList;
}
export declare class DataYandexAlbLoadBalancerListenerEndpointAddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerEndpoint {
}
export declare function dataYandexAlbLoadBalancerListenerEndpointToTerraform(struct?: DataYandexAlbLoadBalancerListenerEndpoint): any;
export declare class DataYandexAlbLoadBalancerListenerEndpointOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerEndpoint | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerEndpoint | undefined);
    private _address;
    get address(): DataYandexAlbLoadBalancerListenerEndpointAddressList;
    get ports(): number[];
}
export declare class DataYandexAlbLoadBalancerListenerEndpointList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerEndpointOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options {
}
export declare function dataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsToTerraform(struct?: DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options): any;
export declare class DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options | undefined);
    get maxConcurrentStreams(): number;
}
export declare class DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerHttpHandler {
}
export declare function dataYandexAlbLoadBalancerListenerHttpHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerHttpHandler): any;
export declare class DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerHttpHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerHttpHandler | undefined);
    get allowHttp10(): cdktf.IResolvable;
    private _http2Options;
    get http2Options(): DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList;
    get httpRouterId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerHttpHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerHttpRedirects {
}
export declare function dataYandexAlbLoadBalancerListenerHttpRedirectsToTerraform(struct?: DataYandexAlbLoadBalancerListenerHttpRedirects): any;
export declare class DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerHttpRedirects | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerHttpRedirects | undefined);
    get httpToHttps(): cdktf.IResolvable;
}
export declare class DataYandexAlbLoadBalancerListenerHttpRedirectsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerHttp {
}
export declare function dataYandexAlbLoadBalancerListenerHttpToTerraform(struct?: DataYandexAlbLoadBalancerListenerHttp): any;
export declare class DataYandexAlbLoadBalancerListenerHttpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerHttp | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerHttp | undefined);
    private _handler;
    get handler(): DataYandexAlbLoadBalancerListenerHttpHandlerList;
    private _redirects;
    get redirects(): DataYandexAlbLoadBalancerListenerHttpRedirectsList;
}
export declare class DataYandexAlbLoadBalancerListenerHttpList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerHttpOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerStreamHandler {
}
export declare function dataYandexAlbLoadBalancerListenerStreamHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerStreamHandler): any;
export declare class DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerStreamHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerStreamHandler | undefined);
    get backendGroupId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerStreamHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerStream {
}
export declare function dataYandexAlbLoadBalancerListenerStreamToTerraform(struct?: DataYandexAlbLoadBalancerListenerStream): any;
export declare class DataYandexAlbLoadBalancerListenerStreamOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerStream | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerStream | undefined);
    private _handler;
    get handler(): DataYandexAlbLoadBalancerListenerStreamHandlerList;
}
export declare class DataYandexAlbLoadBalancerListenerStreamList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerStreamOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options {
}
export declare function dataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options): any;
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options | undefined);
    get maxConcurrentStreams(): number;
}
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler | undefined);
    get allowHttp10(): cdktf.IResolvable;
    private _http2Options;
    get http2Options(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList;
    get httpRouterId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler | undefined);
    get backendGroupId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsDefaultHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsDefaultHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsDefaultHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsDefaultHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsDefaultHandler | undefined);
    get certificateIds(): string[];
    private _httpHandler;
    get httpHandler(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList;
    private _streamHandler;
    get streamHandler(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList;
}
export declare class DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options {
}
export declare function dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options): any;
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options | undefined);
    get maxConcurrentStreams(): number;
}
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler | undefined);
    get allowHttp10(): cdktf.IResolvable;
    private _http2Options;
    get http2Options(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList;
    get httpRouterId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler | undefined);
    get backendGroupId(): string;
}
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler | undefined);
    get certificateIds(): string[];
    private _httpHandler;
    get httpHandler(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList;
    private _streamHandler;
    get streamHandler(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList;
}
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTlsSniHandler {
}
export declare function dataYandexAlbLoadBalancerListenerTlsSniHandlerToTerraform(struct?: DataYandexAlbLoadBalancerListenerTlsSniHandler): any;
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTlsSniHandler | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTlsSniHandler | undefined);
    private _handler;
    get handler(): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList;
    get name(): string;
    get serverNames(): string[];
}
export declare class DataYandexAlbLoadBalancerListenerTlsSniHandlerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference;
}
export interface DataYandexAlbLoadBalancerListenerTls {
}
export declare function dataYandexAlbLoadBalancerListenerTlsToTerraform(struct?: DataYandexAlbLoadBalancerListenerTls): any;
export declare class DataYandexAlbLoadBalancerListenerTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListenerTls | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListenerTls | undefined);
    private _defaultHandler;
    get defaultHandler(): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList;
    private _sniHandler;
    get sniHandler(): DataYandexAlbLoadBalancerListenerTlsSniHandlerList;
}
export declare class DataYandexAlbLoadBalancerListenerTlsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerTlsOutputReference;
}
export interface DataYandexAlbLoadBalancerListener {
}
export declare function dataYandexAlbLoadBalancerListenerToTerraform(struct?: DataYandexAlbLoadBalancerListener): any;
export declare class DataYandexAlbLoadBalancerListenerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbLoadBalancerListener | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerListener | undefined);
    private _endpoint;
    get endpoint(): DataYandexAlbLoadBalancerListenerEndpointList;
    private _http;
    get http(): DataYandexAlbLoadBalancerListenerHttpList;
    get name(): string;
    private _stream;
    get stream(): DataYandexAlbLoadBalancerListenerStreamList;
    private _tls;
    get tls(): DataYandexAlbLoadBalancerListenerTlsList;
}
export declare class DataYandexAlbLoadBalancerListenerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbLoadBalancerListenerOutputReference;
}
export interface DataYandexAlbLoadBalancerTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#create DataYandexAlbLoadBalancer#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#delete DataYandexAlbLoadBalancer#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#update DataYandexAlbLoadBalancer#update}
    */
    readonly update?: string;
}
export declare function dataYandexAlbLoadBalancerTimeoutsToTerraform(struct?: DataYandexAlbLoadBalancerTimeoutsOutputReference | DataYandexAlbLoadBalancerTimeouts | cdktf.IResolvable): any;
export declare class DataYandexAlbLoadBalancerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexAlbLoadBalancerTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexAlbLoadBalancerTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer yandex_alb_load_balancer}
*/
export declare class DataYandexAlbLoadBalancer extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_alb_load_balancer";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer yandex_alb_load_balancer} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexAlbLoadBalancerConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexAlbLoadBalancerConfig);
    private _allocationPolicy;
    get allocationPolicy(): DataYandexAlbLoadBalancerAllocationPolicyList;
    get createdAt(): string;
    get description(): string;
    get folderId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _listener;
    get listener(): DataYandexAlbLoadBalancerListenerList;
    private _loadBalancerId?;
    get loadBalancerId(): string;
    set loadBalancerId(value: string);
    resetLoadBalancerId(): void;
    get loadBalancerIdInput(): string | undefined;
    get logGroupId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    get regionId(): string;
    get securityGroupIds(): string[];
    get status(): string;
    private _timeouts;
    get timeouts(): DataYandexAlbLoadBalancerTimeoutsOutputReference;
    putTimeouts(value: DataYandexAlbLoadBalancerTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataYandexAlbLoadBalancerTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-alb-load-balancer.d.ts.map