import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexAlbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#description DataYandexAlbTargetGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#folder_id DataYandexAlbTargetGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#id DataYandexAlbTargetGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#name DataYandexAlbTargetGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#target_group_id DataYandexAlbTargetGroup#target_group_id}
    */
    readonly targetGroupId?: string;
}
export interface DataYandexAlbTargetGroupTarget {
}
export declare function dataYandexAlbTargetGroupTargetToTerraform(struct?: DataYandexAlbTargetGroupTarget): any;
export declare class DataYandexAlbTargetGroupTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbTargetGroupTarget | undefined;
    set internalValue(value: DataYandexAlbTargetGroupTarget | undefined);
    get ipAddress(): string;
    get privateIpv4Address(): cdktf.IResolvable;
    get subnetId(): string;
}
export declare class DataYandexAlbTargetGroupTargetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbTargetGroupTargetOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group yandex_alb_target_group}
*/
export declare class DataYandexAlbTargetGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_alb_target_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group yandex_alb_target_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexAlbTargetGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexAlbTargetGroupConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _target;
    get target(): DataYandexAlbTargetGroupTargetList;
    private _targetGroupId?;
    get targetGroupId(): string;
    set targetGroupId(value: string);
    resetTargetGroupId(): void;
    get targetGroupIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-alb-target-group.d.ts.map