import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexAlbVirtualHostConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#http_router_id DataYandexAlbVirtualHost#http_router_id}
    */
    readonly httpRouterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#id DataYandexAlbVirtualHost#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#name DataYandexAlbVirtualHost#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#virtual_host_id DataYandexAlbVirtualHost#virtual_host_id}
    */
    readonly virtualHostId?: string;
}
export interface DataYandexAlbVirtualHostModifyRequestHeaders {
}
export declare function dataYandexAlbVirtualHostModifyRequestHeadersToTerraform(struct?: DataYandexAlbVirtualHostModifyRequestHeaders): any;
export declare class DataYandexAlbVirtualHostModifyRequestHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostModifyRequestHeaders | undefined;
    set internalValue(value: DataYandexAlbVirtualHostModifyRequestHeaders | undefined);
    get append(): string;
    get name(): string;
    get remove(): cdktf.IResolvable;
    get replace(): string;
}
export declare class DataYandexAlbVirtualHostModifyRequestHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostModifyRequestHeadersOutputReference;
}
export interface DataYandexAlbVirtualHostModifyResponseHeaders {
}
export declare function dataYandexAlbVirtualHostModifyResponseHeadersToTerraform(struct?: DataYandexAlbVirtualHostModifyResponseHeaders): any;
export declare class DataYandexAlbVirtualHostModifyResponseHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostModifyResponseHeaders | undefined;
    set internalValue(value: DataYandexAlbVirtualHostModifyResponseHeaders | undefined);
    get append(): string;
    get name(): string;
    get remove(): cdktf.IResolvable;
    get replace(): string;
}
export declare class DataYandexAlbVirtualHostModifyResponseHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostModifyResponseHeadersOutputReference;
}
export interface DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn {
}
export declare function dataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnToTerraform(struct?: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn): any;
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn | undefined);
    get exact(): string;
    get prefix(): string;
}
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference;
}
export interface DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch {
}
export declare function dataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchToTerraform(struct?: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch): any;
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch | undefined);
    private _fqmn;
    get fqmn(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList;
}
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference;
}
export interface DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction {
}
export declare function dataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionToTerraform(struct?: DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction): any;
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction | undefined);
    get autoHostRewrite(): cdktf.IResolvable;
    get backendGroupId(): string;
    get hostRewrite(): string;
    get idleTimeout(): string;
    get maxTimeout(): string;
}
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference;
}
export interface DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction {
}
export declare function dataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionToTerraform(struct?: DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction): any;
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction | undefined);
    get status(): string;
}
export declare class DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference;
}
export interface DataYandexAlbVirtualHostRouteGrpcRoute {
}
export declare function dataYandexAlbVirtualHostRouteGrpcRouteToTerraform(struct?: DataYandexAlbVirtualHostRouteGrpcRoute): any;
export declare class DataYandexAlbVirtualHostRouteGrpcRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteGrpcRoute | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteGrpcRoute | undefined);
    private _grpcMatch;
    get grpcMatch(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList;
    private _grpcRouteAction;
    get grpcRouteAction(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList;
    private _grpcStatusResponseAction;
    get grpcStatusResponseAction(): DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList;
}
export declare class DataYandexAlbVirtualHostRouteGrpcRouteList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteOutputReference;
}
export interface DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction {
}
export declare function dataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionToTerraform(struct?: DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction): any;
export declare class DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction | undefined);
    get body(): string;
    get status(): number;
}
export declare class DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference;
}
export interface DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath {
}
export declare function dataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathToTerraform(struct?: DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath): any;
export declare class DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath | undefined);
    get exact(): string;
    get prefix(): string;
}
export declare class DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference;
}
export interface DataYandexAlbVirtualHostRouteHttpRouteHttpMatch {
}
export declare function dataYandexAlbVirtualHostRouteHttpRouteHttpMatchToTerraform(struct?: DataYandexAlbVirtualHostRouteHttpRouteHttpMatch): any;
export declare class DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteHttpRouteHttpMatch | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteHttpRouteHttpMatch | undefined);
    get httpMethod(): string[];
    private _path;
    get path(): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList;
}
export declare class DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference;
}
export interface DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction {
}
export declare function dataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionToTerraform(struct?: DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction): any;
export declare class DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction | undefined);
    get autoHostRewrite(): cdktf.IResolvable;
    get backendGroupId(): string;
    get hostRewrite(): string;
    get idleTimeout(): string;
    get prefixRewrite(): string;
    get timeout(): string;
    get upgradeTypes(): string[];
}
export declare class DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference;
}
export interface DataYandexAlbVirtualHostRouteHttpRouteRedirectAction {
}
export declare function dataYandexAlbVirtualHostRouteHttpRouteRedirectActionToTerraform(struct?: DataYandexAlbVirtualHostRouteHttpRouteRedirectAction): any;
export declare class DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteHttpRouteRedirectAction | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteHttpRouteRedirectAction | undefined);
    get removeQuery(): cdktf.IResolvable;
    get replaceHost(): string;
    get replacePath(): string;
    get replacePort(): number;
    get replacePrefix(): string;
    get replaceScheme(): string;
    get responseCode(): string;
}
export declare class DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference;
}
export interface DataYandexAlbVirtualHostRouteHttpRoute {
}
export declare function dataYandexAlbVirtualHostRouteHttpRouteToTerraform(struct?: DataYandexAlbVirtualHostRouteHttpRoute): any;
export declare class DataYandexAlbVirtualHostRouteHttpRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRouteHttpRoute | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRouteHttpRoute | undefined);
    private _directResponseAction;
    get directResponseAction(): DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList;
    private _httpMatch;
    get httpMatch(): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList;
    private _httpRouteAction;
    get httpRouteAction(): DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList;
    private _redirectAction;
    get redirectAction(): DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList;
}
export declare class DataYandexAlbVirtualHostRouteHttpRouteList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteHttpRouteOutputReference;
}
export interface DataYandexAlbVirtualHostRoute {
}
export declare function dataYandexAlbVirtualHostRouteToTerraform(struct?: DataYandexAlbVirtualHostRoute): any;
export declare class DataYandexAlbVirtualHostRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexAlbVirtualHostRoute | undefined;
    set internalValue(value: DataYandexAlbVirtualHostRoute | undefined);
    private _grpcRoute;
    get grpcRoute(): DataYandexAlbVirtualHostRouteGrpcRouteList;
    private _httpRoute;
    get httpRoute(): DataYandexAlbVirtualHostRouteHttpRouteList;
    get name(): string;
}
export declare class DataYandexAlbVirtualHostRouteList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexAlbVirtualHostRouteOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host yandex_alb_virtual_host}
*/
export declare class DataYandexAlbVirtualHost extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_alb_virtual_host";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host yandex_alb_virtual_host} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexAlbVirtualHostConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexAlbVirtualHostConfig);
    get authority(): string[];
    private _httpRouterId?;
    get httpRouterId(): string;
    set httpRouterId(value: string);
    resetHttpRouterId(): void;
    get httpRouterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _modifyRequestHeaders;
    get modifyRequestHeaders(): DataYandexAlbVirtualHostModifyRequestHeadersList;
    private _modifyResponseHeaders;
    get modifyResponseHeaders(): DataYandexAlbVirtualHostModifyResponseHeadersList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _route;
    get route(): DataYandexAlbVirtualHostRouteList;
    private _virtualHostId?;
    get virtualHostId(): string;
    set virtualHostId(value: string);
    resetVirtualHostId(): void;
    get virtualHostIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-alb-virtual-host.d.ts.map