import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexCdnOriginGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#folder_id DataYandexCdnOriginGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#id DataYandexCdnOriginGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#name DataYandexCdnOriginGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#origin_group_id DataYandexCdnOriginGroup#origin_group_id}
    */
    readonly originGroupId?: number;
}
export interface DataYandexCdnOriginGroupOrigin {
}
export declare function dataYandexCdnOriginGroupOriginToTerraform(struct?: DataYandexCdnOriginGroupOrigin): any;
export declare class DataYandexCdnOriginGroupOriginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexCdnOriginGroupOrigin | undefined;
    set internalValue(value: DataYandexCdnOriginGroupOrigin | undefined);
    get backup(): cdktf.IResolvable;
    get enabled(): cdktf.IResolvable;
    get originGroupId(): number;
    get source(): string;
}
export declare class DataYandexCdnOriginGroupOriginList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexCdnOriginGroupOriginOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group yandex_cdn_origin_group}
*/
export declare class DataYandexCdnOriginGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_cdn_origin_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group yandex_cdn_origin_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexCdnOriginGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexCdnOriginGroupConfig);
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _origin;
    get origin(): DataYandexCdnOriginGroupOriginList;
    private _originGroupId?;
    get originGroupId(): number;
    set originGroupId(value: number);
    resetOriginGroupId(): void;
    get originGroupIdInput(): number | undefined;
    get useNext(): cdktf.IResolvable;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-cdn-origin-group.d.ts.map