import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexComputeDiskConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_id DataYandexComputeDisk#disk_id}
    */
    readonly diskId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#folder_id DataYandexComputeDisk#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#id DataYandexComputeDisk#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#name DataYandexComputeDisk#name}
    */
    readonly name?: string;
    /**
    * disk_placement_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_placement_policy DataYandexComputeDisk#disk_placement_policy}
    */
    readonly diskPlacementPolicy?: DataYandexComputeDiskDiskPlacementPolicy;
}
export interface DataYandexComputeDiskDiskPlacementPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_placement_group_id DataYandexComputeDisk#disk_placement_group_id}
    */
    readonly diskPlacementGroupId: string;
}
export declare function dataYandexComputeDiskDiskPlacementPolicyToTerraform(struct?: DataYandexComputeDiskDiskPlacementPolicyOutputReference | DataYandexComputeDiskDiskPlacementPolicy): any;
export declare class DataYandexComputeDiskDiskPlacementPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexComputeDiskDiskPlacementPolicy | undefined;
    set internalValue(value: DataYandexComputeDiskDiskPlacementPolicy | undefined);
    private _diskPlacementGroupId?;
    get diskPlacementGroupId(): string;
    set diskPlacementGroupId(value: string);
    get diskPlacementGroupIdInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk yandex_compute_disk}
*/
export declare class DataYandexComputeDisk extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_compute_disk";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk yandex_compute_disk} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexComputeDiskConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexComputeDiskConfig);
    get blockSize(): number;
    get createdAt(): string;
    get description(): string;
    private _diskId?;
    get diskId(): string;
    set diskId(value: string);
    resetDiskId(): void;
    get diskIdInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get imageId(): string;
    get instanceIds(): string[];
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get productIds(): string[];
    get size(): number;
    get snapshotId(): string;
    get status(): string;
    get type(): string;
    get zone(): string;
    private _diskPlacementPolicy;
    get diskPlacementPolicy(): DataYandexComputeDiskDiskPlacementPolicyOutputReference;
    putDiskPlacementPolicy(value: DataYandexComputeDiskDiskPlacementPolicy): void;
    resetDiskPlacementPolicy(): void;
    get diskPlacementPolicyInput(): DataYandexComputeDiskDiskPlacementPolicy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-compute-disk.d.ts.map