import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexComputeInstanceGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group#id DataYandexComputeInstanceGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group#instance_group_id DataYandexComputeInstanceGroup#instance_group_id}
    */
    readonly instanceGroupId: string;
}
export interface DataYandexComputeInstanceGroupAllocationPolicy {
}
export declare function dataYandexComputeInstanceGroupAllocationPolicyToTerraform(struct?: DataYandexComputeInstanceGroupAllocationPolicy): any;
export declare class DataYandexComputeInstanceGroupAllocationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupAllocationPolicy | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupAllocationPolicy | undefined);
    get zones(): string[];
}
export declare class DataYandexComputeInstanceGroupAllocationPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupAllocationPolicyOutputReference;
}
export interface DataYandexComputeInstanceGroupApplicationBalancerState {
}
export declare function dataYandexComputeInstanceGroupApplicationBalancerStateToTerraform(struct?: DataYandexComputeInstanceGroupApplicationBalancerState): any;
export declare class DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupApplicationBalancerState | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupApplicationBalancerState | undefined);
    get statusMessage(): string;
    get targetGroupId(): string;
}
export declare class DataYandexComputeInstanceGroupApplicationBalancerStateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference;
}
export interface DataYandexComputeInstanceGroupApplicationLoadBalancer {
}
export declare function dataYandexComputeInstanceGroupApplicationLoadBalancerToTerraform(struct?: DataYandexComputeInstanceGroupApplicationLoadBalancer): any;
export declare class DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupApplicationLoadBalancer | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupApplicationLoadBalancer | undefined);
    get maxOpeningTrafficDuration(): number;
    get statusMessage(): string;
    get targetGroupDescription(): string;
    get targetGroupId(): string;
    private _targetGroupLabels;
    get targetGroupLabels(): cdktf.StringMap;
    get targetGroupName(): string;
}
export declare class DataYandexComputeInstanceGroupApplicationLoadBalancerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference;
}
export interface DataYandexComputeInstanceGroupDeployPolicy {
}
export declare function dataYandexComputeInstanceGroupDeployPolicyToTerraform(struct?: DataYandexComputeInstanceGroupDeployPolicy): any;
export declare class DataYandexComputeInstanceGroupDeployPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupDeployPolicy | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupDeployPolicy | undefined);
    get maxCreating(): number;
    get maxDeleting(): number;
    get maxExpansion(): number;
    get maxUnavailable(): number;
    get startupDuration(): number;
    get strategy(): string;
}
export declare class DataYandexComputeInstanceGroupDeployPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupDeployPolicyOutputReference;
}
export interface DataYandexComputeInstanceGroupHealthCheckHttpOptions {
}
export declare function dataYandexComputeInstanceGroupHealthCheckHttpOptionsToTerraform(struct?: DataYandexComputeInstanceGroupHealthCheckHttpOptions): any;
export declare class DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupHealthCheckHttpOptions | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupHealthCheckHttpOptions | undefined);
    get path(): string;
    get port(): number;
}
export declare class DataYandexComputeInstanceGroupHealthCheckHttpOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference;
}
export interface DataYandexComputeInstanceGroupHealthCheckTcpOptions {
}
export declare function dataYandexComputeInstanceGroupHealthCheckTcpOptionsToTerraform(struct?: DataYandexComputeInstanceGroupHealthCheckTcpOptions): any;
export declare class DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupHealthCheckTcpOptions | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupHealthCheckTcpOptions | undefined);
    get port(): number;
}
export declare class DataYandexComputeInstanceGroupHealthCheckTcpOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference;
}
export interface DataYandexComputeInstanceGroupHealthCheck {
}
export declare function dataYandexComputeInstanceGroupHealthCheckToTerraform(struct?: DataYandexComputeInstanceGroupHealthCheck): any;
export declare class DataYandexComputeInstanceGroupHealthCheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupHealthCheck | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupHealthCheck | undefined);
    get healthyThreshold(): number;
    private _httpOptions;
    get httpOptions(): DataYandexComputeInstanceGroupHealthCheckHttpOptionsList;
    get interval(): number;
    private _tcpOptions;
    get tcpOptions(): DataYandexComputeInstanceGroupHealthCheckTcpOptionsList;
    get timeout(): number;
    get unhealthyThreshold(): number;
}
export declare class DataYandexComputeInstanceGroupHealthCheckList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupHealthCheckOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams | undefined);
    get description(): string;
    get imageId(): string;
    get size(): number;
    get snapshotId(): string;
    get type(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateBootDisk {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateBootDiskToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateBootDisk): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateBootDisk | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateBootDisk | undefined);
    get deviceName(): string;
    get diskId(): string;
    private _initializeParams;
    get initializeParams(): DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList;
    get mode(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateBootDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord | undefined);
    get dnsZoneId(): string;
    get fqdn(): string;
    get ptr(): cdktf.IResolvable;
    get ttl(): number;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord | undefined);
    get dnsZoneId(): string;
    get fqdn(): string;
    get ptr(): cdktf.IResolvable;
    get ttl(): number;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord | undefined);
    get dnsZoneId(): string;
    get fqdn(): string;
    get ptr(): cdktf.IResolvable;
    get ttl(): number;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface | undefined);
    private _dnsRecord;
    get dnsRecord(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList;
    get ipAddress(): string;
    get ipv4(): cdktf.IResolvable;
    get ipv6(): cdktf.IResolvable;
    get ipv6Address(): string;
    private _ipv6DnsRecord;
    get ipv6DnsRecord(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList;
    get nat(): cdktf.IResolvable;
    private _natDnsRecord;
    get natDnsRecord(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList;
    get natIpAddress(): string;
    get networkId(): string;
    get securityGroupIds(): string[];
    get subnetIds(): string[];
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings | undefined);
    get type(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy | undefined);
    get placementGroupId(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateResources {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateResourcesToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateResources): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateResources | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateResources | undefined);
    get coreFraction(): number;
    get cores(): number;
    get gpus(): number;
    get memory(): number;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy | undefined);
    get preemptible(): cdktf.IResolvable;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams | undefined);
    get description(): string;
    get imageId(): string;
    get size(): number;
    get snapshotId(): string;
    get type(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk | undefined);
    get deviceName(): string;
    get diskId(): string;
    private _initializeParams;
    get initializeParams(): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList;
    get mode(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference;
}
export interface DataYandexComputeInstanceGroupInstanceTemplate {
}
export declare function dataYandexComputeInstanceGroupInstanceTemplateToTerraform(struct?: DataYandexComputeInstanceGroupInstanceTemplate): any;
export declare class DataYandexComputeInstanceGroupInstanceTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstanceTemplate | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstanceTemplate | undefined);
    private _bootDisk;
    get bootDisk(): DataYandexComputeInstanceGroupInstanceTemplateBootDiskList;
    get description(): string;
    get hostname(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    private _metadata;
    get metadata(): cdktf.StringMap;
    get name(): string;
    private _networkInterface;
    get networkInterface(): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList;
    private _networkSettings;
    get networkSettings(): DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList;
    private _placementPolicy;
    get placementPolicy(): DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList;
    get platformId(): string;
    private _resources;
    get resources(): DataYandexComputeInstanceGroupInstanceTemplateResourcesList;
    private _schedulingPolicy;
    get schedulingPolicy(): DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList;
    private _secondaryDisk;
    get secondaryDisk(): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList;
    get serviceAccountId(): string;
}
export declare class DataYandexComputeInstanceGroupInstanceTemplateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstanceTemplateOutputReference;
}
export interface DataYandexComputeInstanceGroupInstancesNetworkInterface {
}
export declare function dataYandexComputeInstanceGroupInstancesNetworkInterfaceToTerraform(struct?: DataYandexComputeInstanceGroupInstancesNetworkInterface): any;
export declare class DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstancesNetworkInterface | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstancesNetworkInterface | undefined);
    get index(): number;
    get ipAddress(): string;
    get ipv4(): cdktf.IResolvable;
    get ipv6(): cdktf.IResolvable;
    get ipv6Address(): string;
    get macAddress(): string;
    get nat(): cdktf.IResolvable;
    get natIpAddress(): string;
    get natIpVersion(): string;
    get subnetId(): string;
}
export declare class DataYandexComputeInstanceGroupInstancesNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference;
}
export interface DataYandexComputeInstanceGroupInstances {
}
export declare function dataYandexComputeInstanceGroupInstancesToTerraform(struct?: DataYandexComputeInstanceGroupInstances): any;
export declare class DataYandexComputeInstanceGroupInstancesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupInstances | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupInstances | undefined);
    get fqdn(): string;
    get instanceId(): string;
    get name(): string;
    private _networkInterface;
    get networkInterface(): DataYandexComputeInstanceGroupInstancesNetworkInterfaceList;
    get status(): string;
    get statusChangedAt(): string;
    get statusMessage(): string;
    get zoneId(): string;
}
export declare class DataYandexComputeInstanceGroupInstancesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupInstancesOutputReference;
}
export interface DataYandexComputeInstanceGroupLoadBalancer {
}
export declare function dataYandexComputeInstanceGroupLoadBalancerToTerraform(struct?: DataYandexComputeInstanceGroupLoadBalancer): any;
export declare class DataYandexComputeInstanceGroupLoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupLoadBalancer | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupLoadBalancer | undefined);
    get maxOpeningTrafficDuration(): number;
    get statusMessage(): string;
    get targetGroupDescription(): string;
    get targetGroupId(): string;
    private _targetGroupLabels;
    get targetGroupLabels(): cdktf.StringMap;
    get targetGroupName(): string;
}
export declare class DataYandexComputeInstanceGroupLoadBalancerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupLoadBalancerOutputReference;
}
export interface DataYandexComputeInstanceGroupLoadBalancerState {
}
export declare function dataYandexComputeInstanceGroupLoadBalancerStateToTerraform(struct?: DataYandexComputeInstanceGroupLoadBalancerState): any;
export declare class DataYandexComputeInstanceGroupLoadBalancerStateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupLoadBalancerState | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupLoadBalancerState | undefined);
    get statusMessage(): string;
    get targetGroupId(): string;
}
export declare class DataYandexComputeInstanceGroupLoadBalancerStateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupLoadBalancerStateOutputReference;
}
export interface DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule {
}
export declare function dataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleToTerraform(struct?: DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule): any;
export declare class DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule | undefined);
    get folderId(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    get metricName(): string;
    get metricType(): string;
    get ruleType(): string;
    get service(): string;
    get target(): number;
}
export declare class DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference;
}
export interface DataYandexComputeInstanceGroupScalePolicyAutoScale {
}
export declare function dataYandexComputeInstanceGroupScalePolicyAutoScaleToTerraform(struct?: DataYandexComputeInstanceGroupScalePolicyAutoScale): any;
export declare class DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupScalePolicyAutoScale | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupScalePolicyAutoScale | undefined);
    get cpuUtilizationTarget(): number;
    private _customRule;
    get customRule(): DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList;
    get initialSize(): number;
    get maxSize(): number;
    get measurementDuration(): number;
    get minZoneSize(): number;
    get stabilizationDuration(): number;
    get warmupDuration(): number;
}
export declare class DataYandexComputeInstanceGroupScalePolicyAutoScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference;
}
export interface DataYandexComputeInstanceGroupScalePolicyFixedScale {
}
export declare function dataYandexComputeInstanceGroupScalePolicyFixedScaleToTerraform(struct?: DataYandexComputeInstanceGroupScalePolicyFixedScale): any;
export declare class DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupScalePolicyFixedScale | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupScalePolicyFixedScale | undefined);
    get size(): number;
}
export declare class DataYandexComputeInstanceGroupScalePolicyFixedScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference;
}
export interface DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule {
}
export declare function dataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleToTerraform(struct?: DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule): any;
export declare class DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule | undefined);
    get folderId(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    get metricName(): string;
    get metricType(): string;
    get ruleType(): string;
    get service(): string;
    get target(): number;
}
export declare class DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference;
}
export interface DataYandexComputeInstanceGroupScalePolicyTestAutoScale {
}
export declare function dataYandexComputeInstanceGroupScalePolicyTestAutoScaleToTerraform(struct?: DataYandexComputeInstanceGroupScalePolicyTestAutoScale): any;
export declare class DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupScalePolicyTestAutoScale | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupScalePolicyTestAutoScale | undefined);
    get cpuUtilizationTarget(): number;
    private _customRule;
    get customRule(): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList;
    get initialSize(): number;
    get maxSize(): number;
    get measurementDuration(): number;
    get minZoneSize(): number;
    get stabilizationDuration(): number;
    get warmupDuration(): number;
}
export declare class DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference;
}
export interface DataYandexComputeInstanceGroupScalePolicy {
}
export declare function dataYandexComputeInstanceGroupScalePolicyToTerraform(struct?: DataYandexComputeInstanceGroupScalePolicy): any;
export declare class DataYandexComputeInstanceGroupScalePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceGroupScalePolicy | undefined;
    set internalValue(value: DataYandexComputeInstanceGroupScalePolicy | undefined);
    private _autoScale;
    get autoScale(): DataYandexComputeInstanceGroupScalePolicyAutoScaleList;
    private _fixedScale;
    get fixedScale(): DataYandexComputeInstanceGroupScalePolicyFixedScaleList;
    private _testAutoScale;
    get testAutoScale(): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList;
}
export declare class DataYandexComputeInstanceGroupScalePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceGroupScalePolicyOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group yandex_compute_instance_group}
*/
export declare class DataYandexComputeInstanceGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_compute_instance_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group yandex_compute_instance_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexComputeInstanceGroupConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexComputeInstanceGroupConfig);
    private _allocationPolicy;
    get allocationPolicy(): DataYandexComputeInstanceGroupAllocationPolicyList;
    private _applicationBalancerState;
    get applicationBalancerState(): DataYandexComputeInstanceGroupApplicationBalancerStateList;
    private _applicationLoadBalancer;
    get applicationLoadBalancer(): DataYandexComputeInstanceGroupApplicationLoadBalancerList;
    get createdAt(): string;
    get deletionProtection(): cdktf.IResolvable;
    private _deployPolicy;
    get deployPolicy(): DataYandexComputeInstanceGroupDeployPolicyList;
    get description(): string;
    get folderId(): string;
    private _healthCheck;
    get healthCheck(): DataYandexComputeInstanceGroupHealthCheckList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _instanceGroupId?;
    get instanceGroupId(): string;
    set instanceGroupId(value: string);
    get instanceGroupIdInput(): string | undefined;
    private _instanceTemplate;
    get instanceTemplate(): DataYandexComputeInstanceGroupInstanceTemplateList;
    private _instances;
    get instances(): DataYandexComputeInstanceGroupInstancesList;
    private _labels;
    get labels(): cdktf.StringMap;
    private _loadBalancer;
    get loadBalancer(): DataYandexComputeInstanceGroupLoadBalancerList;
    private _loadBalancerState;
    get loadBalancerState(): DataYandexComputeInstanceGroupLoadBalancerStateList;
    get maxCheckingHealthDuration(): number;
    get name(): string;
    private _scalePolicy;
    get scalePolicy(): DataYandexComputeInstanceGroupScalePolicyList;
    get serviceAccountId(): string;
    get status(): string;
    private _variables;
    get variables(): cdktf.StringMap;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-compute-instance-group.d.ts.map