import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexComputeInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#folder_id DataYandexComputeInstance#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#id DataYandexComputeInstance#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#instance_id DataYandexComputeInstance#instance_id}
    */
    readonly instanceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#name DataYandexComputeInstance#name}
    */
    readonly name?: string;
    /**
    * placement_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#placement_policy DataYandexComputeInstance#placement_policy}
    */
    readonly placementPolicy?: DataYandexComputeInstancePlacementPolicy;
}
export interface DataYandexComputeInstanceBootDiskInitializeParams {
}
export declare function dataYandexComputeInstanceBootDiskInitializeParamsToTerraform(struct?: DataYandexComputeInstanceBootDiskInitializeParams): any;
export declare class DataYandexComputeInstanceBootDiskInitializeParamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceBootDiskInitializeParams | undefined;
    set internalValue(value: DataYandexComputeInstanceBootDiskInitializeParams | undefined);
    get blockSize(): number;
    get description(): string;
    get imageId(): string;
    get name(): string;
    get size(): number;
    get snapshotId(): string;
    get type(): string;
}
export declare class DataYandexComputeInstanceBootDiskInitializeParamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceBootDiskInitializeParamsOutputReference;
}
export interface DataYandexComputeInstanceBootDisk {
}
export declare function dataYandexComputeInstanceBootDiskToTerraform(struct?: DataYandexComputeInstanceBootDisk): any;
export declare class DataYandexComputeInstanceBootDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceBootDisk | undefined;
    set internalValue(value: DataYandexComputeInstanceBootDisk | undefined);
    get autoDelete(): cdktf.IResolvable;
    get deviceName(): string;
    get diskId(): string;
    private _initializeParams;
    get initializeParams(): DataYandexComputeInstanceBootDiskInitializeParamsList;
    get mode(): string;
}
export declare class DataYandexComputeInstanceBootDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceBootDiskOutputReference;
}
export interface DataYandexComputeInstanceNetworkInterfaceDnsRecord {
}
export declare function dataYandexComputeInstanceNetworkInterfaceDnsRecordToTerraform(struct?: DataYandexComputeInstanceNetworkInterfaceDnsRecord): any;
export declare class DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceNetworkInterfaceDnsRecord | undefined;
    set internalValue(value: DataYandexComputeInstanceNetworkInterfaceDnsRecord | undefined);
    get dnsZoneId(): string;
    get fqdn(): string;
    get ptr(): cdktf.IResolvable;
    get ttl(): number;
}
export declare class DataYandexComputeInstanceNetworkInterfaceDnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference;
}
export interface DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord {
}
export declare function dataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordToTerraform(struct?: DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord): any;
export declare class DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord | undefined;
    set internalValue(value: DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord | undefined);
    get dnsZoneId(): string;
    get fqdn(): string;
    get ptr(): cdktf.IResolvable;
    get ttl(): number;
}
export declare class DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference;
}
export interface DataYandexComputeInstanceNetworkInterfaceNatDnsRecord {
}
export declare function dataYandexComputeInstanceNetworkInterfaceNatDnsRecordToTerraform(struct?: DataYandexComputeInstanceNetworkInterfaceNatDnsRecord): any;
export declare class DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceNetworkInterfaceNatDnsRecord | undefined;
    set internalValue(value: DataYandexComputeInstanceNetworkInterfaceNatDnsRecord | undefined);
    get dnsZoneId(): string;
    get fqdn(): string;
    get ptr(): cdktf.IResolvable;
    get ttl(): number;
}
export declare class DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference;
}
export interface DataYandexComputeInstanceNetworkInterface {
}
export declare function dataYandexComputeInstanceNetworkInterfaceToTerraform(struct?: DataYandexComputeInstanceNetworkInterface): any;
export declare class DataYandexComputeInstanceNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceNetworkInterface | undefined;
    set internalValue(value: DataYandexComputeInstanceNetworkInterface | undefined);
    private _dnsRecord;
    get dnsRecord(): DataYandexComputeInstanceNetworkInterfaceDnsRecordList;
    get index(): number;
    get ipAddress(): string;
    get ipv4(): cdktf.IResolvable;
    get ipv6(): cdktf.IResolvable;
    get ipv6Address(): string;
    private _ipv6DnsRecord;
    get ipv6DnsRecord(): DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList;
    get macAddress(): string;
    get nat(): cdktf.IResolvable;
    private _natDnsRecord;
    get natDnsRecord(): DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList;
    get natIpAddress(): string;
    get natIpVersion(): string;
    get securityGroupIds(): string[];
    get subnetId(): string;
}
export declare class DataYandexComputeInstanceNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceNetworkInterfaceOutputReference;
}
export interface DataYandexComputeInstanceResources {
}
export declare function dataYandexComputeInstanceResourcesToTerraform(struct?: DataYandexComputeInstanceResources): any;
export declare class DataYandexComputeInstanceResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceResources | undefined;
    set internalValue(value: DataYandexComputeInstanceResources | undefined);
    get coreFraction(): number;
    get cores(): number;
    get gpus(): number;
    get memory(): number;
}
export declare class DataYandexComputeInstanceResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceResourcesOutputReference;
}
export interface DataYandexComputeInstanceSchedulingPolicy {
}
export declare function dataYandexComputeInstanceSchedulingPolicyToTerraform(struct?: DataYandexComputeInstanceSchedulingPolicy): any;
export declare class DataYandexComputeInstanceSchedulingPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceSchedulingPolicy | undefined;
    set internalValue(value: DataYandexComputeInstanceSchedulingPolicy | undefined);
    get preemptible(): cdktf.IResolvable;
}
export declare class DataYandexComputeInstanceSchedulingPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceSchedulingPolicyOutputReference;
}
export interface DataYandexComputeInstanceSecondaryDisk {
}
export declare function dataYandexComputeInstanceSecondaryDiskToTerraform(struct?: DataYandexComputeInstanceSecondaryDisk): any;
export declare class DataYandexComputeInstanceSecondaryDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstanceSecondaryDisk | undefined;
    set internalValue(value: DataYandexComputeInstanceSecondaryDisk | undefined);
    get autoDelete(): cdktf.IResolvable;
    get deviceName(): string;
    get diskId(): string;
    get mode(): string;
}
export declare class DataYandexComputeInstanceSecondaryDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstanceSecondaryDiskOutputReference;
}
export interface DataYandexComputeInstancePlacementPolicyHostAffinityRules {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#key DataYandexComputeInstance#key}
    */
    readonly key?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#op DataYandexComputeInstance#op}
    */
    readonly op?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#values DataYandexComputeInstance#values}
    */
    readonly values?: string[];
}
export declare function dataYandexComputeInstancePlacementPolicyHostAffinityRulesToTerraform(struct?: DataYandexComputeInstancePlacementPolicyHostAffinityRules | cdktf.IResolvable): any;
export declare class DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexComputeInstancePlacementPolicyHostAffinityRules | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexComputeInstancePlacementPolicyHostAffinityRules | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    resetKey(): void;
    get keyInput(): string | undefined;
    private _op?;
    get op(): string;
    set op(value: string);
    resetOp(): void;
    get opInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    resetValues(): void;
    get valuesInput(): string[] | undefined;
}
export declare class DataYandexComputeInstancePlacementPolicyHostAffinityRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexComputeInstancePlacementPolicyHostAffinityRules[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference;
}
export interface DataYandexComputeInstancePlacementPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#host_affinity_rules DataYandexComputeInstance#host_affinity_rules}
    */
    readonly hostAffinityRules?: DataYandexComputeInstancePlacementPolicyHostAffinityRules[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#placement_group_id DataYandexComputeInstance#placement_group_id}
    */
    readonly placementGroupId?: string;
}
export declare function dataYandexComputeInstancePlacementPolicyToTerraform(struct?: DataYandexComputeInstancePlacementPolicyOutputReference | DataYandexComputeInstancePlacementPolicy): any;
export declare class DataYandexComputeInstancePlacementPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexComputeInstancePlacementPolicy | undefined;
    set internalValue(value: DataYandexComputeInstancePlacementPolicy | undefined);
    private _hostAffinityRules;
    get hostAffinityRules(): DataYandexComputeInstancePlacementPolicyHostAffinityRulesList;
    putHostAffinityRules(value: DataYandexComputeInstancePlacementPolicyHostAffinityRules[] | cdktf.IResolvable): void;
    resetHostAffinityRules(): void;
    get hostAffinityRulesInput(): cdktf.IResolvable | DataYandexComputeInstancePlacementPolicyHostAffinityRules[] | undefined;
    private _placementGroupId?;
    get placementGroupId(): string;
    set placementGroupId(value: string);
    resetPlacementGroupId(): void;
    get placementGroupIdInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance yandex_compute_instance}
*/
export declare class DataYandexComputeInstance extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_compute_instance";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance yandex_compute_instance} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexComputeInstanceConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexComputeInstanceConfig);
    private _bootDisk;
    get bootDisk(): DataYandexComputeInstanceBootDiskList;
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get fqdn(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _instanceId?;
    get instanceId(): string;
    set instanceId(value: string);
    resetInstanceId(): void;
    get instanceIdInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _metadata;
    get metadata(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkAccelerationType(): string;
    private _networkInterface;
    get networkInterface(): DataYandexComputeInstanceNetworkInterfaceList;
    get platformId(): string;
    private _resources;
    get resources(): DataYandexComputeInstanceResourcesList;
    private _schedulingPolicy;
    get schedulingPolicy(): DataYandexComputeInstanceSchedulingPolicyList;
    private _secondaryDisk;
    get secondaryDisk(): DataYandexComputeInstanceSecondaryDiskList;
    get serviceAccountId(): string;
    get status(): string;
    get zone(): string;
    private _placementPolicy;
    get placementPolicy(): DataYandexComputeInstancePlacementPolicyOutputReference;
    putPlacementPolicy(value: DataYandexComputeInstancePlacementPolicy): void;
    resetPlacementPolicy(): void;
    get placementPolicyInput(): DataYandexComputeInstancePlacementPolicy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-compute-instance.d.ts.map