import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexComputeSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#folder_id DataYandexComputeSnapshot#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#id DataYandexComputeSnapshot#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#name DataYandexComputeSnapshot#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#snapshot_id DataYandexComputeSnapshot#snapshot_id}
    */
    readonly snapshotId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot yandex_compute_snapshot}
*/
export declare class DataYandexComputeSnapshot extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_compute_snapshot";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot yandex_compute_snapshot} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexComputeSnapshotConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexComputeSnapshotConfig);
    get createdAt(): string;
    get description(): string;
    get diskSize(): number;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get productIds(): string[];
    private _snapshotId?;
    get snapshotId(): string;
    set snapshotId(value: string);
    resetSnapshotId(): void;
    get snapshotIdInput(): string | undefined;
    get sourceDiskId(): string;
    get status(): string;
    get storageSize(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-compute-snapshot.d.ts.map