import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexContainerRegistryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#folder_id DataYandexContainerRegistry#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#id DataYandexContainerRegistry#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#labels DataYandexContainerRegistry#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#name DataYandexContainerRegistry#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#registry_id DataYandexContainerRegistry#registry_id}
    */
    readonly registryId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/container_registry yandex_container_registry}
*/
export declare class DataYandexContainerRegistry extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_container_registry";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/container_registry yandex_container_registry} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexContainerRegistryConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexContainerRegistryConfig);
    get createdAt(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _registryId?;
    get registryId(): string;
    set registryId(value: string);
    resetRegistryId(): void;
    get registryIdInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-container-registry.d.ts.map