import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexContainerRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#id DataYandexContainerRepository#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#name DataYandexContainerRepository#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#repository_id DataYandexContainerRepository#repository_id}
    */
    readonly repositoryId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/container_repository yandex_container_repository}
*/
export declare class DataYandexContainerRepository extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_container_repository";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/container_repository yandex_container_repository} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexContainerRepositoryConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexContainerRepositoryConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _repositoryId?;
    get repositoryId(): string;
    set repositoryId(value: string);
    resetRepositoryId(): void;
    get repositoryIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-container-repository.d.ts.map