import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexDataprocClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#cluster_id DataYandexDataprocCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#id DataYandexDataprocCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#name DataYandexDataprocCluster#name}
    */
    readonly name?: string;
}
export interface DataYandexDataprocClusterClusterConfigHadoop {
}
export declare function dataYandexDataprocClusterClusterConfigHadoopToTerraform(struct?: DataYandexDataprocClusterClusterConfigHadoop): any;
export declare class DataYandexDataprocClusterClusterConfigHadoopOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexDataprocClusterClusterConfigHadoop | undefined;
    set internalValue(value: DataYandexDataprocClusterClusterConfigHadoop | undefined);
    private _properties;
    get properties(): cdktf.StringMap;
    get services(): string[];
    get sshPublicKeys(): string[];
}
export declare class DataYandexDataprocClusterClusterConfigHadoopList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexDataprocClusterClusterConfigHadoopOutputReference;
}
export interface DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig {
}
export declare function dataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigToTerraform(struct?: DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig): any;
export declare class DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig | undefined;
    set internalValue(value: DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig | undefined);
    get cpuUtilizationTarget(): number;
    get decommissionTimeout(): number;
    get maxHostsCount(): number;
    get measurementDuration(): number;
    get preemptible(): cdktf.IResolvable;
    get stabilizationDuration(): number;
    get warmupDuration(): number;
}
export declare class DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference;
}
export interface DataYandexDataprocClusterClusterConfigSubclusterSpecResources {
}
export declare function dataYandexDataprocClusterClusterConfigSubclusterSpecResourcesToTerraform(struct?: DataYandexDataprocClusterClusterConfigSubclusterSpecResources): any;
export declare class DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexDataprocClusterClusterConfigSubclusterSpecResources | undefined;
    set internalValue(value: DataYandexDataprocClusterClusterConfigSubclusterSpecResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference;
}
export interface DataYandexDataprocClusterClusterConfigSubclusterSpec {
}
export declare function dataYandexDataprocClusterClusterConfigSubclusterSpecToTerraform(struct?: DataYandexDataprocClusterClusterConfigSubclusterSpec): any;
export declare class DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexDataprocClusterClusterConfigSubclusterSpec | undefined;
    set internalValue(value: DataYandexDataprocClusterClusterConfigSubclusterSpec | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    private _autoscalingConfig;
    get autoscalingConfig(): DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList;
    get hostsCount(): number;
    get id(): string;
    get name(): string;
    private _resources;
    get resources(): DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList;
    get role(): string;
    get subnetId(): string;
}
export declare class DataYandexDataprocClusterClusterConfigSubclusterSpecList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference;
}
export interface DataYandexDataprocClusterClusterConfig {
}
export declare function dataYandexDataprocClusterClusterConfigToTerraform(struct?: DataYandexDataprocClusterClusterConfig): any;
export declare class DataYandexDataprocClusterClusterConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexDataprocClusterClusterConfig | undefined;
    set internalValue(value: DataYandexDataprocClusterClusterConfig | undefined);
    private _hadoop;
    get hadoop(): DataYandexDataprocClusterClusterConfigHadoopList;
    private _subclusterSpec;
    get subclusterSpec(): DataYandexDataprocClusterClusterConfigSubclusterSpecList;
    get versionId(): string;
}
export declare class DataYandexDataprocClusterClusterConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexDataprocClusterClusterConfigOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster yandex_dataproc_cluster}
*/
export declare class DataYandexDataprocCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_dataproc_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster yandex_dataproc_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexDataprocClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexDataprocClusterConfig);
    get bucket(): string;
    private _clusterConfig;
    get clusterConfig(): DataYandexDataprocClusterClusterConfigList;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    get deletionProtection(): cdktf.IResolvable;
    get description(): string;
    get folderId(): string;
    get hostGroupIds(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get securityGroupIds(): string[];
    get serviceAccountId(): string;
    get uiProxy(): cdktf.IResolvable;
    get zoneId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-dataproc-cluster.d.ts.map