import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexDnsZoneConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#dns_zone_id DataYandexDnsZone#dns_zone_id}
    */
    readonly dnsZoneId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#folder_id DataYandexDnsZone#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#id DataYandexDnsZone#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#name DataYandexDnsZone#name}
    */
    readonly name?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#timeouts DataYandexDnsZone#timeouts}
    */
    readonly timeouts?: DataYandexDnsZoneTimeouts;
}
export interface DataYandexDnsZoneTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#create DataYandexDnsZone#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#delete DataYandexDnsZone#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#update DataYandexDnsZone#update}
    */
    readonly update?: string;
}
export declare function dataYandexDnsZoneTimeoutsToTerraform(struct?: DataYandexDnsZoneTimeoutsOutputReference | DataYandexDnsZoneTimeouts | cdktf.IResolvable): any;
export declare class DataYandexDnsZoneTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexDnsZoneTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexDnsZoneTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone yandex_dns_zone}
*/
export declare class DataYandexDnsZone extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_dns_zone";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone yandex_dns_zone} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexDnsZoneConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexDnsZoneConfig);
    get createdAt(): string;
    get description(): string;
    private _dnsZoneId?;
    get dnsZoneId(): string;
    set dnsZoneId(value: string);
    resetDnsZoneId(): void;
    get dnsZoneIdInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get privateNetworks(): string[];
    get public(): cdktf.IResolvable;
    get zone(): string;
    private _timeouts;
    get timeouts(): DataYandexDnsZoneTimeoutsOutputReference;
    putTimeouts(value: DataYandexDnsZoneTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DataYandexDnsZoneTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-dns-zone.d.ts.map