import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexFunctionScalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#function_id DataYandexFunctionScalingPolicy#function_id}
    */
    readonly functionId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#id DataYandexFunctionScalingPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#policy DataYandexFunctionScalingPolicy#policy}
    */
    readonly policy?: DataYandexFunctionScalingPolicyPolicy[] | cdktf.IResolvable;
}
export interface DataYandexFunctionScalingPolicyPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_instances_limit DataYandexFunctionScalingPolicy#zone_instances_limit}
    */
    readonly zoneInstancesLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_requests_limit DataYandexFunctionScalingPolicy#zone_requests_limit}
    */
    readonly zoneRequestsLimit?: number;
}
export declare function dataYandexFunctionScalingPolicyPolicyToTerraform(struct?: DataYandexFunctionScalingPolicyPolicy | cdktf.IResolvable): any;
export declare class DataYandexFunctionScalingPolicyPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionScalingPolicyPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexFunctionScalingPolicyPolicy | cdktf.IResolvable | undefined);
    get tag(): string;
    private _zoneInstancesLimit?;
    get zoneInstancesLimit(): number;
    set zoneInstancesLimit(value: number);
    resetZoneInstancesLimit(): void;
    get zoneInstancesLimitInput(): number | undefined;
    private _zoneRequestsLimit?;
    get zoneRequestsLimit(): number;
    set zoneRequestsLimit(value: number);
    resetZoneRequestsLimit(): void;
    get zoneRequestsLimitInput(): number | undefined;
}
export declare class DataYandexFunctionScalingPolicyPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexFunctionScalingPolicyPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionScalingPolicyPolicyOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy yandex_function_scaling_policy}
*/
export declare class DataYandexFunctionScalingPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_function_scaling_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy yandex_function_scaling_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexFunctionScalingPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexFunctionScalingPolicyConfig);
    private _functionId?;
    get functionId(): string;
    set functionId(value: string);
    get functionIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _policy;
    get policy(): DataYandexFunctionScalingPolicyPolicyList;
    putPolicy(value: DataYandexFunctionScalingPolicyPolicy[] | cdktf.IResolvable): void;
    resetPolicy(): void;
    get policyInput(): cdktf.IResolvable | DataYandexFunctionScalingPolicyPolicy[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-function-scaling-policy.d.ts.map