import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexFunctionTriggerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#folder_id DataYandexFunctionTrigger#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#id DataYandexFunctionTrigger#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#name DataYandexFunctionTrigger#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#trigger_id DataYandexFunctionTrigger#trigger_id}
    */
    readonly triggerId?: string;
}
export interface DataYandexFunctionTriggerDlq {
}
export declare function dataYandexFunctionTriggerDlqToTerraform(struct?: DataYandexFunctionTriggerDlq): any;
export declare class DataYandexFunctionTriggerDlqOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerDlq | undefined;
    set internalValue(value: DataYandexFunctionTriggerDlq | undefined);
    get queueId(): string;
    get serviceAccountId(): string;
}
export declare class DataYandexFunctionTriggerDlqList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerDlqOutputReference;
}
export interface DataYandexFunctionTriggerFunction {
}
export declare function dataYandexFunctionTriggerFunctionToTerraform(struct?: DataYandexFunctionTriggerFunction): any;
export declare class DataYandexFunctionTriggerFunctionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerFunction | undefined;
    set internalValue(value: DataYandexFunctionTriggerFunction | undefined);
    get id(): string;
    get retryAttempts(): string;
    get retryInterval(): string;
    get serviceAccountId(): string;
    get tag(): string;
}
export declare class DataYandexFunctionTriggerFunctionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerFunctionOutputReference;
}
export interface DataYandexFunctionTriggerIot {
}
export declare function dataYandexFunctionTriggerIotToTerraform(struct?: DataYandexFunctionTriggerIot): any;
export declare class DataYandexFunctionTriggerIotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerIot | undefined;
    set internalValue(value: DataYandexFunctionTriggerIot | undefined);
    get deviceId(): string;
    get registryId(): string;
    get topic(): string;
}
export declare class DataYandexFunctionTriggerIotList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerIotOutputReference;
}
export interface DataYandexFunctionTriggerLogGroup {
}
export declare function dataYandexFunctionTriggerLogGroupToTerraform(struct?: DataYandexFunctionTriggerLogGroup): any;
export declare class DataYandexFunctionTriggerLogGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerLogGroup | undefined;
    set internalValue(value: DataYandexFunctionTriggerLogGroup | undefined);
    get batchCutoff(): string;
    get batchSize(): string;
    get logGroupIds(): string[];
}
export declare class DataYandexFunctionTriggerLogGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerLogGroupOutputReference;
}
export interface DataYandexFunctionTriggerLogging {
}
export declare function dataYandexFunctionTriggerLoggingToTerraform(struct?: DataYandexFunctionTriggerLogging): any;
export declare class DataYandexFunctionTriggerLoggingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerLogging | undefined;
    set internalValue(value: DataYandexFunctionTriggerLogging | undefined);
    get batchCutoff(): string;
    get batchSize(): string;
    get groupId(): string;
    get levels(): string[];
    get resourceIds(): string[];
    get resourceTypes(): string[];
}
export declare class DataYandexFunctionTriggerLoggingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerLoggingOutputReference;
}
export interface DataYandexFunctionTriggerMessageQueue {
}
export declare function dataYandexFunctionTriggerMessageQueueToTerraform(struct?: DataYandexFunctionTriggerMessageQueue): any;
export declare class DataYandexFunctionTriggerMessageQueueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerMessageQueue | undefined;
    set internalValue(value: DataYandexFunctionTriggerMessageQueue | undefined);
    get batchCutoff(): string;
    get batchSize(): string;
    get queueId(): string;
    get serviceAccountId(): string;
    get visibilityTimeout(): string;
}
export declare class DataYandexFunctionTriggerMessageQueueList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerMessageQueueOutputReference;
}
export interface DataYandexFunctionTriggerObjectStorage {
}
export declare function dataYandexFunctionTriggerObjectStorageToTerraform(struct?: DataYandexFunctionTriggerObjectStorage): any;
export declare class DataYandexFunctionTriggerObjectStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerObjectStorage | undefined;
    set internalValue(value: DataYandexFunctionTriggerObjectStorage | undefined);
    get bucketId(): string;
    get create(): cdktf.IResolvable;
    get delete(): cdktf.IResolvable;
    get prefix(): string;
    get suffix(): string;
    get update(): cdktf.IResolvable;
}
export declare class DataYandexFunctionTriggerObjectStorageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerObjectStorageOutputReference;
}
export interface DataYandexFunctionTriggerTimer {
}
export declare function dataYandexFunctionTriggerTimerToTerraform(struct?: DataYandexFunctionTriggerTimer): any;
export declare class DataYandexFunctionTriggerTimerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexFunctionTriggerTimer | undefined;
    set internalValue(value: DataYandexFunctionTriggerTimer | undefined);
    get cronExpression(): string;
}
export declare class DataYandexFunctionTriggerTimerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexFunctionTriggerTimerOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger yandex_function_trigger}
*/
export declare class DataYandexFunctionTrigger extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_function_trigger";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger yandex_function_trigger} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexFunctionTriggerConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexFunctionTriggerConfig);
    get createdAt(): string;
    get description(): string;
    private _dlq;
    get dlq(): DataYandexFunctionTriggerDlqList;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _function;
    get function(): DataYandexFunctionTriggerFunctionList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _iot;
    get iot(): DataYandexFunctionTriggerIotList;
    private _labels;
    get labels(): cdktf.StringMap;
    private _logGroup;
    get logGroup(): DataYandexFunctionTriggerLogGroupList;
    private _logging;
    get logging(): DataYandexFunctionTriggerLoggingList;
    private _messageQueue;
    get messageQueue(): DataYandexFunctionTriggerMessageQueueList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _objectStorage;
    get objectStorage(): DataYandexFunctionTriggerObjectStorageList;
    private _timer;
    get timer(): DataYandexFunctionTriggerTimerList;
    private _triggerId?;
    get triggerId(): string;
    set triggerId(value: string);
    resetTriggerId(): void;
    get triggerIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-function-trigger.d.ts.map