import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIamPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#id DataYandexIamPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * binding block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#binding DataYandexIamPolicy#binding}
    */
    readonly binding: DataYandexIamPolicyBinding[] | cdktf.IResolvable;
}
export interface DataYandexIamPolicyBinding {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#members DataYandexIamPolicy#members}
    */
    readonly members: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#role DataYandexIamPolicy#role}
    */
    readonly role: string;
}
export declare function dataYandexIamPolicyBindingToTerraform(struct?: DataYandexIamPolicyBinding | cdktf.IResolvable): any;
export declare class DataYandexIamPolicyBindingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexIamPolicyBinding | cdktf.IResolvable | undefined;
    set internalValue(value: DataYandexIamPolicyBinding | cdktf.IResolvable | undefined);
    private _members?;
    get members(): string[];
    set members(value: string[]);
    get membersInput(): string[] | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
}
export declare class DataYandexIamPolicyBindingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataYandexIamPolicyBinding[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexIamPolicyBindingOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy yandex_iam_policy}
*/
export declare class DataYandexIamPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iam_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy yandex_iam_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIamPolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexIamPolicyConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get policyData(): string;
    private _binding;
    get binding(): DataYandexIamPolicyBindingList;
    putBinding(value: DataYandexIamPolicyBinding[] | cdktf.IResolvable): void;
    get bindingInput(): cdktf.IResolvable | DataYandexIamPolicyBinding[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iam-policy.d.ts.map