import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIamRoleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#description DataYandexIamRole#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#id DataYandexIamRole#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#role_id DataYandexIamRole#role_id}
    */
    readonly roleId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_role yandex_iam_role}
*/
export declare class DataYandexIamRole extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iam_role";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iam_role yandex_iam_role} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIamRoleConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexIamRoleConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _roleId?;
    get roleId(): string;
    set roleId(value: string);
    resetRoleId(): void;
    get roleIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iam-role.d.ts.map