import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIamServiceAccountConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#folder_id DataYandexIamServiceAccount#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#id DataYandexIamServiceAccount#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#name DataYandexIamServiceAccount#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#service_account_id DataYandexIamServiceAccount#service_account_id}
    */
    readonly serviceAccountId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account yandex_iam_service_account}
*/
export declare class DataYandexIamServiceAccount extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iam_service_account";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account yandex_iam_service_account} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIamServiceAccountConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexIamServiceAccountConfig);
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    resetServiceAccountId(): void;
    get serviceAccountIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iam-service-account.d.ts.map