import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIamUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#id DataYandexIamUser#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#login DataYandexIamUser#login}
    */
    readonly login?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#user_id DataYandexIamUser#user_id}
    */
    readonly userId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_user yandex_iam_user}
*/
export declare class DataYandexIamUser extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iam_user";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iam_user yandex_iam_user} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIamUserConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexIamUserConfig);
    get defaultEmail(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _login?;
    get login(): string;
    set login(value: string);
    resetLogin(): void;
    get loginInput(): string | undefined;
    private _userId?;
    get userId(): string;
    set userId(value: string);
    resetUserId(): void;
    get userIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iam-user.d.ts.map