import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIotCoreDeviceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#device_id DataYandexIotCoreDevice#device_id}
    */
    readonly deviceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#id DataYandexIotCoreDevice#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#name DataYandexIotCoreDevice#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device yandex_iot_core_device}
*/
export declare class DataYandexIotCoreDevice extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iot_core_device";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device yandex_iot_core_device} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIotCoreDeviceConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexIotCoreDeviceConfig);
    private _aliases;
    get aliases(): cdktf.StringMap;
    get certificates(): string[];
    get createdAt(): string;
    get description(): string;
    private _deviceId?;
    get deviceId(): string;
    set deviceId(value: string);
    resetDeviceId(): void;
    get deviceIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get passwords(): string[];
    get registryId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iot-core-device.d.ts.map