import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIotCoreRegistryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#folder_id DataYandexIotCoreRegistry#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#id DataYandexIotCoreRegistry#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#name DataYandexIotCoreRegistry#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#registry_id DataYandexIotCoreRegistry#registry_id}
    */
    readonly registryId?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry yandex_iot_core_registry}
*/
export declare class DataYandexIotCoreRegistry extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iot_core_registry";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry yandex_iot_core_registry} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIotCoreRegistryConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexIotCoreRegistryConfig);
    get certificates(): string[];
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get passwords(): string[];
    private _registryId?;
    get registryId(): string;
    set registryId(value: string);
    resetRegistryId(): void;
    get registryIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iot-core-registry.d.ts.map