import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexKubernetesClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#cluster_id DataYandexKubernetesCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#folder_id DataYandexKubernetesCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#id DataYandexKubernetesCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#name DataYandexKubernetesCluster#name}
    */
    readonly name?: string;
}
export interface DataYandexKubernetesClusterKmsProvider {
}
export declare function dataYandexKubernetesClusterKmsProviderToTerraform(struct?: DataYandexKubernetesClusterKmsProvider): any;
export declare class DataYandexKubernetesClusterKmsProviderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterKmsProvider | undefined;
    set internalValue(value: DataYandexKubernetesClusterKmsProvider | undefined);
    get keyId(): string;
}
export declare class DataYandexKubernetesClusterKmsProviderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterKmsProviderOutputReference;
}
export interface DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow {
}
export declare function dataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowToTerraform(struct?: DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow): any;
export declare class DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow | undefined;
    set internalValue(value: DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow | undefined);
    get day(): string;
    get duration(): string;
    get startTime(): string;
}
export declare class DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference;
}
export interface DataYandexKubernetesClusterMasterMaintenancePolicy {
}
export declare function dataYandexKubernetesClusterMasterMaintenancePolicyToTerraform(struct?: DataYandexKubernetesClusterMasterMaintenancePolicy): any;
export declare class DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterMasterMaintenancePolicy | undefined;
    set internalValue(value: DataYandexKubernetesClusterMasterMaintenancePolicy | undefined);
    get autoUpgrade(): cdktf.IResolvable;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList;
}
export declare class DataYandexKubernetesClusterMasterMaintenancePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference;
}
export interface DataYandexKubernetesClusterMasterRegional {
}
export declare function dataYandexKubernetesClusterMasterRegionalToTerraform(struct?: DataYandexKubernetesClusterMasterRegional): any;
export declare class DataYandexKubernetesClusterMasterRegionalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterMasterRegional | undefined;
    set internalValue(value: DataYandexKubernetesClusterMasterRegional | undefined);
    get region(): string;
}
export declare class DataYandexKubernetesClusterMasterRegionalList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterMasterRegionalOutputReference;
}
export interface DataYandexKubernetesClusterMasterVersionInfo {
}
export declare function dataYandexKubernetesClusterMasterVersionInfoToTerraform(struct?: DataYandexKubernetesClusterMasterVersionInfo): any;
export declare class DataYandexKubernetesClusterMasterVersionInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterMasterVersionInfo | undefined;
    set internalValue(value: DataYandexKubernetesClusterMasterVersionInfo | undefined);
    get currentVersion(): string;
    get newRevisionAvailable(): cdktf.IResolvable;
    get newRevisionSummary(): string;
    get versionDeprecated(): cdktf.IResolvable;
}
export declare class DataYandexKubernetesClusterMasterVersionInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterMasterVersionInfoOutputReference;
}
export interface DataYandexKubernetesClusterMasterZonal {
}
export declare function dataYandexKubernetesClusterMasterZonalToTerraform(struct?: DataYandexKubernetesClusterMasterZonal): any;
export declare class DataYandexKubernetesClusterMasterZonalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterMasterZonal | undefined;
    set internalValue(value: DataYandexKubernetesClusterMasterZonal | undefined);
    get zone(): string;
}
export declare class DataYandexKubernetesClusterMasterZonalList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterMasterZonalOutputReference;
}
export interface DataYandexKubernetesClusterMaster {
}
export declare function dataYandexKubernetesClusterMasterToTerraform(struct?: DataYandexKubernetesClusterMaster): any;
export declare class DataYandexKubernetesClusterMasterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterMaster | undefined;
    set internalValue(value: DataYandexKubernetesClusterMaster | undefined);
    get clusterCaCertificate(): string;
    get externalV4Address(): string;
    get externalV4Endpoint(): string;
    get internalV4Address(): string;
    get internalV4Endpoint(): string;
    private _maintenancePolicy;
    get maintenancePolicy(): DataYandexKubernetesClusterMasterMaintenancePolicyList;
    get publicIp(): cdktf.IResolvable;
    private _regional;
    get regional(): DataYandexKubernetesClusterMasterRegionalList;
    get securityGroupIds(): string[];
    get version(): string;
    private _versionInfo;
    get versionInfo(): DataYandexKubernetesClusterMasterVersionInfoList;
    private _zonal;
    get zonal(): DataYandexKubernetesClusterMasterZonalList;
}
export declare class DataYandexKubernetesClusterMasterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterMasterOutputReference;
}
export interface DataYandexKubernetesClusterNetworkImplementationCilium {
}
export declare function dataYandexKubernetesClusterNetworkImplementationCiliumToTerraform(struct?: DataYandexKubernetesClusterNetworkImplementationCilium): any;
export declare class DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterNetworkImplementationCilium | undefined;
    set internalValue(value: DataYandexKubernetesClusterNetworkImplementationCilium | undefined);
    get routingMode(): string;
}
export declare class DataYandexKubernetesClusterNetworkImplementationCiliumList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference;
}
export interface DataYandexKubernetesClusterNetworkImplementation {
}
export declare function dataYandexKubernetesClusterNetworkImplementationToTerraform(struct?: DataYandexKubernetesClusterNetworkImplementation): any;
export declare class DataYandexKubernetesClusterNetworkImplementationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesClusterNetworkImplementation | undefined;
    set internalValue(value: DataYandexKubernetesClusterNetworkImplementation | undefined);
    private _cilium;
    get cilium(): DataYandexKubernetesClusterNetworkImplementationCiliumList;
}
export declare class DataYandexKubernetesClusterNetworkImplementationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesClusterNetworkImplementationOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster yandex_kubernetes_cluster}
*/
export declare class DataYandexKubernetesCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_kubernetes_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster yandex_kubernetes_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexKubernetesClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexKubernetesClusterConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    get clusterIpv4Range(): string;
    get clusterIpv6Range(): string;
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _kmsProvider;
    get kmsProvider(): DataYandexKubernetesClusterKmsProviderList;
    private _labels;
    get labels(): cdktf.StringMap;
    get logGroupId(): string;
    private _master;
    get master(): DataYandexKubernetesClusterMasterList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _networkImplementation;
    get networkImplementation(): DataYandexKubernetesClusterNetworkImplementationList;
    get networkPolicyProvider(): string;
    get nodeIpv4CidrMaskSize(): number;
    get nodeServiceAccountId(): string;
    get releaseChannel(): string;
    get serviceAccountId(): string;
    get serviceIpv4Range(): string;
    get serviceIpv6Range(): string;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-kubernetes-cluster.d.ts.map