import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexKubernetesNodeGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#folder_id DataYandexKubernetesNodeGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#id DataYandexKubernetesNodeGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#name DataYandexKubernetesNodeGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#node_group_id DataYandexKubernetesNodeGroup#node_group_id}
    */
    readonly nodeGroupId?: string;
}
export interface DataYandexKubernetesNodeGroupAllocationPolicyLocation {
}
export declare function dataYandexKubernetesNodeGroupAllocationPolicyLocationToTerraform(struct?: DataYandexKubernetesNodeGroupAllocationPolicyLocation): any;
export declare class DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupAllocationPolicyLocation | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupAllocationPolicyLocation | undefined);
    get subnetId(): string;
    get zone(): string;
}
export declare class DataYandexKubernetesNodeGroupAllocationPolicyLocationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference;
}
export interface DataYandexKubernetesNodeGroupAllocationPolicy {
}
export declare function dataYandexKubernetesNodeGroupAllocationPolicyToTerraform(struct?: DataYandexKubernetesNodeGroupAllocationPolicy): any;
export declare class DataYandexKubernetesNodeGroupAllocationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupAllocationPolicy | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupAllocationPolicy | undefined);
    private _location;
    get location(): DataYandexKubernetesNodeGroupAllocationPolicyLocationList;
}
export declare class DataYandexKubernetesNodeGroupAllocationPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupAllocationPolicyOutputReference;
}
export interface DataYandexKubernetesNodeGroupDeployPolicy {
}
export declare function dataYandexKubernetesNodeGroupDeployPolicyToTerraform(struct?: DataYandexKubernetesNodeGroupDeployPolicy): any;
export declare class DataYandexKubernetesNodeGroupDeployPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupDeployPolicy | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupDeployPolicy | undefined);
    get maxExpansion(): number;
    get maxUnavailable(): number;
}
export declare class DataYandexKubernetesNodeGroupDeployPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupDeployPolicyOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplateBootDisk {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplateBootDiskToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplateBootDisk): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplateBootDisk | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplateBootDisk | undefined);
    get size(): number;
    get type(): string;
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime | undefined);
    get type(): string;
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface | undefined);
    get ipv4(): cdktf.IResolvable;
    get ipv6(): cdktf.IResolvable;
    get nat(): cdktf.IResolvable;
    get securityGroupIds(): string[];
    get subnetIds(): string[];
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy | undefined);
    get placementGroupId(): string;
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplateResources {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplateResourcesToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplateResources): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplateResources | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplateResources | undefined);
    get coreFraction(): number;
    get cores(): number;
    get gpus(): number;
    get memory(): number;
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplateResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy | undefined);
    get preemptible(): cdktf.IResolvable;
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference;
}
export interface DataYandexKubernetesNodeGroupInstanceTemplate {
}
export declare function dataYandexKubernetesNodeGroupInstanceTemplateToTerraform(struct?: DataYandexKubernetesNodeGroupInstanceTemplate): any;
export declare class DataYandexKubernetesNodeGroupInstanceTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupInstanceTemplate | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupInstanceTemplate | undefined);
    private _bootDisk;
    get bootDisk(): DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList;
    private _containerRuntime;
    get containerRuntime(): DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList;
    private _metadata;
    get metadata(): cdktf.StringMap;
    get nat(): cdktf.IResolvable;
    get networkAccelerationType(): string;
    private _networkInterface;
    get networkInterface(): DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList;
    private _placementPolicy;
    get placementPolicy(): DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList;
    get platformId(): string;
    private _resources;
    get resources(): DataYandexKubernetesNodeGroupInstanceTemplateResourcesList;
    private _schedulingPolicy;
    get schedulingPolicy(): DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList;
}
export declare class DataYandexKubernetesNodeGroupInstanceTemplateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateOutputReference;
}
export interface DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow {
}
export declare function dataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowToTerraform(struct?: DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow): any;
export declare class DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow | undefined);
    get day(): string;
    get duration(): string;
    get startTime(): string;
}
export declare class DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference;
}
export interface DataYandexKubernetesNodeGroupMaintenancePolicy {
}
export declare function dataYandexKubernetesNodeGroupMaintenancePolicyToTerraform(struct?: DataYandexKubernetesNodeGroupMaintenancePolicy): any;
export declare class DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupMaintenancePolicy | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupMaintenancePolicy | undefined);
    get autoRepair(): cdktf.IResolvable;
    get autoUpgrade(): cdktf.IResolvable;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList;
}
export declare class DataYandexKubernetesNodeGroupMaintenancePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference;
}
export interface DataYandexKubernetesNodeGroupScalePolicyAutoScale {
}
export declare function dataYandexKubernetesNodeGroupScalePolicyAutoScaleToTerraform(struct?: DataYandexKubernetesNodeGroupScalePolicyAutoScale): any;
export declare class DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupScalePolicyAutoScale | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupScalePolicyAutoScale | undefined);
    get initial(): number;
    get max(): number;
    get min(): number;
}
export declare class DataYandexKubernetesNodeGroupScalePolicyAutoScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference;
}
export interface DataYandexKubernetesNodeGroupScalePolicyFixedScale {
}
export declare function dataYandexKubernetesNodeGroupScalePolicyFixedScaleToTerraform(struct?: DataYandexKubernetesNodeGroupScalePolicyFixedScale): any;
export declare class DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupScalePolicyFixedScale | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupScalePolicyFixedScale | undefined);
    get size(): number;
}
export declare class DataYandexKubernetesNodeGroupScalePolicyFixedScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference;
}
export interface DataYandexKubernetesNodeGroupScalePolicy {
}
export declare function dataYandexKubernetesNodeGroupScalePolicyToTerraform(struct?: DataYandexKubernetesNodeGroupScalePolicy): any;
export declare class DataYandexKubernetesNodeGroupScalePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupScalePolicy | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupScalePolicy | undefined);
    private _autoScale;
    get autoScale(): DataYandexKubernetesNodeGroupScalePolicyAutoScaleList;
    private _fixedScale;
    get fixedScale(): DataYandexKubernetesNodeGroupScalePolicyFixedScaleList;
}
export declare class DataYandexKubernetesNodeGroupScalePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupScalePolicyOutputReference;
}
export interface DataYandexKubernetesNodeGroupVersionInfo {
}
export declare function dataYandexKubernetesNodeGroupVersionInfoToTerraform(struct?: DataYandexKubernetesNodeGroupVersionInfo): any;
export declare class DataYandexKubernetesNodeGroupVersionInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexKubernetesNodeGroupVersionInfo | undefined;
    set internalValue(value: DataYandexKubernetesNodeGroupVersionInfo | undefined);
    get currentVersion(): string;
    get newRevisionAvailable(): cdktf.IResolvable;
    get newRevisionSummary(): string;
    get versionDeprecated(): cdktf.IResolvable;
}
export declare class DataYandexKubernetesNodeGroupVersionInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexKubernetesNodeGroupVersionInfoOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group yandex_kubernetes_node_group}
*/
export declare class DataYandexKubernetesNodeGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_kubernetes_node_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group yandex_kubernetes_node_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexKubernetesNodeGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexKubernetesNodeGroupConfig);
    private _allocationPolicy;
    get allocationPolicy(): DataYandexKubernetesNodeGroupAllocationPolicyList;
    get allowedUnsafeSysctls(): string[];
    get clusterId(): string;
    get createdAt(): string;
    private _deployPolicy;
    get deployPolicy(): DataYandexKubernetesNodeGroupDeployPolicyList;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get instanceGroupId(): string;
    private _instanceTemplate;
    get instanceTemplate(): DataYandexKubernetesNodeGroupInstanceTemplateList;
    private _labels;
    get labels(): cdktf.StringMap;
    private _maintenancePolicy;
    get maintenancePolicy(): DataYandexKubernetesNodeGroupMaintenancePolicyList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _nodeGroupId?;
    get nodeGroupId(): string;
    set nodeGroupId(value: string);
    resetNodeGroupId(): void;
    get nodeGroupIdInput(): string | undefined;
    private _nodeLabels;
    get nodeLabels(): cdktf.StringMap;
    get nodeTaints(): string[];
    private _scalePolicy;
    get scalePolicy(): DataYandexKubernetesNodeGroupScalePolicyList;
    get status(): string;
    private _versionInfo;
    get versionInfo(): DataYandexKubernetesNodeGroupVersionInfoList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-kubernetes-node-group.d.ts.map