import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexLbNetworkLoadBalancerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#folder_id DataYandexLbNetworkLoadBalancer#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#id DataYandexLbNetworkLoadBalancer#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#name DataYandexLbNetworkLoadBalancer#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#network_load_balancer_id DataYandexLbNetworkLoadBalancer#network_load_balancer_id}
    */
    readonly networkLoadBalancerId?: string;
}
export interface DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions {
}
export declare function dataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsToTerraform(struct?: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions): any;
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined);
    get path(): string;
    get port(): number;
}
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference;
}
export interface DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions {
}
export declare function dataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsToTerraform(struct?: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions): any;
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined);
    get port(): number;
}
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference;
}
export interface DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck {
}
export declare function dataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckToTerraform(struct?: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck): any;
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck | undefined);
    get healthyThreshold(): number;
    private _httpOptions;
    get httpOptions(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList;
    get interval(): number;
    get name(): string;
    private _tcpOptions;
    get tcpOptions(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList;
    get timeout(): number;
    get unhealthyThreshold(): number;
}
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference;
}
export interface DataYandexLbNetworkLoadBalancerAttachedTargetGroup {
}
export declare function dataYandexLbNetworkLoadBalancerAttachedTargetGroupToTerraform(struct?: DataYandexLbNetworkLoadBalancerAttachedTargetGroup): any;
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerAttachedTargetGroup | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerAttachedTargetGroup | undefined);
    private _healthcheck;
    get healthcheck(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList;
    get targetGroupId(): string;
}
export declare class DataYandexLbNetworkLoadBalancerAttachedTargetGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference;
}
export interface DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec {
}
export declare function dataYandexLbNetworkLoadBalancerListenerExternalAddressSpecToTerraform(struct?: DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec): any;
export declare class DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec | undefined);
    get address(): string;
    get ipVersion(): string;
}
export declare class DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference;
}
export interface DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec {
}
export declare function dataYandexLbNetworkLoadBalancerListenerInternalAddressSpecToTerraform(struct?: DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec): any;
export declare class DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec | undefined);
    get address(): string;
    get ipVersion(): string;
    get subnetId(): string;
}
export declare class DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference;
}
export interface DataYandexLbNetworkLoadBalancerListener {
}
export declare function dataYandexLbNetworkLoadBalancerListenerToTerraform(struct?: DataYandexLbNetworkLoadBalancerListener): any;
export declare class DataYandexLbNetworkLoadBalancerListenerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbNetworkLoadBalancerListener | undefined;
    set internalValue(value: DataYandexLbNetworkLoadBalancerListener | undefined);
    private _externalAddressSpec;
    get externalAddressSpec(): DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList;
    private _internalAddressSpec;
    get internalAddressSpec(): DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList;
    get name(): string;
    get port(): number;
    get protocol(): string;
    get targetPort(): number;
}
export declare class DataYandexLbNetworkLoadBalancerListenerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbNetworkLoadBalancerListenerOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer yandex_lb_network_load_balancer}
*/
export declare class DataYandexLbNetworkLoadBalancer extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_lb_network_load_balancer";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer yandex_lb_network_load_balancer} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexLbNetworkLoadBalancerConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexLbNetworkLoadBalancerConfig);
    private _attachedTargetGroup;
    get attachedTargetGroup(): DataYandexLbNetworkLoadBalancerAttachedTargetGroupList;
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _listener;
    get listener(): DataYandexLbNetworkLoadBalancerListenerList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkLoadBalancerId?;
    get networkLoadBalancerId(): string;
    set networkLoadBalancerId(value: string);
    resetNetworkLoadBalancerId(): void;
    get networkLoadBalancerIdInput(): string | undefined;
    get regionId(): string;
    get type(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-lb-network-load-balancer.d.ts.map