import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexLbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#folder_id DataYandexLbTargetGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#id DataYandexLbTargetGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#name DataYandexLbTargetGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#target_group_id DataYandexLbTargetGroup#target_group_id}
    */
    readonly targetGroupId?: string;
}
export interface DataYandexLbTargetGroupTarget {
}
export declare function dataYandexLbTargetGroupTargetToTerraform(struct?: DataYandexLbTargetGroupTarget): any;
export declare class DataYandexLbTargetGroupTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexLbTargetGroupTarget | undefined;
    set internalValue(value: DataYandexLbTargetGroupTarget | undefined);
    get address(): string;
    get subnetId(): string;
}
export declare class DataYandexLbTargetGroupTargetList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexLbTargetGroupTargetOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group yandex_lb_target_group}
*/
export declare class DataYandexLbTargetGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_lb_target_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group yandex_lb_target_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexLbTargetGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexLbTargetGroupConfig);
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _target;
    get target(): DataYandexLbTargetGroupTargetList;
    private _targetGroupId?;
    get targetGroupId(): string;
    set targetGroupId(value: string);
    resetTargetGroupId(): void;
    get targetGroupIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-lb-target-group.d.ts.map