import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbElasticsearchClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#cluster_id DataYandexMdbElasticsearchCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#deletion_protection DataYandexMdbElasticsearchCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#description DataYandexMdbElasticsearchCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#folder_id DataYandexMdbElasticsearchCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#id DataYandexMdbElasticsearchCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#labels DataYandexMdbElasticsearchCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#name DataYandexMdbElasticsearchCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#security_group_ids DataYandexMdbElasticsearchCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#service_account_id DataYandexMdbElasticsearchCluster#service_account_id}
    */
    readonly serviceAccountId?: string;
}
export interface DataYandexMdbElasticsearchClusterConfigDataNodeResources {
}
export declare function dataYandexMdbElasticsearchClusterConfigDataNodeResourcesToTerraform(struct?: DataYandexMdbElasticsearchClusterConfigDataNodeResources): any;
export declare class DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterConfigDataNodeResources | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterConfigDataNodeResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference;
}
export interface DataYandexMdbElasticsearchClusterConfigDataNode {
}
export declare function dataYandexMdbElasticsearchClusterConfigDataNodeToTerraform(struct?: DataYandexMdbElasticsearchClusterConfigDataNode): any;
export declare class DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterConfigDataNode | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterConfigDataNode | undefined);
    private _resources;
    get resources(): DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList;
}
export declare class DataYandexMdbElasticsearchClusterConfigDataNodeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference;
}
export interface DataYandexMdbElasticsearchClusterConfigMasterNodeResources {
}
export declare function dataYandexMdbElasticsearchClusterConfigMasterNodeResourcesToTerraform(struct?: DataYandexMdbElasticsearchClusterConfigMasterNodeResources): any;
export declare class DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterConfigMasterNodeResources | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterConfigMasterNodeResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference;
}
export interface DataYandexMdbElasticsearchClusterConfigMasterNode {
}
export declare function dataYandexMdbElasticsearchClusterConfigMasterNodeToTerraform(struct?: DataYandexMdbElasticsearchClusterConfigMasterNode): any;
export declare class DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterConfigMasterNode | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterConfigMasterNode | undefined);
    private _resources;
    get resources(): DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList;
}
export declare class DataYandexMdbElasticsearchClusterConfigMasterNodeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference;
}
export interface DataYandexMdbElasticsearchClusterConfigA {
}
export declare function dataYandexMdbElasticsearchClusterConfigAToTerraform(struct?: DataYandexMdbElasticsearchClusterConfigA): any;
export declare class DataYandexMdbElasticsearchClusterConfigAOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterConfigA | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterConfigA | undefined);
    get adminPassword(): string;
    private _dataNode;
    get dataNode(): DataYandexMdbElasticsearchClusterConfigDataNodeList;
    get edition(): string;
    private _masterNode;
    get masterNode(): DataYandexMdbElasticsearchClusterConfigMasterNodeList;
    get plugins(): string[];
    get version(): string;
}
export declare class DataYandexMdbElasticsearchClusterConfigAList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterConfigAOutputReference;
}
export interface DataYandexMdbElasticsearchClusterHost {
}
export declare function dataYandexMdbElasticsearchClusterHostToTerraform(struct?: DataYandexMdbElasticsearchClusterHost): any;
export declare class DataYandexMdbElasticsearchClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterHost | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterHost | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    get fqdn(): string;
    get name(): string;
    get subnetId(): string;
    get type(): string;
    get zone(): string;
}
export declare class DataYandexMdbElasticsearchClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterHostOutputReference;
}
export interface DataYandexMdbElasticsearchClusterMaintenanceWindow {
}
export declare function dataYandexMdbElasticsearchClusterMaintenanceWindowToTerraform(struct?: DataYandexMdbElasticsearchClusterMaintenanceWindow): any;
export declare class DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbElasticsearchClusterMaintenanceWindow | undefined;
    set internalValue(value: DataYandexMdbElasticsearchClusterMaintenanceWindow | undefined);
    get day(): string;
    get hour(): number;
    get type(): string;
}
export declare class DataYandexMdbElasticsearchClusterMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster yandex_mdb_elasticsearch_cluster}
*/
export declare class DataYandexMdbElasticsearchCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_elasticsearch_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster yandex_mdb_elasticsearch_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbElasticsearchClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexMdbElasticsearchClusterConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _config;
    get config(): DataYandexMdbElasticsearchClusterConfigAList;
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get environment(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _host;
    get host(): DataYandexMdbElasticsearchClusterHostList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexMdbElasticsearchClusterMaintenanceWindowList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    resetServiceAccountId(): void;
    get serviceAccountIdInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-mdb-elasticsearch-cluster.d.ts.map