import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbKafkaTopicConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#cluster_id DataYandexMdbKafkaTopic#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#id DataYandexMdbKafkaTopic#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#name DataYandexMdbKafkaTopic#name}
    */
    readonly name: string;
}
export interface DataYandexMdbKafkaTopicTopicConfig {
}
export declare function dataYandexMdbKafkaTopicTopicConfigToTerraform(struct?: DataYandexMdbKafkaTopicTopicConfig): any;
export declare class DataYandexMdbKafkaTopicTopicConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbKafkaTopicTopicConfig | undefined;
    set internalValue(value: DataYandexMdbKafkaTopicTopicConfig | undefined);
    get cleanupPolicy(): string;
    get compressionType(): string;
    get deleteRetentionMs(): string;
    get fileDeleteDelayMs(): string;
    get flushMessages(): string;
    get flushMs(): string;
    get maxMessageBytes(): string;
    get minCompactionLagMs(): string;
    get minInsyncReplicas(): string;
    get preallocate(): cdktf.IResolvable;
    get retentionBytes(): string;
    get retentionMs(): string;
    get segmentBytes(): string;
}
export declare class DataYandexMdbKafkaTopicTopicConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbKafkaTopicTopicConfigOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic yandex_mdb_kafka_topic}
*/
export declare class DataYandexMdbKafkaTopic extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_kafka_topic";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic yandex_mdb_kafka_topic} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbKafkaTopicConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexMdbKafkaTopicConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get partitions(): number;
    get replicationFactor(): number;
    private _topicConfig;
    get topicConfig(): DataYandexMdbKafkaTopicTopicConfigList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-mdb-kafka-topic.d.ts.map