import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbMongodbClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#cluster_id DataYandexMdbMongodbCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#deletion_protection DataYandexMdbMongodbCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#folder_id DataYandexMdbMongodbCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#id DataYandexMdbMongodbCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}
    */
    readonly name?: string;
}
export interface DataYandexMdbMongodbClusterClusterConfigAccess {
}
export declare function dataYandexMdbMongodbClusterClusterConfigAccessToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigAccess): any;
export declare class DataYandexMdbMongodbClusterClusterConfigAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigAccess | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigAccess | undefined);
    get dataLens(): cdktf.IResolvable;
}
export declare class DataYandexMdbMongodbClusterClusterConfigAccessList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterClusterConfigAccessOutputReference;
}
export interface DataYandexMdbMongodbClusterClusterConfigBackupWindowStart {
}
export declare function dataYandexMdbMongodbClusterClusterConfigBackupWindowStartToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart): any;
export declare class DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfigBackupWindowStart | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart | undefined);
    get hours(): number;
    get minutes(): number;
}
export declare class DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference;
}
export interface DataYandexMdbMongodbClusterClusterConfig {
}
export declare function dataYandexMdbMongodbClusterClusterConfigToTerraform(struct?: DataYandexMdbMongodbClusterClusterConfig): any;
export declare class DataYandexMdbMongodbClusterClusterConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterClusterConfig | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterClusterConfig | undefined);
    private _access;
    get access(): DataYandexMdbMongodbClusterClusterConfigAccessList;
    private _backupWindowStart;
    get backupWindowStart(): DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList;
    get featureCompatibilityVersion(): string;
    get version(): string;
}
export declare class DataYandexMdbMongodbClusterClusterConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterClusterConfigOutputReference;
}
export interface DataYandexMdbMongodbClusterDatabase {
}
export declare function dataYandexMdbMongodbClusterDatabaseToTerraform(struct?: DataYandexMdbMongodbClusterDatabase): any;
export declare class DataYandexMdbMongodbClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterDatabase | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterDatabase | undefined);
    get name(): string;
}
export declare class DataYandexMdbMongodbClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterDatabaseOutputReference;
}
export interface DataYandexMdbMongodbClusterHost {
}
export declare function dataYandexMdbMongodbClusterHostToTerraform(struct?: DataYandexMdbMongodbClusterHost): any;
export declare class DataYandexMdbMongodbClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterHost | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterHost | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    get health(): string;
    get name(): string;
    get role(): string;
    get shardName(): string;
    get subnetId(): string;
    get type(): string;
    get zoneId(): string;
}
export declare class DataYandexMdbMongodbClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterHostOutputReference;
}
export interface DataYandexMdbMongodbClusterMaintenanceWindow {
}
export declare function dataYandexMdbMongodbClusterMaintenanceWindowToTerraform(struct?: DataYandexMdbMongodbClusterMaintenanceWindow): any;
export declare class DataYandexMdbMongodbClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterMaintenanceWindow | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterMaintenanceWindow | undefined);
    get day(): string;
    get hour(): number;
    get type(): string;
}
export declare class DataYandexMdbMongodbClusterMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterMaintenanceWindowOutputReference;
}
export interface DataYandexMdbMongodbClusterResources {
}
export declare function dataYandexMdbMongodbClusterResourcesToTerraform(struct?: DataYandexMdbMongodbClusterResources): any;
export declare class DataYandexMdbMongodbClusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterResources | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexMdbMongodbClusterResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterResourcesOutputReference;
}
export interface DataYandexMdbMongodbClusterUserPermission {
}
export declare function dataYandexMdbMongodbClusterUserPermissionToTerraform(struct?: DataYandexMdbMongodbClusterUserPermission): any;
export declare class DataYandexMdbMongodbClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterUserPermission | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterUserPermission | undefined);
    get databaseName(): string;
    get roles(): string[];
}
export declare class DataYandexMdbMongodbClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterUserPermissionOutputReference;
}
export interface DataYandexMdbMongodbClusterUser {
}
export declare function dataYandexMdbMongodbClusterUserToTerraform(struct?: DataYandexMdbMongodbClusterUser): any;
export declare class DataYandexMdbMongodbClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMongodbClusterUser | undefined;
    set internalValue(value: DataYandexMdbMongodbClusterUser | undefined);
    get name(): string;
    private _permission;
    get permission(): DataYandexMdbMongodbClusterUserPermissionList;
}
export declare class DataYandexMdbMongodbClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMongodbClusterUserOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster yandex_mdb_mongodb_cluster}
*/
export declare class DataYandexMdbMongodbCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_mongodb_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster yandex_mdb_mongodb_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbMongodbClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexMdbMongodbClusterConfig);
    private _clusterConfig;
    get clusterConfig(): DataYandexMdbMongodbClusterClusterConfigList;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    private _database;
    get database(): DataYandexMdbMongodbClusterDatabaseList;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    get description(): string;
    get environment(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _host;
    get host(): DataYandexMdbMongodbClusterHostList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexMdbMongodbClusterMaintenanceWindowList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _resources;
    get resources(): DataYandexMdbMongodbClusterResourcesList;
    get securityGroupIds(): string[];
    get sharded(): cdktf.IResolvable;
    get status(): string;
    private _user;
    get user(): DataYandexMdbMongodbClusterUserList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-mdb-mongodb-cluster.d.ts.map