import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbMysqlClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#cluster_id DataYandexMdbMysqlCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#deletion_protection DataYandexMdbMysqlCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#description DataYandexMdbMysqlCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#folder_id DataYandexMdbMysqlCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#id DataYandexMdbMysqlCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#labels DataYandexMdbMysqlCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#mysql_config DataYandexMdbMysqlCluster#mysql_config}
    */
    readonly mysqlConfig?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#name DataYandexMdbMysqlCluster#name}
    */
    readonly name?: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#access DataYandexMdbMysqlCluster#access}
    */
    readonly access?: DataYandexMdbMysqlClusterAccess;
}
export interface DataYandexMdbMysqlClusterBackupWindowStart {
}
export declare function dataYandexMdbMysqlClusterBackupWindowStartToTerraform(struct?: DataYandexMdbMysqlClusterBackupWindowStart): any;
export declare class DataYandexMdbMysqlClusterBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterBackupWindowStart | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterBackupWindowStart | undefined);
    get hours(): number;
    get minutes(): number;
}
export declare class DataYandexMdbMysqlClusterBackupWindowStartList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterBackupWindowStartOutputReference;
}
export interface DataYandexMdbMysqlClusterDatabase {
}
export declare function dataYandexMdbMysqlClusterDatabaseToTerraform(struct?: DataYandexMdbMysqlClusterDatabase): any;
export declare class DataYandexMdbMysqlClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterDatabase | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterDatabase | undefined);
    get name(): string;
}
export declare class DataYandexMdbMysqlClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterDatabaseOutputReference;
}
export interface DataYandexMdbMysqlClusterHost {
}
export declare function dataYandexMdbMysqlClusterHostToTerraform(struct?: DataYandexMdbMysqlClusterHost): any;
export declare class DataYandexMdbMysqlClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterHost | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterHost | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    get backupPriority(): number;
    get fqdn(): string;
    get priority(): number;
    get replicationSource(): string;
    get subnetId(): string;
    get zone(): string;
}
export declare class DataYandexMdbMysqlClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterHostOutputReference;
}
export interface DataYandexMdbMysqlClusterMaintenanceWindow {
}
export declare function dataYandexMdbMysqlClusterMaintenanceWindowToTerraform(struct?: DataYandexMdbMysqlClusterMaintenanceWindow): any;
export declare class DataYandexMdbMysqlClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterMaintenanceWindow | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterMaintenanceWindow | undefined);
    get day(): string;
    get hour(): number;
    get type(): string;
}
export declare class DataYandexMdbMysqlClusterMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterMaintenanceWindowOutputReference;
}
export interface DataYandexMdbMysqlClusterResources {
}
export declare function dataYandexMdbMysqlClusterResourcesToTerraform(struct?: DataYandexMdbMysqlClusterResources): any;
export declare class DataYandexMdbMysqlClusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterResources | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexMdbMysqlClusterResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterResourcesOutputReference;
}
export interface DataYandexMdbMysqlClusterUserConnectionLimits {
}
export declare function dataYandexMdbMysqlClusterUserConnectionLimitsToTerraform(struct?: DataYandexMdbMysqlClusterUserConnectionLimits): any;
export declare class DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterUserConnectionLimits | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterUserConnectionLimits | undefined);
    get maxConnectionsPerHour(): number;
    get maxQuestionsPerHour(): number;
    get maxUpdatesPerHour(): number;
    get maxUserConnections(): number;
}
export declare class DataYandexMdbMysqlClusterUserConnectionLimitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference;
}
export interface DataYandexMdbMysqlClusterUserPermission {
}
export declare function dataYandexMdbMysqlClusterUserPermissionToTerraform(struct?: DataYandexMdbMysqlClusterUserPermission): any;
export declare class DataYandexMdbMysqlClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterUserPermission | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterUserPermission | undefined);
    get databaseName(): string;
    get roles(): string[];
}
export declare class DataYandexMdbMysqlClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterUserPermissionOutputReference;
}
export interface DataYandexMdbMysqlClusterUser {
}
export declare function dataYandexMdbMysqlClusterUserToTerraform(struct?: DataYandexMdbMysqlClusterUser): any;
export declare class DataYandexMdbMysqlClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbMysqlClusterUser | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterUser | undefined);
    get authenticationPlugin(): string;
    private _connectionLimits;
    get connectionLimits(): DataYandexMdbMysqlClusterUserConnectionLimitsList;
    get globalPermissions(): string[];
    get name(): string;
    get password(): string;
    private _permission;
    get permission(): DataYandexMdbMysqlClusterUserPermissionList;
}
export declare class DataYandexMdbMysqlClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbMysqlClusterUserOutputReference;
}
export interface DataYandexMdbMysqlClusterAccess {
}
export declare function dataYandexMdbMysqlClusterAccessToTerraform(struct?: DataYandexMdbMysqlClusterAccessOutputReference | DataYandexMdbMysqlClusterAccess): any;
export declare class DataYandexMdbMysqlClusterAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataYandexMdbMysqlClusterAccess | undefined;
    set internalValue(value: DataYandexMdbMysqlClusterAccess | undefined);
    get dataLens(): cdktf.IResolvable;
    get webSql(): cdktf.IResolvable;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster yandex_mdb_mysql_cluster}
*/
export declare class DataYandexMdbMysqlCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_mysql_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster yandex_mdb_mysql_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbMysqlClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexMdbMysqlClusterConfig);
    private _backupWindowStart;
    get backupWindowStart(): DataYandexMdbMysqlClusterBackupWindowStartList;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    private _database;
    get database(): DataYandexMdbMysqlClusterDatabaseList;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get environment(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _host;
    get host(): DataYandexMdbMysqlClusterHostList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexMdbMysqlClusterMaintenanceWindowList;
    private _mysqlConfig?;
    get mysqlConfig(): {
        [key: string]: string;
    };
    set mysqlConfig(value: {
        [key: string]: string;
    });
    resetMysqlConfig(): void;
    get mysqlConfigInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _resources;
    get resources(): DataYandexMdbMysqlClusterResourcesList;
    get securityGroupIds(): string[];
    get status(): string;
    private _user;
    get user(): DataYandexMdbMysqlClusterUserList;
    get version(): string;
    private _access;
    get access(): DataYandexMdbMysqlClusterAccessOutputReference;
    putAccess(value: DataYandexMdbMysqlClusterAccess): void;
    resetAccess(): void;
    get accessInput(): DataYandexMdbMysqlClusterAccess | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-mdb-mysql-cluster.d.ts.map