import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbPostgresqlClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#cluster_id DataYandexMdbPostgresqlCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#deletion_protection DataYandexMdbPostgresqlCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#description DataYandexMdbPostgresqlCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#folder_id DataYandexMdbPostgresqlCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#id DataYandexMdbPostgresqlCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#name DataYandexMdbPostgresqlCluster#name}
    */
    readonly name?: string;
}
export interface DataYandexMdbPostgresqlClusterConfigAccess {
}
export declare function dataYandexMdbPostgresqlClusterConfigAccessToTerraform(struct?: DataYandexMdbPostgresqlClusterConfigAccess): any;
export declare class DataYandexMdbPostgresqlClusterConfigAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterConfigAccess | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterConfigAccess | undefined);
    get dataLens(): cdktf.IResolvable;
    get serverless(): cdktf.IResolvable;
    get webSql(): cdktf.IResolvable;
}
export declare class DataYandexMdbPostgresqlClusterConfigAccessList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterConfigAccessOutputReference;
}
export interface DataYandexMdbPostgresqlClusterConfigBackupWindowStart {
}
export declare function dataYandexMdbPostgresqlClusterConfigBackupWindowStartToTerraform(struct?: DataYandexMdbPostgresqlClusterConfigBackupWindowStart): any;
export declare class DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterConfigBackupWindowStart | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterConfigBackupWindowStart | undefined);
    get hours(): number;
    get minutes(): number;
}
export declare class DataYandexMdbPostgresqlClusterConfigBackupWindowStartList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference;
}
export interface DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics {
}
export declare function dataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsToTerraform(struct?: DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics): any;
export declare class DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics | undefined);
    get enabled(): cdktf.IResolvable;
    get sessionsSamplingInterval(): number;
    get statementsSamplingInterval(): number;
}
export declare class DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference;
}
export interface DataYandexMdbPostgresqlClusterConfigPoolerConfig {
}
export declare function dataYandexMdbPostgresqlClusterConfigPoolerConfigToTerraform(struct?: DataYandexMdbPostgresqlClusterConfigPoolerConfig): any;
export declare class DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterConfigPoolerConfig | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterConfigPoolerConfig | undefined);
    get poolDiscard(): cdktf.IResolvable;
    get poolingMode(): string;
}
export declare class DataYandexMdbPostgresqlClusterConfigPoolerConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference;
}
export interface DataYandexMdbPostgresqlClusterConfigResources {
}
export declare function dataYandexMdbPostgresqlClusterConfigResourcesToTerraform(struct?: DataYandexMdbPostgresqlClusterConfigResources): any;
export declare class DataYandexMdbPostgresqlClusterConfigResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterConfigResources | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterConfigResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexMdbPostgresqlClusterConfigResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterConfigResourcesOutputReference;
}
export interface DataYandexMdbPostgresqlClusterConfigA {
}
export declare function dataYandexMdbPostgresqlClusterConfigAToTerraform(struct?: DataYandexMdbPostgresqlClusterConfigA): any;
export declare class DataYandexMdbPostgresqlClusterConfigAOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterConfigA | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterConfigA | undefined);
    private _access;
    get access(): DataYandexMdbPostgresqlClusterConfigAccessList;
    get autofailover(): cdktf.IResolvable;
    get backupRetainPeriodDays(): number;
    private _backupWindowStart;
    get backupWindowStart(): DataYandexMdbPostgresqlClusterConfigBackupWindowStartList;
    private _performanceDiagnostics;
    get performanceDiagnostics(): DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList;
    private _poolerConfig;
    get poolerConfig(): DataYandexMdbPostgresqlClusterConfigPoolerConfigList;
    private _postgresqlConfig;
    get postgresqlConfig(): cdktf.StringMap;
    private _resources;
    get resources(): DataYandexMdbPostgresqlClusterConfigResourcesList;
    get version(): string;
}
export declare class DataYandexMdbPostgresqlClusterConfigAList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterConfigAOutputReference;
}
export interface DataYandexMdbPostgresqlClusterDatabaseExtension {
}
export declare function dataYandexMdbPostgresqlClusterDatabaseExtensionToTerraform(struct?: DataYandexMdbPostgresqlClusterDatabaseExtension): any;
export declare class DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterDatabaseExtension | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterDatabaseExtension | undefined);
    get name(): string;
    get version(): string;
}
export declare class DataYandexMdbPostgresqlClusterDatabaseExtensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference;
}
export interface DataYandexMdbPostgresqlClusterDatabase {
}
export declare function dataYandexMdbPostgresqlClusterDatabaseToTerraform(struct?: DataYandexMdbPostgresqlClusterDatabase): any;
export declare class DataYandexMdbPostgresqlClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterDatabase | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterDatabase | undefined);
    private _extension;
    get extension(): DataYandexMdbPostgresqlClusterDatabaseExtensionList;
    get lcCollate(): string;
    get lcType(): string;
    get name(): string;
    get owner(): string;
}
export declare class DataYandexMdbPostgresqlClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterDatabaseOutputReference;
}
export interface DataYandexMdbPostgresqlClusterHost {
}
export declare function dataYandexMdbPostgresqlClusterHostToTerraform(struct?: DataYandexMdbPostgresqlClusterHost): any;
export declare class DataYandexMdbPostgresqlClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterHost | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterHost | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    get fqdn(): string;
    get priority(): number;
    get replicationSource(): string;
    get role(): string;
    get subnetId(): string;
    get zone(): string;
}
export declare class DataYandexMdbPostgresqlClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterHostOutputReference;
}
export interface DataYandexMdbPostgresqlClusterMaintenanceWindow {
}
export declare function dataYandexMdbPostgresqlClusterMaintenanceWindowToTerraform(struct?: DataYandexMdbPostgresqlClusterMaintenanceWindow): any;
export declare class DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterMaintenanceWindow | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterMaintenanceWindow | undefined);
    get day(): string;
    get hour(): number;
    get type(): string;
}
export declare class DataYandexMdbPostgresqlClusterMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference;
}
export interface DataYandexMdbPostgresqlClusterUserPermission {
}
export declare function dataYandexMdbPostgresqlClusterUserPermissionToTerraform(struct?: DataYandexMdbPostgresqlClusterUserPermission): any;
export declare class DataYandexMdbPostgresqlClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterUserPermission | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterUserPermission | undefined);
    get databaseName(): string;
}
export declare class DataYandexMdbPostgresqlClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterUserPermissionOutputReference;
}
export interface DataYandexMdbPostgresqlClusterUser {
}
export declare function dataYandexMdbPostgresqlClusterUserToTerraform(struct?: DataYandexMdbPostgresqlClusterUser): any;
export declare class DataYandexMdbPostgresqlClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbPostgresqlClusterUser | undefined;
    set internalValue(value: DataYandexMdbPostgresqlClusterUser | undefined);
    get connLimit(): number;
    get grants(): string[];
    get login(): cdktf.IResolvable;
    get name(): string;
    get password(): string;
    private _permission;
    get permission(): DataYandexMdbPostgresqlClusterUserPermissionList;
    private _settings;
    get settings(): cdktf.StringMap;
}
export declare class DataYandexMdbPostgresqlClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbPostgresqlClusterUserOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster yandex_mdb_postgresql_cluster}
*/
export declare class DataYandexMdbPostgresqlCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_postgresql_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster yandex_mdb_postgresql_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbPostgresqlClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexMdbPostgresqlClusterConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    private _config;
    get config(): DataYandexMdbPostgresqlClusterConfigAList;
    get createdAt(): string;
    private _database;
    get database(): DataYandexMdbPostgresqlClusterDatabaseList;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get environment(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _host;
    get host(): DataYandexMdbPostgresqlClusterHostList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _maintenanceWindow;
    get maintenanceWindow(): DataYandexMdbPostgresqlClusterMaintenanceWindowList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    get securityGroupIds(): string[];
    get status(): string;
    private _user;
    get user(): DataYandexMdbPostgresqlClusterUserList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-mdb-postgresql-cluster.d.ts.map