import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMdbSqlserverClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#cluster_id DataYandexMdbSqlserverCluster#cluster_id}
    */
    readonly clusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#deletion_protection DataYandexMdbSqlserverCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#folder_id DataYandexMdbSqlserverCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#id DataYandexMdbSqlserverCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#name DataYandexMdbSqlserverCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#sqlserver_config DataYandexMdbSqlserverCluster#sqlserver_config}
    */
    readonly sqlserverConfig?: {
        [key: string]: string;
    };
}
export interface DataYandexMdbSqlserverClusterBackupWindowStart {
}
export declare function dataYandexMdbSqlserverClusterBackupWindowStartToTerraform(struct?: DataYandexMdbSqlserverClusterBackupWindowStart): any;
export declare class DataYandexMdbSqlserverClusterBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbSqlserverClusterBackupWindowStart | undefined;
    set internalValue(value: DataYandexMdbSqlserverClusterBackupWindowStart | undefined);
    get hours(): number;
    get minutes(): number;
}
export declare class DataYandexMdbSqlserverClusterBackupWindowStartList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbSqlserverClusterBackupWindowStartOutputReference;
}
export interface DataYandexMdbSqlserverClusterDatabase {
}
export declare function dataYandexMdbSqlserverClusterDatabaseToTerraform(struct?: DataYandexMdbSqlserverClusterDatabase): any;
export declare class DataYandexMdbSqlserverClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbSqlserverClusterDatabase | undefined;
    set internalValue(value: DataYandexMdbSqlserverClusterDatabase | undefined);
    get name(): string;
}
export declare class DataYandexMdbSqlserverClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbSqlserverClusterDatabaseOutputReference;
}
export interface DataYandexMdbSqlserverClusterHost {
}
export declare function dataYandexMdbSqlserverClusterHostToTerraform(struct?: DataYandexMdbSqlserverClusterHost): any;
export declare class DataYandexMdbSqlserverClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbSqlserverClusterHost | undefined;
    set internalValue(value: DataYandexMdbSqlserverClusterHost | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    get fqdn(): string;
    get subnetId(): string;
    get zone(): string;
}
export declare class DataYandexMdbSqlserverClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbSqlserverClusterHostOutputReference;
}
export interface DataYandexMdbSqlserverClusterResources {
}
export declare function dataYandexMdbSqlserverClusterResourcesToTerraform(struct?: DataYandexMdbSqlserverClusterResources): any;
export declare class DataYandexMdbSqlserverClusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbSqlserverClusterResources | undefined;
    set internalValue(value: DataYandexMdbSqlserverClusterResources | undefined);
    get diskSize(): number;
    get diskTypeId(): string;
    get resourcePresetId(): string;
}
export declare class DataYandexMdbSqlserverClusterResourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbSqlserverClusterResourcesOutputReference;
}
export interface DataYandexMdbSqlserverClusterUserPermission {
}
export declare function dataYandexMdbSqlserverClusterUserPermissionToTerraform(struct?: DataYandexMdbSqlserverClusterUserPermission): any;
export declare class DataYandexMdbSqlserverClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbSqlserverClusterUserPermission | undefined;
    set internalValue(value: DataYandexMdbSqlserverClusterUserPermission | undefined);
    get databaseName(): string;
    get roles(): string[];
}
export declare class DataYandexMdbSqlserverClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbSqlserverClusterUserPermissionOutputReference;
}
export interface DataYandexMdbSqlserverClusterUser {
}
export declare function dataYandexMdbSqlserverClusterUserToTerraform(struct?: DataYandexMdbSqlserverClusterUser): any;
export declare class DataYandexMdbSqlserverClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexMdbSqlserverClusterUser | undefined;
    set internalValue(value: DataYandexMdbSqlserverClusterUser | undefined);
    get name(): string;
    get password(): string;
    private _permission;
    get permission(): DataYandexMdbSqlserverClusterUserPermissionList;
}
export declare class DataYandexMdbSqlserverClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexMdbSqlserverClusterUserOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster yandex_mdb_sqlserver_cluster}
*/
export declare class DataYandexMdbSqlserverCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_mdb_sqlserver_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster yandex_mdb_sqlserver_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMdbSqlserverClusterConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexMdbSqlserverClusterConfig);
    private _backupWindowStart;
    get backupWindowStart(): DataYandexMdbSqlserverClusterBackupWindowStartList;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    resetClusterId(): void;
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    private _database;
    get database(): DataYandexMdbSqlserverClusterDatabaseList;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    get description(): string;
    get environment(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _host;
    get host(): DataYandexMdbSqlserverClusterHostList;
    get hostGroupIds(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _resources;
    get resources(): DataYandexMdbSqlserverClusterResourcesList;
    get securityGroupIds(): string[];
    private _sqlserverConfig?;
    get sqlserverConfig(): {
        [key: string]: string;
    };
    set sqlserverConfig(value: {
        [key: string]: string;
    });
    resetSqlserverConfig(): void;
    get sqlserverConfigInput(): {
        [key: string]: string;
    } | undefined;
    get status(): string;
    private _user;
    get user(): DataYandexMdbSqlserverClusterUserList;
    get version(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-mdb-sqlserver-cluster.d.ts.map