import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexMessageQueueConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#access_key DataYandexMessageQueue#access_key}
    */
    readonly accessKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#id DataYandexMessageQueue#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#name DataYandexMessageQueue#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#secret_key DataYandexMessageQueue#secret_key}
    */
    readonly secretKey?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/message_queue yandex_message_queue}
*/
export declare class DataYandexMessageQueue extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_message_queue";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/message_queue yandex_message_queue} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexMessageQueueConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexMessageQueueConfig);
    private _accessKey?;
    get accessKey(): string;
    set accessKey(value: string);
    resetAccessKey(): void;
    get accessKeyInput(): string | undefined;
    get arn(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    resetSecretKey(): void;
    get secretKeyInput(): string | undefined;
    get url(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-message-queue.d.ts.map