import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexResourcemanagerCloudConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#cloud_id DataYandexResourcemanagerCloud#cloud_id}
    */
    readonly cloudId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#description DataYandexResourcemanagerCloud#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#id DataYandexResourcemanagerCloud#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#name DataYandexResourcemanagerCloud#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud yandex_resourcemanager_cloud}
*/
export declare class DataYandexResourcemanagerCloud extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_resourcemanager_cloud";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud yandex_resourcemanager_cloud} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexResourcemanagerCloudConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexResourcemanagerCloudConfig);
    private _cloudId?;
    get cloudId(): string;
    set cloudId(value: string);
    resetCloudId(): void;
    get cloudIdInput(): string | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-resourcemanager-cloud.d.ts.map