import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexResourcemanagerFolderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#cloud_id DataYandexResourcemanagerFolder#cloud_id}
    */
    readonly cloudId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#folder_id DataYandexResourcemanagerFolder#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#id DataYandexResourcemanagerFolder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#labels DataYandexResourcemanagerFolder#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#name DataYandexResourcemanagerFolder#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder yandex_resourcemanager_folder}
*/
export declare class DataYandexResourcemanagerFolder extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_resourcemanager_folder";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder yandex_resourcemanager_folder} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexResourcemanagerFolderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexResourcemanagerFolderConfig);
    private _cloudId?;
    get cloudId(): string;
    set cloudId(value: string);
    resetCloudId(): void;
    get cloudIdInput(): string | undefined;
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-resourcemanager-folder.d.ts.map