import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexServerlessContainerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#container_id DataYandexServerlessContainer#container_id}
    */
    readonly containerId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#folder_id DataYandexServerlessContainer#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#id DataYandexServerlessContainer#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#name DataYandexServerlessContainer#name}
    */
    readonly name?: string;
}
export interface DataYandexServerlessContainerImage {
}
export declare function dataYandexServerlessContainerImageToTerraform(struct?: DataYandexServerlessContainerImage): any;
export declare class DataYandexServerlessContainerImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexServerlessContainerImage | undefined;
    set internalValue(value: DataYandexServerlessContainerImage | undefined);
    get args(): string[];
    get command(): string[];
    get digest(): string;
    private _environment;
    get environment(): cdktf.StringMap;
    get url(): string;
    get workDir(): string;
}
export declare class DataYandexServerlessContainerImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexServerlessContainerImageOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container yandex_serverless_container}
*/
export declare class DataYandexServerlessContainer extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_serverless_container";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container yandex_serverless_container} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexServerlessContainerConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexServerlessContainerConfig);
    get concurrency(): number;
    private _containerId?;
    get containerId(): string;
    set containerId(value: string);
    resetContainerId(): void;
    get containerIdInput(): string | undefined;
    get coreFraction(): number;
    get cores(): number;
    get createdAt(): string;
    get description(): string;
    get executionTimeout(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _image;
    get image(): DataYandexServerlessContainerImageList;
    private _labels;
    get labels(): cdktf.StringMap;
    get memory(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get revisionId(): string;
    get serviceAccountId(): string;
    get url(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-serverless-container.d.ts.map