import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexVpcAddressConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#address_id DataYandexVpcAddress#address_id}
    */
    readonly addressId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#folder_id DataYandexVpcAddress#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#id DataYandexVpcAddress#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#name DataYandexVpcAddress#name}
    */
    readonly name?: string;
}
export interface DataYandexVpcAddressExternalIpv4Address {
}
export declare function dataYandexVpcAddressExternalIpv4AddressToTerraform(struct?: DataYandexVpcAddressExternalIpv4Address): any;
export declare class DataYandexVpcAddressExternalIpv4AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexVpcAddressExternalIpv4Address | undefined;
    set internalValue(value: DataYandexVpcAddressExternalIpv4Address | undefined);
    get address(): string;
    get ddosProtectionProvider(): string;
    get outgoingSmtpCapability(): string;
    get zoneId(): string;
}
export declare class DataYandexVpcAddressExternalIpv4AddressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexVpcAddressExternalIpv4AddressOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address yandex_vpc_address}
*/
export declare class DataYandexVpcAddress extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_vpc_address";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address yandex_vpc_address} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexVpcAddressConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexVpcAddressConfig);
    private _addressId?;
    get addressId(): string;
    set addressId(value: string);
    resetAddressId(): void;
    get addressIdInput(): string | undefined;
    get createdAt(): string;
    get description(): string;
    private _externalIpv4Address;
    get externalIpv4Address(): DataYandexVpcAddressExternalIpv4AddressList;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get reserved(): cdktf.IResolvable;
    get used(): cdktf.IResolvable;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-vpc-address.d.ts.map