import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexVpcRouteTableConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#folder_id DataYandexVpcRouteTable#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#id DataYandexVpcRouteTable#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#name DataYandexVpcRouteTable#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#route_table_id DataYandexVpcRouteTable#route_table_id}
    */
    readonly routeTableId?: string;
}
export interface DataYandexVpcRouteTableStaticRoute {
}
export declare function dataYandexVpcRouteTableStaticRouteToTerraform(struct?: DataYandexVpcRouteTableStaticRoute): any;
export declare class DataYandexVpcRouteTableStaticRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexVpcRouteTableStaticRoute | undefined;
    set internalValue(value: DataYandexVpcRouteTableStaticRoute | undefined);
    get destinationPrefix(): string;
    get nextHopAddress(): string;
}
export declare class DataYandexVpcRouteTableStaticRouteList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexVpcRouteTableStaticRouteOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table yandex_vpc_route_table}
*/
export declare class DataYandexVpcRouteTable extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_vpc_route_table";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table yandex_vpc_route_table} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexVpcRouteTableConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexVpcRouteTableConfig);
    get createdAt(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _routeTableId?;
    get routeTableId(): string;
    set routeTableId(value: string);
    resetRouteTableId(): void;
    get routeTableIdInput(): string | undefined;
    private _staticRoute;
    get staticRoute(): DataYandexVpcRouteTableStaticRouteList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-vpc-route-table.d.ts.map