import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexVpcSecurityGroupRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#id DataYandexVpcSecurityGroupRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#rule_id DataYandexVpcSecurityGroupRule#rule_id}
    */
    readonly ruleId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#security_group_binding DataYandexVpcSecurityGroupRule#security_group_binding}
    */
    readonly securityGroupBinding: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule yandex_vpc_security_group_rule}
*/
export declare class DataYandexVpcSecurityGroupRule extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_vpc_security_group_rule";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule yandex_vpc_security_group_rule} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexVpcSecurityGroupRuleConfig
    */
    constructor(scope: Construct, id: string, config: DataYandexVpcSecurityGroupRuleConfig);
    get description(): string;
    get direction(): string;
    get fromPort(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    get port(): number;
    get predefinedTarget(): string;
    get protocol(): string;
    private _ruleId?;
    get ruleId(): string;
    set ruleId(value: string);
    get ruleIdInput(): string | undefined;
    private _securityGroupBinding?;
    get securityGroupBinding(): string;
    set securityGroupBinding(value: string);
    get securityGroupBindingInput(): string | undefined;
    get securityGroupId(): string;
    get toPort(): number;
    get v4CidrBlocks(): string[];
    get v6CidrBlocks(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-vpc-security-group-rule.d.ts.map