import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexVpcSecurityGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#folder_id DataYandexVpcSecurityGroup#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#id DataYandexVpcSecurityGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#name DataYandexVpcSecurityGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#security_group_id DataYandexVpcSecurityGroup#security_group_id}
    */
    readonly securityGroupId?: string;
}
export interface DataYandexVpcSecurityGroupEgress {
}
export declare function dataYandexVpcSecurityGroupEgressToTerraform(struct?: DataYandexVpcSecurityGroupEgress): any;
export declare class DataYandexVpcSecurityGroupEgressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexVpcSecurityGroupEgress | undefined;
    set internalValue(value: DataYandexVpcSecurityGroupEgress | undefined);
    get description(): string;
    get fromPort(): number;
    get id(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    get port(): number;
    get predefinedTarget(): string;
    get protocol(): string;
    get securityGroupId(): string;
    get toPort(): number;
    get v4CidrBlocks(): string[];
    get v6CidrBlocks(): string[];
}
export declare class DataYandexVpcSecurityGroupEgressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexVpcSecurityGroupEgressOutputReference;
}
export interface DataYandexVpcSecurityGroupIngress {
}
export declare function dataYandexVpcSecurityGroupIngressToTerraform(struct?: DataYandexVpcSecurityGroupIngress): any;
export declare class DataYandexVpcSecurityGroupIngressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexVpcSecurityGroupIngress | undefined;
    set internalValue(value: DataYandexVpcSecurityGroupIngress | undefined);
    get description(): string;
    get fromPort(): number;
    get id(): string;
    private _labels;
    get labels(): cdktf.StringMap;
    get port(): number;
    get predefinedTarget(): string;
    get protocol(): string;
    get securityGroupId(): string;
    get toPort(): number;
    get v4CidrBlocks(): string[];
    get v6CidrBlocks(): string[];
}
export declare class DataYandexVpcSecurityGroupIngressList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexVpcSecurityGroupIngressOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group yandex_vpc_security_group}
*/
export declare class DataYandexVpcSecurityGroup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_vpc_security_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group yandex_vpc_security_group} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexVpcSecurityGroupConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexVpcSecurityGroupConfig);
    get createdAt(): string;
    get description(): string;
    private _egress;
    get egress(): DataYandexVpcSecurityGroupEgressList;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ingress;
    get ingress(): DataYandexVpcSecurityGroupIngressList;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    private _securityGroupId?;
    get securityGroupId(): string;
    set securityGroupId(value: string);
    resetSecurityGroupId(): void;
    get securityGroupIdInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-vpc-security-group.d.ts.map