import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexVpcSubnetConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#folder_id DataYandexVpcSubnet#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#id DataYandexVpcSubnet#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#name DataYandexVpcSubnet#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#subnet_id DataYandexVpcSubnet#subnet_id}
    */
    readonly subnetId?: string;
}
export interface DataYandexVpcSubnetDhcpOptions {
}
export declare function dataYandexVpcSubnetDhcpOptionsToTerraform(struct?: DataYandexVpcSubnetDhcpOptions): any;
export declare class DataYandexVpcSubnetDhcpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexVpcSubnetDhcpOptions | undefined;
    set internalValue(value: DataYandexVpcSubnetDhcpOptions | undefined);
    get domainName(): string;
    get domainNameServers(): string[];
    get ntpServers(): string[];
}
export declare class DataYandexVpcSubnetDhcpOptionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexVpcSubnetDhcpOptionsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet yandex_vpc_subnet}
*/
export declare class DataYandexVpcSubnet extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_vpc_subnet";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet yandex_vpc_subnet} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexVpcSubnetConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexVpcSubnetConfig);
    get createdAt(): string;
    get description(): string;
    private _dhcpOptions;
    get dhcpOptions(): DataYandexVpcSubnetDhcpOptionsList;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    get routeTableId(): string;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    get v4CidrBlocks(): string[];
    get v6CidrBlocks(): string[];
    get zone(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-vpc-subnet.d.ts.map