import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexYdbDatabaseDedicatedConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#database_id DataYandexYdbDatabaseDedicated#database_id}
    */
    readonly databaseId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#folder_id DataYandexYdbDatabaseDedicated#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#id DataYandexYdbDatabaseDedicated#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#name DataYandexYdbDatabaseDedicated#name}
    */
    readonly name?: string;
}
export interface DataYandexYdbDatabaseDedicatedLocationRegion {
}
export declare function dataYandexYdbDatabaseDedicatedLocationRegionToTerraform(struct?: DataYandexYdbDatabaseDedicatedLocationRegion): any;
export declare class DataYandexYdbDatabaseDedicatedLocationRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexYdbDatabaseDedicatedLocationRegion | undefined;
    set internalValue(value: DataYandexYdbDatabaseDedicatedLocationRegion | undefined);
    get id(): string;
}
export declare class DataYandexYdbDatabaseDedicatedLocationRegionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexYdbDatabaseDedicatedLocationRegionOutputReference;
}
export interface DataYandexYdbDatabaseDedicatedLocationZone {
}
export declare function dataYandexYdbDatabaseDedicatedLocationZoneToTerraform(struct?: DataYandexYdbDatabaseDedicatedLocationZone): any;
export declare class DataYandexYdbDatabaseDedicatedLocationZoneOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexYdbDatabaseDedicatedLocationZone | undefined;
    set internalValue(value: DataYandexYdbDatabaseDedicatedLocationZone | undefined);
    get id(): string;
}
export declare class DataYandexYdbDatabaseDedicatedLocationZoneList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexYdbDatabaseDedicatedLocationZoneOutputReference;
}
export interface DataYandexYdbDatabaseDedicatedLocation {
}
export declare function dataYandexYdbDatabaseDedicatedLocationToTerraform(struct?: DataYandexYdbDatabaseDedicatedLocation): any;
export declare class DataYandexYdbDatabaseDedicatedLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexYdbDatabaseDedicatedLocation | undefined;
    set internalValue(value: DataYandexYdbDatabaseDedicatedLocation | undefined);
    private _region;
    get region(): DataYandexYdbDatabaseDedicatedLocationRegionList;
    private _zone;
    get zone(): DataYandexYdbDatabaseDedicatedLocationZoneList;
}
export declare class DataYandexYdbDatabaseDedicatedLocationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexYdbDatabaseDedicatedLocationOutputReference;
}
export interface DataYandexYdbDatabaseDedicatedScalePolicyFixedScale {
}
export declare function dataYandexYdbDatabaseDedicatedScalePolicyFixedScaleToTerraform(struct?: DataYandexYdbDatabaseDedicatedScalePolicyFixedScale): any;
export declare class DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexYdbDatabaseDedicatedScalePolicyFixedScale | undefined;
    set internalValue(value: DataYandexYdbDatabaseDedicatedScalePolicyFixedScale | undefined);
    get size(): number;
}
export declare class DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference;
}
export interface DataYandexYdbDatabaseDedicatedScalePolicy {
}
export declare function dataYandexYdbDatabaseDedicatedScalePolicyToTerraform(struct?: DataYandexYdbDatabaseDedicatedScalePolicy): any;
export declare class DataYandexYdbDatabaseDedicatedScalePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexYdbDatabaseDedicatedScalePolicy | undefined;
    set internalValue(value: DataYandexYdbDatabaseDedicatedScalePolicy | undefined);
    private _fixedScale;
    get fixedScale(): DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList;
}
export declare class DataYandexYdbDatabaseDedicatedScalePolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexYdbDatabaseDedicatedScalePolicyOutputReference;
}
export interface DataYandexYdbDatabaseDedicatedStorageConfig {
}
export declare function dataYandexYdbDatabaseDedicatedStorageConfigToTerraform(struct?: DataYandexYdbDatabaseDedicatedStorageConfig): any;
export declare class DataYandexYdbDatabaseDedicatedStorageConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataYandexYdbDatabaseDedicatedStorageConfig | undefined;
    set internalValue(value: DataYandexYdbDatabaseDedicatedStorageConfig | undefined);
    get groupCount(): number;
    get storageTypeId(): string;
}
export declare class DataYandexYdbDatabaseDedicatedStorageConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataYandexYdbDatabaseDedicatedStorageConfigOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated yandex_ydb_database_dedicated}
*/
export declare class DataYandexYdbDatabaseDedicated extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_ydb_database_dedicated";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated yandex_ydb_database_dedicated} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexYdbDatabaseDedicatedConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexYdbDatabaseDedicatedConfig);
    get assignPublicIps(): cdktf.IResolvable;
    get createdAt(): string;
    private _databaseId?;
    get databaseId(): string;
    set databaseId(value: string);
    resetDatabaseId(): void;
    get databaseIdInput(): string | undefined;
    get databasePath(): string;
    get description(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    private _location;
    get location(): DataYandexYdbDatabaseDedicatedLocationList;
    get locationId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get networkId(): string;
    get resourcePresetId(): string;
    private _scalePolicy;
    get scalePolicy(): DataYandexYdbDatabaseDedicatedScalePolicyList;
    get status(): string;
    private _storageConfig;
    get storageConfig(): DataYandexYdbDatabaseDedicatedStorageConfigList;
    get subnetIds(): string[];
    get tlsEnabled(): cdktf.IResolvable;
    get ydbApiEndpoint(): string;
    get ydbFullEndpoint(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-ydb-database-dedicated.d.ts.map