import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexYdbDatabaseServerlessConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#database_id DataYandexYdbDatabaseServerless#database_id}
    */
    readonly databaseId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#folder_id DataYandexYdbDatabaseServerless#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#id DataYandexYdbDatabaseServerless#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#name DataYandexYdbDatabaseServerless#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless yandex_ydb_database_serverless}
*/
export declare class DataYandexYdbDatabaseServerless extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_ydb_database_serverless";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless yandex_ydb_database_serverless} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexYdbDatabaseServerlessConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexYdbDatabaseServerlessConfig);
    get createdAt(): string;
    private _databaseId?;
    get databaseId(): string;
    set databaseId(value: string);
    resetDatabaseId(): void;
    get databaseIdInput(): string | undefined;
    get databasePath(): string;
    get description(): string;
    get documentApiEndpoint(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels;
    get labels(): cdktf.StringMap;
    get locationId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get status(): string;
    get tlsEnabled(): cdktf.IResolvable;
    get ydbApiEndpoint(): string;
    get ydbFullEndpoint(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-ydb-database-serverless.d.ts.map