import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DatatransferEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#description DatatransferEndpoint#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#folder_id DatatransferEndpoint#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#id DatatransferEndpoint#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#labels DatatransferEndpoint#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#name DatatransferEndpoint#name}
    */
    readonly name?: string;
    /**
    * settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#settings DatatransferEndpoint#settings}
    */
    readonly settings?: DatatransferEndpointSettings;
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference | DatatransferEndpointSettingsMysqlSourceConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise;
}
export declare function datatransferEndpointSettingsMysqlSourceConnectionToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceConnectionOutputReference | DatatransferEndpointSettingsMysqlSourceConnection): any;
export declare class DatatransferEndpointSettingsMysqlSourceConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsMysqlSourceConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourceObjectTransferSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#routine DatatransferEndpoint#routine}
    */
    readonly routine?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}
    */
    readonly trigger?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}
    */
    readonly view?: string;
}
export declare function datatransferEndpointSettingsMysqlSourceObjectTransferSettingsToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference | DatatransferEndpointSettingsMysqlSourceObjectTransferSettings): any;
export declare class DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourceObjectTransferSettings | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings | undefined);
    private _routine?;
    get routine(): string;
    set routine(value: string);
    resetRoutine(): void;
    get routineInput(): string | undefined;
    private _trigger?;
    get trigger(): string;
    set trigger(value: string);
    resetTrigger(): void;
    get triggerInput(): string | undefined;
    private _view?;
    get view(): string;
    set view(value: string);
    resetView(): void;
    get viewInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlSourcePassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsMysqlSourcePasswordToTerraform(struct?: DatatransferEndpointSettingsMysqlSourcePasswordOutputReference | DatatransferEndpointSettingsMysqlSourcePassword): any;
export declare class DatatransferEndpointSettingsMysqlSourcePasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSourcePassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSourcePassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlSource {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables_regex DatatransferEndpoint#exclude_tables_regex}
    */
    readonly excludeTablesRegex?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables_regex DatatransferEndpoint#include_tables_regex}
    */
    readonly includeTablesRegex?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsMysqlSourceConnection;
    /**
    * object_transfer_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#object_transfer_settings DatatransferEndpoint#object_transfer_settings}
    */
    readonly objectTransferSettings?: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsMysqlSourcePassword;
}
export declare function datatransferEndpointSettingsMysqlSourceToTerraform(struct?: DatatransferEndpointSettingsMysqlSourceOutputReference | DatatransferEndpointSettingsMysqlSource): any;
export declare class DatatransferEndpointSettingsMysqlSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlSource | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlSource | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _excludeTablesRegex?;
    get excludeTablesRegex(): string[];
    set excludeTablesRegex(value: string[]);
    resetExcludeTablesRegex(): void;
    get excludeTablesRegexInput(): string[] | undefined;
    private _includeTablesRegex?;
    get includeTablesRegex(): string[];
    set includeTablesRegex(value: string[]);
    resetIncludeTablesRegex(): void;
    get includeTablesRegexInput(): string[] | undefined;
    private _timezone?;
    get timezone(): string;
    set timezone(value: string);
    resetTimezone(): void;
    get timezoneInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsMysqlSourceConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsMysqlSourceConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsMysqlSourceConnection | undefined;
    private _objectTransferSettings;
    get objectTransferSettings(): DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference;
    putObjectTransferSettings(value: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings): void;
    resetObjectTransferSettings(): void;
    get objectTransferSettingsInput(): DatatransferEndpointSettingsMysqlSourceObjectTransferSettings | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsMysqlSourcePasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsMysqlSourcePassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsMysqlSourcePassword | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference | DatatransferEndpointSettingsMysqlTargetConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise;
}
export declare function datatransferEndpointSettingsMysqlTargetConnectionToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetConnectionOutputReference | DatatransferEndpointSettingsMysqlTargetConnection): any;
export declare class DatatransferEndpointSettingsMysqlTargetConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsMysqlTargetConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsMysqlTargetPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsMysqlTargetPasswordToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetPasswordOutputReference | DatatransferEndpointSettingsMysqlTargetPassword): any;
export declare class DatatransferEndpointSettingsMysqlTargetPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTargetPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTargetPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsMysqlTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}
    */
    readonly serviceSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#skip_constraint_checks DatatransferEndpoint#skip_constraint_checks}
    */
    readonly skipConstraintChecks?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sql_mode DatatransferEndpoint#sql_mode}
    */
    readonly sqlMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsMysqlTargetConnection;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsMysqlTargetPassword;
}
export declare function datatransferEndpointSettingsMysqlTargetToTerraform(struct?: DatatransferEndpointSettingsMysqlTargetOutputReference | DatatransferEndpointSettingsMysqlTarget): any;
export declare class DatatransferEndpointSettingsMysqlTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsMysqlTarget | undefined;
    set internalValue(value: DatatransferEndpointSettingsMysqlTarget | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _serviceSchema?;
    get serviceSchema(): string;
    set serviceSchema(value: string);
    resetServiceSchema(): void;
    get serviceSchemaInput(): string | undefined;
    private _skipConstraintChecks?;
    get skipConstraintChecks(): boolean | cdktf.IResolvable;
    set skipConstraintChecks(value: boolean | cdktf.IResolvable);
    resetSkipConstraintChecks(): void;
    get skipConstraintChecksInput(): boolean | cdktf.IResolvable | undefined;
    private _sqlMode?;
    get sqlMode(): string;
    set sqlMode(value: string);
    resetSqlMode(): void;
    get sqlModeInput(): string | undefined;
    private _timezone?;
    get timezone(): string;
    set timezone(value: string);
    resetTimezone(): void;
    get timezoneInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsMysqlTargetConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsMysqlTargetConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsMysqlTargetConnection | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsMysqlTargetPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsMysqlTargetPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsMysqlTargetPassword | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference | DatatransferEndpointSettingsPostgresSourceConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise;
}
export declare function datatransferEndpointSettingsPostgresSourceConnectionToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceConnectionOutputReference | DatatransferEndpointSettingsPostgresSourceConnection): any;
export declare class DatatransferEndpointSettingsPostgresSourceConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsPostgresSourceConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourceObjectTransferSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#cast DatatransferEndpoint#cast}
    */
    readonly cast?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collation DatatransferEndpoint#collation}
    */
    readonly collation?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#constraint DatatransferEndpoint#constraint}
    */
    readonly constraint?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#default_values DatatransferEndpoint#default_values}
    */
    readonly defaultValues?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#fk_constraint DatatransferEndpoint#fk_constraint}
    */
    readonly fkConstraint?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#function DatatransferEndpoint#function}
    */
    readonly function?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#index DatatransferEndpoint#index}
    */
    readonly index?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#policy DatatransferEndpoint#policy}
    */
    readonly policy?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#primary_key DatatransferEndpoint#primary_key}
    */
    readonly primaryKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#rule DatatransferEndpoint#rule}
    */
    readonly rule?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence DatatransferEndpoint#sequence}
    */
    readonly sequence?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence_owned_by DatatransferEndpoint#sequence_owned_by}
    */
    readonly sequenceOwnedBy?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#table DatatransferEndpoint#table}
    */
    readonly table?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}
    */
    readonly trigger?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#type DatatransferEndpoint#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}
    */
    readonly view?: string;
}
export declare function datatransferEndpointSettingsPostgresSourceObjectTransferSettingsToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference | DatatransferEndpointSettingsPostgresSourceObjectTransferSettings): any;
export declare class DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourceObjectTransferSettings | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings | undefined);
    private _cast?;
    get cast(): string;
    set cast(value: string);
    resetCast(): void;
    get castInput(): string | undefined;
    private _collation?;
    get collation(): string;
    set collation(value: string);
    resetCollation(): void;
    get collationInput(): string | undefined;
    private _constraint?;
    get constraint(): string;
    set constraint(value: string);
    resetConstraint(): void;
    get constraintInput(): string | undefined;
    private _defaultValues?;
    get defaultValues(): string;
    set defaultValues(value: string);
    resetDefaultValues(): void;
    get defaultValuesInput(): string | undefined;
    private _fkConstraint?;
    get fkConstraint(): string;
    set fkConstraint(value: string);
    resetFkConstraint(): void;
    get fkConstraintInput(): string | undefined;
    private _function?;
    get function(): string;
    set function(value: string);
    resetFunction(): void;
    get functionInput(): string | undefined;
    private _index?;
    get index(): string;
    set index(value: string);
    resetIndex(): void;
    get indexInput(): string | undefined;
    private _policy?;
    get policy(): string;
    set policy(value: string);
    resetPolicy(): void;
    get policyInput(): string | undefined;
    private _primaryKey?;
    get primaryKey(): string;
    set primaryKey(value: string);
    resetPrimaryKey(): void;
    get primaryKeyInput(): string | undefined;
    private _rule?;
    get rule(): string;
    set rule(value: string);
    resetRule(): void;
    get ruleInput(): string | undefined;
    private _sequence?;
    get sequence(): string;
    set sequence(value: string);
    resetSequence(): void;
    get sequenceInput(): string | undefined;
    private _sequenceOwnedBy?;
    get sequenceOwnedBy(): string;
    set sequenceOwnedBy(value: string);
    resetSequenceOwnedBy(): void;
    get sequenceOwnedByInput(): string | undefined;
    private _table?;
    get table(): string;
    set table(value: string);
    resetTable(): void;
    get tableInput(): string | undefined;
    private _trigger?;
    get trigger(): string;
    set trigger(value: string);
    resetTrigger(): void;
    get triggerInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _view?;
    get view(): string;
    set view(value: string);
    resetView(): void;
    get viewInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresSourcePassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsPostgresSourcePasswordToTerraform(struct?: DatatransferEndpointSettingsPostgresSourcePasswordOutputReference | DatatransferEndpointSettingsPostgresSourcePassword): any;
export declare class DatatransferEndpointSettingsPostgresSourcePasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSourcePassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSourcePassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresSource {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collapse_inherit_table DatatransferEndpoint#collapse_inherit_table}
    */
    readonly collapseInheritTable?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables DatatransferEndpoint#exclude_tables}
    */
    readonly excludeTables?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables DatatransferEndpoint#include_tables}
    */
    readonly includeTables?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}
    */
    readonly serviceSchema?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#slot_gigabyte_lag_limit DatatransferEndpoint#slot_gigabyte_lag_limit}
    */
    readonly slotGigabyteLagLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsPostgresSourceConnection;
    /**
    * object_transfer_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#object_transfer_settings DatatransferEndpoint#object_transfer_settings}
    */
    readonly objectTransferSettings?: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsPostgresSourcePassword;
}
export declare function datatransferEndpointSettingsPostgresSourceToTerraform(struct?: DatatransferEndpointSettingsPostgresSourceOutputReference | DatatransferEndpointSettingsPostgresSource): any;
export declare class DatatransferEndpointSettingsPostgresSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresSource | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresSource | undefined);
    private _collapseInheritTable?;
    get collapseInheritTable(): boolean | cdktf.IResolvable;
    set collapseInheritTable(value: boolean | cdktf.IResolvable);
    resetCollapseInheritTable(): void;
    get collapseInheritTableInput(): boolean | cdktf.IResolvable | undefined;
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _excludeTables?;
    get excludeTables(): string[];
    set excludeTables(value: string[]);
    resetExcludeTables(): void;
    get excludeTablesInput(): string[] | undefined;
    private _includeTables?;
    get includeTables(): string[];
    set includeTables(value: string[]);
    resetIncludeTables(): void;
    get includeTablesInput(): string[] | undefined;
    private _serviceSchema?;
    get serviceSchema(): string;
    set serviceSchema(value: string);
    resetServiceSchema(): void;
    get serviceSchemaInput(): string | undefined;
    private _slotGigabyteLagLimit?;
    get slotGigabyteLagLimit(): number;
    set slotGigabyteLagLimit(value: number);
    resetSlotGigabyteLagLimit(): void;
    get slotGigabyteLagLimitInput(): number | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsPostgresSourceConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsPostgresSourceConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsPostgresSourceConnection | undefined;
    private _objectTransferSettings;
    get objectTransferSettings(): DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference;
    putObjectTransferSettings(value: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings): void;
    resetObjectTransferSettings(): void;
    get objectTransferSettingsInput(): DatatransferEndpointSettingsPostgresSourceObjectTransferSettings | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsPostgresSourcePasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsPostgresSourcePassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsPostgresSourcePassword | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled {
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled | undefined);
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode {
    /**
    * disabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}
    */
    readonly disabled?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled;
    /**
    * enabled block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}
    */
    readonly enabled?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode | undefined);
    private _disabled;
    get disabled(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference;
    putDisabled(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled): void;
    resetDisabled(): void;
    get disabledInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled | undefined;
    private _enabled;
    get enabled(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference;
    putEnabled(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled): void;
    resetEnabled(): void;
    get enabledInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnectionOnPremise {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}
    */
    readonly caCertificate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}
    */
    readonly hosts?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * tls_mode block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}
    */
    readonly tlsMode?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionOnPremiseToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference | DatatransferEndpointSettingsPostgresTargetConnectionOnPremise): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremise | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise | undefined);
    private _caCertificate?;
    get caCertificate(): string;
    set caCertificate(value: string);
    resetCaCertificate(): void;
    get caCertificateInput(): string | undefined;
    private _hosts?;
    get hosts(): string[];
    set hosts(value: string[]);
    resetHosts(): void;
    get hostsInput(): string[] | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _tlsMode;
    get tlsMode(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference;
    putTlsMode(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode): void;
    resetTlsMode(): void;
    get tlsModeInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetConnection {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}
    */
    readonly mdbClusterId?: string;
    /**
    * on_premise block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}
    */
    readonly onPremise?: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise;
}
export declare function datatransferEndpointSettingsPostgresTargetConnectionToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetConnectionOutputReference | DatatransferEndpointSettingsPostgresTargetConnection): any;
export declare class DatatransferEndpointSettingsPostgresTargetConnectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetConnection | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetConnection | undefined);
    private _mdbClusterId?;
    get mdbClusterId(): string;
    set mdbClusterId(value: string);
    resetMdbClusterId(): void;
    get mdbClusterIdInput(): string | undefined;
    private _onPremise;
    get onPremise(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference;
    putOnPremise(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise): void;
    resetOnPremise(): void;
    get onPremiseInput(): DatatransferEndpointSettingsPostgresTargetConnectionOnPremise | undefined;
}
export interface DatatransferEndpointSettingsPostgresTargetPassword {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}
    */
    readonly raw?: string;
}
export declare function datatransferEndpointSettingsPostgresTargetPasswordToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetPasswordOutputReference | DatatransferEndpointSettingsPostgresTargetPassword): any;
export declare class DatatransferEndpointSettingsPostgresTargetPasswordOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTargetPassword | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTargetPassword | undefined);
    private _raw?;
    get raw(): string;
    set raw(value: string);
    resetRaw(): void;
    get rawInput(): string | undefined;
}
export interface DatatransferEndpointSettingsPostgresTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}
    */
    readonly database?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}
    */
    readonly user?: string;
    /**
    * connection block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}
    */
    readonly connection?: DatatransferEndpointSettingsPostgresTargetConnection;
    /**
    * password block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}
    */
    readonly password?: DatatransferEndpointSettingsPostgresTargetPassword;
}
export declare function datatransferEndpointSettingsPostgresTargetToTerraform(struct?: DatatransferEndpointSettingsPostgresTargetOutputReference | DatatransferEndpointSettingsPostgresTarget): any;
export declare class DatatransferEndpointSettingsPostgresTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettingsPostgresTarget | undefined;
    set internalValue(value: DatatransferEndpointSettingsPostgresTarget | undefined);
    private _database?;
    get database(): string;
    set database(value: string);
    resetDatabase(): void;
    get databaseInput(): string | undefined;
    private _user?;
    get user(): string;
    set user(value: string);
    resetUser(): void;
    get userInput(): string | undefined;
    private _connection;
    get connection(): DatatransferEndpointSettingsPostgresTargetConnectionOutputReference;
    putConnection(value: DatatransferEndpointSettingsPostgresTargetConnection): void;
    resetConnection(): void;
    get connectionInput(): DatatransferEndpointSettingsPostgresTargetConnection | undefined;
    private _password;
    get password(): DatatransferEndpointSettingsPostgresTargetPasswordOutputReference;
    putPassword(value: DatatransferEndpointSettingsPostgresTargetPassword): void;
    resetPassword(): void;
    get passwordInput(): DatatransferEndpointSettingsPostgresTargetPassword | undefined;
}
export interface DatatransferEndpointSettings {
    /**
    * mysql_source block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mysql_source DatatransferEndpoint#mysql_source}
    */
    readonly mysqlSource?: DatatransferEndpointSettingsMysqlSource;
    /**
    * mysql_target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mysql_target DatatransferEndpoint#mysql_target}
    */
    readonly mysqlTarget?: DatatransferEndpointSettingsMysqlTarget;
    /**
    * postgres_source block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#postgres_source DatatransferEndpoint#postgres_source}
    */
    readonly postgresSource?: DatatransferEndpointSettingsPostgresSource;
    /**
    * postgres_target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#postgres_target DatatransferEndpoint#postgres_target}
    */
    readonly postgresTarget?: DatatransferEndpointSettingsPostgresTarget;
}
export declare function datatransferEndpointSettingsToTerraform(struct?: DatatransferEndpointSettingsOutputReference | DatatransferEndpointSettings): any;
export declare class DatatransferEndpointSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DatatransferEndpointSettings | undefined;
    set internalValue(value: DatatransferEndpointSettings | undefined);
    private _mysqlSource;
    get mysqlSource(): DatatransferEndpointSettingsMysqlSourceOutputReference;
    putMysqlSource(value: DatatransferEndpointSettingsMysqlSource): void;
    resetMysqlSource(): void;
    get mysqlSourceInput(): DatatransferEndpointSettingsMysqlSource | undefined;
    private _mysqlTarget;
    get mysqlTarget(): DatatransferEndpointSettingsMysqlTargetOutputReference;
    putMysqlTarget(value: DatatransferEndpointSettingsMysqlTarget): void;
    resetMysqlTarget(): void;
    get mysqlTargetInput(): DatatransferEndpointSettingsMysqlTarget | undefined;
    private _postgresSource;
    get postgresSource(): DatatransferEndpointSettingsPostgresSourceOutputReference;
    putPostgresSource(value: DatatransferEndpointSettingsPostgresSource): void;
    resetPostgresSource(): void;
    get postgresSourceInput(): DatatransferEndpointSettingsPostgresSource | undefined;
    private _postgresTarget;
    get postgresTarget(): DatatransferEndpointSettingsPostgresTargetOutputReference;
    putPostgresTarget(value: DatatransferEndpointSettingsPostgresTarget): void;
    resetPostgresTarget(): void;
    get postgresTargetInput(): DatatransferEndpointSettingsPostgresTarget | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint yandex_datatransfer_endpoint}
*/
export declare class DatatransferEndpoint extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_datatransfer_endpoint";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint yandex_datatransfer_endpoint} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DatatransferEndpointConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DatatransferEndpointConfig);
    get author(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _settings;
    get settings(): DatatransferEndpointSettingsOutputReference;
    putSettings(value: DatatransferEndpointSettings): void;
    resetSettings(): void;
    get settingsInput(): DatatransferEndpointSettings | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=datatransfer-endpoint.d.ts.map