import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface FunctionScalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#function_id FunctionScalingPolicy#function_id}
    */
    readonly functionId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#id FunctionScalingPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#policy FunctionScalingPolicy#policy}
    */
    readonly policy?: FunctionScalingPolicyPolicy[] | cdktf.IResolvable;
}
export interface FunctionScalingPolicyPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#tag FunctionScalingPolicy#tag}
    */
    readonly tag: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_instances_limit FunctionScalingPolicy#zone_instances_limit}
    */
    readonly zoneInstancesLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_requests_limit FunctionScalingPolicy#zone_requests_limit}
    */
    readonly zoneRequestsLimit?: number;
}
export declare function functionScalingPolicyPolicyToTerraform(struct?: FunctionScalingPolicyPolicy | cdktf.IResolvable): any;
export declare class FunctionScalingPolicyPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): FunctionScalingPolicyPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: FunctionScalingPolicyPolicy | cdktf.IResolvable | undefined);
    private _tag?;
    get tag(): string;
    set tag(value: string);
    get tagInput(): string | undefined;
    private _zoneInstancesLimit?;
    get zoneInstancesLimit(): number;
    set zoneInstancesLimit(value: number);
    resetZoneInstancesLimit(): void;
    get zoneInstancesLimitInput(): number | undefined;
    private _zoneRequestsLimit?;
    get zoneRequestsLimit(): number;
    set zoneRequestsLimit(value: number);
    resetZoneRequestsLimit(): void;
    get zoneRequestsLimitInput(): number | undefined;
}
export declare class FunctionScalingPolicyPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: FunctionScalingPolicyPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): FunctionScalingPolicyPolicyOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy yandex_function_scaling_policy}
*/
export declare class FunctionScalingPolicy extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_function_scaling_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy yandex_function_scaling_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options FunctionScalingPolicyConfig
    */
    constructor(scope: Construct, id: string, config: FunctionScalingPolicyConfig);
    private _functionId?;
    get functionId(): string;
    set functionId(value: string);
    get functionIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _policy;
    get policy(): FunctionScalingPolicyPolicyList;
    putPolicy(value: FunctionScalingPolicyPolicy[] | cdktf.IResolvable): void;
    resetPolicy(): void;
    get policyInput(): cdktf.IResolvable | FunctionScalingPolicyPolicy[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=function-scaling-policy.d.ts.map