import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface FunctionTriggerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#description FunctionTrigger#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#folder_id FunctionTrigger#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#id FunctionTrigger#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#labels FunctionTrigger#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#name FunctionTrigger#name}
    */
    readonly name: string;
    /**
    * dlq block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#dlq FunctionTrigger#dlq}
    */
    readonly dlq?: FunctionTriggerDlq;
    /**
    * function block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#function FunctionTrigger#function}
    */
    readonly function: FunctionTriggerFunction;
    /**
    * iot block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#iot FunctionTrigger#iot}
    */
    readonly iot?: FunctionTriggerIot;
    /**
    * log_group block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#log_group FunctionTrigger#log_group}
    */
    readonly logGroup?: FunctionTriggerLogGroup;
    /**
    * logging block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#logging FunctionTrigger#logging}
    */
    readonly logging?: FunctionTriggerLogging;
    /**
    * message_queue block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#message_queue FunctionTrigger#message_queue}
    */
    readonly messageQueue?: FunctionTriggerMessageQueue;
    /**
    * object_storage block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#object_storage FunctionTrigger#object_storage}
    */
    readonly objectStorage?: FunctionTriggerObjectStorage;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#timeouts FunctionTrigger#timeouts}
    */
    readonly timeouts?: FunctionTriggerTimeouts;
    /**
    * timer block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#timer FunctionTrigger#timer}
    */
    readonly timer?: FunctionTriggerTimer;
}
export interface FunctionTriggerDlq {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#queue_id FunctionTrigger#queue_id}
    */
    readonly queueId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}
    */
    readonly serviceAccountId: string;
}
export declare function functionTriggerDlqToTerraform(struct?: FunctionTriggerDlqOutputReference | FunctionTriggerDlq): any;
export declare class FunctionTriggerDlqOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerDlq | undefined;
    set internalValue(value: FunctionTriggerDlq | undefined);
    private _queueId?;
    get queueId(): string;
    set queueId(value: string);
    get queueIdInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
}
export interface FunctionTriggerFunction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#id FunctionTrigger#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#retry_attempts FunctionTrigger#retry_attempts}
    */
    readonly retryAttempts?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#retry_interval FunctionTrigger#retry_interval}
    */
    readonly retryInterval?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}
    */
    readonly serviceAccountId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#tag FunctionTrigger#tag}
    */
    readonly tag?: string;
}
export declare function functionTriggerFunctionToTerraform(struct?: FunctionTriggerFunctionOutputReference | FunctionTriggerFunction): any;
export declare class FunctionTriggerFunctionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerFunction | undefined;
    set internalValue(value: FunctionTriggerFunction | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    private _retryAttempts?;
    get retryAttempts(): string;
    set retryAttempts(value: string);
    resetRetryAttempts(): void;
    get retryAttemptsInput(): string | undefined;
    private _retryInterval?;
    get retryInterval(): string;
    set retryInterval(value: string);
    resetRetryInterval(): void;
    get retryIntervalInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    resetServiceAccountId(): void;
    get serviceAccountIdInput(): string | undefined;
    private _tag?;
    get tag(): string;
    set tag(value: string);
    resetTag(): void;
    get tagInput(): string | undefined;
}
export interface FunctionTriggerIot {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#device_id FunctionTrigger#device_id}
    */
    readonly deviceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#registry_id FunctionTrigger#registry_id}
    */
    readonly registryId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#topic FunctionTrigger#topic}
    */
    readonly topic?: string;
}
export declare function functionTriggerIotToTerraform(struct?: FunctionTriggerIotOutputReference | FunctionTriggerIot): any;
export declare class FunctionTriggerIotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerIot | undefined;
    set internalValue(value: FunctionTriggerIot | undefined);
    private _deviceId?;
    get deviceId(): string;
    set deviceId(value: string);
    resetDeviceId(): void;
    get deviceIdInput(): string | undefined;
    private _registryId?;
    get registryId(): string;
    set registryId(value: string);
    get registryIdInput(): string | undefined;
    private _topic?;
    get topic(): string;
    set topic(value: string);
    resetTopic(): void;
    get topicInput(): string | undefined;
}
export interface FunctionTriggerLogGroup {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}
    */
    readonly batchCutoff: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}
    */
    readonly batchSize?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#log_group_ids FunctionTrigger#log_group_ids}
    */
    readonly logGroupIds: string[];
}
export declare function functionTriggerLogGroupToTerraform(struct?: FunctionTriggerLogGroupOutputReference | FunctionTriggerLogGroup): any;
export declare class FunctionTriggerLogGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerLogGroup | undefined;
    set internalValue(value: FunctionTriggerLogGroup | undefined);
    private _batchCutoff?;
    get batchCutoff(): string;
    set batchCutoff(value: string);
    get batchCutoffInput(): string | undefined;
    private _batchSize?;
    get batchSize(): string;
    set batchSize(value: string);
    resetBatchSize(): void;
    get batchSizeInput(): string | undefined;
    private _logGroupIds?;
    get logGroupIds(): string[];
    set logGroupIds(value: string[]);
    get logGroupIdsInput(): string[] | undefined;
}
export interface FunctionTriggerLogging {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}
    */
    readonly batchCutoff: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}
    */
    readonly batchSize?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#group_id FunctionTrigger#group_id}
    */
    readonly groupId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#levels FunctionTrigger#levels}
    */
    readonly levels: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#resource_ids FunctionTrigger#resource_ids}
    */
    readonly resourceIds: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#resource_types FunctionTrigger#resource_types}
    */
    readonly resourceTypes: string[];
}
export declare function functionTriggerLoggingToTerraform(struct?: FunctionTriggerLoggingOutputReference | FunctionTriggerLogging): any;
export declare class FunctionTriggerLoggingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerLogging | undefined;
    set internalValue(value: FunctionTriggerLogging | undefined);
    private _batchCutoff?;
    get batchCutoff(): string;
    set batchCutoff(value: string);
    get batchCutoffInput(): string | undefined;
    private _batchSize?;
    get batchSize(): string;
    set batchSize(value: string);
    resetBatchSize(): void;
    get batchSizeInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    get groupIdInput(): string | undefined;
    private _levels?;
    get levels(): string[];
    set levels(value: string[]);
    get levelsInput(): string[] | undefined;
    private _resourceIds?;
    get resourceIds(): string[];
    set resourceIds(value: string[]);
    get resourceIdsInput(): string[] | undefined;
    private _resourceTypes?;
    get resourceTypes(): string[];
    set resourceTypes(value: string[]);
    get resourceTypesInput(): string[] | undefined;
}
export interface FunctionTriggerMessageQueue {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}
    */
    readonly batchCutoff: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}
    */
    readonly batchSize?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#queue_id FunctionTrigger#queue_id}
    */
    readonly queueId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}
    */
    readonly serviceAccountId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#visibility_timeout FunctionTrigger#visibility_timeout}
    */
    readonly visibilityTimeout?: string;
}
export declare function functionTriggerMessageQueueToTerraform(struct?: FunctionTriggerMessageQueueOutputReference | FunctionTriggerMessageQueue): any;
export declare class FunctionTriggerMessageQueueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerMessageQueue | undefined;
    set internalValue(value: FunctionTriggerMessageQueue | undefined);
    private _batchCutoff?;
    get batchCutoff(): string;
    set batchCutoff(value: string);
    get batchCutoffInput(): string | undefined;
    private _batchSize?;
    get batchSize(): string;
    set batchSize(value: string);
    resetBatchSize(): void;
    get batchSizeInput(): string | undefined;
    private _queueId?;
    get queueId(): string;
    set queueId(value: string);
    get queueIdInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
    private _visibilityTimeout?;
    get visibilityTimeout(): string;
    set visibilityTimeout(value: string);
    resetVisibilityTimeout(): void;
    get visibilityTimeoutInput(): string | undefined;
}
export interface FunctionTriggerObjectStorage {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#bucket_id FunctionTrigger#bucket_id}
    */
    readonly bucketId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#create FunctionTrigger#create}
    */
    readonly create?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#delete FunctionTrigger#delete}
    */
    readonly delete?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#prefix FunctionTrigger#prefix}
    */
    readonly prefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#suffix FunctionTrigger#suffix}
    */
    readonly suffix?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#update FunctionTrigger#update}
    */
    readonly update?: boolean | cdktf.IResolvable;
}
export declare function functionTriggerObjectStorageToTerraform(struct?: FunctionTriggerObjectStorageOutputReference | FunctionTriggerObjectStorage): any;
export declare class FunctionTriggerObjectStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerObjectStorage | undefined;
    set internalValue(value: FunctionTriggerObjectStorage | undefined);
    private _bucketId?;
    get bucketId(): string;
    set bucketId(value: string);
    get bucketIdInput(): string | undefined;
    private _create?;
    get create(): boolean | cdktf.IResolvable;
    set create(value: boolean | cdktf.IResolvable);
    resetCreate(): void;
    get createInput(): boolean | cdktf.IResolvable | undefined;
    private _delete?;
    get delete(): boolean | cdktf.IResolvable;
    set delete(value: boolean | cdktf.IResolvable);
    resetDelete(): void;
    get deleteInput(): boolean | cdktf.IResolvable | undefined;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
    private _suffix?;
    get suffix(): string;
    set suffix(value: string);
    resetSuffix(): void;
    get suffixInput(): string | undefined;
    private _update?;
    get update(): boolean | cdktf.IResolvable;
    set update(value: boolean | cdktf.IResolvable);
    resetUpdate(): void;
    get updateInput(): boolean | cdktf.IResolvable | undefined;
}
export interface FunctionTriggerTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#create FunctionTrigger#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#delete FunctionTrigger#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#update FunctionTrigger#update}
    */
    readonly update?: string;
}
export declare function functionTriggerTimeoutsToTerraform(struct?: FunctionTriggerTimeoutsOutputReference | FunctionTriggerTimeouts | cdktf.IResolvable): any;
export declare class FunctionTriggerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: FunctionTriggerTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
export interface FunctionTriggerTimer {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#cron_expression FunctionTrigger#cron_expression}
    */
    readonly cronExpression: string;
}
export declare function functionTriggerTimerToTerraform(struct?: FunctionTriggerTimerOutputReference | FunctionTriggerTimer): any;
export declare class FunctionTriggerTimerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): FunctionTriggerTimer | undefined;
    set internalValue(value: FunctionTriggerTimer | undefined);
    private _cronExpression?;
    get cronExpression(): string;
    set cronExpression(value: string);
    get cronExpressionInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger yandex_function_trigger}
*/
export declare class FunctionTrigger extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_function_trigger";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger yandex_function_trigger} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options FunctionTriggerConfig
    */
    constructor(scope: Construct, id: string, config: FunctionTriggerConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _dlq;
    get dlq(): FunctionTriggerDlqOutputReference;
    putDlq(value: FunctionTriggerDlq): void;
    resetDlq(): void;
    get dlqInput(): FunctionTriggerDlq | undefined;
    private _function;
    get function(): FunctionTriggerFunctionOutputReference;
    putFunction(value: FunctionTriggerFunction): void;
    get functionInput(): FunctionTriggerFunction | undefined;
    private _iot;
    get iot(): FunctionTriggerIotOutputReference;
    putIot(value: FunctionTriggerIot): void;
    resetIot(): void;
    get iotInput(): FunctionTriggerIot | undefined;
    private _logGroup;
    get logGroup(): FunctionTriggerLogGroupOutputReference;
    putLogGroup(value: FunctionTriggerLogGroup): void;
    resetLogGroup(): void;
    get logGroupInput(): FunctionTriggerLogGroup | undefined;
    private _logging;
    get logging(): FunctionTriggerLoggingOutputReference;
    putLogging(value: FunctionTriggerLogging): void;
    resetLogging(): void;
    get loggingInput(): FunctionTriggerLogging | undefined;
    private _messageQueue;
    get messageQueue(): FunctionTriggerMessageQueueOutputReference;
    putMessageQueue(value: FunctionTriggerMessageQueue): void;
    resetMessageQueue(): void;
    get messageQueueInput(): FunctionTriggerMessageQueue | undefined;
    private _objectStorage;
    get objectStorage(): FunctionTriggerObjectStorageOutputReference;
    putObjectStorage(value: FunctionTriggerObjectStorage): void;
    resetObjectStorage(): void;
    get objectStorageInput(): FunctionTriggerObjectStorage | undefined;
    private _timeouts;
    get timeouts(): FunctionTriggerTimeoutsOutputReference;
    putTimeouts(value: FunctionTriggerTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | FunctionTriggerTimeouts | undefined;
    private _timer;
    get timer(): FunctionTriggerTimerOutputReference;
    putTimer(value: FunctionTriggerTimer): void;
    resetTimer(): void;
    get timerInput(): FunctionTriggerTimer | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=function-trigger.d.ts.map