import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IamServiceAccountStaticAccessKeyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#description IamServiceAccountStaticAccessKey#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#id IamServiceAccountStaticAccessKey#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#pgp_key IamServiceAccountStaticAccessKey#pgp_key}
    */
    readonly pgpKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#service_account_id IamServiceAccountStaticAccessKey#service_account_id}
    */
    readonly serviceAccountId: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key yandex_iam_service_account_static_access_key}
*/
export declare class IamServiceAccountStaticAccessKey extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_iam_service_account_static_access_key";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key yandex_iam_service_account_static_access_key} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IamServiceAccountStaticAccessKeyConfig
    */
    constructor(scope: Construct, id: string, config: IamServiceAccountStaticAccessKeyConfig);
    get accessKey(): string;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get encryptedSecretKey(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get keyFingerprint(): string;
    private _pgpKey?;
    get pgpKey(): string;
    set pgpKey(value: string);
    resetPgpKey(): void;
    get pgpKeyInput(): string | undefined;
    get secretKey(): string;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=iam-service-account-static-access-key.d.ts.map