import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IotCoreDeviceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#aliases IotCoreDevice#aliases}
    */
    readonly aliases?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#certificates IotCoreDevice#certificates}
    */
    readonly certificates?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#description IotCoreDevice#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#id IotCoreDevice#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#name IotCoreDevice#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#passwords IotCoreDevice#passwords}
    */
    readonly passwords?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#registry_id IotCoreDevice#registry_id}
    */
    readonly registryId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#timeouts IotCoreDevice#timeouts}
    */
    readonly timeouts?: IotCoreDeviceTimeouts;
}
export interface IotCoreDeviceTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#create IotCoreDevice#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#delete IotCoreDevice#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#update IotCoreDevice#update}
    */
    readonly update?: string;
}
export declare function iotCoreDeviceTimeoutsToTerraform(struct?: IotCoreDeviceTimeoutsOutputReference | IotCoreDeviceTimeouts | cdktf.IResolvable): any;
export declare class IotCoreDeviceTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): IotCoreDeviceTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: IotCoreDeviceTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device yandex_iot_core_device}
*/
export declare class IotCoreDevice extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_iot_core_device";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device yandex_iot_core_device} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IotCoreDeviceConfig
    */
    constructor(scope: Construct, id: string, config: IotCoreDeviceConfig);
    private _aliases?;
    get aliases(): {
        [key: string]: string;
    };
    set aliases(value: {
        [key: string]: string;
    });
    resetAliases(): void;
    get aliasesInput(): {
        [key: string]: string;
    } | undefined;
    private _certificates?;
    get certificates(): string[];
    set certificates(value: string[]);
    resetCertificates(): void;
    get certificatesInput(): string[] | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _passwords?;
    get passwords(): string[];
    set passwords(value: string[]);
    resetPasswords(): void;
    get passwordsInput(): string[] | undefined;
    private _registryId?;
    get registryId(): string;
    set registryId(value: string);
    get registryIdInput(): string | undefined;
    private _timeouts;
    get timeouts(): IotCoreDeviceTimeoutsOutputReference;
    putTimeouts(value: IotCoreDeviceTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | IotCoreDeviceTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=iot-core-device.d.ts.map