import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IotCoreRegistryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#certificates IotCoreRegistry#certificates}
    */
    readonly certificates?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#description IotCoreRegistry#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#folder_id IotCoreRegistry#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#id IotCoreRegistry#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#labels IotCoreRegistry#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#name IotCoreRegistry#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#passwords IotCoreRegistry#passwords}
    */
    readonly passwords?: string[];
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#timeouts IotCoreRegistry#timeouts}
    */
    readonly timeouts?: IotCoreRegistryTimeouts;
}
export interface IotCoreRegistryTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#create IotCoreRegistry#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#delete IotCoreRegistry#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#update IotCoreRegistry#update}
    */
    readonly update?: string;
}
export declare function iotCoreRegistryTimeoutsToTerraform(struct?: IotCoreRegistryTimeoutsOutputReference | IotCoreRegistryTimeouts | cdktf.IResolvable): any;
export declare class IotCoreRegistryTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): IotCoreRegistryTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: IotCoreRegistryTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry yandex_iot_core_registry}
*/
export declare class IotCoreRegistry extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_iot_core_registry";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry yandex_iot_core_registry} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IotCoreRegistryConfig
    */
    constructor(scope: Construct, id: string, config: IotCoreRegistryConfig);
    private _certificates?;
    get certificates(): string[];
    set certificates(value: string[]);
    resetCertificates(): void;
    get certificatesInput(): string[] | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _passwords?;
    get passwords(): string[];
    set passwords(value: string[]);
    resetPasswords(): void;
    get passwordsInput(): string[] | undefined;
    private _timeouts;
    get timeouts(): IotCoreRegistryTimeoutsOutputReference;
    putTimeouts(value: IotCoreRegistryTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | IotCoreRegistryTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=iot-core-registry.d.ts.map