import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface KmsSymmetricKeyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#default_algorithm KmsSymmetricKey#default_algorithm}
    */
    readonly defaultAlgorithm?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#description KmsSymmetricKey#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#folder_id KmsSymmetricKey#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#id KmsSymmetricKey#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#labels KmsSymmetricKey#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#name KmsSymmetricKey#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#rotation_period KmsSymmetricKey#rotation_period}
    */
    readonly rotationPeriod?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#timeouts KmsSymmetricKey#timeouts}
    */
    readonly timeouts?: KmsSymmetricKeyTimeouts;
}
export interface KmsSymmetricKeyTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#create KmsSymmetricKey#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#delete KmsSymmetricKey#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#read KmsSymmetricKey#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#update KmsSymmetricKey#update}
    */
    readonly update?: string;
}
export declare function kmsSymmetricKeyTimeoutsToTerraform(struct?: KmsSymmetricKeyTimeoutsOutputReference | KmsSymmetricKeyTimeouts | cdktf.IResolvable): any;
export declare class KmsSymmetricKeyTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KmsSymmetricKeyTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: KmsSymmetricKeyTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key yandex_kms_symmetric_key}
*/
export declare class KmsSymmetricKey extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_kms_symmetric_key";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key yandex_kms_symmetric_key} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options KmsSymmetricKeyConfig = {}
    */
    constructor(scope: Construct, id: string, config?: KmsSymmetricKeyConfig);
    get createdAt(): string;
    private _defaultAlgorithm?;
    get defaultAlgorithm(): string;
    set defaultAlgorithm(value: string);
    resetDefaultAlgorithm(): void;
    get defaultAlgorithmInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get rotatedAt(): string;
    private _rotationPeriod?;
    get rotationPeriod(): string;
    set rotationPeriod(value: string);
    resetRotationPeriod(): void;
    get rotationPeriodInput(): string | undefined;
    get status(): string;
    private _timeouts;
    get timeouts(): KmsSymmetricKeyTimeoutsOutputReference;
    putTimeouts(value: KmsSymmetricKeyTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | KmsSymmetricKeyTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=kms-symmetric-key.d.ts.map