import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface KubernetesClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cluster_ipv4_range KubernetesCluster#cluster_ipv4_range}
    */
    readonly clusterIpv4Range?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cluster_ipv6_range KubernetesCluster#cluster_ipv6_range}
    */
    readonly clusterIpv6Range?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#description KubernetesCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#folder_id KubernetesCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#id KubernetesCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#labels KubernetesCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#name KubernetesCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_id KubernetesCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_policy_provider KubernetesCluster#network_policy_provider}
    */
    readonly networkPolicyProvider?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#node_ipv4_cidr_mask_size KubernetesCluster#node_ipv4_cidr_mask_size}
    */
    readonly nodeIpv4CidrMaskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#node_service_account_id KubernetesCluster#node_service_account_id}
    */
    readonly nodeServiceAccountId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#release_channel KubernetesCluster#release_channel}
    */
    readonly releaseChannel?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_account_id KubernetesCluster#service_account_id}
    */
    readonly serviceAccountId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_ipv4_range KubernetesCluster#service_ipv4_range}
    */
    readonly serviceIpv4Range?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_ipv6_range KubernetesCluster#service_ipv6_range}
    */
    readonly serviceIpv6Range?: string;
    /**
    * kms_provider block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#kms_provider KubernetesCluster#kms_provider}
    */
    readonly kmsProvider?: KubernetesClusterKmsProvider;
    /**
    * master block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#master KubernetesCluster#master}
    */
    readonly master: KubernetesClusterMaster;
    /**
    * network_implementation block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_implementation KubernetesCluster#network_implementation}
    */
    readonly networkImplementation?: KubernetesClusterNetworkImplementation;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#timeouts KubernetesCluster#timeouts}
    */
    readonly timeouts?: KubernetesClusterTimeouts;
}
export interface KubernetesClusterKmsProvider {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#key_id KubernetesCluster#key_id}
    */
    readonly keyId?: string;
}
export declare function kubernetesClusterKmsProviderToTerraform(struct?: KubernetesClusterKmsProviderOutputReference | KubernetesClusterKmsProvider): any;
export declare class KubernetesClusterKmsProviderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterKmsProvider | undefined;
    set internalValue(value: KubernetesClusterKmsProvider | undefined);
    private _keyId?;
    get keyId(): string;
    set keyId(value: string);
    resetKeyId(): void;
    get keyIdInput(): string | undefined;
}
export interface KubernetesClusterMasterVersionInfo {
}
export declare function kubernetesClusterMasterVersionInfoToTerraform(struct?: KubernetesClusterMasterVersionInfo): any;
export declare class KubernetesClusterMasterVersionInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesClusterMasterVersionInfo | undefined;
    set internalValue(value: KubernetesClusterMasterVersionInfo | undefined);
    get currentVersion(): string;
    get newRevisionAvailable(): cdktf.IResolvable;
    get newRevisionSummary(): string;
    get versionDeprecated(): cdktf.IResolvable;
}
export declare class KubernetesClusterMasterVersionInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesClusterMasterVersionInfoOutputReference;
}
export interface KubernetesClusterMasterMaintenancePolicyMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#day KubernetesCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#duration KubernetesCluster#duration}
    */
    readonly duration: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#start_time KubernetesCluster#start_time}
    */
    readonly startTime: string;
}
export declare function kubernetesClusterMasterMaintenancePolicyMaintenanceWindowToTerraform(struct?: KubernetesClusterMasterMaintenancePolicyMaintenanceWindow | cdktf.IResolvable): any;
export declare class KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesClusterMasterMaintenancePolicyMaintenanceWindow | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesClusterMasterMaintenancePolicyMaintenanceWindow | cdktf.IResolvable | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _duration?;
    get duration(): string;
    set duration(value: string);
    get durationInput(): string | undefined;
    private _startTime?;
    get startTime(): string;
    set startTime(value: string);
    get startTimeInput(): string | undefined;
}
export declare class KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference;
}
export interface KubernetesClusterMasterMaintenancePolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#auto_upgrade KubernetesCluster#auto_upgrade}
    */
    readonly autoUpgrade: boolean | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#maintenance_window KubernetesCluster#maintenance_window}
    */
    readonly maintenanceWindow?: KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[] | cdktf.IResolvable;
}
export declare function kubernetesClusterMasterMaintenancePolicyToTerraform(struct?: KubernetesClusterMasterMaintenancePolicyOutputReference | KubernetesClusterMasterMaintenancePolicy): any;
export declare class KubernetesClusterMasterMaintenancePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterMasterMaintenancePolicy | undefined;
    set internalValue(value: KubernetesClusterMasterMaintenancePolicy | undefined);
    private _autoUpgrade?;
    get autoUpgrade(): boolean | cdktf.IResolvable;
    set autoUpgrade(value: boolean | cdktf.IResolvable);
    get autoUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList;
    putMaintenanceWindow(value: KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[] | cdktf.IResolvable): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): cdktf.IResolvable | KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[] | undefined;
}
export interface KubernetesClusterMasterRegionalLocation {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#subnet_id KubernetesCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zone KubernetesCluster#zone}
    */
    readonly zone?: string;
}
export declare function kubernetesClusterMasterRegionalLocationToTerraform(struct?: KubernetesClusterMasterRegionalLocation | cdktf.IResolvable): any;
export declare class KubernetesClusterMasterRegionalLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesClusterMasterRegionalLocation | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesClusterMasterRegionalLocation | cdktf.IResolvable | undefined);
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    resetZone(): void;
    get zoneInput(): string | undefined;
}
export declare class KubernetesClusterMasterRegionalLocationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: KubernetesClusterMasterRegionalLocation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesClusterMasterRegionalLocationOutputReference;
}
export interface KubernetesClusterMasterRegional {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#region KubernetesCluster#region}
    */
    readonly region: string;
    /**
    * location block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#location KubernetesCluster#location}
    */
    readonly location?: KubernetesClusterMasterRegionalLocation[] | cdktf.IResolvable;
}
export declare function kubernetesClusterMasterRegionalToTerraform(struct?: KubernetesClusterMasterRegionalOutputReference | KubernetesClusterMasterRegional): any;
export declare class KubernetesClusterMasterRegionalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterMasterRegional | undefined;
    set internalValue(value: KubernetesClusterMasterRegional | undefined);
    private _region?;
    get region(): string;
    set region(value: string);
    get regionInput(): string | undefined;
    private _location;
    get location(): KubernetesClusterMasterRegionalLocationList;
    putLocation(value: KubernetesClusterMasterRegionalLocation[] | cdktf.IResolvable): void;
    resetLocation(): void;
    get locationInput(): cdktf.IResolvable | KubernetesClusterMasterRegionalLocation[] | undefined;
}
export interface KubernetesClusterMasterZonal {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#subnet_id KubernetesCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zone KubernetesCluster#zone}
    */
    readonly zone?: string;
}
export declare function kubernetesClusterMasterZonalToTerraform(struct?: KubernetesClusterMasterZonalOutputReference | KubernetesClusterMasterZonal): any;
export declare class KubernetesClusterMasterZonalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterMasterZonal | undefined;
    set internalValue(value: KubernetesClusterMasterZonal | undefined);
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    resetZone(): void;
    get zoneInput(): string | undefined;
}
export interface KubernetesClusterMaster {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#public_ip KubernetesCluster#public_ip}
    */
    readonly publicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#security_group_ids KubernetesCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#version KubernetesCluster#version}
    */
    readonly version?: string;
    /**
    * maintenance_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#maintenance_policy KubernetesCluster#maintenance_policy}
    */
    readonly maintenancePolicy?: KubernetesClusterMasterMaintenancePolicy;
    /**
    * regional block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#regional KubernetesCluster#regional}
    */
    readonly regional?: KubernetesClusterMasterRegional;
    /**
    * zonal block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zonal KubernetesCluster#zonal}
    */
    readonly zonal?: KubernetesClusterMasterZonal;
}
export declare function kubernetesClusterMasterToTerraform(struct?: KubernetesClusterMasterOutputReference | KubernetesClusterMaster): any;
export declare class KubernetesClusterMasterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterMaster | undefined;
    set internalValue(value: KubernetesClusterMaster | undefined);
    get clusterCaCertificate(): string;
    get externalV4Address(): string;
    get externalV4Endpoint(): string;
    get internalV4Address(): string;
    get internalV4Endpoint(): string;
    private _publicIp?;
    get publicIp(): boolean | cdktf.IResolvable;
    set publicIp(value: boolean | cdktf.IResolvable);
    resetPublicIp(): void;
    get publicIpInput(): boolean | cdktf.IResolvable | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
    private _versionInfo;
    get versionInfo(): KubernetesClusterMasterVersionInfoList;
    private _maintenancePolicy;
    get maintenancePolicy(): KubernetesClusterMasterMaintenancePolicyOutputReference;
    putMaintenancePolicy(value: KubernetesClusterMasterMaintenancePolicy): void;
    resetMaintenancePolicy(): void;
    get maintenancePolicyInput(): KubernetesClusterMasterMaintenancePolicy | undefined;
    private _regional;
    get regional(): KubernetesClusterMasterRegionalOutputReference;
    putRegional(value: KubernetesClusterMasterRegional): void;
    resetRegional(): void;
    get regionalInput(): KubernetesClusterMasterRegional | undefined;
    private _zonal;
    get zonal(): KubernetesClusterMasterZonalOutputReference;
    putZonal(value: KubernetesClusterMasterZonal): void;
    resetZonal(): void;
    get zonalInput(): KubernetesClusterMasterZonal | undefined;
}
export interface KubernetesClusterNetworkImplementationCilium {
}
export declare function kubernetesClusterNetworkImplementationCiliumToTerraform(struct?: KubernetesClusterNetworkImplementationCiliumOutputReference | KubernetesClusterNetworkImplementationCilium): any;
export declare class KubernetesClusterNetworkImplementationCiliumOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterNetworkImplementationCilium | undefined;
    set internalValue(value: KubernetesClusterNetworkImplementationCilium | undefined);
}
export interface KubernetesClusterNetworkImplementation {
    /**
    * cilium block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cilium KubernetesCluster#cilium}
    */
    readonly cilium?: KubernetesClusterNetworkImplementationCilium;
}
export declare function kubernetesClusterNetworkImplementationToTerraform(struct?: KubernetesClusterNetworkImplementationOutputReference | KubernetesClusterNetworkImplementation): any;
export declare class KubernetesClusterNetworkImplementationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterNetworkImplementation | undefined;
    set internalValue(value: KubernetesClusterNetworkImplementation | undefined);
    private _cilium;
    get cilium(): KubernetesClusterNetworkImplementationCiliumOutputReference;
    putCilium(value: KubernetesClusterNetworkImplementationCilium): void;
    resetCilium(): void;
    get ciliumInput(): KubernetesClusterNetworkImplementationCilium | undefined;
}
export interface KubernetesClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#create KubernetesCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#delete KubernetesCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#read KubernetesCluster#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#update KubernetesCluster#update}
    */
    readonly update?: string;
}
export declare function kubernetesClusterTimeoutsToTerraform(struct?: KubernetesClusterTimeoutsOutputReference | KubernetesClusterTimeouts | cdktf.IResolvable): any;
export declare class KubernetesClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesClusterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster yandex_kubernetes_cluster}
*/
export declare class KubernetesCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_kubernetes_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster yandex_kubernetes_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options KubernetesClusterConfig
    */
    constructor(scope: Construct, id: string, config: KubernetesClusterConfig);
    private _clusterIpv4Range?;
    get clusterIpv4Range(): string;
    set clusterIpv4Range(value: string);
    resetClusterIpv4Range(): void;
    get clusterIpv4RangeInput(): string | undefined;
    private _clusterIpv6Range?;
    get clusterIpv6Range(): string;
    set clusterIpv6Range(value: string);
    resetClusterIpv6Range(): void;
    get clusterIpv6RangeInput(): string | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    get logGroupId(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _networkPolicyProvider?;
    get networkPolicyProvider(): string;
    set networkPolicyProvider(value: string);
    resetNetworkPolicyProvider(): void;
    get networkPolicyProviderInput(): string | undefined;
    private _nodeIpv4CidrMaskSize?;
    get nodeIpv4CidrMaskSize(): number;
    set nodeIpv4CidrMaskSize(value: number);
    resetNodeIpv4CidrMaskSize(): void;
    get nodeIpv4CidrMaskSizeInput(): number | undefined;
    private _nodeServiceAccountId?;
    get nodeServiceAccountId(): string;
    set nodeServiceAccountId(value: string);
    get nodeServiceAccountIdInput(): string | undefined;
    private _releaseChannel?;
    get releaseChannel(): string;
    set releaseChannel(value: string);
    resetReleaseChannel(): void;
    get releaseChannelInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
    private _serviceIpv4Range?;
    get serviceIpv4Range(): string;
    set serviceIpv4Range(value: string);
    resetServiceIpv4Range(): void;
    get serviceIpv4RangeInput(): string | undefined;
    private _serviceIpv6Range?;
    get serviceIpv6Range(): string;
    set serviceIpv6Range(value: string);
    resetServiceIpv6Range(): void;
    get serviceIpv6RangeInput(): string | undefined;
    get status(): string;
    private _kmsProvider;
    get kmsProvider(): KubernetesClusterKmsProviderOutputReference;
    putKmsProvider(value: KubernetesClusterKmsProvider): void;
    resetKmsProvider(): void;
    get kmsProviderInput(): KubernetesClusterKmsProvider | undefined;
    private _master;
    get master(): KubernetesClusterMasterOutputReference;
    putMaster(value: KubernetesClusterMaster): void;
    get masterInput(): KubernetesClusterMaster | undefined;
    private _networkImplementation;
    get networkImplementation(): KubernetesClusterNetworkImplementationOutputReference;
    putNetworkImplementation(value: KubernetesClusterNetworkImplementation): void;
    resetNetworkImplementation(): void;
    get networkImplementationInput(): KubernetesClusterNetworkImplementation | undefined;
    private _timeouts;
    get timeouts(): KubernetesClusterTimeoutsOutputReference;
    putTimeouts(value: KubernetesClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | KubernetesClusterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=kubernetes-cluster.d.ts.map