import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface KubernetesNodeGroupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#allowed_unsafe_sysctls KubernetesNodeGroup#allowed_unsafe_sysctls}
    */
    readonly allowedUnsafeSysctls?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#cluster_id KubernetesNodeGroup#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#description KubernetesNodeGroup#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#id KubernetesNodeGroup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#labels KubernetesNodeGroup#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#name KubernetesNodeGroup#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#node_labels KubernetesNodeGroup#node_labels}
    */
    readonly nodeLabels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#node_taints KubernetesNodeGroup#node_taints}
    */
    readonly nodeTaints?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#version KubernetesNodeGroup#version}
    */
    readonly version?: string;
    /**
    * allocation_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#allocation_policy KubernetesNodeGroup#allocation_policy}
    */
    readonly allocationPolicy?: KubernetesNodeGroupAllocationPolicy;
    /**
    * deploy_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#deploy_policy KubernetesNodeGroup#deploy_policy}
    */
    readonly deployPolicy?: KubernetesNodeGroupDeployPolicy;
    /**
    * instance_template block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#instance_template KubernetesNodeGroup#instance_template}
    */
    readonly instanceTemplate: KubernetesNodeGroupInstanceTemplate;
    /**
    * maintenance_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#maintenance_policy KubernetesNodeGroup#maintenance_policy}
    */
    readonly maintenancePolicy?: KubernetesNodeGroupMaintenancePolicy;
    /**
    * scale_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#scale_policy KubernetesNodeGroup#scale_policy}
    */
    readonly scalePolicy: KubernetesNodeGroupScalePolicy;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#timeouts KubernetesNodeGroup#timeouts}
    */
    readonly timeouts?: KubernetesNodeGroupTimeouts;
}
export interface KubernetesNodeGroupVersionInfo {
}
export declare function kubernetesNodeGroupVersionInfoToTerraform(struct?: KubernetesNodeGroupVersionInfo): any;
export declare class KubernetesNodeGroupVersionInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesNodeGroupVersionInfo | undefined;
    set internalValue(value: KubernetesNodeGroupVersionInfo | undefined);
    get currentVersion(): string;
    get newRevisionAvailable(): cdktf.IResolvable;
    get newRevisionSummary(): string;
    get versionDeprecated(): cdktf.IResolvable;
}
export declare class KubernetesNodeGroupVersionInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesNodeGroupVersionInfoOutputReference;
}
export interface KubernetesNodeGroupAllocationPolicyLocation {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#subnet_id KubernetesNodeGroup#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#zone KubernetesNodeGroup#zone}
    */
    readonly zone?: string;
}
export declare function kubernetesNodeGroupAllocationPolicyLocationToTerraform(struct?: KubernetesNodeGroupAllocationPolicyLocation | cdktf.IResolvable): any;
export declare class KubernetesNodeGroupAllocationPolicyLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesNodeGroupAllocationPolicyLocation | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesNodeGroupAllocationPolicyLocation | cdktf.IResolvable | undefined);
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    resetZone(): void;
    get zoneInput(): string | undefined;
}
export declare class KubernetesNodeGroupAllocationPolicyLocationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: KubernetesNodeGroupAllocationPolicyLocation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesNodeGroupAllocationPolicyLocationOutputReference;
}
export interface KubernetesNodeGroupAllocationPolicy {
    /**
    * location block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#location KubernetesNodeGroup#location}
    */
    readonly location?: KubernetesNodeGroupAllocationPolicyLocation[] | cdktf.IResolvable;
}
export declare function kubernetesNodeGroupAllocationPolicyToTerraform(struct?: KubernetesNodeGroupAllocationPolicyOutputReference | KubernetesNodeGroupAllocationPolicy): any;
export declare class KubernetesNodeGroupAllocationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupAllocationPolicy | undefined;
    set internalValue(value: KubernetesNodeGroupAllocationPolicy | undefined);
    private _location;
    get location(): KubernetesNodeGroupAllocationPolicyLocationList;
    putLocation(value: KubernetesNodeGroupAllocationPolicyLocation[] | cdktf.IResolvable): void;
    resetLocation(): void;
    get locationInput(): cdktf.IResolvable | KubernetesNodeGroupAllocationPolicyLocation[] | undefined;
}
export interface KubernetesNodeGroupDeployPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max_expansion KubernetesNodeGroup#max_expansion}
    */
    readonly maxExpansion: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max_unavailable KubernetesNodeGroup#max_unavailable}
    */
    readonly maxUnavailable: number;
}
export declare function kubernetesNodeGroupDeployPolicyToTerraform(struct?: KubernetesNodeGroupDeployPolicyOutputReference | KubernetesNodeGroupDeployPolicy): any;
export declare class KubernetesNodeGroupDeployPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupDeployPolicy | undefined;
    set internalValue(value: KubernetesNodeGroupDeployPolicy | undefined);
    private _maxExpansion?;
    get maxExpansion(): number;
    set maxExpansion(value: number);
    get maxExpansionInput(): number | undefined;
    private _maxUnavailable?;
    get maxUnavailable(): number;
    set maxUnavailable(value: number);
    get maxUnavailableInput(): number | undefined;
}
export interface KubernetesNodeGroupInstanceTemplateBootDisk {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#size KubernetesNodeGroup#size}
    */
    readonly size?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#type KubernetesNodeGroup#type}
    */
    readonly type?: string;
}
export declare function kubernetesNodeGroupInstanceTemplateBootDiskToTerraform(struct?: KubernetesNodeGroupInstanceTemplateBootDiskOutputReference | KubernetesNodeGroupInstanceTemplateBootDisk): any;
export declare class KubernetesNodeGroupInstanceTemplateBootDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupInstanceTemplateBootDisk | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplateBootDisk | undefined);
    private _size?;
    get size(): number;
    set size(value: number);
    resetSize(): void;
    get sizeInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface KubernetesNodeGroupInstanceTemplateContainerRuntime {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#type KubernetesNodeGroup#type}
    */
    readonly type: string;
}
export declare function kubernetesNodeGroupInstanceTemplateContainerRuntimeToTerraform(struct?: KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference | KubernetesNodeGroupInstanceTemplateContainerRuntime): any;
export declare class KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupInstanceTemplateContainerRuntime | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplateContainerRuntime | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface KubernetesNodeGroupInstanceTemplateNetworkInterface {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#ipv4 KubernetesNodeGroup#ipv4}
    */
    readonly ipv4?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#ipv6 KubernetesNodeGroup#ipv6}
    */
    readonly ipv6?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#nat KubernetesNodeGroup#nat}
    */
    readonly nat?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#security_group_ids KubernetesNodeGroup#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#subnet_ids KubernetesNodeGroup#subnet_ids}
    */
    readonly subnetIds: string[];
}
export declare function kubernetesNodeGroupInstanceTemplateNetworkInterfaceToTerraform(struct?: KubernetesNodeGroupInstanceTemplateNetworkInterface | cdktf.IResolvable): any;
export declare class KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesNodeGroupInstanceTemplateNetworkInterface | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplateNetworkInterface | cdktf.IResolvable | undefined);
    private _ipv4?;
    get ipv4(): boolean | cdktf.IResolvable;
    set ipv4(value: boolean | cdktf.IResolvable);
    resetIpv4(): void;
    get ipv4Input(): boolean | cdktf.IResolvable | undefined;
    private _ipv6?;
    get ipv6(): boolean | cdktf.IResolvable;
    set ipv6(value: boolean | cdktf.IResolvable);
    resetIpv6(): void;
    get ipv6Input(): boolean | cdktf.IResolvable | undefined;
    private _nat?;
    get nat(): boolean | cdktf.IResolvable;
    set nat(value: boolean | cdktf.IResolvable);
    resetNat(): void;
    get natInput(): boolean | cdktf.IResolvable | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    get subnetIds(): string[];
    set subnetIds(value: string[]);
    get subnetIdsInput(): string[] | undefined;
}
export declare class KubernetesNodeGroupInstanceTemplateNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: KubernetesNodeGroupInstanceTemplateNetworkInterface[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference;
}
export interface KubernetesNodeGroupInstanceTemplatePlacementPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#placement_group_id KubernetesNodeGroup#placement_group_id}
    */
    readonly placementGroupId: string;
}
export declare function kubernetesNodeGroupInstanceTemplatePlacementPolicyToTerraform(struct?: KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference | KubernetesNodeGroupInstanceTemplatePlacementPolicy): any;
export declare class KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupInstanceTemplatePlacementPolicy | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplatePlacementPolicy | undefined);
    private _placementGroupId?;
    get placementGroupId(): string;
    set placementGroupId(value: string);
    get placementGroupIdInput(): string | undefined;
}
export interface KubernetesNodeGroupInstanceTemplateResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#core_fraction KubernetesNodeGroup#core_fraction}
    */
    readonly coreFraction?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#cores KubernetesNodeGroup#cores}
    */
    readonly cores?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#gpus KubernetesNodeGroup#gpus}
    */
    readonly gpus?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#memory KubernetesNodeGroup#memory}
    */
    readonly memory?: number;
}
export declare function kubernetesNodeGroupInstanceTemplateResourcesToTerraform(struct?: KubernetesNodeGroupInstanceTemplateResourcesOutputReference | KubernetesNodeGroupInstanceTemplateResources): any;
export declare class KubernetesNodeGroupInstanceTemplateResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupInstanceTemplateResources | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplateResources | undefined);
    private _coreFraction?;
    get coreFraction(): number;
    set coreFraction(value: number);
    resetCoreFraction(): void;
    get coreFractionInput(): number | undefined;
    private _cores?;
    get cores(): number;
    set cores(value: number);
    resetCores(): void;
    get coresInput(): number | undefined;
    private _gpus?;
    get gpus(): number;
    set gpus(value: number);
    resetGpus(): void;
    get gpusInput(): number | undefined;
    private _memory?;
    get memory(): number;
    set memory(value: number);
    resetMemory(): void;
    get memoryInput(): number | undefined;
}
export interface KubernetesNodeGroupInstanceTemplateSchedulingPolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#preemptible KubernetesNodeGroup#preemptible}
    */
    readonly preemptible?: boolean | cdktf.IResolvable;
}
export declare function kubernetesNodeGroupInstanceTemplateSchedulingPolicyToTerraform(struct?: KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference | KubernetesNodeGroupInstanceTemplateSchedulingPolicy): any;
export declare class KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupInstanceTemplateSchedulingPolicy | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplateSchedulingPolicy | undefined);
    private _preemptible?;
    get preemptible(): boolean | cdktf.IResolvable;
    set preemptible(value: boolean | cdktf.IResolvable);
    resetPreemptible(): void;
    get preemptibleInput(): boolean | cdktf.IResolvable | undefined;
}
export interface KubernetesNodeGroupInstanceTemplate {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#metadata KubernetesNodeGroup#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#nat KubernetesNodeGroup#nat}
    */
    readonly nat?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#network_acceleration_type KubernetesNodeGroup#network_acceleration_type}
    */
    readonly networkAccelerationType?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#platform_id KubernetesNodeGroup#platform_id}
    */
    readonly platformId?: string;
    /**
    * boot_disk block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#boot_disk KubernetesNodeGroup#boot_disk}
    */
    readonly bootDisk?: KubernetesNodeGroupInstanceTemplateBootDisk;
    /**
    * container_runtime block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#container_runtime KubernetesNodeGroup#container_runtime}
    */
    readonly containerRuntime?: KubernetesNodeGroupInstanceTemplateContainerRuntime;
    /**
    * network_interface block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#network_interface KubernetesNodeGroup#network_interface}
    */
    readonly networkInterface?: KubernetesNodeGroupInstanceTemplateNetworkInterface[] | cdktf.IResolvable;
    /**
    * placement_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#placement_policy KubernetesNodeGroup#placement_policy}
    */
    readonly placementPolicy?: KubernetesNodeGroupInstanceTemplatePlacementPolicy;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#resources KubernetesNodeGroup#resources}
    */
    readonly resources?: KubernetesNodeGroupInstanceTemplateResources;
    /**
    * scheduling_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#scheduling_policy KubernetesNodeGroup#scheduling_policy}
    */
    readonly schedulingPolicy?: KubernetesNodeGroupInstanceTemplateSchedulingPolicy;
}
export declare function kubernetesNodeGroupInstanceTemplateToTerraform(struct?: KubernetesNodeGroupInstanceTemplateOutputReference | KubernetesNodeGroupInstanceTemplate): any;
export declare class KubernetesNodeGroupInstanceTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupInstanceTemplate | undefined;
    set internalValue(value: KubernetesNodeGroupInstanceTemplate | undefined);
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _nat?;
    get nat(): boolean | cdktf.IResolvable;
    set nat(value: boolean | cdktf.IResolvable);
    resetNat(): void;
    get natInput(): boolean | cdktf.IResolvable | undefined;
    private _networkAccelerationType?;
    get networkAccelerationType(): string;
    set networkAccelerationType(value: string);
    resetNetworkAccelerationType(): void;
    get networkAccelerationTypeInput(): string | undefined;
    private _platformId?;
    get platformId(): string;
    set platformId(value: string);
    resetPlatformId(): void;
    get platformIdInput(): string | undefined;
    private _bootDisk;
    get bootDisk(): KubernetesNodeGroupInstanceTemplateBootDiskOutputReference;
    putBootDisk(value: KubernetesNodeGroupInstanceTemplateBootDisk): void;
    resetBootDisk(): void;
    get bootDiskInput(): KubernetesNodeGroupInstanceTemplateBootDisk | undefined;
    private _containerRuntime;
    get containerRuntime(): KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference;
    putContainerRuntime(value: KubernetesNodeGroupInstanceTemplateContainerRuntime): void;
    resetContainerRuntime(): void;
    get containerRuntimeInput(): KubernetesNodeGroupInstanceTemplateContainerRuntime | undefined;
    private _networkInterface;
    get networkInterface(): KubernetesNodeGroupInstanceTemplateNetworkInterfaceList;
    putNetworkInterface(value: KubernetesNodeGroupInstanceTemplateNetworkInterface[] | cdktf.IResolvable): void;
    resetNetworkInterface(): void;
    get networkInterfaceInput(): cdktf.IResolvable | KubernetesNodeGroupInstanceTemplateNetworkInterface[] | undefined;
    private _placementPolicy;
    get placementPolicy(): KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference;
    putPlacementPolicy(value: KubernetesNodeGroupInstanceTemplatePlacementPolicy): void;
    resetPlacementPolicy(): void;
    get placementPolicyInput(): KubernetesNodeGroupInstanceTemplatePlacementPolicy | undefined;
    private _resources;
    get resources(): KubernetesNodeGroupInstanceTemplateResourcesOutputReference;
    putResources(value: KubernetesNodeGroupInstanceTemplateResources): void;
    resetResources(): void;
    get resourcesInput(): KubernetesNodeGroupInstanceTemplateResources | undefined;
    private _schedulingPolicy;
    get schedulingPolicy(): KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference;
    putSchedulingPolicy(value: KubernetesNodeGroupInstanceTemplateSchedulingPolicy): void;
    resetSchedulingPolicy(): void;
    get schedulingPolicyInput(): KubernetesNodeGroupInstanceTemplateSchedulingPolicy | undefined;
}
export interface KubernetesNodeGroupMaintenancePolicyMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#day KubernetesNodeGroup#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#duration KubernetesNodeGroup#duration}
    */
    readonly duration: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#start_time KubernetesNodeGroup#start_time}
    */
    readonly startTime: string;
}
export declare function kubernetesNodeGroupMaintenancePolicyMaintenanceWindowToTerraform(struct?: KubernetesNodeGroupMaintenancePolicyMaintenanceWindow | cdktf.IResolvable): any;
export declare class KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): KubernetesNodeGroupMaintenancePolicyMaintenanceWindow | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesNodeGroupMaintenancePolicyMaintenanceWindow | cdktf.IResolvable | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _duration?;
    get duration(): string;
    set duration(value: string);
    get durationInput(): string | undefined;
    private _startTime?;
    get startTime(): string;
    set startTime(value: string);
    get startTimeInput(): string | undefined;
}
export declare class KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference;
}
export interface KubernetesNodeGroupMaintenancePolicy {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_repair KubernetesNodeGroup#auto_repair}
    */
    readonly autoRepair: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_upgrade KubernetesNodeGroup#auto_upgrade}
    */
    readonly autoUpgrade: boolean | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#maintenance_window KubernetesNodeGroup#maintenance_window}
    */
    readonly maintenanceWindow?: KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[] | cdktf.IResolvable;
}
export declare function kubernetesNodeGroupMaintenancePolicyToTerraform(struct?: KubernetesNodeGroupMaintenancePolicyOutputReference | KubernetesNodeGroupMaintenancePolicy): any;
export declare class KubernetesNodeGroupMaintenancePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupMaintenancePolicy | undefined;
    set internalValue(value: KubernetesNodeGroupMaintenancePolicy | undefined);
    private _autoRepair?;
    get autoRepair(): boolean | cdktf.IResolvable;
    set autoRepair(value: boolean | cdktf.IResolvable);
    get autoRepairInput(): boolean | cdktf.IResolvable | undefined;
    private _autoUpgrade?;
    get autoUpgrade(): boolean | cdktf.IResolvable;
    set autoUpgrade(value: boolean | cdktf.IResolvable);
    get autoUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList;
    putMaintenanceWindow(value: KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[] | cdktf.IResolvable): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): cdktf.IResolvable | KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[] | undefined;
}
export interface KubernetesNodeGroupScalePolicyAutoScale {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#initial KubernetesNodeGroup#initial}
    */
    readonly initial: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max KubernetesNodeGroup#max}
    */
    readonly max: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#min KubernetesNodeGroup#min}
    */
    readonly min: number;
}
export declare function kubernetesNodeGroupScalePolicyAutoScaleToTerraform(struct?: KubernetesNodeGroupScalePolicyAutoScaleOutputReference | KubernetesNodeGroupScalePolicyAutoScale): any;
export declare class KubernetesNodeGroupScalePolicyAutoScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupScalePolicyAutoScale | undefined;
    set internalValue(value: KubernetesNodeGroupScalePolicyAutoScale | undefined);
    private _initial?;
    get initial(): number;
    set initial(value: number);
    get initialInput(): number | undefined;
    private _max?;
    get max(): number;
    set max(value: number);
    get maxInput(): number | undefined;
    private _min?;
    get min(): number;
    set min(value: number);
    get minInput(): number | undefined;
}
export interface KubernetesNodeGroupScalePolicyFixedScale {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#size KubernetesNodeGroup#size}
    */
    readonly size?: number;
}
export declare function kubernetesNodeGroupScalePolicyFixedScaleToTerraform(struct?: KubernetesNodeGroupScalePolicyFixedScaleOutputReference | KubernetesNodeGroupScalePolicyFixedScale): any;
export declare class KubernetesNodeGroupScalePolicyFixedScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupScalePolicyFixedScale | undefined;
    set internalValue(value: KubernetesNodeGroupScalePolicyFixedScale | undefined);
    private _size?;
    get size(): number;
    set size(value: number);
    resetSize(): void;
    get sizeInput(): number | undefined;
}
export interface KubernetesNodeGroupScalePolicy {
    /**
    * auto_scale block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_scale KubernetesNodeGroup#auto_scale}
    */
    readonly autoScale?: KubernetesNodeGroupScalePolicyAutoScale;
    /**
    * fixed_scale block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#fixed_scale KubernetesNodeGroup#fixed_scale}
    */
    readonly fixedScale?: KubernetesNodeGroupScalePolicyFixedScale;
}
export declare function kubernetesNodeGroupScalePolicyToTerraform(struct?: KubernetesNodeGroupScalePolicyOutputReference | KubernetesNodeGroupScalePolicy): any;
export declare class KubernetesNodeGroupScalePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupScalePolicy | undefined;
    set internalValue(value: KubernetesNodeGroupScalePolicy | undefined);
    private _autoScale;
    get autoScale(): KubernetesNodeGroupScalePolicyAutoScaleOutputReference;
    putAutoScale(value: KubernetesNodeGroupScalePolicyAutoScale): void;
    resetAutoScale(): void;
    get autoScaleInput(): KubernetesNodeGroupScalePolicyAutoScale | undefined;
    private _fixedScale;
    get fixedScale(): KubernetesNodeGroupScalePolicyFixedScaleOutputReference;
    putFixedScale(value: KubernetesNodeGroupScalePolicyFixedScale): void;
    resetFixedScale(): void;
    get fixedScaleInput(): KubernetesNodeGroupScalePolicyFixedScale | undefined;
}
export interface KubernetesNodeGroupTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#create KubernetesNodeGroup#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#delete KubernetesNodeGroup#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#read KubernetesNodeGroup#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#update KubernetesNodeGroup#update}
    */
    readonly update?: string;
}
export declare function kubernetesNodeGroupTimeoutsToTerraform(struct?: KubernetesNodeGroupTimeoutsOutputReference | KubernetesNodeGroupTimeouts | cdktf.IResolvable): any;
export declare class KubernetesNodeGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): KubernetesNodeGroupTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: KubernetesNodeGroupTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group yandex_kubernetes_node_group}
*/
export declare class KubernetesNodeGroup extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_kubernetes_node_group";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group yandex_kubernetes_node_group} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options KubernetesNodeGroupConfig
    */
    constructor(scope: Construct, id: string, config: KubernetesNodeGroupConfig);
    private _allowedUnsafeSysctls?;
    get allowedUnsafeSysctls(): string[];
    set allowedUnsafeSysctls(value: string[]);
    resetAllowedUnsafeSysctls(): void;
    get allowedUnsafeSysctlsInput(): string[] | undefined;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get instanceGroupId(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _nodeLabels?;
    get nodeLabels(): {
        [key: string]: string;
    };
    set nodeLabels(value: {
        [key: string]: string;
    });
    resetNodeLabels(): void;
    get nodeLabelsInput(): {
        [key: string]: string;
    } | undefined;
    private _nodeTaints?;
    get nodeTaints(): string[];
    set nodeTaints(value: string[]);
    resetNodeTaints(): void;
    get nodeTaintsInput(): string[] | undefined;
    get status(): string;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
    private _versionInfo;
    get versionInfo(): KubernetesNodeGroupVersionInfoList;
    private _allocationPolicy;
    get allocationPolicy(): KubernetesNodeGroupAllocationPolicyOutputReference;
    putAllocationPolicy(value: KubernetesNodeGroupAllocationPolicy): void;
    resetAllocationPolicy(): void;
    get allocationPolicyInput(): KubernetesNodeGroupAllocationPolicy | undefined;
    private _deployPolicy;
    get deployPolicy(): KubernetesNodeGroupDeployPolicyOutputReference;
    putDeployPolicy(value: KubernetesNodeGroupDeployPolicy): void;
    resetDeployPolicy(): void;
    get deployPolicyInput(): KubernetesNodeGroupDeployPolicy | undefined;
    private _instanceTemplate;
    get instanceTemplate(): KubernetesNodeGroupInstanceTemplateOutputReference;
    putInstanceTemplate(value: KubernetesNodeGroupInstanceTemplate): void;
    get instanceTemplateInput(): KubernetesNodeGroupInstanceTemplate | undefined;
    private _maintenancePolicy;
    get maintenancePolicy(): KubernetesNodeGroupMaintenancePolicyOutputReference;
    putMaintenancePolicy(value: KubernetesNodeGroupMaintenancePolicy): void;
    resetMaintenancePolicy(): void;
    get maintenancePolicyInput(): KubernetesNodeGroupMaintenancePolicy | undefined;
    private _scalePolicy;
    get scalePolicy(): KubernetesNodeGroupScalePolicyOutputReference;
    putScalePolicy(value: KubernetesNodeGroupScalePolicy): void;
    get scalePolicyInput(): KubernetesNodeGroupScalePolicy | undefined;
    private _timeouts;
    get timeouts(): KubernetesNodeGroupTimeoutsOutputReference;
    putTimeouts(value: KubernetesNodeGroupTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | KubernetesNodeGroupTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=kubernetes-node-group.d.ts.map