import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbNetworkLoadBalancerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#description LbNetworkLoadBalancer#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#folder_id LbNetworkLoadBalancer#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#id LbNetworkLoadBalancer#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#labels LbNetworkLoadBalancer#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#region_id LbNetworkLoadBalancer#region_id}
    */
    readonly regionId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#type LbNetworkLoadBalancer#type}
    */
    readonly type?: string;
    /**
    * attached_target_group block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#attached_target_group LbNetworkLoadBalancer#attached_target_group}
    */
    readonly attachedTargetGroup?: LbNetworkLoadBalancerAttachedTargetGroup[] | cdktf.IResolvable;
    /**
    * listener block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#listener LbNetworkLoadBalancer#listener}
    */
    readonly listener?: LbNetworkLoadBalancerListener[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeouts LbNetworkLoadBalancer#timeouts}
    */
    readonly timeouts?: LbNetworkLoadBalancerTimeouts;
}
export interface LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#path LbNetworkLoadBalancer#path}
    */
    readonly path?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}
    */
    readonly port: number;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference | LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions): any;
export declare class LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined;
    set internalValue(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined);
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
}
export interface LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}
    */
    readonly port: number;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference | LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions): any;
export declare class LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined;
    set internalValue(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined);
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
}
export interface LbNetworkLoadBalancerAttachedTargetGroupHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthy_threshold LbNetworkLoadBalancer#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#interval LbNetworkLoadBalancer#interval}
    */
    readonly interval?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeout LbNetworkLoadBalancer#timeout}
    */
    readonly timeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#unhealthy_threshold LbNetworkLoadBalancer#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * http_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#http_options LbNetworkLoadBalancer#http_options}
    */
    readonly httpOptions?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions;
    /**
    * tcp_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#tcp_options LbNetworkLoadBalancer#tcp_options}
    */
    readonly tcpOptions?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupHealthcheckToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck | cdktf.IResolvable): any;
export declare class LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheck | cdktf.IResolvable | undefined;
    set internalValue(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck | cdktf.IResolvable | undefined);
    private _healthyThreshold?;
    get healthyThreshold(): number;
    set healthyThreshold(value: number);
    resetHealthyThreshold(): void;
    get healthyThresholdInput(): number | undefined;
    private _interval?;
    get interval(): number;
    set interval(value: number);
    resetInterval(): void;
    get intervalInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _timeout?;
    get timeout(): number;
    set timeout(value: number);
    resetTimeout(): void;
    get timeoutInput(): number | undefined;
    private _unhealthyThreshold?;
    get unhealthyThreshold(): number;
    set unhealthyThreshold(value: number);
    resetUnhealthyThreshold(): void;
    get unhealthyThresholdInput(): number | undefined;
    private _httpOptions;
    get httpOptions(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference;
    putHttpOptions(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions): void;
    resetHttpOptions(): void;
    get httpOptionsInput(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined;
    private _tcpOptions;
    get tcpOptions(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference;
    putTcpOptions(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions): void;
    resetTcpOptions(): void;
    get tcpOptionsInput(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined;
}
export declare class LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference;
}
export interface LbNetworkLoadBalancerAttachedTargetGroup {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_group_id LbNetworkLoadBalancer#target_group_id}
    */
    readonly targetGroupId: string;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthcheck LbNetworkLoadBalancer#healthcheck}
    */
    readonly healthcheck: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[] | cdktf.IResolvable;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroup | cdktf.IResolvable): any;
export declare class LbNetworkLoadBalancerAttachedTargetGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): LbNetworkLoadBalancerAttachedTargetGroup | cdktf.IResolvable | undefined;
    set internalValue(value: LbNetworkLoadBalancerAttachedTargetGroup | cdktf.IResolvable | undefined);
    private _targetGroupId?;
    get targetGroupId(): string;
    set targetGroupId(value: string);
    get targetGroupIdInput(): string | undefined;
    private _healthcheck;
    get healthcheck(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList;
    putHealthcheck(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[] | cdktf.IResolvable): void;
    get healthcheckInput(): cdktf.IResolvable | LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[] | undefined;
}
export declare class LbNetworkLoadBalancerAttachedTargetGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: LbNetworkLoadBalancerAttachedTargetGroup[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): LbNetworkLoadBalancerAttachedTargetGroupOutputReference;
}
export interface LbNetworkLoadBalancerListenerExternalAddressSpec {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}
    */
    readonly address?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}
    */
    readonly ipVersion?: string;
}
export declare function lbNetworkLoadBalancerListenerExternalAddressSpecToTerraform(struct?: LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference | LbNetworkLoadBalancerListenerExternalAddressSpec): any;
export declare class LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerListenerExternalAddressSpec | undefined;
    set internalValue(value: LbNetworkLoadBalancerListenerExternalAddressSpec | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): string;
    set ipVersion(value: string);
    resetIpVersion(): void;
    get ipVersionInput(): string | undefined;
}
export interface LbNetworkLoadBalancerListenerInternalAddressSpec {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}
    */
    readonly address?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}
    */
    readonly ipVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#subnet_id LbNetworkLoadBalancer#subnet_id}
    */
    readonly subnetId: string;
}
export declare function lbNetworkLoadBalancerListenerInternalAddressSpecToTerraform(struct?: LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference | LbNetworkLoadBalancerListenerInternalAddressSpec): any;
export declare class LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerListenerInternalAddressSpec | undefined;
    set internalValue(value: LbNetworkLoadBalancerListenerInternalAddressSpec | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): string;
    set ipVersion(value: string);
    resetIpVersion(): void;
    get ipVersionInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    get subnetIdInput(): string | undefined;
}
export interface LbNetworkLoadBalancerListener {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}
    */
    readonly port: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#protocol LbNetworkLoadBalancer#protocol}
    */
    readonly protocol?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_port LbNetworkLoadBalancer#target_port}
    */
    readonly targetPort?: number;
    /**
    * external_address_spec block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#external_address_spec LbNetworkLoadBalancer#external_address_spec}
    */
    readonly externalAddressSpec?: LbNetworkLoadBalancerListenerExternalAddressSpec;
    /**
    * internal_address_spec block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#internal_address_spec LbNetworkLoadBalancer#internal_address_spec}
    */
    readonly internalAddressSpec?: LbNetworkLoadBalancerListenerInternalAddressSpec;
}
export declare function lbNetworkLoadBalancerListenerToTerraform(struct?: LbNetworkLoadBalancerListener | cdktf.IResolvable): any;
export declare class LbNetworkLoadBalancerListenerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): LbNetworkLoadBalancerListener | cdktf.IResolvable | undefined;
    set internalValue(value: LbNetworkLoadBalancerListener | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _targetPort?;
    get targetPort(): number;
    set targetPort(value: number);
    resetTargetPort(): void;
    get targetPortInput(): number | undefined;
    private _externalAddressSpec;
    get externalAddressSpec(): LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference;
    putExternalAddressSpec(value: LbNetworkLoadBalancerListenerExternalAddressSpec): void;
    resetExternalAddressSpec(): void;
    get externalAddressSpecInput(): LbNetworkLoadBalancerListenerExternalAddressSpec | undefined;
    private _internalAddressSpec;
    get internalAddressSpec(): LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference;
    putInternalAddressSpec(value: LbNetworkLoadBalancerListenerInternalAddressSpec): void;
    resetInternalAddressSpec(): void;
    get internalAddressSpecInput(): LbNetworkLoadBalancerListenerInternalAddressSpec | undefined;
}
export declare class LbNetworkLoadBalancerListenerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: LbNetworkLoadBalancerListener[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): LbNetworkLoadBalancerListenerOutputReference;
}
export interface LbNetworkLoadBalancerTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#create LbNetworkLoadBalancer#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#delete LbNetworkLoadBalancer#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#update LbNetworkLoadBalancer#update}
    */
    readonly update?: string;
}
export declare function lbNetworkLoadBalancerTimeoutsToTerraform(struct?: LbNetworkLoadBalancerTimeoutsOutputReference | LbNetworkLoadBalancerTimeouts | cdktf.IResolvable): any;
export declare class LbNetworkLoadBalancerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: LbNetworkLoadBalancerTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer yandex_lb_network_load_balancer}
*/
export declare class LbNetworkLoadBalancer extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_lb_network_load_balancer";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer yandex_lb_network_load_balancer} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbNetworkLoadBalancerConfig = {}
    */
    constructor(scope: Construct, id: string, config?: LbNetworkLoadBalancerConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _regionId?;
    get regionId(): string;
    set regionId(value: string);
    resetRegionId(): void;
    get regionIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _attachedTargetGroup;
    get attachedTargetGroup(): LbNetworkLoadBalancerAttachedTargetGroupList;
    putAttachedTargetGroup(value: LbNetworkLoadBalancerAttachedTargetGroup[] | cdktf.IResolvable): void;
    resetAttachedTargetGroup(): void;
    get attachedTargetGroupInput(): cdktf.IResolvable | LbNetworkLoadBalancerAttachedTargetGroup[] | undefined;
    private _listener;
    get listener(): LbNetworkLoadBalancerListenerList;
    putListener(value: LbNetworkLoadBalancerListener[] | cdktf.IResolvable): void;
    resetListener(): void;
    get listenerInput(): cdktf.IResolvable | LbNetworkLoadBalancerListener[] | undefined;
    private _timeouts;
    get timeouts(): LbNetworkLoadBalancerTimeoutsOutputReference;
    putTimeouts(value: LbNetworkLoadBalancerTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | LbNetworkLoadBalancerTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=lb-network-load-balancer.d.ts.map