import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbClickhouseClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#admin_password MdbClickhouseCluster#admin_password}
    */
    readonly adminPassword?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#copy_schema_on_new_hosts MdbClickhouseCluster#copy_schema_on_new_hosts}
    */
    readonly copySchemaOnNewHosts?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#deletion_protection MdbClickhouseCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#description MdbClickhouseCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#embedded_keeper MdbClickhouseCluster#embedded_keeper}
    */
    readonly embeddedKeeper?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#environment MdbClickhouseCluster#environment}
    */
    readonly environment: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#folder_id MdbClickhouseCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#id MdbClickhouseCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#labels MdbClickhouseCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#network_id MdbClickhouseCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_group_ids MdbClickhouseCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#service_account_id MdbClickhouseCluster#service_account_id}
    */
    readonly serviceAccountId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sql_database_management MdbClickhouseCluster#sql_database_management}
    */
    readonly sqlDatabaseManagement?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sql_user_management MdbClickhouseCluster#sql_user_management}
    */
    readonly sqlUserManagement?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#version MdbClickhouseCluster#version}
    */
    readonly version?: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#access MdbClickhouseCluster#access}
    */
    readonly access?: MdbClickhouseClusterAccess;
    /**
    * backup_window_start block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#backup_window_start MdbClickhouseCluster#backup_window_start}
    */
    readonly backupWindowStart?: MdbClickhouseClusterBackupWindowStart;
    /**
    * clickhouse block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#clickhouse MdbClickhouseCluster#clickhouse}
    */
    readonly clickhouse: MdbClickhouseClusterClickhouse;
    /**
    * cloud_storage block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#cloud_storage MdbClickhouseCluster#cloud_storage}
    */
    readonly cloudStorage?: MdbClickhouseClusterCloudStorage;
    /**
    * database block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#database MdbClickhouseCluster#database}
    */
    readonly database?: MdbClickhouseClusterDatabase[] | cdktf.IResolvable;
    /**
    * format_schema block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#format_schema MdbClickhouseCluster#format_schema}
    */
    readonly formatSchema?: MdbClickhouseClusterFormatSchema[] | cdktf.IResolvable;
    /**
    * host block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#host MdbClickhouseCluster#host}
    */
    readonly host: MdbClickhouseClusterHost[] | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#maintenance_window MdbClickhouseCluster#maintenance_window}
    */
    readonly maintenanceWindow?: MdbClickhouseClusterMaintenanceWindow;
    /**
    * ml_model block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#ml_model MdbClickhouseCluster#ml_model}
    */
    readonly mlModel?: MdbClickhouseClusterMlModel[] | cdktf.IResolvable;
    /**
    * shard_group block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_group MdbClickhouseCluster#shard_group}
    */
    readonly shardGroup?: MdbClickhouseClusterShardGroup[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timeouts MdbClickhouseCluster#timeouts}
    */
    readonly timeouts?: MdbClickhouseClusterTimeouts;
    /**
    * user block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#user MdbClickhouseCluster#user}
    */
    readonly user?: MdbClickhouseClusterUser[] | cdktf.IResolvable;
    /**
    * zookeeper block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#zookeeper MdbClickhouseCluster#zookeeper}
    */
    readonly zookeeper?: MdbClickhouseClusterZookeeper;
}
export interface MdbClickhouseClusterAccess {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#data_lens MdbClickhouseCluster#data_lens}
    */
    readonly dataLens?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metrika MdbClickhouseCluster#metrika}
    */
    readonly metrika?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#serverless MdbClickhouseCluster#serverless}
    */
    readonly serverless?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#web_sql MdbClickhouseCluster#web_sql}
    */
    readonly webSql?: boolean | cdktf.IResolvable;
}
export declare function mdbClickhouseClusterAccessToTerraform(struct?: MdbClickhouseClusterAccessOutputReference | MdbClickhouseClusterAccess): any;
export declare class MdbClickhouseClusterAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterAccess | undefined;
    set internalValue(value: MdbClickhouseClusterAccess | undefined);
    private _dataLens?;
    get dataLens(): boolean | cdktf.IResolvable;
    set dataLens(value: boolean | cdktf.IResolvable);
    resetDataLens(): void;
    get dataLensInput(): boolean | cdktf.IResolvable | undefined;
    private _metrika?;
    get metrika(): boolean | cdktf.IResolvable;
    set metrika(value: boolean | cdktf.IResolvable);
    resetMetrika(): void;
    get metrikaInput(): boolean | cdktf.IResolvable | undefined;
    private _serverless?;
    get serverless(): boolean | cdktf.IResolvable;
    set serverless(value: boolean | cdktf.IResolvable);
    resetServerless(): void;
    get serverlessInput(): boolean | cdktf.IResolvable | undefined;
    private _webSql?;
    get webSql(): boolean | cdktf.IResolvable;
    set webSql(value: boolean | cdktf.IResolvable);
    resetWebSql(): void;
    get webSqlInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbClickhouseClusterBackupWindowStart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#hours MdbClickhouseCluster#hours}
    */
    readonly hours?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#minutes MdbClickhouseCluster#minutes}
    */
    readonly minutes?: number;
}
export declare function mdbClickhouseClusterBackupWindowStartToTerraform(struct?: MdbClickhouseClusterBackupWindowStartOutputReference | MdbClickhouseClusterBackupWindowStart): any;
export declare class MdbClickhouseClusterBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterBackupWindowStart | undefined;
    set internalValue(value: MdbClickhouseClusterBackupWindowStart | undefined);
    private _hours?;
    get hours(): number;
    set hours(value: number);
    resetHours(): void;
    get hoursInput(): number | undefined;
    private _minutes?;
    get minutes(): number;
    set minutes(value: number);
    resetMinutes(): void;
    get minutesInput(): number | undefined;
}
export interface MdbClickhouseClusterClickhouseConfigCompression {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#method MdbClickhouseCluster#method}
    */
    readonly method: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_part_size MdbClickhouseCluster#min_part_size}
    */
    readonly minPartSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_part_size_ratio MdbClickhouseCluster#min_part_size_ratio}
    */
    readonly minPartSizeRatio: number;
}
export declare function mdbClickhouseClusterClickhouseConfigCompressionToTerraform(struct?: MdbClickhouseClusterClickhouseConfigCompression | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterClickhouseConfigCompressionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterClickhouseConfigCompression | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigCompression | cdktf.IResolvable | undefined);
    private _method?;
    get method(): string;
    set method(value: string);
    get methodInput(): string | undefined;
    private _minPartSize?;
    get minPartSize(): number;
    set minPartSize(value: number);
    get minPartSizeInput(): number | undefined;
    private _minPartSizeRatio?;
    get minPartSizeRatio(): number;
    set minPartSizeRatio(value: number);
    get minPartSizeRatioInput(): number | undefined;
}
export declare class MdbClickhouseClusterClickhouseConfigCompressionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterClickhouseConfigCompression[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterClickhouseConfigCompressionOutputReference;
}
export interface MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#age MdbClickhouseCluster#age}
    */
    readonly age: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#precision MdbClickhouseCluster#precision}
    */
    readonly precision: number;
}
export declare function mdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionToTerraform(struct?: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention | cdktf.IResolvable | undefined);
    private _age?;
    get age(): number;
    set age(value: number);
    get ageInput(): number | undefined;
    private _precision?;
    get precision(): number;
    set precision(value: number);
    get precisionInput(): number | undefined;
}
export declare class MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference;
}
export interface MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#function MdbClickhouseCluster#function}
    */
    readonly function: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#regexp MdbClickhouseCluster#regexp}
    */
    readonly regexp?: string;
    /**
    * retention block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#retention MdbClickhouseCluster#retention}
    */
    readonly retention?: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[] | cdktf.IResolvable;
}
export declare function mdbClickhouseClusterClickhouseConfigGraphiteRollupPatternToTerraform(struct?: MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern | cdktf.IResolvable | undefined);
    private _function?;
    get function(): string;
    set function(value: string);
    get functionInput(): string | undefined;
    private _regexp?;
    get regexp(): string;
    set regexp(value: string);
    resetRegexp(): void;
    get regexpInput(): string | undefined;
    private _retention;
    get retention(): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList;
    putRetention(value: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[] | cdktf.IResolvable): void;
    resetRetention(): void;
    get retentionInput(): cdktf.IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[] | undefined;
}
export declare class MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference;
}
export interface MdbClickhouseClusterClickhouseConfigGraphiteRollup {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * pattern block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#pattern MdbClickhouseCluster#pattern}
    */
    readonly pattern?: MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[] | cdktf.IResolvable;
}
export declare function mdbClickhouseClusterClickhouseConfigGraphiteRollupToTerraform(struct?: MdbClickhouseClusterClickhouseConfigGraphiteRollup | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterClickhouseConfigGraphiteRollup | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigGraphiteRollup | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _pattern;
    get pattern(): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList;
    putPattern(value: MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[] | cdktf.IResolvable): void;
    resetPattern(): void;
    get patternInput(): cdktf.IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[] | undefined;
}
export declare class MdbClickhouseClusterClickhouseConfigGraphiteRollupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterClickhouseConfigGraphiteRollup[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference;
}
export interface MdbClickhouseClusterClickhouseConfigKafka {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_mechanism MdbClickhouseCluster#sasl_mechanism}
    */
    readonly saslMechanism?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_password MdbClickhouseCluster#sasl_password}
    */
    readonly saslPassword?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_username MdbClickhouseCluster#sasl_username}
    */
    readonly saslUsername?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_protocol MdbClickhouseCluster#security_protocol}
    */
    readonly securityProtocol?: string;
}
export declare function mdbClickhouseClusterClickhouseConfigKafkaToTerraform(struct?: MdbClickhouseClusterClickhouseConfigKafkaOutputReference | MdbClickhouseClusterClickhouseConfigKafka): any;
export declare class MdbClickhouseClusterClickhouseConfigKafkaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouseConfigKafka | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigKafka | undefined);
    private _saslMechanism?;
    get saslMechanism(): string;
    set saslMechanism(value: string);
    resetSaslMechanism(): void;
    get saslMechanismInput(): string | undefined;
    private _saslPassword?;
    get saslPassword(): string;
    set saslPassword(value: string);
    resetSaslPassword(): void;
    get saslPasswordInput(): string | undefined;
    private _saslUsername?;
    get saslUsername(): string;
    set saslUsername(value: string);
    resetSaslUsername(): void;
    get saslUsernameInput(): string | undefined;
    private _securityProtocol?;
    get securityProtocol(): string;
    set securityProtocol(value: string);
    resetSecurityProtocol(): void;
    get securityProtocolInput(): string | undefined;
}
export interface MdbClickhouseClusterClickhouseConfigKafkaTopicSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_mechanism MdbClickhouseCluster#sasl_mechanism}
    */
    readonly saslMechanism?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_password MdbClickhouseCluster#sasl_password}
    */
    readonly saslPassword?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_username MdbClickhouseCluster#sasl_username}
    */
    readonly saslUsername?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_protocol MdbClickhouseCluster#security_protocol}
    */
    readonly securityProtocol?: string;
}
export declare function mdbClickhouseClusterClickhouseConfigKafkaTopicSettingsToTerraform(struct?: MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference | MdbClickhouseClusterClickhouseConfigKafkaTopicSettings): any;
export declare class MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouseConfigKafkaTopicSettings | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings | undefined);
    private _saslMechanism?;
    get saslMechanism(): string;
    set saslMechanism(value: string);
    resetSaslMechanism(): void;
    get saslMechanismInput(): string | undefined;
    private _saslPassword?;
    get saslPassword(): string;
    set saslPassword(value: string);
    resetSaslPassword(): void;
    get saslPasswordInput(): string | undefined;
    private _saslUsername?;
    get saslUsername(): string;
    set saslUsername(value: string);
    resetSaslUsername(): void;
    get saslUsernameInput(): string | undefined;
    private _securityProtocol?;
    get securityProtocol(): string;
    set securityProtocol(value: string);
    resetSecurityProtocol(): void;
    get securityProtocolInput(): string | undefined;
}
export interface MdbClickhouseClusterClickhouseConfigKafkaTopic {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#settings MdbClickhouseCluster#settings}
    */
    readonly settings?: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings;
}
export declare function mdbClickhouseClusterClickhouseConfigKafkaTopicToTerraform(struct?: MdbClickhouseClusterClickhouseConfigKafkaTopic | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterClickhouseConfigKafkaTopic | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigKafkaTopic | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _settings;
    get settings(): MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference;
    putSettings(value: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings): void;
    resetSettings(): void;
    get settingsInput(): MdbClickhouseClusterClickhouseConfigKafkaTopicSettings | undefined;
}
export declare class MdbClickhouseClusterClickhouseConfigKafkaTopicList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterClickhouseConfigKafkaTopic[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference;
}
export interface MdbClickhouseClusterClickhouseConfigMergeTree {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_merge_at_min_space_in_pool MdbClickhouseCluster#max_bytes_to_merge_at_min_space_in_pool}
    */
    readonly maxBytesToMergeAtMinSpaceInPool?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_replicated_merges_in_queue MdbClickhouseCluster#max_replicated_merges_in_queue}
    */
    readonly maxReplicatedMergesInQueue?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#number_of_free_entries_in_pool_to_lower_max_size_of_merge MdbClickhouseCluster#number_of_free_entries_in_pool_to_lower_max_size_of_merge}
    */
    readonly numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#parts_to_delay_insert MdbClickhouseCluster#parts_to_delay_insert}
    */
    readonly partsToDelayInsert?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#parts_to_throw_insert MdbClickhouseCluster#parts_to_throw_insert}
    */
    readonly partsToThrowInsert?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replicated_deduplication_window MdbClickhouseCluster#replicated_deduplication_window}
    */
    readonly replicatedDeduplicationWindow?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replicated_deduplication_window_seconds MdbClickhouseCluster#replicated_deduplication_window_seconds}
    */
    readonly replicatedDeduplicationWindowSeconds?: number;
}
export declare function mdbClickhouseClusterClickhouseConfigMergeTreeToTerraform(struct?: MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference | MdbClickhouseClusterClickhouseConfigMergeTree): any;
export declare class MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouseConfigMergeTree | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigMergeTree | undefined);
    private _maxBytesToMergeAtMinSpaceInPool?;
    get maxBytesToMergeAtMinSpaceInPool(): number;
    set maxBytesToMergeAtMinSpaceInPool(value: number);
    resetMaxBytesToMergeAtMinSpaceInPool(): void;
    get maxBytesToMergeAtMinSpaceInPoolInput(): number | undefined;
    private _maxReplicatedMergesInQueue?;
    get maxReplicatedMergesInQueue(): number;
    set maxReplicatedMergesInQueue(value: number);
    resetMaxReplicatedMergesInQueue(): void;
    get maxReplicatedMergesInQueueInput(): number | undefined;
    private _numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge?;
    get numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge(): number;
    set numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge(value: number);
    resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge(): void;
    get numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput(): number | undefined;
    private _partsToDelayInsert?;
    get partsToDelayInsert(): number;
    set partsToDelayInsert(value: number);
    resetPartsToDelayInsert(): void;
    get partsToDelayInsertInput(): number | undefined;
    private _partsToThrowInsert?;
    get partsToThrowInsert(): number;
    set partsToThrowInsert(value: number);
    resetPartsToThrowInsert(): void;
    get partsToThrowInsertInput(): number | undefined;
    private _replicatedDeduplicationWindow?;
    get replicatedDeduplicationWindow(): number;
    set replicatedDeduplicationWindow(value: number);
    resetReplicatedDeduplicationWindow(): void;
    get replicatedDeduplicationWindowInput(): number | undefined;
    private _replicatedDeduplicationWindowSeconds?;
    get replicatedDeduplicationWindowSeconds(): number;
    set replicatedDeduplicationWindowSeconds(value: number);
    resetReplicatedDeduplicationWindowSeconds(): void;
    get replicatedDeduplicationWindowSecondsInput(): number | undefined;
}
export interface MdbClickhouseClusterClickhouseConfigRabbitmq {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#password MdbClickhouseCluster#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#username MdbClickhouseCluster#username}
    */
    readonly username?: string;
}
export declare function mdbClickhouseClusterClickhouseConfigRabbitmqToTerraform(struct?: MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference | MdbClickhouseClusterClickhouseConfigRabbitmq): any;
export declare class MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouseConfigRabbitmq | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfigRabbitmq | undefined);
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
}
export interface MdbClickhouseClusterClickhouseConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#background_pool_size MdbClickhouseCluster#background_pool_size}
    */
    readonly backgroundPoolSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#background_schedule_pool_size MdbClickhouseCluster#background_schedule_pool_size}
    */
    readonly backgroundSchedulePoolSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#geobase_uri MdbClickhouseCluster#geobase_uri}
    */
    readonly geobaseUri?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#keep_alive_timeout MdbClickhouseCluster#keep_alive_timeout}
    */
    readonly keepAliveTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#log_level MdbClickhouseCluster#log_level}
    */
    readonly logLevel?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#mark_cache_size MdbClickhouseCluster#mark_cache_size}
    */
    readonly markCacheSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_concurrent_queries MdbClickhouseCluster#max_concurrent_queries}
    */
    readonly maxConcurrentQueries?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_connections MdbClickhouseCluster#max_connections}
    */
    readonly maxConnections?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_partition_size_to_drop MdbClickhouseCluster#max_partition_size_to_drop}
    */
    readonly maxPartitionSizeToDrop?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_table_size_to_drop MdbClickhouseCluster#max_table_size_to_drop}
    */
    readonly maxTableSizeToDrop?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_enabled MdbClickhouseCluster#metric_log_enabled}
    */
    readonly metricLogEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_retention_size MdbClickhouseCluster#metric_log_retention_size}
    */
    readonly metricLogRetentionSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_retention_time MdbClickhouseCluster#metric_log_retention_time}
    */
    readonly metricLogRetentionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#part_log_retention_size MdbClickhouseCluster#part_log_retention_size}
    */
    readonly partLogRetentionSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#part_log_retention_time MdbClickhouseCluster#part_log_retention_time}
    */
    readonly partLogRetentionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_log_retention_size MdbClickhouseCluster#query_log_retention_size}
    */
    readonly queryLogRetentionSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_log_retention_time MdbClickhouseCluster#query_log_retention_time}
    */
    readonly queryLogRetentionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_enabled MdbClickhouseCluster#query_thread_log_enabled}
    */
    readonly queryThreadLogEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_retention_size MdbClickhouseCluster#query_thread_log_retention_size}
    */
    readonly queryThreadLogRetentionSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_retention_time MdbClickhouseCluster#query_thread_log_retention_time}
    */
    readonly queryThreadLogRetentionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_enabled MdbClickhouseCluster#text_log_enabled}
    */
    readonly textLogEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_level MdbClickhouseCluster#text_log_level}
    */
    readonly textLogLevel?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_retention_size MdbClickhouseCluster#text_log_retention_size}
    */
    readonly textLogRetentionSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_retention_time MdbClickhouseCluster#text_log_retention_time}
    */
    readonly textLogRetentionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timezone MdbClickhouseCluster#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_enabled MdbClickhouseCluster#trace_log_enabled}
    */
    readonly traceLogEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_retention_size MdbClickhouseCluster#trace_log_retention_size}
    */
    readonly traceLogRetentionSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_retention_time MdbClickhouseCluster#trace_log_retention_time}
    */
    readonly traceLogRetentionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uncompressed_cache_size MdbClickhouseCluster#uncompressed_cache_size}
    */
    readonly uncompressedCacheSize?: number;
    /**
    * compression block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compression MdbClickhouseCluster#compression}
    */
    readonly compression?: MdbClickhouseClusterClickhouseConfigCompression[] | cdktf.IResolvable;
    /**
    * graphite_rollup block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#graphite_rollup MdbClickhouseCluster#graphite_rollup}
    */
    readonly graphiteRollup?: MdbClickhouseClusterClickhouseConfigGraphiteRollup[] | cdktf.IResolvable;
    /**
    * kafka block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#kafka MdbClickhouseCluster#kafka}
    */
    readonly kafka?: MdbClickhouseClusterClickhouseConfigKafka;
    /**
    * kafka_topic block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#kafka_topic MdbClickhouseCluster#kafka_topic}
    */
    readonly kafkaTopic?: MdbClickhouseClusterClickhouseConfigKafkaTopic[] | cdktf.IResolvable;
    /**
    * merge_tree block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree MdbClickhouseCluster#merge_tree}
    */
    readonly mergeTree?: MdbClickhouseClusterClickhouseConfigMergeTree;
    /**
    * rabbitmq block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#rabbitmq MdbClickhouseCluster#rabbitmq}
    */
    readonly rabbitmq?: MdbClickhouseClusterClickhouseConfigRabbitmq;
}
export declare function mdbClickhouseClusterClickhouseConfigToTerraform(struct?: MdbClickhouseClusterClickhouseConfigOutputReference | MdbClickhouseClusterClickhouseConfig): any;
export declare class MdbClickhouseClusterClickhouseConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouseConfig | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseConfig | undefined);
    private _backgroundPoolSize?;
    get backgroundPoolSize(): number;
    set backgroundPoolSize(value: number);
    resetBackgroundPoolSize(): void;
    get backgroundPoolSizeInput(): number | undefined;
    private _backgroundSchedulePoolSize?;
    get backgroundSchedulePoolSize(): number;
    set backgroundSchedulePoolSize(value: number);
    resetBackgroundSchedulePoolSize(): void;
    get backgroundSchedulePoolSizeInput(): number | undefined;
    private _geobaseUri?;
    get geobaseUri(): string;
    set geobaseUri(value: string);
    resetGeobaseUri(): void;
    get geobaseUriInput(): string | undefined;
    private _keepAliveTimeout?;
    get keepAliveTimeout(): number;
    set keepAliveTimeout(value: number);
    resetKeepAliveTimeout(): void;
    get keepAliveTimeoutInput(): number | undefined;
    private _logLevel?;
    get logLevel(): string;
    set logLevel(value: string);
    resetLogLevel(): void;
    get logLevelInput(): string | undefined;
    private _markCacheSize?;
    get markCacheSize(): number;
    set markCacheSize(value: number);
    resetMarkCacheSize(): void;
    get markCacheSizeInput(): number | undefined;
    private _maxConcurrentQueries?;
    get maxConcurrentQueries(): number;
    set maxConcurrentQueries(value: number);
    resetMaxConcurrentQueries(): void;
    get maxConcurrentQueriesInput(): number | undefined;
    private _maxConnections?;
    get maxConnections(): number;
    set maxConnections(value: number);
    resetMaxConnections(): void;
    get maxConnectionsInput(): number | undefined;
    private _maxPartitionSizeToDrop?;
    get maxPartitionSizeToDrop(): number;
    set maxPartitionSizeToDrop(value: number);
    resetMaxPartitionSizeToDrop(): void;
    get maxPartitionSizeToDropInput(): number | undefined;
    private _maxTableSizeToDrop?;
    get maxTableSizeToDrop(): number;
    set maxTableSizeToDrop(value: number);
    resetMaxTableSizeToDrop(): void;
    get maxTableSizeToDropInput(): number | undefined;
    private _metricLogEnabled?;
    get metricLogEnabled(): boolean | cdktf.IResolvable;
    set metricLogEnabled(value: boolean | cdktf.IResolvable);
    resetMetricLogEnabled(): void;
    get metricLogEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _metricLogRetentionSize?;
    get metricLogRetentionSize(): number;
    set metricLogRetentionSize(value: number);
    resetMetricLogRetentionSize(): void;
    get metricLogRetentionSizeInput(): number | undefined;
    private _metricLogRetentionTime?;
    get metricLogRetentionTime(): number;
    set metricLogRetentionTime(value: number);
    resetMetricLogRetentionTime(): void;
    get metricLogRetentionTimeInput(): number | undefined;
    private _partLogRetentionSize?;
    get partLogRetentionSize(): number;
    set partLogRetentionSize(value: number);
    resetPartLogRetentionSize(): void;
    get partLogRetentionSizeInput(): number | undefined;
    private _partLogRetentionTime?;
    get partLogRetentionTime(): number;
    set partLogRetentionTime(value: number);
    resetPartLogRetentionTime(): void;
    get partLogRetentionTimeInput(): number | undefined;
    private _queryLogRetentionSize?;
    get queryLogRetentionSize(): number;
    set queryLogRetentionSize(value: number);
    resetQueryLogRetentionSize(): void;
    get queryLogRetentionSizeInput(): number | undefined;
    private _queryLogRetentionTime?;
    get queryLogRetentionTime(): number;
    set queryLogRetentionTime(value: number);
    resetQueryLogRetentionTime(): void;
    get queryLogRetentionTimeInput(): number | undefined;
    private _queryThreadLogEnabled?;
    get queryThreadLogEnabled(): boolean | cdktf.IResolvable;
    set queryThreadLogEnabled(value: boolean | cdktf.IResolvable);
    resetQueryThreadLogEnabled(): void;
    get queryThreadLogEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _queryThreadLogRetentionSize?;
    get queryThreadLogRetentionSize(): number;
    set queryThreadLogRetentionSize(value: number);
    resetQueryThreadLogRetentionSize(): void;
    get queryThreadLogRetentionSizeInput(): number | undefined;
    private _queryThreadLogRetentionTime?;
    get queryThreadLogRetentionTime(): number;
    set queryThreadLogRetentionTime(value: number);
    resetQueryThreadLogRetentionTime(): void;
    get queryThreadLogRetentionTimeInput(): number | undefined;
    private _textLogEnabled?;
    get textLogEnabled(): boolean | cdktf.IResolvable;
    set textLogEnabled(value: boolean | cdktf.IResolvable);
    resetTextLogEnabled(): void;
    get textLogEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _textLogLevel?;
    get textLogLevel(): string;
    set textLogLevel(value: string);
    resetTextLogLevel(): void;
    get textLogLevelInput(): string | undefined;
    private _textLogRetentionSize?;
    get textLogRetentionSize(): number;
    set textLogRetentionSize(value: number);
    resetTextLogRetentionSize(): void;
    get textLogRetentionSizeInput(): number | undefined;
    private _textLogRetentionTime?;
    get textLogRetentionTime(): number;
    set textLogRetentionTime(value: number);
    resetTextLogRetentionTime(): void;
    get textLogRetentionTimeInput(): number | undefined;
    private _timezone?;
    get timezone(): string;
    set timezone(value: string);
    resetTimezone(): void;
    get timezoneInput(): string | undefined;
    private _traceLogEnabled?;
    get traceLogEnabled(): boolean | cdktf.IResolvable;
    set traceLogEnabled(value: boolean | cdktf.IResolvable);
    resetTraceLogEnabled(): void;
    get traceLogEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _traceLogRetentionSize?;
    get traceLogRetentionSize(): number;
    set traceLogRetentionSize(value: number);
    resetTraceLogRetentionSize(): void;
    get traceLogRetentionSizeInput(): number | undefined;
    private _traceLogRetentionTime?;
    get traceLogRetentionTime(): number;
    set traceLogRetentionTime(value: number);
    resetTraceLogRetentionTime(): void;
    get traceLogRetentionTimeInput(): number | undefined;
    private _uncompressedCacheSize?;
    get uncompressedCacheSize(): number;
    set uncompressedCacheSize(value: number);
    resetUncompressedCacheSize(): void;
    get uncompressedCacheSizeInput(): number | undefined;
    private _compression;
    get compression(): MdbClickhouseClusterClickhouseConfigCompressionList;
    putCompression(value: MdbClickhouseClusterClickhouseConfigCompression[] | cdktf.IResolvable): void;
    resetCompression(): void;
    get compressionInput(): cdktf.IResolvable | MdbClickhouseClusterClickhouseConfigCompression[] | undefined;
    private _graphiteRollup;
    get graphiteRollup(): MdbClickhouseClusterClickhouseConfigGraphiteRollupList;
    putGraphiteRollup(value: MdbClickhouseClusterClickhouseConfigGraphiteRollup[] | cdktf.IResolvable): void;
    resetGraphiteRollup(): void;
    get graphiteRollupInput(): cdktf.IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollup[] | undefined;
    private _kafka;
    get kafka(): MdbClickhouseClusterClickhouseConfigKafkaOutputReference;
    putKafka(value: MdbClickhouseClusterClickhouseConfigKafka): void;
    resetKafka(): void;
    get kafkaInput(): MdbClickhouseClusterClickhouseConfigKafka | undefined;
    private _kafkaTopic;
    get kafkaTopic(): MdbClickhouseClusterClickhouseConfigKafkaTopicList;
    putKafkaTopic(value: MdbClickhouseClusterClickhouseConfigKafkaTopic[] | cdktf.IResolvable): void;
    resetKafkaTopic(): void;
    get kafkaTopicInput(): cdktf.IResolvable | MdbClickhouseClusterClickhouseConfigKafkaTopic[] | undefined;
    private _mergeTree;
    get mergeTree(): MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference;
    putMergeTree(value: MdbClickhouseClusterClickhouseConfigMergeTree): void;
    resetMergeTree(): void;
    get mergeTreeInput(): MdbClickhouseClusterClickhouseConfigMergeTree | undefined;
    private _rabbitmq;
    get rabbitmq(): MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference;
    putRabbitmq(value: MdbClickhouseClusterClickhouseConfigRabbitmq): void;
    resetRabbitmq(): void;
    get rabbitmqInput(): MdbClickhouseClusterClickhouseConfigRabbitmq | undefined;
}
export interface MdbClickhouseClusterClickhouseResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_size MdbClickhouseCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_type_id MdbClickhouseCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resource_preset_id MdbClickhouseCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbClickhouseClusterClickhouseResourcesToTerraform(struct?: MdbClickhouseClusterClickhouseResourcesOutputReference | MdbClickhouseClusterClickhouseResources): any;
export declare class MdbClickhouseClusterClickhouseResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouseResources | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouseResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbClickhouseClusterClickhouse {
    /**
    * config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#config MdbClickhouseCluster#config}
    */
    readonly config?: MdbClickhouseClusterClickhouseConfig;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resources MdbClickhouseCluster#resources}
    */
    readonly resources: MdbClickhouseClusterClickhouseResources;
}
export declare function mdbClickhouseClusterClickhouseToTerraform(struct?: MdbClickhouseClusterClickhouseOutputReference | MdbClickhouseClusterClickhouse): any;
export declare class MdbClickhouseClusterClickhouseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterClickhouse | undefined;
    set internalValue(value: MdbClickhouseClusterClickhouse | undefined);
    private _config;
    get config(): MdbClickhouseClusterClickhouseConfigOutputReference;
    putConfig(value: MdbClickhouseClusterClickhouseConfig): void;
    resetConfig(): void;
    get configInput(): MdbClickhouseClusterClickhouseConfig | undefined;
    private _resources;
    get resources(): MdbClickhouseClusterClickhouseResourcesOutputReference;
    putResources(value: MdbClickhouseClusterClickhouseResources): void;
    get resourcesInput(): MdbClickhouseClusterClickhouseResources | undefined;
}
export interface MdbClickhouseClusterCloudStorage {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#enabled MdbClickhouseCluster#enabled}
    */
    readonly enabled: boolean | cdktf.IResolvable;
}
export declare function mdbClickhouseClusterCloudStorageToTerraform(struct?: MdbClickhouseClusterCloudStorageOutputReference | MdbClickhouseClusterCloudStorage): any;
export declare class MdbClickhouseClusterCloudStorageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterCloudStorage | undefined;
    set internalValue(value: MdbClickhouseClusterCloudStorage | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbClickhouseClusterDatabase {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
}
export declare function mdbClickhouseClusterDatabaseToTerraform(struct?: MdbClickhouseClusterDatabase | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterDatabase | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterDatabase | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export declare class MdbClickhouseClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterDatabase[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterDatabaseOutputReference;
}
export interface MdbClickhouseClusterFormatSchema {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uri MdbClickhouseCluster#uri}
    */
    readonly uri: string;
}
export declare function mdbClickhouseClusterFormatSchemaToTerraform(struct?: MdbClickhouseClusterFormatSchema | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterFormatSchemaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterFormatSchema | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterFormatSchema | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _uri?;
    get uri(): string;
    set uri(value: string);
    get uriInput(): string | undefined;
}
export declare class MdbClickhouseClusterFormatSchemaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterFormatSchema[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterFormatSchemaOutputReference;
}
export interface MdbClickhouseClusterHost {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#assign_public_ip MdbClickhouseCluster#assign_public_ip}
    */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_name MdbClickhouseCluster#shard_name}
    */
    readonly shardName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#subnet_id MdbClickhouseCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#zone MdbClickhouseCluster#zone}
    */
    readonly zone: string;
}
export declare function mdbClickhouseClusterHostToTerraform(struct?: MdbClickhouseClusterHost | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterHost | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterHost | cdktf.IResolvable | undefined);
    private _assignPublicIp?;
    get assignPublicIp(): boolean | cdktf.IResolvable;
    set assignPublicIp(value: boolean | cdktf.IResolvable);
    resetAssignPublicIp(): void;
    get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    get fqdn(): string;
    private _shardName?;
    get shardName(): string;
    set shardName(value: string);
    resetShardName(): void;
    get shardNameInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
}
export declare class MdbClickhouseClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterHost[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterHostOutputReference;
}
export interface MdbClickhouseClusterMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#day MdbClickhouseCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#hour MdbClickhouseCluster#hour}
    */
    readonly hour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}
    */
    readonly type: string;
}
export declare function mdbClickhouseClusterMaintenanceWindowToTerraform(struct?: MdbClickhouseClusterMaintenanceWindowOutputReference | MdbClickhouseClusterMaintenanceWindow): any;
export declare class MdbClickhouseClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterMaintenanceWindow | undefined;
    set internalValue(value: MdbClickhouseClusterMaintenanceWindow | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _hour?;
    get hour(): number;
    set hour(value: number);
    resetHour(): void;
    get hourInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface MdbClickhouseClusterMlModel {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uri MdbClickhouseCluster#uri}
    */
    readonly uri: string;
}
export declare function mdbClickhouseClusterMlModelToTerraform(struct?: MdbClickhouseClusterMlModel | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterMlModelOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterMlModel | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterMlModel | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _uri?;
    get uri(): string;
    set uri(value: string);
    get uriInput(): string | undefined;
}
export declare class MdbClickhouseClusterMlModelList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterMlModel[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterMlModelOutputReference;
}
export interface MdbClickhouseClusterShardGroup {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#description MdbClickhouseCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_names MdbClickhouseCluster#shard_names}
    */
    readonly shardNames: string[];
}
export declare function mdbClickhouseClusterShardGroupToTerraform(struct?: MdbClickhouseClusterShardGroup | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterShardGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterShardGroup | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterShardGroup | cdktf.IResolvable | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _shardNames?;
    get shardNames(): string[];
    set shardNames(value: string[]);
    get shardNamesInput(): string[] | undefined;
}
export declare class MdbClickhouseClusterShardGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterShardGroup[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterShardGroupOutputReference;
}
export interface MdbClickhouseClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#create MdbClickhouseCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#delete MdbClickhouseCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#update MdbClickhouseCluster#update}
    */
    readonly update?: string;
}
export declare function mdbClickhouseClusterTimeoutsToTerraform(struct?: MdbClickhouseClusterTimeoutsOutputReference | MdbClickhouseClusterTimeouts | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
export interface MdbClickhouseClusterUserPermission {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#database_name MdbClickhouseCluster#database_name}
    */
    readonly databaseName: string;
}
export declare function mdbClickhouseClusterUserPermissionToTerraform(struct?: MdbClickhouseClusterUserPermission | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterUserPermission | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterUserPermission | cdktf.IResolvable | undefined);
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    get databaseNameInput(): string | undefined;
}
export declare class MdbClickhouseClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterUserPermission[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterUserPermissionOutputReference;
}
export interface MdbClickhouseClusterUserQuota {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#errors MdbClickhouseCluster#errors}
    */
    readonly errors?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#execution_time MdbClickhouseCluster#execution_time}
    */
    readonly executionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#interval_duration MdbClickhouseCluster#interval_duration}
    */
    readonly intervalDuration: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#queries MdbClickhouseCluster#queries}
    */
    readonly queries?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#read_rows MdbClickhouseCluster#read_rows}
    */
    readonly readRows?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#result_rows MdbClickhouseCluster#result_rows}
    */
    readonly resultRows?: number;
}
export declare function mdbClickhouseClusterUserQuotaToTerraform(struct?: MdbClickhouseClusterUserQuota | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterUserQuotaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterUserQuota | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterUserQuota | cdktf.IResolvable | undefined);
    private _errors?;
    get errors(): number;
    set errors(value: number);
    resetErrors(): void;
    get errorsInput(): number | undefined;
    private _executionTime?;
    get executionTime(): number;
    set executionTime(value: number);
    resetExecutionTime(): void;
    get executionTimeInput(): number | undefined;
    private _intervalDuration?;
    get intervalDuration(): number;
    set intervalDuration(value: number);
    get intervalDurationInput(): number | undefined;
    private _queries?;
    get queries(): number;
    set queries(value: number);
    resetQueries(): void;
    get queriesInput(): number | undefined;
    private _readRows?;
    get readRows(): number;
    set readRows(value: number);
    resetReadRows(): void;
    get readRowsInput(): number | undefined;
    private _resultRows?;
    get resultRows(): number;
    set resultRows(value: number);
    resetResultRows(): void;
    get resultRowsInput(): number | undefined;
}
export declare class MdbClickhouseClusterUserQuotaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterUserQuota[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterUserQuotaOutputReference;
}
export interface MdbClickhouseClusterUserSettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#add_http_cors_header MdbClickhouseCluster#add_http_cors_header}
    */
    readonly addHttpCorsHeader?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#allow_ddl MdbClickhouseCluster#allow_ddl}
    */
    readonly allowDdl?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compile MdbClickhouseCluster#compile}
    */
    readonly compile?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compile_expressions MdbClickhouseCluster#compile_expressions}
    */
    readonly compileExpressions?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#connect_timeout MdbClickhouseCluster#connect_timeout}
    */
    readonly connectTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#count_distinct_implementation MdbClickhouseCluster#count_distinct_implementation}
    */
    readonly countDistinctImplementation?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distinct_overflow_mode MdbClickhouseCluster#distinct_overflow_mode}
    */
    readonly distinctOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_aggregation_memory_efficient MdbClickhouseCluster#distributed_aggregation_memory_efficient}
    */
    readonly distributedAggregationMemoryEfficient?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_ddl_task_timeout MdbClickhouseCluster#distributed_ddl_task_timeout}
    */
    readonly distributedDdlTaskTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_product_mode MdbClickhouseCluster#distributed_product_mode}
    */
    readonly distributedProductMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#empty_result_for_aggregation_by_empty_set MdbClickhouseCluster#empty_result_for_aggregation_by_empty_set}
    */
    readonly emptyResultForAggregationByEmptySet?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#enable_http_compression MdbClickhouseCluster#enable_http_compression}
    */
    readonly enableHttpCompression?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#fallback_to_stale_replicas_for_distributed_queries MdbClickhouseCluster#fallback_to_stale_replicas_for_distributed_queries}
    */
    readonly fallbackToStaleReplicasForDistributedQueries?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#force_index_by_date MdbClickhouseCluster#force_index_by_date}
    */
    readonly forceIndexByDate?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#force_primary_key MdbClickhouseCluster#force_primary_key}
    */
    readonly forcePrimaryKey?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_overflow_mode MdbClickhouseCluster#group_by_overflow_mode}
    */
    readonly groupByOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_two_level_threshold MdbClickhouseCluster#group_by_two_level_threshold}
    */
    readonly groupByTwoLevelThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_two_level_threshold_bytes MdbClickhouseCluster#group_by_two_level_threshold_bytes}
    */
    readonly groupByTwoLevelThresholdBytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_connection_timeout MdbClickhouseCluster#http_connection_timeout}
    */
    readonly httpConnectionTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_headers_progress_interval MdbClickhouseCluster#http_headers_progress_interval}
    */
    readonly httpHeadersProgressInterval?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_receive_timeout MdbClickhouseCluster#http_receive_timeout}
    */
    readonly httpReceiveTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_send_timeout MdbClickhouseCluster#http_send_timeout}
    */
    readonly httpSendTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#input_format_defaults_for_omitted_fields MdbClickhouseCluster#input_format_defaults_for_omitted_fields}
    */
    readonly inputFormatDefaultsForOmittedFields?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#input_format_values_interpret_expressions MdbClickhouseCluster#input_format_values_interpret_expressions}
    */
    readonly inputFormatValuesInterpretExpressions?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#insert_quorum MdbClickhouseCluster#insert_quorum}
    */
    readonly insertQuorum?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#insert_quorum_timeout MdbClickhouseCluster#insert_quorum_timeout}
    */
    readonly insertQuorumTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#join_overflow_mode MdbClickhouseCluster#join_overflow_mode}
    */
    readonly joinOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#join_use_nulls MdbClickhouseCluster#join_use_nulls}
    */
    readonly joinUseNulls?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#joined_subquery_requires_alias MdbClickhouseCluster#joined_subquery_requires_alias}
    */
    readonly joinedSubqueryRequiresAlias?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#low_cardinality_allow_in_native_format MdbClickhouseCluster#low_cardinality_allow_in_native_format}
    */
    readonly lowCardinalityAllowInNativeFormat?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_ast_depth MdbClickhouseCluster#max_ast_depth}
    */
    readonly maxAstDepth?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_ast_elements MdbClickhouseCluster#max_ast_elements}
    */
    readonly maxAstElements?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_block_size MdbClickhouseCluster#max_block_size}
    */
    readonly maxBlockSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_before_external_group_by MdbClickhouseCluster#max_bytes_before_external_group_by}
    */
    readonly maxBytesBeforeExternalGroupBy?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_before_external_sort MdbClickhouseCluster#max_bytes_before_external_sort}
    */
    readonly maxBytesBeforeExternalSort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_distinct MdbClickhouseCluster#max_bytes_in_distinct}
    */
    readonly maxBytesInDistinct?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_join MdbClickhouseCluster#max_bytes_in_join}
    */
    readonly maxBytesInJoin?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_set MdbClickhouseCluster#max_bytes_in_set}
    */
    readonly maxBytesInSet?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_read MdbClickhouseCluster#max_bytes_to_read}
    */
    readonly maxBytesToRead?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_sort MdbClickhouseCluster#max_bytes_to_sort}
    */
    readonly maxBytesToSort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_transfer MdbClickhouseCluster#max_bytes_to_transfer}
    */
    readonly maxBytesToTransfer?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_columns_to_read MdbClickhouseCluster#max_columns_to_read}
    */
    readonly maxColumnsToRead?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_execution_time MdbClickhouseCluster#max_execution_time}
    */
    readonly maxExecutionTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_expanded_ast_elements MdbClickhouseCluster#max_expanded_ast_elements}
    */
    readonly maxExpandedAstElements?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_insert_block_size MdbClickhouseCluster#max_insert_block_size}
    */
    readonly maxInsertBlockSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_memory_usage MdbClickhouseCluster#max_memory_usage}
    */
    readonly maxMemoryUsage?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_memory_usage_for_user MdbClickhouseCluster#max_memory_usage_for_user}
    */
    readonly maxMemoryUsageForUser?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_network_bandwidth MdbClickhouseCluster#max_network_bandwidth}
    */
    readonly maxNetworkBandwidth?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_network_bandwidth_for_user MdbClickhouseCluster#max_network_bandwidth_for_user}
    */
    readonly maxNetworkBandwidthForUser?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_query_size MdbClickhouseCluster#max_query_size}
    */
    readonly maxQuerySize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_replica_delay_for_distributed_queries MdbClickhouseCluster#max_replica_delay_for_distributed_queries}
    */
    readonly maxReplicaDelayForDistributedQueries?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_result_bytes MdbClickhouseCluster#max_result_bytes}
    */
    readonly maxResultBytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_result_rows MdbClickhouseCluster#max_result_rows}
    */
    readonly maxResultRows?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_distinct MdbClickhouseCluster#max_rows_in_distinct}
    */
    readonly maxRowsInDistinct?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_join MdbClickhouseCluster#max_rows_in_join}
    */
    readonly maxRowsInJoin?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_set MdbClickhouseCluster#max_rows_in_set}
    */
    readonly maxRowsInSet?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_group_by MdbClickhouseCluster#max_rows_to_group_by}
    */
    readonly maxRowsToGroupBy?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_read MdbClickhouseCluster#max_rows_to_read}
    */
    readonly maxRowsToRead?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_sort MdbClickhouseCluster#max_rows_to_sort}
    */
    readonly maxRowsToSort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_transfer MdbClickhouseCluster#max_rows_to_transfer}
    */
    readonly maxRowsToTransfer?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_temporary_columns MdbClickhouseCluster#max_temporary_columns}
    */
    readonly maxTemporaryColumns?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_temporary_non_const_columns MdbClickhouseCluster#max_temporary_non_const_columns}
    */
    readonly maxTemporaryNonConstColumns?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_threads MdbClickhouseCluster#max_threads}
    */
    readonly maxThreads?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_max_bytes_to_use_cache MdbClickhouseCluster#merge_tree_max_bytes_to_use_cache}
    */
    readonly mergeTreeMaxBytesToUseCache?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_max_rows_to_use_cache MdbClickhouseCluster#merge_tree_max_rows_to_use_cache}
    */
    readonly mergeTreeMaxRowsToUseCache?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_min_bytes_for_concurrent_read MdbClickhouseCluster#merge_tree_min_bytes_for_concurrent_read}
    */
    readonly mergeTreeMinBytesForConcurrentRead?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_min_rows_for_concurrent_read MdbClickhouseCluster#merge_tree_min_rows_for_concurrent_read}
    */
    readonly mergeTreeMinRowsForConcurrentRead?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_bytes_to_use_direct_io MdbClickhouseCluster#min_bytes_to_use_direct_io}
    */
    readonly minBytesToUseDirectIo?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_count_to_compile MdbClickhouseCluster#min_count_to_compile}
    */
    readonly minCountToCompile?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_count_to_compile_expression MdbClickhouseCluster#min_count_to_compile_expression}
    */
    readonly minCountToCompileExpression?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_execution_speed MdbClickhouseCluster#min_execution_speed}
    */
    readonly minExecutionSpeed?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_execution_speed_bytes MdbClickhouseCluster#min_execution_speed_bytes}
    */
    readonly minExecutionSpeedBytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_insert_block_size_bytes MdbClickhouseCluster#min_insert_block_size_bytes}
    */
    readonly minInsertBlockSizeBytes?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_insert_block_size_rows MdbClickhouseCluster#min_insert_block_size_rows}
    */
    readonly minInsertBlockSizeRows?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#output_format_json_quote_64bit_integers MdbClickhouseCluster#output_format_json_quote_64bit_integers}
    */
    readonly outputFormatJsonQuote64BitIntegers?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#output_format_json_quote_denormals MdbClickhouseCluster#output_format_json_quote_denormals}
    */
    readonly outputFormatJsonQuoteDenormals?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#priority MdbClickhouseCluster#priority}
    */
    readonly priority?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#quota_mode MdbClickhouseCluster#quota_mode}
    */
    readonly quotaMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#read_overflow_mode MdbClickhouseCluster#read_overflow_mode}
    */
    readonly readOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#readonly MdbClickhouseCluster#readonly}
    */
    readonly readonly?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#receive_timeout MdbClickhouseCluster#receive_timeout}
    */
    readonly receiveTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replication_alter_partitions_sync MdbClickhouseCluster#replication_alter_partitions_sync}
    */
    readonly replicationAlterPartitionsSync?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#result_overflow_mode MdbClickhouseCluster#result_overflow_mode}
    */
    readonly resultOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#select_sequential_consistency MdbClickhouseCluster#select_sequential_consistency}
    */
    readonly selectSequentialConsistency?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#send_progress_in_http_headers MdbClickhouseCluster#send_progress_in_http_headers}
    */
    readonly sendProgressInHttpHeaders?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#send_timeout MdbClickhouseCluster#send_timeout}
    */
    readonly sendTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#set_overflow_mode MdbClickhouseCluster#set_overflow_mode}
    */
    readonly setOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#skip_unavailable_shards MdbClickhouseCluster#skip_unavailable_shards}
    */
    readonly skipUnavailableShards?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sort_overflow_mode MdbClickhouseCluster#sort_overflow_mode}
    */
    readonly sortOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timeout_overflow_mode MdbClickhouseCluster#timeout_overflow_mode}
    */
    readonly timeoutOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#transfer_overflow_mode MdbClickhouseCluster#transfer_overflow_mode}
    */
    readonly transferOverflowMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#transform_null_in MdbClickhouseCluster#transform_null_in}
    */
    readonly transformNullIn?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#use_uncompressed_cache MdbClickhouseCluster#use_uncompressed_cache}
    */
    readonly useUncompressedCache?: boolean | cdktf.IResolvable;
}
export declare function mdbClickhouseClusterUserSettingsToTerraform(struct?: MdbClickhouseClusterUserSettingsOutputReference | MdbClickhouseClusterUserSettings): any;
export declare class MdbClickhouseClusterUserSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterUserSettings | undefined;
    set internalValue(value: MdbClickhouseClusterUserSettings | undefined);
    private _addHttpCorsHeader?;
    get addHttpCorsHeader(): boolean | cdktf.IResolvable;
    set addHttpCorsHeader(value: boolean | cdktf.IResolvable);
    resetAddHttpCorsHeader(): void;
    get addHttpCorsHeaderInput(): boolean | cdktf.IResolvable | undefined;
    private _allowDdl?;
    get allowDdl(): boolean | cdktf.IResolvable;
    set allowDdl(value: boolean | cdktf.IResolvable);
    resetAllowDdl(): void;
    get allowDdlInput(): boolean | cdktf.IResolvable | undefined;
    private _compile?;
    get compile(): boolean | cdktf.IResolvable;
    set compile(value: boolean | cdktf.IResolvable);
    resetCompile(): void;
    get compileInput(): boolean | cdktf.IResolvable | undefined;
    private _compileExpressions?;
    get compileExpressions(): boolean | cdktf.IResolvable;
    set compileExpressions(value: boolean | cdktf.IResolvable);
    resetCompileExpressions(): void;
    get compileExpressionsInput(): boolean | cdktf.IResolvable | undefined;
    private _connectTimeout?;
    get connectTimeout(): number;
    set connectTimeout(value: number);
    resetConnectTimeout(): void;
    get connectTimeoutInput(): number | undefined;
    private _countDistinctImplementation?;
    get countDistinctImplementation(): string;
    set countDistinctImplementation(value: string);
    resetCountDistinctImplementation(): void;
    get countDistinctImplementationInput(): string | undefined;
    private _distinctOverflowMode?;
    get distinctOverflowMode(): string;
    set distinctOverflowMode(value: string);
    resetDistinctOverflowMode(): void;
    get distinctOverflowModeInput(): string | undefined;
    private _distributedAggregationMemoryEfficient?;
    get distributedAggregationMemoryEfficient(): boolean | cdktf.IResolvable;
    set distributedAggregationMemoryEfficient(value: boolean | cdktf.IResolvable);
    resetDistributedAggregationMemoryEfficient(): void;
    get distributedAggregationMemoryEfficientInput(): boolean | cdktf.IResolvable | undefined;
    private _distributedDdlTaskTimeout?;
    get distributedDdlTaskTimeout(): number;
    set distributedDdlTaskTimeout(value: number);
    resetDistributedDdlTaskTimeout(): void;
    get distributedDdlTaskTimeoutInput(): number | undefined;
    private _distributedProductMode?;
    get distributedProductMode(): string;
    set distributedProductMode(value: string);
    resetDistributedProductMode(): void;
    get distributedProductModeInput(): string | undefined;
    private _emptyResultForAggregationByEmptySet?;
    get emptyResultForAggregationByEmptySet(): boolean | cdktf.IResolvable;
    set emptyResultForAggregationByEmptySet(value: boolean | cdktf.IResolvable);
    resetEmptyResultForAggregationByEmptySet(): void;
    get emptyResultForAggregationByEmptySetInput(): boolean | cdktf.IResolvable | undefined;
    private _enableHttpCompression?;
    get enableHttpCompression(): boolean | cdktf.IResolvable;
    set enableHttpCompression(value: boolean | cdktf.IResolvable);
    resetEnableHttpCompression(): void;
    get enableHttpCompressionInput(): boolean | cdktf.IResolvable | undefined;
    private _fallbackToStaleReplicasForDistributedQueries?;
    get fallbackToStaleReplicasForDistributedQueries(): boolean | cdktf.IResolvable;
    set fallbackToStaleReplicasForDistributedQueries(value: boolean | cdktf.IResolvable);
    resetFallbackToStaleReplicasForDistributedQueries(): void;
    get fallbackToStaleReplicasForDistributedQueriesInput(): boolean | cdktf.IResolvable | undefined;
    private _forceIndexByDate?;
    get forceIndexByDate(): boolean | cdktf.IResolvable;
    set forceIndexByDate(value: boolean | cdktf.IResolvable);
    resetForceIndexByDate(): void;
    get forceIndexByDateInput(): boolean | cdktf.IResolvable | undefined;
    private _forcePrimaryKey?;
    get forcePrimaryKey(): boolean | cdktf.IResolvable;
    set forcePrimaryKey(value: boolean | cdktf.IResolvable);
    resetForcePrimaryKey(): void;
    get forcePrimaryKeyInput(): boolean | cdktf.IResolvable | undefined;
    private _groupByOverflowMode?;
    get groupByOverflowMode(): string;
    set groupByOverflowMode(value: string);
    resetGroupByOverflowMode(): void;
    get groupByOverflowModeInput(): string | undefined;
    private _groupByTwoLevelThreshold?;
    get groupByTwoLevelThreshold(): number;
    set groupByTwoLevelThreshold(value: number);
    resetGroupByTwoLevelThreshold(): void;
    get groupByTwoLevelThresholdInput(): number | undefined;
    private _groupByTwoLevelThresholdBytes?;
    get groupByTwoLevelThresholdBytes(): number;
    set groupByTwoLevelThresholdBytes(value: number);
    resetGroupByTwoLevelThresholdBytes(): void;
    get groupByTwoLevelThresholdBytesInput(): number | undefined;
    private _httpConnectionTimeout?;
    get httpConnectionTimeout(): number;
    set httpConnectionTimeout(value: number);
    resetHttpConnectionTimeout(): void;
    get httpConnectionTimeoutInput(): number | undefined;
    private _httpHeadersProgressInterval?;
    get httpHeadersProgressInterval(): number;
    set httpHeadersProgressInterval(value: number);
    resetHttpHeadersProgressInterval(): void;
    get httpHeadersProgressIntervalInput(): number | undefined;
    private _httpReceiveTimeout?;
    get httpReceiveTimeout(): number;
    set httpReceiveTimeout(value: number);
    resetHttpReceiveTimeout(): void;
    get httpReceiveTimeoutInput(): number | undefined;
    private _httpSendTimeout?;
    get httpSendTimeout(): number;
    set httpSendTimeout(value: number);
    resetHttpSendTimeout(): void;
    get httpSendTimeoutInput(): number | undefined;
    private _inputFormatDefaultsForOmittedFields?;
    get inputFormatDefaultsForOmittedFields(): boolean | cdktf.IResolvable;
    set inputFormatDefaultsForOmittedFields(value: boolean | cdktf.IResolvable);
    resetInputFormatDefaultsForOmittedFields(): void;
    get inputFormatDefaultsForOmittedFieldsInput(): boolean | cdktf.IResolvable | undefined;
    private _inputFormatValuesInterpretExpressions?;
    get inputFormatValuesInterpretExpressions(): boolean | cdktf.IResolvable;
    set inputFormatValuesInterpretExpressions(value: boolean | cdktf.IResolvable);
    resetInputFormatValuesInterpretExpressions(): void;
    get inputFormatValuesInterpretExpressionsInput(): boolean | cdktf.IResolvable | undefined;
    private _insertQuorum?;
    get insertQuorum(): number;
    set insertQuorum(value: number);
    resetInsertQuorum(): void;
    get insertQuorumInput(): number | undefined;
    private _insertQuorumTimeout?;
    get insertQuorumTimeout(): number;
    set insertQuorumTimeout(value: number);
    resetInsertQuorumTimeout(): void;
    get insertQuorumTimeoutInput(): number | undefined;
    private _joinOverflowMode?;
    get joinOverflowMode(): string;
    set joinOverflowMode(value: string);
    resetJoinOverflowMode(): void;
    get joinOverflowModeInput(): string | undefined;
    private _joinUseNulls?;
    get joinUseNulls(): boolean | cdktf.IResolvable;
    set joinUseNulls(value: boolean | cdktf.IResolvable);
    resetJoinUseNulls(): void;
    get joinUseNullsInput(): boolean | cdktf.IResolvable | undefined;
    private _joinedSubqueryRequiresAlias?;
    get joinedSubqueryRequiresAlias(): boolean | cdktf.IResolvable;
    set joinedSubqueryRequiresAlias(value: boolean | cdktf.IResolvable);
    resetJoinedSubqueryRequiresAlias(): void;
    get joinedSubqueryRequiresAliasInput(): boolean | cdktf.IResolvable | undefined;
    private _lowCardinalityAllowInNativeFormat?;
    get lowCardinalityAllowInNativeFormat(): boolean | cdktf.IResolvable;
    set lowCardinalityAllowInNativeFormat(value: boolean | cdktf.IResolvable);
    resetLowCardinalityAllowInNativeFormat(): void;
    get lowCardinalityAllowInNativeFormatInput(): boolean | cdktf.IResolvable | undefined;
    private _maxAstDepth?;
    get maxAstDepth(): number;
    set maxAstDepth(value: number);
    resetMaxAstDepth(): void;
    get maxAstDepthInput(): number | undefined;
    private _maxAstElements?;
    get maxAstElements(): number;
    set maxAstElements(value: number);
    resetMaxAstElements(): void;
    get maxAstElementsInput(): number | undefined;
    private _maxBlockSize?;
    get maxBlockSize(): number;
    set maxBlockSize(value: number);
    resetMaxBlockSize(): void;
    get maxBlockSizeInput(): number | undefined;
    private _maxBytesBeforeExternalGroupBy?;
    get maxBytesBeforeExternalGroupBy(): number;
    set maxBytesBeforeExternalGroupBy(value: number);
    resetMaxBytesBeforeExternalGroupBy(): void;
    get maxBytesBeforeExternalGroupByInput(): number | undefined;
    private _maxBytesBeforeExternalSort?;
    get maxBytesBeforeExternalSort(): number;
    set maxBytesBeforeExternalSort(value: number);
    resetMaxBytesBeforeExternalSort(): void;
    get maxBytesBeforeExternalSortInput(): number | undefined;
    private _maxBytesInDistinct?;
    get maxBytesInDistinct(): number;
    set maxBytesInDistinct(value: number);
    resetMaxBytesInDistinct(): void;
    get maxBytesInDistinctInput(): number | undefined;
    private _maxBytesInJoin?;
    get maxBytesInJoin(): number;
    set maxBytesInJoin(value: number);
    resetMaxBytesInJoin(): void;
    get maxBytesInJoinInput(): number | undefined;
    private _maxBytesInSet?;
    get maxBytesInSet(): number;
    set maxBytesInSet(value: number);
    resetMaxBytesInSet(): void;
    get maxBytesInSetInput(): number | undefined;
    private _maxBytesToRead?;
    get maxBytesToRead(): number;
    set maxBytesToRead(value: number);
    resetMaxBytesToRead(): void;
    get maxBytesToReadInput(): number | undefined;
    private _maxBytesToSort?;
    get maxBytesToSort(): number;
    set maxBytesToSort(value: number);
    resetMaxBytesToSort(): void;
    get maxBytesToSortInput(): number | undefined;
    private _maxBytesToTransfer?;
    get maxBytesToTransfer(): number;
    set maxBytesToTransfer(value: number);
    resetMaxBytesToTransfer(): void;
    get maxBytesToTransferInput(): number | undefined;
    private _maxColumnsToRead?;
    get maxColumnsToRead(): number;
    set maxColumnsToRead(value: number);
    resetMaxColumnsToRead(): void;
    get maxColumnsToReadInput(): number | undefined;
    private _maxExecutionTime?;
    get maxExecutionTime(): number;
    set maxExecutionTime(value: number);
    resetMaxExecutionTime(): void;
    get maxExecutionTimeInput(): number | undefined;
    private _maxExpandedAstElements?;
    get maxExpandedAstElements(): number;
    set maxExpandedAstElements(value: number);
    resetMaxExpandedAstElements(): void;
    get maxExpandedAstElementsInput(): number | undefined;
    private _maxInsertBlockSize?;
    get maxInsertBlockSize(): number;
    set maxInsertBlockSize(value: number);
    resetMaxInsertBlockSize(): void;
    get maxInsertBlockSizeInput(): number | undefined;
    private _maxMemoryUsage?;
    get maxMemoryUsage(): number;
    set maxMemoryUsage(value: number);
    resetMaxMemoryUsage(): void;
    get maxMemoryUsageInput(): number | undefined;
    private _maxMemoryUsageForUser?;
    get maxMemoryUsageForUser(): number;
    set maxMemoryUsageForUser(value: number);
    resetMaxMemoryUsageForUser(): void;
    get maxMemoryUsageForUserInput(): number | undefined;
    private _maxNetworkBandwidth?;
    get maxNetworkBandwidth(): number;
    set maxNetworkBandwidth(value: number);
    resetMaxNetworkBandwidth(): void;
    get maxNetworkBandwidthInput(): number | undefined;
    private _maxNetworkBandwidthForUser?;
    get maxNetworkBandwidthForUser(): number;
    set maxNetworkBandwidthForUser(value: number);
    resetMaxNetworkBandwidthForUser(): void;
    get maxNetworkBandwidthForUserInput(): number | undefined;
    private _maxQuerySize?;
    get maxQuerySize(): number;
    set maxQuerySize(value: number);
    resetMaxQuerySize(): void;
    get maxQuerySizeInput(): number | undefined;
    private _maxReplicaDelayForDistributedQueries?;
    get maxReplicaDelayForDistributedQueries(): number;
    set maxReplicaDelayForDistributedQueries(value: number);
    resetMaxReplicaDelayForDistributedQueries(): void;
    get maxReplicaDelayForDistributedQueriesInput(): number | undefined;
    private _maxResultBytes?;
    get maxResultBytes(): number;
    set maxResultBytes(value: number);
    resetMaxResultBytes(): void;
    get maxResultBytesInput(): number | undefined;
    private _maxResultRows?;
    get maxResultRows(): number;
    set maxResultRows(value: number);
    resetMaxResultRows(): void;
    get maxResultRowsInput(): number | undefined;
    private _maxRowsInDistinct?;
    get maxRowsInDistinct(): number;
    set maxRowsInDistinct(value: number);
    resetMaxRowsInDistinct(): void;
    get maxRowsInDistinctInput(): number | undefined;
    private _maxRowsInJoin?;
    get maxRowsInJoin(): number;
    set maxRowsInJoin(value: number);
    resetMaxRowsInJoin(): void;
    get maxRowsInJoinInput(): number | undefined;
    private _maxRowsInSet?;
    get maxRowsInSet(): number;
    set maxRowsInSet(value: number);
    resetMaxRowsInSet(): void;
    get maxRowsInSetInput(): number | undefined;
    private _maxRowsToGroupBy?;
    get maxRowsToGroupBy(): number;
    set maxRowsToGroupBy(value: number);
    resetMaxRowsToGroupBy(): void;
    get maxRowsToGroupByInput(): number | undefined;
    private _maxRowsToRead?;
    get maxRowsToRead(): number;
    set maxRowsToRead(value: number);
    resetMaxRowsToRead(): void;
    get maxRowsToReadInput(): number | undefined;
    private _maxRowsToSort?;
    get maxRowsToSort(): number;
    set maxRowsToSort(value: number);
    resetMaxRowsToSort(): void;
    get maxRowsToSortInput(): number | undefined;
    private _maxRowsToTransfer?;
    get maxRowsToTransfer(): number;
    set maxRowsToTransfer(value: number);
    resetMaxRowsToTransfer(): void;
    get maxRowsToTransferInput(): number | undefined;
    private _maxTemporaryColumns?;
    get maxTemporaryColumns(): number;
    set maxTemporaryColumns(value: number);
    resetMaxTemporaryColumns(): void;
    get maxTemporaryColumnsInput(): number | undefined;
    private _maxTemporaryNonConstColumns?;
    get maxTemporaryNonConstColumns(): number;
    set maxTemporaryNonConstColumns(value: number);
    resetMaxTemporaryNonConstColumns(): void;
    get maxTemporaryNonConstColumnsInput(): number | undefined;
    private _maxThreads?;
    get maxThreads(): number;
    set maxThreads(value: number);
    resetMaxThreads(): void;
    get maxThreadsInput(): number | undefined;
    private _mergeTreeMaxBytesToUseCache?;
    get mergeTreeMaxBytesToUseCache(): number;
    set mergeTreeMaxBytesToUseCache(value: number);
    resetMergeTreeMaxBytesToUseCache(): void;
    get mergeTreeMaxBytesToUseCacheInput(): number | undefined;
    private _mergeTreeMaxRowsToUseCache?;
    get mergeTreeMaxRowsToUseCache(): number;
    set mergeTreeMaxRowsToUseCache(value: number);
    resetMergeTreeMaxRowsToUseCache(): void;
    get mergeTreeMaxRowsToUseCacheInput(): number | undefined;
    private _mergeTreeMinBytesForConcurrentRead?;
    get mergeTreeMinBytesForConcurrentRead(): number;
    set mergeTreeMinBytesForConcurrentRead(value: number);
    resetMergeTreeMinBytesForConcurrentRead(): void;
    get mergeTreeMinBytesForConcurrentReadInput(): number | undefined;
    private _mergeTreeMinRowsForConcurrentRead?;
    get mergeTreeMinRowsForConcurrentRead(): number;
    set mergeTreeMinRowsForConcurrentRead(value: number);
    resetMergeTreeMinRowsForConcurrentRead(): void;
    get mergeTreeMinRowsForConcurrentReadInput(): number | undefined;
    private _minBytesToUseDirectIo?;
    get minBytesToUseDirectIo(): number;
    set minBytesToUseDirectIo(value: number);
    resetMinBytesToUseDirectIo(): void;
    get minBytesToUseDirectIoInput(): number | undefined;
    private _minCountToCompile?;
    get minCountToCompile(): number;
    set minCountToCompile(value: number);
    resetMinCountToCompile(): void;
    get minCountToCompileInput(): number | undefined;
    private _minCountToCompileExpression?;
    get minCountToCompileExpression(): number;
    set minCountToCompileExpression(value: number);
    resetMinCountToCompileExpression(): void;
    get minCountToCompileExpressionInput(): number | undefined;
    private _minExecutionSpeed?;
    get minExecutionSpeed(): number;
    set minExecutionSpeed(value: number);
    resetMinExecutionSpeed(): void;
    get minExecutionSpeedInput(): number | undefined;
    private _minExecutionSpeedBytes?;
    get minExecutionSpeedBytes(): number;
    set minExecutionSpeedBytes(value: number);
    resetMinExecutionSpeedBytes(): void;
    get minExecutionSpeedBytesInput(): number | undefined;
    private _minInsertBlockSizeBytes?;
    get minInsertBlockSizeBytes(): number;
    set minInsertBlockSizeBytes(value: number);
    resetMinInsertBlockSizeBytes(): void;
    get minInsertBlockSizeBytesInput(): number | undefined;
    private _minInsertBlockSizeRows?;
    get minInsertBlockSizeRows(): number;
    set minInsertBlockSizeRows(value: number);
    resetMinInsertBlockSizeRows(): void;
    get minInsertBlockSizeRowsInput(): number | undefined;
    private _outputFormatJsonQuote64BitIntegers?;
    get outputFormatJsonQuote64BitIntegers(): boolean | cdktf.IResolvable;
    set outputFormatJsonQuote64BitIntegers(value: boolean | cdktf.IResolvable);
    resetOutputFormatJsonQuote64BitIntegers(): void;
    get outputFormatJsonQuote64BitIntegersInput(): boolean | cdktf.IResolvable | undefined;
    private _outputFormatJsonQuoteDenormals?;
    get outputFormatJsonQuoteDenormals(): boolean | cdktf.IResolvable;
    set outputFormatJsonQuoteDenormals(value: boolean | cdktf.IResolvable);
    resetOutputFormatJsonQuoteDenormals(): void;
    get outputFormatJsonQuoteDenormalsInput(): boolean | cdktf.IResolvable | undefined;
    private _priority?;
    get priority(): number;
    set priority(value: number);
    resetPriority(): void;
    get priorityInput(): number | undefined;
    private _quotaMode?;
    get quotaMode(): string;
    set quotaMode(value: string);
    resetQuotaMode(): void;
    get quotaModeInput(): string | undefined;
    private _readOverflowMode?;
    get readOverflowMode(): string;
    set readOverflowMode(value: string);
    resetReadOverflowMode(): void;
    get readOverflowModeInput(): string | undefined;
    private _readonly?;
    get readonly(): number;
    set readonly(value: number);
    resetReadonly(): void;
    get readonlyInput(): number | undefined;
    private _receiveTimeout?;
    get receiveTimeout(): number;
    set receiveTimeout(value: number);
    resetReceiveTimeout(): void;
    get receiveTimeoutInput(): number | undefined;
    private _replicationAlterPartitionsSync?;
    get replicationAlterPartitionsSync(): number;
    set replicationAlterPartitionsSync(value: number);
    resetReplicationAlterPartitionsSync(): void;
    get replicationAlterPartitionsSyncInput(): number | undefined;
    private _resultOverflowMode?;
    get resultOverflowMode(): string;
    set resultOverflowMode(value: string);
    resetResultOverflowMode(): void;
    get resultOverflowModeInput(): string | undefined;
    private _selectSequentialConsistency?;
    get selectSequentialConsistency(): boolean | cdktf.IResolvable;
    set selectSequentialConsistency(value: boolean | cdktf.IResolvable);
    resetSelectSequentialConsistency(): void;
    get selectSequentialConsistencyInput(): boolean | cdktf.IResolvable | undefined;
    private _sendProgressInHttpHeaders?;
    get sendProgressInHttpHeaders(): boolean | cdktf.IResolvable;
    set sendProgressInHttpHeaders(value: boolean | cdktf.IResolvable);
    resetSendProgressInHttpHeaders(): void;
    get sendProgressInHttpHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _sendTimeout?;
    get sendTimeout(): number;
    set sendTimeout(value: number);
    resetSendTimeout(): void;
    get sendTimeoutInput(): number | undefined;
    private _setOverflowMode?;
    get setOverflowMode(): string;
    set setOverflowMode(value: string);
    resetSetOverflowMode(): void;
    get setOverflowModeInput(): string | undefined;
    private _skipUnavailableShards?;
    get skipUnavailableShards(): boolean | cdktf.IResolvable;
    set skipUnavailableShards(value: boolean | cdktf.IResolvable);
    resetSkipUnavailableShards(): void;
    get skipUnavailableShardsInput(): boolean | cdktf.IResolvable | undefined;
    private _sortOverflowMode?;
    get sortOverflowMode(): string;
    set sortOverflowMode(value: string);
    resetSortOverflowMode(): void;
    get sortOverflowModeInput(): string | undefined;
    private _timeoutOverflowMode?;
    get timeoutOverflowMode(): string;
    set timeoutOverflowMode(value: string);
    resetTimeoutOverflowMode(): void;
    get timeoutOverflowModeInput(): string | undefined;
    private _transferOverflowMode?;
    get transferOverflowMode(): string;
    set transferOverflowMode(value: string);
    resetTransferOverflowMode(): void;
    get transferOverflowModeInput(): string | undefined;
    private _transformNullIn?;
    get transformNullIn(): boolean | cdktf.IResolvable;
    set transformNullIn(value: boolean | cdktf.IResolvable);
    resetTransformNullIn(): void;
    get transformNullInInput(): boolean | cdktf.IResolvable | undefined;
    private _useUncompressedCache?;
    get useUncompressedCache(): boolean | cdktf.IResolvable;
    set useUncompressedCache(value: boolean | cdktf.IResolvable);
    resetUseUncompressedCache(): void;
    get useUncompressedCacheInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbClickhouseClusterUser {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#password MdbClickhouseCluster#password}
    */
    readonly password: string;
    /**
    * permission block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#permission MdbClickhouseCluster#permission}
    */
    readonly permission?: MdbClickhouseClusterUserPermission[] | cdktf.IResolvable;
    /**
    * quota block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#quota MdbClickhouseCluster#quota}
    */
    readonly quota?: MdbClickhouseClusterUserQuota[] | cdktf.IResolvable;
    /**
    * settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#settings MdbClickhouseCluster#settings}
    */
    readonly settings?: MdbClickhouseClusterUserSettings;
}
export declare function mdbClickhouseClusterUserToTerraform(struct?: MdbClickhouseClusterUser | cdktf.IResolvable): any;
export declare class MdbClickhouseClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbClickhouseClusterUser | cdktf.IResolvable | undefined;
    set internalValue(value: MdbClickhouseClusterUser | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    get passwordInput(): string | undefined;
    private _permission;
    get permission(): MdbClickhouseClusterUserPermissionList;
    putPermission(value: MdbClickhouseClusterUserPermission[] | cdktf.IResolvable): void;
    resetPermission(): void;
    get permissionInput(): cdktf.IResolvable | MdbClickhouseClusterUserPermission[] | undefined;
    private _quota;
    get quota(): MdbClickhouseClusterUserQuotaList;
    putQuota(value: MdbClickhouseClusterUserQuota[] | cdktf.IResolvable): void;
    resetQuota(): void;
    get quotaInput(): cdktf.IResolvable | MdbClickhouseClusterUserQuota[] | undefined;
    private _settings;
    get settings(): MdbClickhouseClusterUserSettingsOutputReference;
    putSettings(value: MdbClickhouseClusterUserSettings): void;
    resetSettings(): void;
    get settingsInput(): MdbClickhouseClusterUserSettings | undefined;
}
export declare class MdbClickhouseClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbClickhouseClusterUser[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbClickhouseClusterUserOutputReference;
}
export interface MdbClickhouseClusterZookeeperResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_size MdbClickhouseCluster#disk_size}
    */
    readonly diskSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_type_id MdbClickhouseCluster#disk_type_id}
    */
    readonly diskTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resource_preset_id MdbClickhouseCluster#resource_preset_id}
    */
    readonly resourcePresetId?: string;
}
export declare function mdbClickhouseClusterZookeeperResourcesToTerraform(struct?: MdbClickhouseClusterZookeeperResourcesOutputReference | MdbClickhouseClusterZookeeperResources): any;
export declare class MdbClickhouseClusterZookeeperResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterZookeeperResources | undefined;
    set internalValue(value: MdbClickhouseClusterZookeeperResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    resetDiskSize(): void;
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    resetDiskTypeId(): void;
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    resetResourcePresetId(): void;
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbClickhouseClusterZookeeper {
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resources MdbClickhouseCluster#resources}
    */
    readonly resources?: MdbClickhouseClusterZookeeperResources;
}
export declare function mdbClickhouseClusterZookeeperToTerraform(struct?: MdbClickhouseClusterZookeeperOutputReference | MdbClickhouseClusterZookeeper): any;
export declare class MdbClickhouseClusterZookeeperOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbClickhouseClusterZookeeper | undefined;
    set internalValue(value: MdbClickhouseClusterZookeeper | undefined);
    private _resources;
    get resources(): MdbClickhouseClusterZookeeperResourcesOutputReference;
    putResources(value: MdbClickhouseClusterZookeeperResources): void;
    resetResources(): void;
    get resourcesInput(): MdbClickhouseClusterZookeeperResources | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster yandex_mdb_clickhouse_cluster}
*/
export declare class MdbClickhouseCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_clickhouse_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster yandex_mdb_clickhouse_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbClickhouseClusterConfig
    */
    constructor(scope: Construct, id: string, config: MdbClickhouseClusterConfig);
    private _adminPassword?;
    get adminPassword(): string;
    set adminPassword(value: string);
    resetAdminPassword(): void;
    get adminPasswordInput(): string | undefined;
    private _copySchemaOnNewHosts?;
    get copySchemaOnNewHosts(): boolean | cdktf.IResolvable;
    set copySchemaOnNewHosts(value: boolean | cdktf.IResolvable);
    resetCopySchemaOnNewHosts(): void;
    get copySchemaOnNewHostsInput(): boolean | cdktf.IResolvable | undefined;
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _embeddedKeeper?;
    get embeddedKeeper(): boolean | cdktf.IResolvable;
    set embeddedKeeper(value: boolean | cdktf.IResolvable);
    resetEmbeddedKeeper(): void;
    get embeddedKeeperInput(): boolean | cdktf.IResolvable | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    resetServiceAccountId(): void;
    get serviceAccountIdInput(): string | undefined;
    private _sqlDatabaseManagement?;
    get sqlDatabaseManagement(): boolean | cdktf.IResolvable;
    set sqlDatabaseManagement(value: boolean | cdktf.IResolvable);
    resetSqlDatabaseManagement(): void;
    get sqlDatabaseManagementInput(): boolean | cdktf.IResolvable | undefined;
    private _sqlUserManagement?;
    get sqlUserManagement(): boolean | cdktf.IResolvable;
    set sqlUserManagement(value: boolean | cdktf.IResolvable);
    resetSqlUserManagement(): void;
    get sqlUserManagementInput(): boolean | cdktf.IResolvable | undefined;
    get status(): string;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
    private _access;
    get access(): MdbClickhouseClusterAccessOutputReference;
    putAccess(value: MdbClickhouseClusterAccess): void;
    resetAccess(): void;
    get accessInput(): MdbClickhouseClusterAccess | undefined;
    private _backupWindowStart;
    get backupWindowStart(): MdbClickhouseClusterBackupWindowStartOutputReference;
    putBackupWindowStart(value: MdbClickhouseClusterBackupWindowStart): void;
    resetBackupWindowStart(): void;
    get backupWindowStartInput(): MdbClickhouseClusterBackupWindowStart | undefined;
    private _clickhouse;
    get clickhouse(): MdbClickhouseClusterClickhouseOutputReference;
    putClickhouse(value: MdbClickhouseClusterClickhouse): void;
    get clickhouseInput(): MdbClickhouseClusterClickhouse | undefined;
    private _cloudStorage;
    get cloudStorage(): MdbClickhouseClusterCloudStorageOutputReference;
    putCloudStorage(value: MdbClickhouseClusterCloudStorage): void;
    resetCloudStorage(): void;
    get cloudStorageInput(): MdbClickhouseClusterCloudStorage | undefined;
    private _database;
    get database(): MdbClickhouseClusterDatabaseList;
    putDatabase(value: MdbClickhouseClusterDatabase[] | cdktf.IResolvable): void;
    resetDatabase(): void;
    get databaseInput(): cdktf.IResolvable | MdbClickhouseClusterDatabase[] | undefined;
    private _formatSchema;
    get formatSchema(): MdbClickhouseClusterFormatSchemaList;
    putFormatSchema(value: MdbClickhouseClusterFormatSchema[] | cdktf.IResolvable): void;
    resetFormatSchema(): void;
    get formatSchemaInput(): cdktf.IResolvable | MdbClickhouseClusterFormatSchema[] | undefined;
    private _host;
    get host(): MdbClickhouseClusterHostList;
    putHost(value: MdbClickhouseClusterHost[] | cdktf.IResolvable): void;
    get hostInput(): cdktf.IResolvable | MdbClickhouseClusterHost[] | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): MdbClickhouseClusterMaintenanceWindowOutputReference;
    putMaintenanceWindow(value: MdbClickhouseClusterMaintenanceWindow): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): MdbClickhouseClusterMaintenanceWindow | undefined;
    private _mlModel;
    get mlModel(): MdbClickhouseClusterMlModelList;
    putMlModel(value: MdbClickhouseClusterMlModel[] | cdktf.IResolvable): void;
    resetMlModel(): void;
    get mlModelInput(): cdktf.IResolvable | MdbClickhouseClusterMlModel[] | undefined;
    private _shardGroup;
    get shardGroup(): MdbClickhouseClusterShardGroupList;
    putShardGroup(value: MdbClickhouseClusterShardGroup[] | cdktf.IResolvable): void;
    resetShardGroup(): void;
    get shardGroupInput(): cdktf.IResolvable | MdbClickhouseClusterShardGroup[] | undefined;
    private _timeouts;
    get timeouts(): MdbClickhouseClusterTimeoutsOutputReference;
    putTimeouts(value: MdbClickhouseClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | MdbClickhouseClusterTimeouts | undefined;
    private _user;
    get user(): MdbClickhouseClusterUserList;
    putUser(value: MdbClickhouseClusterUser[] | cdktf.IResolvable): void;
    resetUser(): void;
    get userInput(): cdktf.IResolvable | MdbClickhouseClusterUser[] | undefined;
    private _zookeeper;
    get zookeeper(): MdbClickhouseClusterZookeeperOutputReference;
    putZookeeper(value: MdbClickhouseClusterZookeeper): void;
    resetZookeeper(): void;
    get zookeeperInput(): MdbClickhouseClusterZookeeper | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=mdb-clickhouse-cluster.d.ts.map