import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbGreenplumClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#assign_public_ip MdbGreenplumCluster#assign_public_ip}
    */
    readonly assignPublicIp: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#deletion_protection MdbGreenplumCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#description MdbGreenplumCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#environment MdbGreenplumCluster#environment}
    */
    readonly environment: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#folder_id MdbGreenplumCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#id MdbGreenplumCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#labels MdbGreenplumCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#master_host_count MdbGreenplumCluster#master_host_count}
    */
    readonly masterHostCount: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#name MdbGreenplumCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#network_id MdbGreenplumCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#security_group_ids MdbGreenplumCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_host_count MdbGreenplumCluster#segment_host_count}
    */
    readonly segmentHostCount: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_in_host MdbGreenplumCluster#segment_in_host}
    */
    readonly segmentInHost: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#subnet_id MdbGreenplumCluster#subnet_id}
    */
    readonly subnetId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#user_name MdbGreenplumCluster#user_name}
    */
    readonly userName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#user_password MdbGreenplumCluster#user_password}
    */
    readonly userPassword: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#version MdbGreenplumCluster#version}
    */
    readonly version: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#zone MdbGreenplumCluster#zone}
    */
    readonly zone: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#access MdbGreenplumCluster#access}
    */
    readonly access?: MdbGreenplumClusterAccess;
    /**
    * backup_window_start block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#backup_window_start MdbGreenplumCluster#backup_window_start}
    */
    readonly backupWindowStart?: MdbGreenplumClusterBackupWindowStart;
    /**
    * master_subcluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#master_subcluster MdbGreenplumCluster#master_subcluster}
    */
    readonly masterSubcluster: MdbGreenplumClusterMasterSubcluster;
    /**
    * segment_subcluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_subcluster MdbGreenplumCluster#segment_subcluster}
    */
    readonly segmentSubcluster: MdbGreenplumClusterSegmentSubcluster;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#timeouts MdbGreenplumCluster#timeouts}
    */
    readonly timeouts?: MdbGreenplumClusterTimeouts;
}
export interface MdbGreenplumClusterMasterHosts {
}
export declare function mdbGreenplumClusterMasterHostsToTerraform(struct?: MdbGreenplumClusterMasterHosts): any;
export declare class MdbGreenplumClusterMasterHostsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbGreenplumClusterMasterHosts | undefined;
    set internalValue(value: MdbGreenplumClusterMasterHosts | undefined);
    get assignPublicIp(): cdktf.IResolvable;
    get fqdn(): string;
}
export declare class MdbGreenplumClusterMasterHostsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbGreenplumClusterMasterHostsOutputReference;
}
export interface MdbGreenplumClusterSegmentHosts {
}
export declare function mdbGreenplumClusterSegmentHostsToTerraform(struct?: MdbGreenplumClusterSegmentHosts): any;
export declare class MdbGreenplumClusterSegmentHostsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbGreenplumClusterSegmentHosts | undefined;
    set internalValue(value: MdbGreenplumClusterSegmentHosts | undefined);
    get fqdn(): string;
}
export declare class MdbGreenplumClusterSegmentHostsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbGreenplumClusterSegmentHostsOutputReference;
}
export interface MdbGreenplumClusterAccess {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#data_lens MdbGreenplumCluster#data_lens}
    */
    readonly dataLens?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#web_sql MdbGreenplumCluster#web_sql}
    */
    readonly webSql?: boolean | cdktf.IResolvable;
}
export declare function mdbGreenplumClusterAccessToTerraform(struct?: MdbGreenplumClusterAccessOutputReference | MdbGreenplumClusterAccess): any;
export declare class MdbGreenplumClusterAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterAccess | undefined;
    set internalValue(value: MdbGreenplumClusterAccess | undefined);
    private _dataLens?;
    get dataLens(): boolean | cdktf.IResolvable;
    set dataLens(value: boolean | cdktf.IResolvable);
    resetDataLens(): void;
    get dataLensInput(): boolean | cdktf.IResolvable | undefined;
    private _webSql?;
    get webSql(): boolean | cdktf.IResolvable;
    set webSql(value: boolean | cdktf.IResolvable);
    resetWebSql(): void;
    get webSqlInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbGreenplumClusterBackupWindowStart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#hours MdbGreenplumCluster#hours}
    */
    readonly hours?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#minutes MdbGreenplumCluster#minutes}
    */
    readonly minutes?: number;
}
export declare function mdbGreenplumClusterBackupWindowStartToTerraform(struct?: MdbGreenplumClusterBackupWindowStartOutputReference | MdbGreenplumClusterBackupWindowStart): any;
export declare class MdbGreenplumClusterBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterBackupWindowStart | undefined;
    set internalValue(value: MdbGreenplumClusterBackupWindowStart | undefined);
    private _hours?;
    get hours(): number;
    set hours(value: number);
    resetHours(): void;
    get hoursInput(): number | undefined;
    private _minutes?;
    get minutes(): number;
    set minutes(value: number);
    resetMinutes(): void;
    get minutesInput(): number | undefined;
}
export interface MdbGreenplumClusterMasterSubclusterResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_size MdbGreenplumCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_type_id MdbGreenplumCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resource_preset_id MdbGreenplumCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbGreenplumClusterMasterSubclusterResourcesToTerraform(struct?: MdbGreenplumClusterMasterSubclusterResourcesOutputReference | MdbGreenplumClusterMasterSubclusterResources): any;
export declare class MdbGreenplumClusterMasterSubclusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterMasterSubclusterResources | undefined;
    set internalValue(value: MdbGreenplumClusterMasterSubclusterResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbGreenplumClusterMasterSubcluster {
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resources MdbGreenplumCluster#resources}
    */
    readonly resources: MdbGreenplumClusterMasterSubclusterResources;
}
export declare function mdbGreenplumClusterMasterSubclusterToTerraform(struct?: MdbGreenplumClusterMasterSubclusterOutputReference | MdbGreenplumClusterMasterSubcluster): any;
export declare class MdbGreenplumClusterMasterSubclusterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterMasterSubcluster | undefined;
    set internalValue(value: MdbGreenplumClusterMasterSubcluster | undefined);
    private _resources;
    get resources(): MdbGreenplumClusterMasterSubclusterResourcesOutputReference;
    putResources(value: MdbGreenplumClusterMasterSubclusterResources): void;
    get resourcesInput(): MdbGreenplumClusterMasterSubclusterResources | undefined;
}
export interface MdbGreenplumClusterSegmentSubclusterResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_size MdbGreenplumCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_type_id MdbGreenplumCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resource_preset_id MdbGreenplumCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbGreenplumClusterSegmentSubclusterResourcesToTerraform(struct?: MdbGreenplumClusterSegmentSubclusterResourcesOutputReference | MdbGreenplumClusterSegmentSubclusterResources): any;
export declare class MdbGreenplumClusterSegmentSubclusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterSegmentSubclusterResources | undefined;
    set internalValue(value: MdbGreenplumClusterSegmentSubclusterResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbGreenplumClusterSegmentSubcluster {
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resources MdbGreenplumCluster#resources}
    */
    readonly resources: MdbGreenplumClusterSegmentSubclusterResources;
}
export declare function mdbGreenplumClusterSegmentSubclusterToTerraform(struct?: MdbGreenplumClusterSegmentSubclusterOutputReference | MdbGreenplumClusterSegmentSubcluster): any;
export declare class MdbGreenplumClusterSegmentSubclusterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterSegmentSubcluster | undefined;
    set internalValue(value: MdbGreenplumClusterSegmentSubcluster | undefined);
    private _resources;
    get resources(): MdbGreenplumClusterSegmentSubclusterResourcesOutputReference;
    putResources(value: MdbGreenplumClusterSegmentSubclusterResources): void;
    get resourcesInput(): MdbGreenplumClusterSegmentSubclusterResources | undefined;
}
export interface MdbGreenplumClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#create MdbGreenplumCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#delete MdbGreenplumCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#update MdbGreenplumCluster#update}
    */
    readonly update?: string;
}
export declare function mdbGreenplumClusterTimeoutsToTerraform(struct?: MdbGreenplumClusterTimeoutsOutputReference | MdbGreenplumClusterTimeouts | cdktf.IResolvable): any;
export declare class MdbGreenplumClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbGreenplumClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: MdbGreenplumClusterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster yandex_mdb_greenplum_cluster}
*/
export declare class MdbGreenplumCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_greenplum_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster yandex_mdb_greenplum_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbGreenplumClusterConfig
    */
    constructor(scope: Construct, id: string, config: MdbGreenplumClusterConfig);
    private _assignPublicIp?;
    get assignPublicIp(): boolean | cdktf.IResolvable;
    set assignPublicIp(value: boolean | cdktf.IResolvable);
    get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _masterHostCount?;
    get masterHostCount(): number;
    set masterHostCount(value: number);
    get masterHostCountInput(): number | undefined;
    private _masterHosts;
    get masterHosts(): MdbGreenplumClusterMasterHostsList;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _segmentHostCount?;
    get segmentHostCount(): number;
    set segmentHostCount(value: number);
    get segmentHostCountInput(): number | undefined;
    private _segmentHosts;
    get segmentHosts(): MdbGreenplumClusterSegmentHostsList;
    private _segmentInHost?;
    get segmentInHost(): number;
    set segmentInHost(value: number);
    get segmentInHostInput(): number | undefined;
    get status(): string;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    get subnetIdInput(): string | undefined;
    private _userName?;
    get userName(): string;
    set userName(value: string);
    get userNameInput(): string | undefined;
    private _userPassword?;
    get userPassword(): string;
    set userPassword(value: string);
    get userPasswordInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
    private _access;
    get access(): MdbGreenplumClusterAccessOutputReference;
    putAccess(value: MdbGreenplumClusterAccess): void;
    resetAccess(): void;
    get accessInput(): MdbGreenplumClusterAccess | undefined;
    private _backupWindowStart;
    get backupWindowStart(): MdbGreenplumClusterBackupWindowStartOutputReference;
    putBackupWindowStart(value: MdbGreenplumClusterBackupWindowStart): void;
    resetBackupWindowStart(): void;
    get backupWindowStartInput(): MdbGreenplumClusterBackupWindowStart | undefined;
    private _masterSubcluster;
    get masterSubcluster(): MdbGreenplumClusterMasterSubclusterOutputReference;
    putMasterSubcluster(value: MdbGreenplumClusterMasterSubcluster): void;
    get masterSubclusterInput(): MdbGreenplumClusterMasterSubcluster | undefined;
    private _segmentSubcluster;
    get segmentSubcluster(): MdbGreenplumClusterSegmentSubclusterOutputReference;
    putSegmentSubcluster(value: MdbGreenplumClusterSegmentSubcluster): void;
    get segmentSubclusterInput(): MdbGreenplumClusterSegmentSubcluster | undefined;
    private _timeouts;
    get timeouts(): MdbGreenplumClusterTimeoutsOutputReference;
    putTimeouts(value: MdbGreenplumClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | MdbGreenplumClusterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=mdb-greenplum-cluster.d.ts.map