import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbMysqlClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#allow_regeneration_host MdbMysqlCluster#allow_regeneration_host}
    */
    readonly allowRegenerationHost?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#deletion_protection MdbMysqlCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#description MdbMysqlCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#environment MdbMysqlCluster#environment}
    */
    readonly environment: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#folder_id MdbMysqlCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#id MdbMysqlCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#labels MdbMysqlCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#mysql_config MdbMysqlCluster#mysql_config}
    */
    readonly mysqlConfig?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#network_id MdbMysqlCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#security_group_ids MdbMysqlCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#version MdbMysqlCluster#version}
    */
    readonly version: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#access MdbMysqlCluster#access}
    */
    readonly access?: MdbMysqlClusterAccess;
    /**
    * backup_window_start block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_window_start MdbMysqlCluster#backup_window_start}
    */
    readonly backupWindowStart?: MdbMysqlClusterBackupWindowStart;
    /**
    * database block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#database MdbMysqlCluster#database}
    */
    readonly database: MdbMysqlClusterDatabase[] | cdktf.IResolvable;
    /**
    * host block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#host MdbMysqlCluster#host}
    */
    readonly host: MdbMysqlClusterHost[] | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#maintenance_window MdbMysqlCluster#maintenance_window}
    */
    readonly maintenanceWindow?: MdbMysqlClusterMaintenanceWindow;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#resources MdbMysqlCluster#resources}
    */
    readonly resources: MdbMysqlClusterResources;
    /**
    * restore block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#restore MdbMysqlCluster#restore}
    */
    readonly restore?: MdbMysqlClusterRestore;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#timeouts MdbMysqlCluster#timeouts}
    */
    readonly timeouts?: MdbMysqlClusterTimeouts;
    /**
    * user block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#user MdbMysqlCluster#user}
    */
    readonly user: MdbMysqlClusterUser[] | cdktf.IResolvable;
}
export interface MdbMysqlClusterAccess {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#data_lens MdbMysqlCluster#data_lens}
    */
    readonly dataLens?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#web_sql MdbMysqlCluster#web_sql}
    */
    readonly webSql?: boolean | cdktf.IResolvable;
}
export declare function mdbMysqlClusterAccessToTerraform(struct?: MdbMysqlClusterAccessOutputReference | MdbMysqlClusterAccess): any;
export declare class MdbMysqlClusterAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterAccess | undefined;
    set internalValue(value: MdbMysqlClusterAccess | undefined);
    private _dataLens?;
    get dataLens(): boolean | cdktf.IResolvable;
    set dataLens(value: boolean | cdktf.IResolvable);
    resetDataLens(): void;
    get dataLensInput(): boolean | cdktf.IResolvable | undefined;
    private _webSql?;
    get webSql(): boolean | cdktf.IResolvable;
    set webSql(value: boolean | cdktf.IResolvable);
    resetWebSql(): void;
    get webSqlInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbMysqlClusterBackupWindowStart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#hours MdbMysqlCluster#hours}
    */
    readonly hours?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#minutes MdbMysqlCluster#minutes}
    */
    readonly minutes?: number;
}
export declare function mdbMysqlClusterBackupWindowStartToTerraform(struct?: MdbMysqlClusterBackupWindowStartOutputReference | MdbMysqlClusterBackupWindowStart): any;
export declare class MdbMysqlClusterBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterBackupWindowStart | undefined;
    set internalValue(value: MdbMysqlClusterBackupWindowStart | undefined);
    private _hours?;
    get hours(): number;
    set hours(value: number);
    resetHours(): void;
    get hoursInput(): number | undefined;
    private _minutes?;
    get minutes(): number;
    set minutes(value: number);
    resetMinutes(): void;
    get minutesInput(): number | undefined;
}
export interface MdbMysqlClusterDatabase {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}
    */
    readonly name: string;
}
export declare function mdbMysqlClusterDatabaseToTerraform(struct?: MdbMysqlClusterDatabase | cdktf.IResolvable): any;
export declare class MdbMysqlClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbMysqlClusterDatabase | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlClusterDatabase | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export declare class MdbMysqlClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbMysqlClusterDatabase[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbMysqlClusterDatabaseOutputReference;
}
export interface MdbMysqlClusterHost {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#assign_public_ip MdbMysqlCluster#assign_public_ip}
    */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_priority MdbMysqlCluster#backup_priority}
    */
    readonly backupPriority?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#priority MdbMysqlCluster#priority}
    */
    readonly priority?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#replication_source_name MdbMysqlCluster#replication_source_name}
    */
    readonly replicationSourceName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#subnet_id MdbMysqlCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#zone MdbMysqlCluster#zone}
    */
    readonly zone: string;
}
export declare function mdbMysqlClusterHostToTerraform(struct?: MdbMysqlClusterHost | cdktf.IResolvable): any;
export declare class MdbMysqlClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbMysqlClusterHost | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlClusterHost | cdktf.IResolvable | undefined);
    private _assignPublicIp?;
    get assignPublicIp(): boolean | cdktf.IResolvable;
    set assignPublicIp(value: boolean | cdktf.IResolvable);
    resetAssignPublicIp(): void;
    get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    private _backupPriority?;
    get backupPriority(): number;
    set backupPriority(value: number);
    resetBackupPriority(): void;
    get backupPriorityInput(): number | undefined;
    get fqdn(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _priority?;
    get priority(): number;
    set priority(value: number);
    resetPriority(): void;
    get priorityInput(): number | undefined;
    get replicationSource(): string;
    private _replicationSourceName?;
    get replicationSourceName(): string;
    set replicationSourceName(value: string);
    resetReplicationSourceName(): void;
    get replicationSourceNameInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
}
export declare class MdbMysqlClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbMysqlClusterHost[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbMysqlClusterHostOutputReference;
}
export interface MdbMysqlClusterMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#day MdbMysqlCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#hour MdbMysqlCluster#hour}
    */
    readonly hour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#type MdbMysqlCluster#type}
    */
    readonly type: string;
}
export declare function mdbMysqlClusterMaintenanceWindowToTerraform(struct?: MdbMysqlClusterMaintenanceWindowOutputReference | MdbMysqlClusterMaintenanceWindow): any;
export declare class MdbMysqlClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterMaintenanceWindow | undefined;
    set internalValue(value: MdbMysqlClusterMaintenanceWindow | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _hour?;
    get hour(): number;
    set hour(value: number);
    resetHour(): void;
    get hourInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface MdbMysqlClusterResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#disk_size MdbMysqlCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#disk_type_id MdbMysqlCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#resource_preset_id MdbMysqlCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbMysqlClusterResourcesToTerraform(struct?: MdbMysqlClusterResourcesOutputReference | MdbMysqlClusterResources): any;
export declare class MdbMysqlClusterResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterResources | undefined;
    set internalValue(value: MdbMysqlClusterResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbMysqlClusterRestore {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_id MdbMysqlCluster#backup_id}
    */
    readonly backupId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#time MdbMysqlCluster#time}
    */
    readonly time?: string;
}
export declare function mdbMysqlClusterRestoreToTerraform(struct?: MdbMysqlClusterRestoreOutputReference | MdbMysqlClusterRestore): any;
export declare class MdbMysqlClusterRestoreOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterRestore | undefined;
    set internalValue(value: MdbMysqlClusterRestore | undefined);
    private _backupId?;
    get backupId(): string;
    set backupId(value: string);
    get backupIdInput(): string | undefined;
    private _time?;
    get time(): string;
    set time(value: string);
    resetTime(): void;
    get timeInput(): string | undefined;
}
export interface MdbMysqlClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#create MdbMysqlCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#delete MdbMysqlCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#update MdbMysqlCluster#update}
    */
    readonly update?: string;
}
export declare function mdbMysqlClusterTimeoutsToTerraform(struct?: MdbMysqlClusterTimeoutsOutputReference | MdbMysqlClusterTimeouts | cdktf.IResolvable): any;
export declare class MdbMysqlClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlClusterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
export interface MdbMysqlClusterUserConnectionLimits {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_connections_per_hour MdbMysqlCluster#max_connections_per_hour}
    */
    readonly maxConnectionsPerHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_questions_per_hour MdbMysqlCluster#max_questions_per_hour}
    */
    readonly maxQuestionsPerHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_updates_per_hour MdbMysqlCluster#max_updates_per_hour}
    */
    readonly maxUpdatesPerHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_user_connections MdbMysqlCluster#max_user_connections}
    */
    readonly maxUserConnections?: number;
}
export declare function mdbMysqlClusterUserConnectionLimitsToTerraform(struct?: MdbMysqlClusterUserConnectionLimitsOutputReference | MdbMysqlClusterUserConnectionLimits): any;
export declare class MdbMysqlClusterUserConnectionLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlClusterUserConnectionLimits | undefined;
    set internalValue(value: MdbMysqlClusterUserConnectionLimits | undefined);
    private _maxConnectionsPerHour?;
    get maxConnectionsPerHour(): number;
    set maxConnectionsPerHour(value: number);
    resetMaxConnectionsPerHour(): void;
    get maxConnectionsPerHourInput(): number | undefined;
    private _maxQuestionsPerHour?;
    get maxQuestionsPerHour(): number;
    set maxQuestionsPerHour(value: number);
    resetMaxQuestionsPerHour(): void;
    get maxQuestionsPerHourInput(): number | undefined;
    private _maxUpdatesPerHour?;
    get maxUpdatesPerHour(): number;
    set maxUpdatesPerHour(value: number);
    resetMaxUpdatesPerHour(): void;
    get maxUpdatesPerHourInput(): number | undefined;
    private _maxUserConnections?;
    get maxUserConnections(): number;
    set maxUserConnections(value: number);
    resetMaxUserConnections(): void;
    get maxUserConnectionsInput(): number | undefined;
}
export interface MdbMysqlClusterUserPermission {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#database_name MdbMysqlCluster#database_name}
    */
    readonly databaseName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#roles MdbMysqlCluster#roles}
    */
    readonly roles?: string[];
}
export declare function mdbMysqlClusterUserPermissionToTerraform(struct?: MdbMysqlClusterUserPermission | cdktf.IResolvable): any;
export declare class MdbMysqlClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbMysqlClusterUserPermission | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlClusterUserPermission | cdktf.IResolvable | undefined);
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    get databaseNameInput(): string | undefined;
    private _roles?;
    get roles(): string[];
    set roles(value: string[]);
    resetRoles(): void;
    get rolesInput(): string[] | undefined;
}
export declare class MdbMysqlClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbMysqlClusterUserPermission[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbMysqlClusterUserPermissionOutputReference;
}
export interface MdbMysqlClusterUser {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#authentication_plugin MdbMysqlCluster#authentication_plugin}
    */
    readonly authenticationPlugin?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#global_permissions MdbMysqlCluster#global_permissions}
    */
    readonly globalPermissions?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#password MdbMysqlCluster#password}
    */
    readonly password: string;
    /**
    * connection_limits block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#connection_limits MdbMysqlCluster#connection_limits}
    */
    readonly connectionLimits?: MdbMysqlClusterUserConnectionLimits;
    /**
    * permission block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#permission MdbMysqlCluster#permission}
    */
    readonly permission?: MdbMysqlClusterUserPermission[] | cdktf.IResolvable;
}
export declare function mdbMysqlClusterUserToTerraform(struct?: MdbMysqlClusterUser | cdktf.IResolvable): any;
export declare class MdbMysqlClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbMysqlClusterUser | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlClusterUser | cdktf.IResolvable | undefined);
    private _authenticationPlugin?;
    get authenticationPlugin(): string;
    set authenticationPlugin(value: string);
    resetAuthenticationPlugin(): void;
    get authenticationPluginInput(): string | undefined;
    private _globalPermissions?;
    get globalPermissions(): string[];
    set globalPermissions(value: string[]);
    resetGlobalPermissions(): void;
    get globalPermissionsInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    get passwordInput(): string | undefined;
    private _connectionLimits;
    get connectionLimits(): MdbMysqlClusterUserConnectionLimitsOutputReference;
    putConnectionLimits(value: MdbMysqlClusterUserConnectionLimits): void;
    resetConnectionLimits(): void;
    get connectionLimitsInput(): MdbMysqlClusterUserConnectionLimits | undefined;
    private _permission;
    get permission(): MdbMysqlClusterUserPermissionList;
    putPermission(value: MdbMysqlClusterUserPermission[] | cdktf.IResolvable): void;
    resetPermission(): void;
    get permissionInput(): cdktf.IResolvable | MdbMysqlClusterUserPermission[] | undefined;
}
export declare class MdbMysqlClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbMysqlClusterUser[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbMysqlClusterUserOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster yandex_mdb_mysql_cluster}
*/
export declare class MdbMysqlCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_mysql_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster yandex_mdb_mysql_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbMysqlClusterConfig
    */
    constructor(scope: Construct, id: string, config: MdbMysqlClusterConfig);
    private _allowRegenerationHost?;
    get allowRegenerationHost(): boolean | cdktf.IResolvable;
    set allowRegenerationHost(value: boolean | cdktf.IResolvable);
    resetAllowRegenerationHost(): void;
    get allowRegenerationHostInput(): boolean | cdktf.IResolvable | undefined;
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _mysqlConfig?;
    get mysqlConfig(): {
        [key: string]: string;
    };
    set mysqlConfig(value: {
        [key: string]: string;
    });
    resetMysqlConfig(): void;
    get mysqlConfigInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    get status(): string;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
    private _access;
    get access(): MdbMysqlClusterAccessOutputReference;
    putAccess(value: MdbMysqlClusterAccess): void;
    resetAccess(): void;
    get accessInput(): MdbMysqlClusterAccess | undefined;
    private _backupWindowStart;
    get backupWindowStart(): MdbMysqlClusterBackupWindowStartOutputReference;
    putBackupWindowStart(value: MdbMysqlClusterBackupWindowStart): void;
    resetBackupWindowStart(): void;
    get backupWindowStartInput(): MdbMysqlClusterBackupWindowStart | undefined;
    private _database;
    get database(): MdbMysqlClusterDatabaseList;
    putDatabase(value: MdbMysqlClusterDatabase[] | cdktf.IResolvable): void;
    get databaseInput(): cdktf.IResolvable | MdbMysqlClusterDatabase[] | undefined;
    private _host;
    get host(): MdbMysqlClusterHostList;
    putHost(value: MdbMysqlClusterHost[] | cdktf.IResolvable): void;
    get hostInput(): cdktf.IResolvable | MdbMysqlClusterHost[] | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): MdbMysqlClusterMaintenanceWindowOutputReference;
    putMaintenanceWindow(value: MdbMysqlClusterMaintenanceWindow): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): MdbMysqlClusterMaintenanceWindow | undefined;
    private _resources;
    get resources(): MdbMysqlClusterResourcesOutputReference;
    putResources(value: MdbMysqlClusterResources): void;
    get resourcesInput(): MdbMysqlClusterResources | undefined;
    private _restore;
    get restore(): MdbMysqlClusterRestoreOutputReference;
    putRestore(value: MdbMysqlClusterRestore): void;
    resetRestore(): void;
    get restoreInput(): MdbMysqlClusterRestore | undefined;
    private _timeouts;
    get timeouts(): MdbMysqlClusterTimeoutsOutputReference;
    putTimeouts(value: MdbMysqlClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | MdbMysqlClusterTimeouts | undefined;
    private _user;
    get user(): MdbMysqlClusterUserList;
    putUser(value: MdbMysqlClusterUser[] | cdktf.IResolvable): void;
    get userInput(): cdktf.IResolvable | MdbMysqlClusterUser[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=mdb-mysql-cluster.d.ts.map