import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbPostgresqlClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#deletion_protection MdbPostgresqlCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#description MdbPostgresqlCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#environment MdbPostgresqlCluster#environment}
    */
    readonly environment: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#folder_id MdbPostgresqlCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#host_master_name MdbPostgresqlCluster#host_master_name}
    */
    readonly hostMasterName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#id MdbPostgresqlCluster#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#labels MdbPostgresqlCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#network_id MdbPostgresqlCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#security_group_ids MdbPostgresqlCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#config MdbPostgresqlCluster#config}
    */
    readonly config: MdbPostgresqlClusterConfigA;
    /**
    * database block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#database MdbPostgresqlCluster#database}
    */
    readonly database: MdbPostgresqlClusterDatabase[] | cdktf.IResolvable;
    /**
    * host block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#host MdbPostgresqlCluster#host}
    */
    readonly host: MdbPostgresqlClusterHost[] | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#maintenance_window MdbPostgresqlCluster#maintenance_window}
    */
    readonly maintenanceWindow?: MdbPostgresqlClusterMaintenanceWindow;
    /**
    * restore block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#restore MdbPostgresqlCluster#restore}
    */
    readonly restore?: MdbPostgresqlClusterRestore;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#timeouts MdbPostgresqlCluster#timeouts}
    */
    readonly timeouts?: MdbPostgresqlClusterTimeouts;
    /**
    * user block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#user MdbPostgresqlCluster#user}
    */
    readonly user: MdbPostgresqlClusterUser[] | cdktf.IResolvable;
}
export interface MdbPostgresqlClusterConfigAccess {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#data_lens MdbPostgresqlCluster#data_lens}
    */
    readonly dataLens?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#serverless MdbPostgresqlCluster#serverless}
    */
    readonly serverless?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#web_sql MdbPostgresqlCluster#web_sql}
    */
    readonly webSql?: boolean | cdktf.IResolvable;
}
export declare function mdbPostgresqlClusterConfigAccessToTerraform(struct?: MdbPostgresqlClusterConfigAccessOutputReference | MdbPostgresqlClusterConfigAccess): any;
export declare class MdbPostgresqlClusterConfigAccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterConfigAccess | undefined;
    set internalValue(value: MdbPostgresqlClusterConfigAccess | undefined);
    private _dataLens?;
    get dataLens(): boolean | cdktf.IResolvable;
    set dataLens(value: boolean | cdktf.IResolvable);
    resetDataLens(): void;
    get dataLensInput(): boolean | cdktf.IResolvable | undefined;
    private _serverless?;
    get serverless(): boolean | cdktf.IResolvable;
    set serverless(value: boolean | cdktf.IResolvable);
    resetServerless(): void;
    get serverlessInput(): boolean | cdktf.IResolvable | undefined;
    private _webSql?;
    get webSql(): boolean | cdktf.IResolvable;
    set webSql(value: boolean | cdktf.IResolvable);
    resetWebSql(): void;
    get webSqlInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbPostgresqlClusterConfigBackupWindowStart {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#hours MdbPostgresqlCluster#hours}
    */
    readonly hours?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#minutes MdbPostgresqlCluster#minutes}
    */
    readonly minutes?: number;
}
export declare function mdbPostgresqlClusterConfigBackupWindowStartToTerraform(struct?: MdbPostgresqlClusterConfigBackupWindowStartOutputReference | MdbPostgresqlClusterConfigBackupWindowStart): any;
export declare class MdbPostgresqlClusterConfigBackupWindowStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterConfigBackupWindowStart | undefined;
    set internalValue(value: MdbPostgresqlClusterConfigBackupWindowStart | undefined);
    private _hours?;
    get hours(): number;
    set hours(value: number);
    resetHours(): void;
    get hoursInput(): number | undefined;
    private _minutes?;
    get minutes(): number;
    set minutes(value: number);
    resetMinutes(): void;
    get minutesInput(): number | undefined;
}
export interface MdbPostgresqlClusterConfigPerformanceDiagnostics {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#enabled MdbPostgresqlCluster#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#sessions_sampling_interval MdbPostgresqlCluster#sessions_sampling_interval}
    */
    readonly sessionsSamplingInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#statements_sampling_interval MdbPostgresqlCluster#statements_sampling_interval}
    */
    readonly statementsSamplingInterval: number;
}
export declare function mdbPostgresqlClusterConfigPerformanceDiagnosticsToTerraform(struct?: MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference | MdbPostgresqlClusterConfigPerformanceDiagnostics): any;
export declare class MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterConfigPerformanceDiagnostics | undefined;
    set internalValue(value: MdbPostgresqlClusterConfigPerformanceDiagnostics | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _sessionsSamplingInterval?;
    get sessionsSamplingInterval(): number;
    set sessionsSamplingInterval(value: number);
    get sessionsSamplingIntervalInput(): number | undefined;
    private _statementsSamplingInterval?;
    get statementsSamplingInterval(): number;
    set statementsSamplingInterval(value: number);
    get statementsSamplingIntervalInput(): number | undefined;
}
export interface MdbPostgresqlClusterConfigPoolerConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pool_discard MdbPostgresqlCluster#pool_discard}
    */
    readonly poolDiscard?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pooling_mode MdbPostgresqlCluster#pooling_mode}
    */
    readonly poolingMode?: string;
}
export declare function mdbPostgresqlClusterConfigPoolerConfigToTerraform(struct?: MdbPostgresqlClusterConfigPoolerConfigOutputReference | MdbPostgresqlClusterConfigPoolerConfig): any;
export declare class MdbPostgresqlClusterConfigPoolerConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterConfigPoolerConfig | undefined;
    set internalValue(value: MdbPostgresqlClusterConfigPoolerConfig | undefined);
    private _poolDiscard?;
    get poolDiscard(): boolean | cdktf.IResolvable;
    set poolDiscard(value: boolean | cdktf.IResolvable);
    resetPoolDiscard(): void;
    get poolDiscardInput(): boolean | cdktf.IResolvable | undefined;
    private _poolingMode?;
    get poolingMode(): string;
    set poolingMode(value: string);
    resetPoolingMode(): void;
    get poolingModeInput(): string | undefined;
}
export interface MdbPostgresqlClusterConfigResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#disk_size MdbPostgresqlCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#disk_type_id MdbPostgresqlCluster#disk_type_id}
    */
    readonly diskTypeId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#resource_preset_id MdbPostgresqlCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbPostgresqlClusterConfigResourcesToTerraform(struct?: MdbPostgresqlClusterConfigResourcesOutputReference | MdbPostgresqlClusterConfigResources): any;
export declare class MdbPostgresqlClusterConfigResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterConfigResources | undefined;
    set internalValue(value: MdbPostgresqlClusterConfigResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    resetDiskTypeId(): void;
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbPostgresqlClusterConfigA {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#autofailover MdbPostgresqlCluster#autofailover}
    */
    readonly autofailover?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_retain_period_days MdbPostgresqlCluster#backup_retain_period_days}
    */
    readonly backupRetainPeriodDays?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#postgresql_config MdbPostgresqlCluster#postgresql_config}
    */
    readonly postgresqlConfig?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#version MdbPostgresqlCluster#version}
    */
    readonly version: string;
    /**
    * access block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#access MdbPostgresqlCluster#access}
    */
    readonly access?: MdbPostgresqlClusterConfigAccess;
    /**
    * backup_window_start block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_window_start MdbPostgresqlCluster#backup_window_start}
    */
    readonly backupWindowStart?: MdbPostgresqlClusterConfigBackupWindowStart;
    /**
    * performance_diagnostics block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#performance_diagnostics MdbPostgresqlCluster#performance_diagnostics}
    */
    readonly performanceDiagnostics?: MdbPostgresqlClusterConfigPerformanceDiagnostics;
    /**
    * pooler_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pooler_config MdbPostgresqlCluster#pooler_config}
    */
    readonly poolerConfig?: MdbPostgresqlClusterConfigPoolerConfig;
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#resources MdbPostgresqlCluster#resources}
    */
    readonly resources: MdbPostgresqlClusterConfigResources;
}
export declare function mdbPostgresqlClusterConfigAToTerraform(struct?: MdbPostgresqlClusterConfigAOutputReference | MdbPostgresqlClusterConfigA): any;
export declare class MdbPostgresqlClusterConfigAOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterConfigA | undefined;
    set internalValue(value: MdbPostgresqlClusterConfigA | undefined);
    private _autofailover?;
    get autofailover(): boolean | cdktf.IResolvable;
    set autofailover(value: boolean | cdktf.IResolvable);
    resetAutofailover(): void;
    get autofailoverInput(): boolean | cdktf.IResolvable | undefined;
    private _backupRetainPeriodDays?;
    get backupRetainPeriodDays(): number;
    set backupRetainPeriodDays(value: number);
    resetBackupRetainPeriodDays(): void;
    get backupRetainPeriodDaysInput(): number | undefined;
    private _postgresqlConfig?;
    get postgresqlConfig(): {
        [key: string]: string;
    };
    set postgresqlConfig(value: {
        [key: string]: string;
    });
    resetPostgresqlConfig(): void;
    get postgresqlConfigInput(): {
        [key: string]: string;
    } | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
    private _access;
    get access(): MdbPostgresqlClusterConfigAccessOutputReference;
    putAccess(value: MdbPostgresqlClusterConfigAccess): void;
    resetAccess(): void;
    get accessInput(): MdbPostgresqlClusterConfigAccess | undefined;
    private _backupWindowStart;
    get backupWindowStart(): MdbPostgresqlClusterConfigBackupWindowStartOutputReference;
    putBackupWindowStart(value: MdbPostgresqlClusterConfigBackupWindowStart): void;
    resetBackupWindowStart(): void;
    get backupWindowStartInput(): MdbPostgresqlClusterConfigBackupWindowStart | undefined;
    private _performanceDiagnostics;
    get performanceDiagnostics(): MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference;
    putPerformanceDiagnostics(value: MdbPostgresqlClusterConfigPerformanceDiagnostics): void;
    resetPerformanceDiagnostics(): void;
    get performanceDiagnosticsInput(): MdbPostgresqlClusterConfigPerformanceDiagnostics | undefined;
    private _poolerConfig;
    get poolerConfig(): MdbPostgresqlClusterConfigPoolerConfigOutputReference;
    putPoolerConfig(value: MdbPostgresqlClusterConfigPoolerConfig): void;
    resetPoolerConfig(): void;
    get poolerConfigInput(): MdbPostgresqlClusterConfigPoolerConfig | undefined;
    private _resources;
    get resources(): MdbPostgresqlClusterConfigResourcesOutputReference;
    putResources(value: MdbPostgresqlClusterConfigResources): void;
    get resourcesInput(): MdbPostgresqlClusterConfigResources | undefined;
}
export interface MdbPostgresqlClusterDatabaseExtension {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#version MdbPostgresqlCluster#version}
    */
    readonly version?: string;
}
export declare function mdbPostgresqlClusterDatabaseExtensionToTerraform(struct?: MdbPostgresqlClusterDatabaseExtension | cdktf.IResolvable): any;
export declare class MdbPostgresqlClusterDatabaseExtensionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbPostgresqlClusterDatabaseExtension | cdktf.IResolvable | undefined;
    set internalValue(value: MdbPostgresqlClusterDatabaseExtension | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
}
export declare class MdbPostgresqlClusterDatabaseExtensionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbPostgresqlClusterDatabaseExtension[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbPostgresqlClusterDatabaseExtensionOutputReference;
}
export interface MdbPostgresqlClusterDatabase {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#lc_collate MdbPostgresqlCluster#lc_collate}
    */
    readonly lcCollate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#lc_type MdbPostgresqlCluster#lc_type}
    */
    readonly lcType?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#owner MdbPostgresqlCluster#owner}
    */
    readonly owner: string;
    /**
    * extension block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#extension MdbPostgresqlCluster#extension}
    */
    readonly extension?: MdbPostgresqlClusterDatabaseExtension[] | cdktf.IResolvable;
}
export declare function mdbPostgresqlClusterDatabaseToTerraform(struct?: MdbPostgresqlClusterDatabase | cdktf.IResolvable): any;
export declare class MdbPostgresqlClusterDatabaseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbPostgresqlClusterDatabase | cdktf.IResolvable | undefined;
    set internalValue(value: MdbPostgresqlClusterDatabase | cdktf.IResolvable | undefined);
    private _lcCollate?;
    get lcCollate(): string;
    set lcCollate(value: string);
    resetLcCollate(): void;
    get lcCollateInput(): string | undefined;
    private _lcType?;
    get lcType(): string;
    set lcType(value: string);
    resetLcType(): void;
    get lcTypeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _owner?;
    get owner(): string;
    set owner(value: string);
    get ownerInput(): string | undefined;
    private _extension;
    get extension(): MdbPostgresqlClusterDatabaseExtensionList;
    putExtension(value: MdbPostgresqlClusterDatabaseExtension[] | cdktf.IResolvable): void;
    resetExtension(): void;
    get extensionInput(): cdktf.IResolvable | MdbPostgresqlClusterDatabaseExtension[] | undefined;
}
export declare class MdbPostgresqlClusterDatabaseList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbPostgresqlClusterDatabase[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbPostgresqlClusterDatabaseOutputReference;
}
export interface MdbPostgresqlClusterHost {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#assign_public_ip MdbPostgresqlCluster#assign_public_ip}
    */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#priority MdbPostgresqlCluster#priority}
    */
    readonly priority?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#replication_source_name MdbPostgresqlCluster#replication_source_name}
    */
    readonly replicationSourceName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#subnet_id MdbPostgresqlCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#zone MdbPostgresqlCluster#zone}
    */
    readonly zone: string;
}
export declare function mdbPostgresqlClusterHostToTerraform(struct?: MdbPostgresqlClusterHost | cdktf.IResolvable): any;
export declare class MdbPostgresqlClusterHostOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbPostgresqlClusterHost | cdktf.IResolvable | undefined;
    set internalValue(value: MdbPostgresqlClusterHost | cdktf.IResolvable | undefined);
    private _assignPublicIp?;
    get assignPublicIp(): boolean | cdktf.IResolvable;
    set assignPublicIp(value: boolean | cdktf.IResolvable);
    resetAssignPublicIp(): void;
    get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    get fqdn(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _priority?;
    get priority(): number;
    set priority(value: number);
    resetPriority(): void;
    get priorityInput(): number | undefined;
    get replicationSource(): string;
    private _replicationSourceName?;
    get replicationSourceName(): string;
    set replicationSourceName(value: string);
    resetReplicationSourceName(): void;
    get replicationSourceNameInput(): string | undefined;
    get role(): string;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    resetSubnetId(): void;
    get subnetIdInput(): string | undefined;
    private _zone?;
    get zone(): string;
    set zone(value: string);
    get zoneInput(): string | undefined;
}
export declare class MdbPostgresqlClusterHostList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbPostgresqlClusterHost[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbPostgresqlClusterHostOutputReference;
}
export interface MdbPostgresqlClusterMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#day MdbPostgresqlCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#hour MdbPostgresqlCluster#hour}
    */
    readonly hour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#type MdbPostgresqlCluster#type}
    */
    readonly type: string;
}
export declare function mdbPostgresqlClusterMaintenanceWindowToTerraform(struct?: MdbPostgresqlClusterMaintenanceWindowOutputReference | MdbPostgresqlClusterMaintenanceWindow): any;
export declare class MdbPostgresqlClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterMaintenanceWindow | undefined;
    set internalValue(value: MdbPostgresqlClusterMaintenanceWindow | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _hour?;
    get hour(): number;
    set hour(value: number);
    resetHour(): void;
    get hourInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface MdbPostgresqlClusterRestore {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_id MdbPostgresqlCluster#backup_id}
    */
    readonly backupId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#time MdbPostgresqlCluster#time}
    */
    readonly time?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#time_inclusive MdbPostgresqlCluster#time_inclusive}
    */
    readonly timeInclusive?: boolean | cdktf.IResolvable;
}
export declare function mdbPostgresqlClusterRestoreToTerraform(struct?: MdbPostgresqlClusterRestoreOutputReference | MdbPostgresqlClusterRestore): any;
export declare class MdbPostgresqlClusterRestoreOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterRestore | undefined;
    set internalValue(value: MdbPostgresqlClusterRestore | undefined);
    private _backupId?;
    get backupId(): string;
    set backupId(value: string);
    get backupIdInput(): string | undefined;
    private _time?;
    get time(): string;
    set time(value: string);
    resetTime(): void;
    get timeInput(): string | undefined;
    private _timeInclusive?;
    get timeInclusive(): boolean | cdktf.IResolvable;
    set timeInclusive(value: boolean | cdktf.IResolvable);
    resetTimeInclusive(): void;
    get timeInclusiveInput(): boolean | cdktf.IResolvable | undefined;
}
export interface MdbPostgresqlClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#create MdbPostgresqlCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#delete MdbPostgresqlCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#update MdbPostgresqlCluster#update}
    */
    readonly update?: string;
}
export declare function mdbPostgresqlClusterTimeoutsToTerraform(struct?: MdbPostgresqlClusterTimeoutsOutputReference | MdbPostgresqlClusterTimeouts | cdktf.IResolvable): any;
export declare class MdbPostgresqlClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbPostgresqlClusterTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: MdbPostgresqlClusterTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
export interface MdbPostgresqlClusterUserPermission {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#database_name MdbPostgresqlCluster#database_name}
    */
    readonly databaseName: string;
}
export declare function mdbPostgresqlClusterUserPermissionToTerraform(struct?: MdbPostgresqlClusterUserPermission | cdktf.IResolvable): any;
export declare class MdbPostgresqlClusterUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbPostgresqlClusterUserPermission | cdktf.IResolvable | undefined;
    set internalValue(value: MdbPostgresqlClusterUserPermission | cdktf.IResolvable | undefined);
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    get databaseNameInput(): string | undefined;
}
export declare class MdbPostgresqlClusterUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbPostgresqlClusterUserPermission[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbPostgresqlClusterUserPermissionOutputReference;
}
export interface MdbPostgresqlClusterUser {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#conn_limit MdbPostgresqlCluster#conn_limit}
    */
    readonly connLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#grants MdbPostgresqlCluster#grants}
    */
    readonly grants?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#login MdbPostgresqlCluster#login}
    */
    readonly login?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#password MdbPostgresqlCluster#password}
    */
    readonly password: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#settings MdbPostgresqlCluster#settings}
    */
    readonly settings?: {
        [key: string]: string;
    };
    /**
    * permission block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#permission MdbPostgresqlCluster#permission}
    */
    readonly permission?: MdbPostgresqlClusterUserPermission[] | cdktf.IResolvable;
}
export declare function mdbPostgresqlClusterUserToTerraform(struct?: MdbPostgresqlClusterUser | cdktf.IResolvable): any;
export declare class MdbPostgresqlClusterUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbPostgresqlClusterUser | cdktf.IResolvable | undefined;
    set internalValue(value: MdbPostgresqlClusterUser | cdktf.IResolvable | undefined);
    private _connLimit?;
    get connLimit(): number;
    set connLimit(value: number);
    resetConnLimit(): void;
    get connLimitInput(): number | undefined;
    private _grants?;
    get grants(): string[];
    set grants(value: string[]);
    resetGrants(): void;
    get grantsInput(): string[] | undefined;
    private _login?;
    get login(): boolean | cdktf.IResolvable;
    set login(value: boolean | cdktf.IResolvable);
    resetLogin(): void;
    get loginInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    get passwordInput(): string | undefined;
    private _settings?;
    get settings(): {
        [key: string]: string;
    };
    set settings(value: {
        [key: string]: string;
    });
    resetSettings(): void;
    get settingsInput(): {
        [key: string]: string;
    } | undefined;
    private _permission;
    get permission(): MdbPostgresqlClusterUserPermissionList;
    putPermission(value: MdbPostgresqlClusterUserPermission[] | cdktf.IResolvable): void;
    resetPermission(): void;
    get permissionInput(): cdktf.IResolvable | MdbPostgresqlClusterUserPermission[] | undefined;
}
export declare class MdbPostgresqlClusterUserList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbPostgresqlClusterUser[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbPostgresqlClusterUserOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster yandex_mdb_postgresql_cluster}
*/
export declare class MdbPostgresqlCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_postgresql_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster yandex_mdb_postgresql_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbPostgresqlClusterConfig
    */
    constructor(scope: Construct, id: string, config: MdbPostgresqlClusterConfig);
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    private _hostMasterName?;
    get hostMasterName(): string;
    set hostMasterName(value: string);
    resetHostMasterName(): void;
    get hostMasterNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    get status(): string;
    private _config;
    get config(): MdbPostgresqlClusterConfigAOutputReference;
    putConfig(value: MdbPostgresqlClusterConfigA): void;
    get configInput(): MdbPostgresqlClusterConfigA | undefined;
    private _database;
    get database(): MdbPostgresqlClusterDatabaseList;
    putDatabase(value: MdbPostgresqlClusterDatabase[] | cdktf.IResolvable): void;
    get databaseInput(): cdktf.IResolvable | MdbPostgresqlClusterDatabase[] | undefined;
    private _host;
    get host(): MdbPostgresqlClusterHostList;
    putHost(value: MdbPostgresqlClusterHost[] | cdktf.IResolvable): void;
    get hostInput(): cdktf.IResolvable | MdbPostgresqlClusterHost[] | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): MdbPostgresqlClusterMaintenanceWindowOutputReference;
    putMaintenanceWindow(value: MdbPostgresqlClusterMaintenanceWindow): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): MdbPostgresqlClusterMaintenanceWindow | undefined;
    private _restore;
    get restore(): MdbPostgresqlClusterRestoreOutputReference;
    putRestore(value: MdbPostgresqlClusterRestore): void;
    resetRestore(): void;
    get restoreInput(): MdbPostgresqlClusterRestore | undefined;
    private _timeouts;
    get timeouts(): MdbPostgresqlClusterTimeoutsOutputReference;
    putTimeouts(value: MdbPostgresqlClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | MdbPostgresqlClusterTimeouts | undefined;
    private _user;
    get user(): MdbPostgresqlClusterUserList;
    putUser(value: MdbPostgresqlClusterUser[] | cdktf.IResolvable): void;
    get userInput(): cdktf.IResolvable | MdbPostgresqlClusterUser[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=mdb-postgresql-cluster.d.ts.map