import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OrganizationmanagerOrganizationIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#id OrganizationmanagerOrganizationIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#member OrganizationmanagerOrganizationIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#organization_id OrganizationmanagerOrganizationIamMember#organization_id}
    */
    readonly organizationId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#role OrganizationmanagerOrganizationIamMember#role}
    */
    readonly role: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#sleep_after OrganizationmanagerOrganizationIamMember#sleep_after}
    */
    readonly sleepAfter?: number;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member yandex_organizationmanager_organization_iam_member}
*/
export declare class OrganizationmanagerOrganizationIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_organizationmanager_organization_iam_member";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member yandex_organizationmanager_organization_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OrganizationmanagerOrganizationIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: OrganizationmanagerOrganizationIamMemberConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _organizationId?;
    get organizationId(): string;
    set organizationId(value: string);
    get organizationIdInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _sleepAfter?;
    get sleepAfter(): number;
    set sleepAfter(value: number);
    resetSleepAfter(): void;
    get sleepAfterInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=organizationmanager-organization-iam-member.d.ts.map