import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OrganizationmanagerSamlFederationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#auto_create_account_on_login OrganizationmanagerSamlFederation#auto_create_account_on_login}
    */
    readonly autoCreateAccountOnLogin?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#case_insensitive_name_ids OrganizationmanagerSamlFederation#case_insensitive_name_ids}
    */
    readonly caseInsensitiveNameIds?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#cookie_max_age OrganizationmanagerSamlFederation#cookie_max_age}
    */
    readonly cookieMaxAge?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#description OrganizationmanagerSamlFederation#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#id OrganizationmanagerSamlFederation#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#issuer OrganizationmanagerSamlFederation#issuer}
    */
    readonly issuer: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#labels OrganizationmanagerSamlFederation#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#name OrganizationmanagerSamlFederation#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#organization_id OrganizationmanagerSamlFederation#organization_id}
    */
    readonly organizationId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#sso_binding OrganizationmanagerSamlFederation#sso_binding}
    */
    readonly ssoBinding: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#sso_url OrganizationmanagerSamlFederation#sso_url}
    */
    readonly ssoUrl: string;
    /**
    * security_settings block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#security_settings OrganizationmanagerSamlFederation#security_settings}
    */
    readonly securitySettings?: OrganizationmanagerSamlFederationSecuritySettings;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#timeouts OrganizationmanagerSamlFederation#timeouts}
    */
    readonly timeouts?: OrganizationmanagerSamlFederationTimeouts;
}
export interface OrganizationmanagerSamlFederationSecuritySettings {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#encrypted_assertions OrganizationmanagerSamlFederation#encrypted_assertions}
    */
    readonly encryptedAssertions: boolean | cdktf.IResolvable;
}
export declare function organizationmanagerSamlFederationSecuritySettingsToTerraform(struct?: OrganizationmanagerSamlFederationSecuritySettingsOutputReference | OrganizationmanagerSamlFederationSecuritySettings): any;
export declare class OrganizationmanagerSamlFederationSecuritySettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OrganizationmanagerSamlFederationSecuritySettings | undefined;
    set internalValue(value: OrganizationmanagerSamlFederationSecuritySettings | undefined);
    private _encryptedAssertions?;
    get encryptedAssertions(): boolean | cdktf.IResolvable;
    set encryptedAssertions(value: boolean | cdktf.IResolvable);
    get encryptedAssertionsInput(): boolean | cdktf.IResolvable | undefined;
}
export interface OrganizationmanagerSamlFederationTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#create OrganizationmanagerSamlFederation#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#delete OrganizationmanagerSamlFederation#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#read OrganizationmanagerSamlFederation#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#update OrganizationmanagerSamlFederation#update}
    */
    readonly update?: string;
}
export declare function organizationmanagerSamlFederationTimeoutsToTerraform(struct?: OrganizationmanagerSamlFederationTimeoutsOutputReference | OrganizationmanagerSamlFederationTimeouts | cdktf.IResolvable): any;
export declare class OrganizationmanagerSamlFederationTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OrganizationmanagerSamlFederationTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: OrganizationmanagerSamlFederationTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation yandex_organizationmanager_saml_federation}
*/
export declare class OrganizationmanagerSamlFederation extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_organizationmanager_saml_federation";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation yandex_organizationmanager_saml_federation} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OrganizationmanagerSamlFederationConfig
    */
    constructor(scope: Construct, id: string, config: OrganizationmanagerSamlFederationConfig);
    private _autoCreateAccountOnLogin?;
    get autoCreateAccountOnLogin(): boolean | cdktf.IResolvable;
    set autoCreateAccountOnLogin(value: boolean | cdktf.IResolvable);
    resetAutoCreateAccountOnLogin(): void;
    get autoCreateAccountOnLoginInput(): boolean | cdktf.IResolvable | undefined;
    private _caseInsensitiveNameIds?;
    get caseInsensitiveNameIds(): boolean | cdktf.IResolvable;
    set caseInsensitiveNameIds(value: boolean | cdktf.IResolvable);
    resetCaseInsensitiveNameIds(): void;
    get caseInsensitiveNameIdsInput(): boolean | cdktf.IResolvable | undefined;
    private _cookieMaxAge?;
    get cookieMaxAge(): string;
    set cookieMaxAge(value: string);
    resetCookieMaxAge(): void;
    get cookieMaxAgeInput(): string | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _issuer?;
    get issuer(): string;
    set issuer(value: string);
    get issuerInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _organizationId?;
    get organizationId(): string;
    set organizationId(value: string);
    get organizationIdInput(): string | undefined;
    private _ssoBinding?;
    get ssoBinding(): string;
    set ssoBinding(value: string);
    get ssoBindingInput(): string | undefined;
    private _ssoUrl?;
    get ssoUrl(): string;
    set ssoUrl(value: string);
    get ssoUrlInput(): string | undefined;
    private _securitySettings;
    get securitySettings(): OrganizationmanagerSamlFederationSecuritySettingsOutputReference;
    putSecuritySettings(value: OrganizationmanagerSamlFederationSecuritySettings): void;
    resetSecuritySettings(): void;
    get securitySettingsInput(): OrganizationmanagerSamlFederationSecuritySettings | undefined;
    private _timeouts;
    get timeouts(): OrganizationmanagerSamlFederationTimeoutsOutputReference;
    putTimeouts(value: OrganizationmanagerSamlFederationTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | OrganizationmanagerSamlFederationTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=organizationmanager-saml-federation.d.ts.map