import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ResourcemanagerFolderIamPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#folder_id ResourcemanagerFolderIamPolicy#folder_id}
    */
    readonly folderId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#id ResourcemanagerFolderIamPolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#policy_data ResourcemanagerFolderIamPolicy#policy_data}
    */
    readonly policyData: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy yandex_resourcemanager_folder_iam_policy}
*/
export declare class ResourcemanagerFolderIamPolicy extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_resourcemanager_folder_iam_policy";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy yandex_resourcemanager_folder_iam_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ResourcemanagerFolderIamPolicyConfig
    */
    constructor(scope: Construct, id: string, config: ResourcemanagerFolderIamPolicyConfig);
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _policyData?;
    get policyData(): string;
    set policyData(value: string);
    get policyDataInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=resourcemanager-folder-iam-policy.d.ts.map