import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface VpcAddressConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#description VpcAddress#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#folder_id VpcAddress#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#id VpcAddress#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#labels VpcAddress#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#name VpcAddress#name}
    */
    readonly name?: string;
    /**
    * external_ipv4_address block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#external_ipv4_address VpcAddress#external_ipv4_address}
    */
    readonly externalIpv4Address?: VpcAddressExternalIpv4Address;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#timeouts VpcAddress#timeouts}
    */
    readonly timeouts?: VpcAddressTimeouts;
}
export interface VpcAddressExternalIpv4Address {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#ddos_protection_provider VpcAddress#ddos_protection_provider}
    */
    readonly ddosProtectionProvider?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#outgoing_smtp_capability VpcAddress#outgoing_smtp_capability}
    */
    readonly outgoingSmtpCapability?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#zone_id VpcAddress#zone_id}
    */
    readonly zoneId?: string;
}
export declare function vpcAddressExternalIpv4AddressToTerraform(struct?: VpcAddressExternalIpv4AddressOutputReference | VpcAddressExternalIpv4Address): any;
export declare class VpcAddressExternalIpv4AddressOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VpcAddressExternalIpv4Address | undefined;
    set internalValue(value: VpcAddressExternalIpv4Address | undefined);
    get address(): string;
    private _ddosProtectionProvider?;
    get ddosProtectionProvider(): string;
    set ddosProtectionProvider(value: string);
    resetDdosProtectionProvider(): void;
    get ddosProtectionProviderInput(): string | undefined;
    private _outgoingSmtpCapability?;
    get outgoingSmtpCapability(): string;
    set outgoingSmtpCapability(value: string);
    resetOutgoingSmtpCapability(): void;
    get outgoingSmtpCapabilityInput(): string | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    resetZoneId(): void;
    get zoneIdInput(): string | undefined;
}
export interface VpcAddressTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#create VpcAddress#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#delete VpcAddress#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#update VpcAddress#update}
    */
    readonly update?: string;
}
export declare function vpcAddressTimeoutsToTerraform(struct?: VpcAddressTimeoutsOutputReference | VpcAddressTimeouts | cdktf.IResolvable): any;
export declare class VpcAddressTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VpcAddressTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: VpcAddressTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address yandex_vpc_address}
*/
export declare class VpcAddress extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_vpc_address";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address yandex_vpc_address} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options VpcAddressConfig = {}
    */
    constructor(scope: Construct, id: string, config?: VpcAddressConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get reserved(): cdktf.IResolvable;
    get used(): cdktf.IResolvable;
    private _externalIpv4Address;
    get externalIpv4Address(): VpcAddressExternalIpv4AddressOutputReference;
    putExternalIpv4Address(value: VpcAddressExternalIpv4Address): void;
    resetExternalIpv4Address(): void;
    get externalIpv4AddressInput(): VpcAddressExternalIpv4Address | undefined;
    private _timeouts;
    get timeouts(): VpcAddressTimeoutsOutputReference;
    putTimeouts(value: VpcAddressTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | VpcAddressTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=vpc-address.d.ts.map