import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface VpcSecurityGroupRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#description VpcSecurityGroupRule#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#direction VpcSecurityGroupRule#direction}
    */
    readonly direction: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#from_port VpcSecurityGroupRule#from_port}
    */
    readonly fromPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#id VpcSecurityGroupRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#labels VpcSecurityGroupRule#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#port VpcSecurityGroupRule#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#predefined_target VpcSecurityGroupRule#predefined_target}
    */
    readonly predefinedTarget?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#protocol VpcSecurityGroupRule#protocol}
    */
    readonly protocol?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#security_group_binding VpcSecurityGroupRule#security_group_binding}
    */
    readonly securityGroupBinding: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#security_group_id VpcSecurityGroupRule#security_group_id}
    */
    readonly securityGroupId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#to_port VpcSecurityGroupRule#to_port}
    */
    readonly toPort?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#v4_cidr_blocks VpcSecurityGroupRule#v4_cidr_blocks}
    */
    readonly v4CidrBlocks?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#v6_cidr_blocks VpcSecurityGroupRule#v6_cidr_blocks}
    */
    readonly v6CidrBlocks?: string[];
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#timeouts VpcSecurityGroupRule#timeouts}
    */
    readonly timeouts?: VpcSecurityGroupRuleTimeouts;
}
export interface VpcSecurityGroupRuleTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#create VpcSecurityGroupRule#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#delete VpcSecurityGroupRule#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#read VpcSecurityGroupRule#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#update VpcSecurityGroupRule#update}
    */
    readonly update?: string;
}
export declare function vpcSecurityGroupRuleTimeoutsToTerraform(struct?: VpcSecurityGroupRuleTimeoutsOutputReference | VpcSecurityGroupRuleTimeouts | cdktf.IResolvable): any;
export declare class VpcSecurityGroupRuleTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VpcSecurityGroupRuleTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: VpcSecurityGroupRuleTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule yandex_vpc_security_group_rule}
*/
export declare class VpcSecurityGroupRule extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_vpc_security_group_rule";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule yandex_vpc_security_group_rule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options VpcSecurityGroupRuleConfig
    */
    constructor(scope: Construct, id: string, config: VpcSecurityGroupRuleConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _direction?;
    get direction(): string;
    set direction(value: string);
    get directionInput(): string | undefined;
    private _fromPort?;
    get fromPort(): number;
    set fromPort(value: number);
    resetFromPort(): void;
    get fromPortInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _predefinedTarget?;
    get predefinedTarget(): string;
    set predefinedTarget(value: string);
    resetPredefinedTarget(): void;
    get predefinedTargetInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    resetProtocol(): void;
    get protocolInput(): string | undefined;
    private _securityGroupBinding?;
    get securityGroupBinding(): string;
    set securityGroupBinding(value: string);
    get securityGroupBindingInput(): string | undefined;
    private _securityGroupId?;
    get securityGroupId(): string;
    set securityGroupId(value: string);
    resetSecurityGroupId(): void;
    get securityGroupIdInput(): string | undefined;
    private _toPort?;
    get toPort(): number;
    set toPort(value: number);
    resetToPort(): void;
    get toPortInput(): number | undefined;
    private _v4CidrBlocks?;
    get v4CidrBlocks(): string[];
    set v4CidrBlocks(value: string[]);
    resetV4CidrBlocks(): void;
    get v4CidrBlocksInput(): string[] | undefined;
    private _v6CidrBlocks?;
    get v6CidrBlocks(): string[];
    set v6CidrBlocks(value: string[]);
    resetV6CidrBlocks(): void;
    get v6CidrBlocksInput(): string[] | undefined;
    private _timeouts;
    get timeouts(): VpcSecurityGroupRuleTimeoutsOutputReference;
    putTimeouts(value: VpcSecurityGroupRuleTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | VpcSecurityGroupRuleTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=vpc-security-group-rule.d.ts.map