import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface YdbDatabaseDedicatedConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#assign_public_ips YdbDatabaseDedicated#assign_public_ips}
    */
    readonly assignPublicIps?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#description YdbDatabaseDedicated#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#folder_id YdbDatabaseDedicated#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#id YdbDatabaseDedicated#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#labels YdbDatabaseDedicated#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#location_id YdbDatabaseDedicated#location_id}
    */
    readonly locationId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#name YdbDatabaseDedicated#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#network_id YdbDatabaseDedicated#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#resource_preset_id YdbDatabaseDedicated#resource_preset_id}
    */
    readonly resourcePresetId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#subnet_ids YdbDatabaseDedicated#subnet_ids}
    */
    readonly subnetIds: string[];
    /**
    * location block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#location YdbDatabaseDedicated#location}
    */
    readonly location?: YdbDatabaseDedicatedLocation;
    /**
    * scale_policy block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#scale_policy YdbDatabaseDedicated#scale_policy}
    */
    readonly scalePolicy: YdbDatabaseDedicatedScalePolicy;
    /**
    * storage_config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#storage_config YdbDatabaseDedicated#storage_config}
    */
    readonly storageConfig: YdbDatabaseDedicatedStorageConfig;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#timeouts YdbDatabaseDedicated#timeouts}
    */
    readonly timeouts?: YdbDatabaseDedicatedTimeouts;
}
export interface YdbDatabaseDedicatedLocationRegion {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#id YdbDatabaseDedicated#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
}
export declare function ydbDatabaseDedicatedLocationRegionToTerraform(struct?: YdbDatabaseDedicatedLocationRegionOutputReference | YdbDatabaseDedicatedLocationRegion): any;
export declare class YdbDatabaseDedicatedLocationRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseDedicatedLocationRegion | undefined;
    set internalValue(value: YdbDatabaseDedicatedLocationRegion | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
}
export interface YdbDatabaseDedicatedLocation {
    /**
    * region block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#region YdbDatabaseDedicated#region}
    */
    readonly region?: YdbDatabaseDedicatedLocationRegion;
}
export declare function ydbDatabaseDedicatedLocationToTerraform(struct?: YdbDatabaseDedicatedLocationOutputReference | YdbDatabaseDedicatedLocation): any;
export declare class YdbDatabaseDedicatedLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseDedicatedLocation | undefined;
    set internalValue(value: YdbDatabaseDedicatedLocation | undefined);
    private _region;
    get region(): YdbDatabaseDedicatedLocationRegionOutputReference;
    putRegion(value: YdbDatabaseDedicatedLocationRegion): void;
    resetRegion(): void;
    get regionInput(): YdbDatabaseDedicatedLocationRegion | undefined;
}
export interface YdbDatabaseDedicatedScalePolicyFixedScale {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#size YdbDatabaseDedicated#size}
    */
    readonly size: number;
}
export declare function ydbDatabaseDedicatedScalePolicyFixedScaleToTerraform(struct?: YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference | YdbDatabaseDedicatedScalePolicyFixedScale): any;
export declare class YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseDedicatedScalePolicyFixedScale | undefined;
    set internalValue(value: YdbDatabaseDedicatedScalePolicyFixedScale | undefined);
    private _size?;
    get size(): number;
    set size(value: number);
    get sizeInput(): number | undefined;
}
export interface YdbDatabaseDedicatedScalePolicy {
    /**
    * fixed_scale block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#fixed_scale YdbDatabaseDedicated#fixed_scale}
    */
    readonly fixedScale: YdbDatabaseDedicatedScalePolicyFixedScale;
}
export declare function ydbDatabaseDedicatedScalePolicyToTerraform(struct?: YdbDatabaseDedicatedScalePolicyOutputReference | YdbDatabaseDedicatedScalePolicy): any;
export declare class YdbDatabaseDedicatedScalePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseDedicatedScalePolicy | undefined;
    set internalValue(value: YdbDatabaseDedicatedScalePolicy | undefined);
    private _fixedScale;
    get fixedScale(): YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference;
    putFixedScale(value: YdbDatabaseDedicatedScalePolicyFixedScale): void;
    get fixedScaleInput(): YdbDatabaseDedicatedScalePolicyFixedScale | undefined;
}
export interface YdbDatabaseDedicatedStorageConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#group_count YdbDatabaseDedicated#group_count}
    */
    readonly groupCount: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#storage_type_id YdbDatabaseDedicated#storage_type_id}
    */
    readonly storageTypeId: string;
}
export declare function ydbDatabaseDedicatedStorageConfigToTerraform(struct?: YdbDatabaseDedicatedStorageConfigOutputReference | YdbDatabaseDedicatedStorageConfig): any;
export declare class YdbDatabaseDedicatedStorageConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseDedicatedStorageConfig | undefined;
    set internalValue(value: YdbDatabaseDedicatedStorageConfig | undefined);
    private _groupCount?;
    get groupCount(): number;
    set groupCount(value: number);
    get groupCountInput(): number | undefined;
    private _storageTypeId?;
    get storageTypeId(): string;
    set storageTypeId(value: string);
    get storageTypeIdInput(): string | undefined;
}
export interface YdbDatabaseDedicatedTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#default YdbDatabaseDedicated#default}
    */
    readonly default?: string;
}
export declare function ydbDatabaseDedicatedTimeoutsToTerraform(struct?: YdbDatabaseDedicatedTimeoutsOutputReference | YdbDatabaseDedicatedTimeouts | cdktf.IResolvable): any;
export declare class YdbDatabaseDedicatedTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseDedicatedTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: YdbDatabaseDedicatedTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated yandex_ydb_database_dedicated}
*/
export declare class YdbDatabaseDedicated extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_ydb_database_dedicated";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated yandex_ydb_database_dedicated} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options YdbDatabaseDedicatedConfig
    */
    constructor(scope: Construct, id: string, config: YdbDatabaseDedicatedConfig);
    private _assignPublicIps?;
    get assignPublicIps(): boolean | cdktf.IResolvable;
    set assignPublicIps(value: boolean | cdktf.IResolvable);
    resetAssignPublicIps(): void;
    get assignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
    get createdAt(): string;
    get databasePath(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _locationId?;
    get locationId(): string;
    set locationId(value: string);
    resetLocationId(): void;
    get locationIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
    get status(): string;
    private _subnetIds?;
    get subnetIds(): string[];
    set subnetIds(value: string[]);
    get subnetIdsInput(): string[] | undefined;
    get tlsEnabled(): cdktf.IResolvable;
    get ydbApiEndpoint(): string;
    get ydbFullEndpoint(): string;
    private _location;
    get location(): YdbDatabaseDedicatedLocationOutputReference;
    putLocation(value: YdbDatabaseDedicatedLocation): void;
    resetLocation(): void;
    get locationInput(): YdbDatabaseDedicatedLocation | undefined;
    private _scalePolicy;
    get scalePolicy(): YdbDatabaseDedicatedScalePolicyOutputReference;
    putScalePolicy(value: YdbDatabaseDedicatedScalePolicy): void;
    get scalePolicyInput(): YdbDatabaseDedicatedScalePolicy | undefined;
    private _storageConfig;
    get storageConfig(): YdbDatabaseDedicatedStorageConfigOutputReference;
    putStorageConfig(value: YdbDatabaseDedicatedStorageConfig): void;
    get storageConfigInput(): YdbDatabaseDedicatedStorageConfig | undefined;
    private _timeouts;
    get timeouts(): YdbDatabaseDedicatedTimeoutsOutputReference;
    putTimeouts(value: YdbDatabaseDedicatedTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | YdbDatabaseDedicatedTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=ydb-database-dedicated.d.ts.map