import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface YdbDatabaseServerlessConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#description YdbDatabaseServerless#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#folder_id YdbDatabaseServerless#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#id YdbDatabaseServerless#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#labels YdbDatabaseServerless#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#location_id YdbDatabaseServerless#location_id}
    */
    readonly locationId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#name YdbDatabaseServerless#name}
    */
    readonly name: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#timeouts YdbDatabaseServerless#timeouts}
    */
    readonly timeouts?: YdbDatabaseServerlessTimeouts;
}
export interface YdbDatabaseServerlessTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#default YdbDatabaseServerless#default}
    */
    readonly default?: string;
}
export declare function ydbDatabaseServerlessTimeoutsToTerraform(struct?: YdbDatabaseServerlessTimeoutsOutputReference | YdbDatabaseServerlessTimeouts | cdktf.IResolvable): any;
export declare class YdbDatabaseServerlessTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): YdbDatabaseServerlessTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: YdbDatabaseServerlessTimeouts | cdktf.IResolvable | undefined);
    private _default?;
    get default(): string;
    set default(value: string);
    resetDefault(): void;
    get defaultInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless yandex_ydb_database_serverless}
*/
export declare class YdbDatabaseServerless extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_ydb_database_serverless";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless yandex_ydb_database_serverless} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options YdbDatabaseServerlessConfig
    */
    constructor(scope: Construct, id: string, config: YdbDatabaseServerlessConfig);
    get createdAt(): string;
    get databasePath(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get documentApiEndpoint(): string;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _locationId?;
    get locationId(): string;
    set locationId(value: string);
    resetLocationId(): void;
    get locationIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get status(): string;
    get tlsEnabled(): cdktf.IResolvable;
    get ydbApiEndpoint(): string;
    get ydbFullEndpoint(): string;
    private _timeouts;
    get timeouts(): YdbDatabaseServerlessTimeoutsOutputReference;
    putTimeouts(value: YdbDatabaseServerlessTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | YdbDatabaseServerlessTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=ydb-database-serverless.d.ts.map